#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <string>
#include <unordered_map>
#include <unordered_set>

using namespace std;

signed main() {
    ios_base::sync_with_stdio(NULL);
    cin.tie(NULL);
    cout.tie(NULL);
#ifdef DEBUG_BENTSA
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#else

#endif
    int n;
    cin >> n;
    vector<int> v(n);
    int k = -1;
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
        if (k == -1 && v[i] != i + 1) {
            k = i;
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        int d1 = x1 - y1;
        int d2 = x2 - y2;
        if (d1 <= k && d2 <= k) {
            if (d1 != d2) {
                cout << min(d1, d2) << " " << 0 << "\n";
            } else {
                cout << min(x1, x2) << " " << min(y1, y2) << "\n";
            }
        } else if (d1 > k && d2 > k) {
            if (y1 == y2) {
                cout << min(x1, x2) << " " << y1 << "\n";
            } else {
                cout << min(y1, y2) + k << " " << min(y1, y2) << "\n";
            }
        } else {
            cout << min(d1, d2) << " " << 0 << "\n";
        }
    }
}
