#include<bits/stdc++.h>
 
using std::cin;
using std::cout;
using std::cerr;
using std::vector;
using std::string;
using std::pair;
 
using ll = long long;
using ld = long double;
 
#define int ll

struct Node {
    int l, r;
};

vector<vector<int>> g;
vector<int> c;
vector<Node> bd;
vector<int> ans;
vector<std::set<pair<int, int>>> s;
 
vector<int> nodes;
void get(int u) {
	nodes.push_back(u);
	for(int v : g[u])
		get(v);
}

int dfs(int u) {
    int sum = 0;
    //s[u].insert({c[u], u});
    for(int v : g[u]) {
        int res = dfs(v);
        /*if(s[v].size() > s[u].size())
            std::swap(s[v], s[u]);
        for(auto p : s[v])
            s[u].insert(p);*/
        if(res == -1)
            return -1;
        sum += res;
    }
    int left = std::max(0ll, bd[u].l - sum);
    sum += left;
    if(sum > bd[u].r)
        return -1;
    /*while(!s[u].empty() && left > 0) {
        auto p = *s[u].begin();
        int c = bd[p.second].r - ans[p.second];
        if(c > left) {
            ans[p.second] += left;
            left = 0;
        } else {
            left -= c;
            ans[p.second] = bd[p.second].r;
            s[u].erase(s[u].begin());
        }
    }*/
	nodes.clear();
	get(u);
	std::sort(nodes.begin(), nodes.end(), [&](int a, int b){
		return c[a] < c[b];
	});
	for(int i : nodes) {
		int a = bd[i].r - ans[i];
		assert(a >= 0);
		ans[i] += std::min(a, left);
		left = std::max(0ll, left - a);
	}
    if(left != 0)
        return -1;
    return sum;
}
 
 
signed main() {
    std::ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
 
    int t;
    cin >> t;
    while(t--) {
        int n;
        cin >> n;
        g.assign(n, vector<int> (0)), c.resize(n), bd.resize(n), ans.assign(n, 0), s.assign(n, std::set<pair<int, int>> ());
        for(int i = 1; i < n; ++i) {
            int p;
            cin >> p;
            --p;
            g[p].push_back(i);
        }
        for(int i = 0; i < n; ++i)
            cin >> c[i];
        for(int i = 0; i < n; ++i)
            cin >> bd[i].l >> bd[i].r;
 
        auto res = dfs(0);
        if(res == -1) {
            cout << -1 << '\n';
            continue;
        }
        ll sum = 0;
        for(int i = 0; i < n; ++i)
            sum += (ll)ans[i] * c[i];
     
        cout << sum << '\n';
        for(int i : ans)
            cout << i << ' ';
        cout << '\n';
    }
 
    return 0;
}
