#include <bits/stdc++.h>
//#pragma GCC optimize("Ofast,unroll-loops")

#define endl '\n'
#define F first
#define S second

typedef long long ll;
typedef long double ld;

using namespace std;

vector <pair <int, int>> g[3010][3010];
pair <int, int> p[3010][3010];
int t = 0;
int tin[3010][3010], tout[3010][3010];

void dfs(int xs, int ys) {
    tin[xs][ys] = t;
    t++;
    for (auto& i : g[xs][ys])
        dfs(i.F, i.S);
    tout[xs][ys] = t;
    t++;
}

void run() {
    int n, q;
    cin >> n;

    vector <int> ins(n, 0);
    for (int i = 0; i < n + 1; i++) {
        int xs = 0, ys = 0, xe = 0, ye = 0;
        for (auto& j : ins) {
            if (j == 0) {
                xe = xs + 1;
                ye = ys + 1;
            }
            else {
                xe = xs + 1;
                ye = ys;
            }
            p[xe][ye] = {xs, ys};
            g[xs][ys].push_back({xe, ye});
            xs = xe;
            ys = ye;
        }
        if (i != n) {
            int a;
            cin >> a;
            ins[a - 1] = 1;
        }
    }

    dfs(0, 0);

    cin >> q;
    for (int _ = 0; _ < q; _++) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        while (!(tin[a][b] <= tin[c][d] && tout[a][b] >= tout[c][d])) {
            auto now = p[a][b];
            a = now.F;
            b = now.S;
        }
        cout << a << ' ' << b << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    run();
}
