#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <utility>
#define int long long
using namespace std;

vector <vector <int>> g;
vector <int> pr, c, a, l, r;
bool f = 1;
vector <int> per;

struct vert
{
	set <vector <int>> s;
	int l;
	long long c;
};

vert dfs(int v) {
	if (g[v].size() == 0) {
		vert k;
		k.c = c[v] * (long long)l[v];
		k.l = l[v];
		a[v] += l[v];
		k.s.clear();
		k.s.insert({c[v], v});
		return k;
	}
	vert k;
	k.c = 0;
	k.l = 0;
	k.s.clear();
	for (auto& i : g[v]) {
		if (i == pr[v]) continue;
		auto p = dfs(i);
		k.c += p.c;
		k.l += p.l;
		for (auto j : p.s)k.s.insert(j);
	}
	k.s.insert({ c[v], v });
	if (k.l > r[v]) f = 0;
	while (k.l < l[v] && k.s.size()) {
		auto p = *k.s.begin();
		int o = per[p[1]];
		int po = p[1];
		while (po) {
			po = pr[po];
			o = min(o, per[po]);
		}
		o = min(o, l[v] - k.l);
		k.l += o;
		k.c += o * (long long)p[0];
		k.s.erase(k.s.begin());
		a[p[1]] += o;
		if (o == l[v] - k.l) k.s.insert(p);
		po = p[1];
		per[p[1]] -= o;
		while (po) {
			po = pr[po];
			per[po] -= o;
		}
	}
	return k;
}

void solve() {
	int n;
	f = 1;
	cin >> n;
	g.clear();
	g.resize(n);
	a.resize(n);
	pr = { 0 };
	per.clear();
	per.resize(n);
	for (int i = 1; i < n; i++) {
		int t;
		cin >> t;
		pr.push_back(--t);
		g[t].push_back(i);
	}
	c = {};
	for (int i = 0; i < n; i++) {
		int t;
		cin >> t;
		c.push_back(t);
	}
	l.clear();
	r.clear();
	for (int i = 0; i < n; i++) {
		int v1, v2;
		cin >> v1 >> v2;
		l.push_back(v1);
		r.push_back(v2);
		per[i] = v2;
	}
	auto k = dfs(0);
	if (f) {
		cout << k.c << "\n";
		for (auto& i : a) {
			cout << i << " ";
		}
		cout << "\n";
	}
	else cout << -1 << "\n";
}

signed main() {
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}