#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define ll long long
#define pii pair<int, int>
#define sz(x) (int) size(x)
#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)
#define uniq(x) x.resize(unique(all(x)) - begin(x));
#define mp make_pair

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const int infI = 1e9 + 7;
const ll infL = 2e18;
const ll mod = 998244353;
const int N = (3000) + 1;

template<typename T>
bool ckmx(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool ckmn(T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

pii p[N][N];



void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    vector<pii> now(n + 1);
    vector<bool> used(n + 1);
    for (int i = 0; i <= n; ++i) {
        now[i] = {i, i};
        p[i][i] = {i - 1, i - 1};
    }
    for (int k : a) {
        used[k] = true;
        auto [i, j] = now[k - 1];
        for (int v = k; v <= n; ++v) {
            i = i + 1;
            j = j + (!used[v]);
            now[v] = {i, j};
            p[i][j] = now[v - 1];
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        while (true) {
            if (x1 == x2 && y1 == y2) {
                cout << x1 << " " << y1 << '\n';
                break;
            }
            if (x1 < x2) {
                auto[i, j] = p[x2][y2];
                x2 = i;
                y2 = j;
            } else {
                auto[i, j] = p[x1][y1];
                x1 = i;
                y1 = j;
            }
        }
    }
}


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}