#include "iostream"
#include "vector"
#include "algorithm"

using namespace std;

const int INF = 1e9;

signed main() {
    int n; cin >> n;
    vector<int> p(n);
    for (int i = 0; i < n; i++) {
        cin >> p[i];
    }
    vector<vector<int>> ans(n, vector<int>(n, 0));
    /*for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            ans[i][j] = j - i;
        }
    }*/
    for (int i = n - 1; i >= 0; --i) {
        int dist = 0;
        for (int j = i + 1; j < n; ++j) {
            if (p[j] < p[i]) dist++;
        }
        int mx = -INF, less = 0;
        for (int j = i - 1; j >= 0; --j) {
            mx = max(mx, j + less);
            ans[j][i] = max(ans[j][i], dist + mx - j + 1);
            if (p[j] < p[i]) less++;
        }
    }
    /*for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            cout << ans[i][j] << " ";
        }
        cout << endl;
    }*/
    for (int i = 0; i < n; ++i) {
        int dist = 0;
        for (int j = 0; j < i; ++j) {
            if (p[j] > p[i]) dist++;
        }
        int mx = -INF, more = 0;
        for (int j = i + 1; j < n; ++j) {
            mx = max(mx, more - j);
            ans[i][j] = max(ans[i][j], dist + mx + j + 1);
            if (p[j] > p[i]) more++;
        }
    }
    /*for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            cout << ans[i][j] << " ";
        }
        cout << endl;
    }*/
    vector<pair<int, int>> s;
    for (int i = 0; i < n; ++i) {
        s.emplace_back(p[i], i);
    }
    sort(s.begin(), s.end());
    vector<int> pos(n);
    for (int i = 0; i < n; ++i) {
        pos[s[i].second] = i;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            ans[i][j] = max(ans[i][j], abs(pos[i] - pos[j]));
        }
    }
    int res = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            res += ans[i][j];
        }
    }
    /*for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            cout << ans[i][j] << " ";
        }
        cout << endl;
    }*/
    cout << res << endl;
}