#include <bits/stdc++.h>

using namespace std;

const int lg = 24;

int main() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto& i : a)
        cin >> i, --i;

    vector<int> path(n, 1);
    vector<int> p((n + 1) * (n + 1), 0);
    int cur = 0;
    for (int i = 0; i < n; ++i) {
        int next = cur + n + 1 + path[i];
        p[next] = cur;
        cur = next;
    }

    for (auto j : a) {
        path[j] = 0;
        int cur = 0;
        for (int i = 0; i < n; ++i) {
            int next = cur + n + 1 + path[i];
            p[next] = cur;
            cur = next;
        }
    }

    vector<vector<int>> dp(lg + 1, vector<int>(p.size()));
    for (int i = 0; i < p.size(); ++i)
        dp[0][i] = p[i];

    for (int i = 1; i <= lg; ++i)
        for (int j = 0; j < p.size(); ++j)
            dp[i][j] = dp[i - 1][dp[i - 1][j]];
    /*
    for (auto& i : dp) {
        for (auto& j : i)
            cerr << j << " ";
        cerr << endl;
    }
    */
    int q;
    cin >> q;
    while (q--) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        if (x1 < x2) {
            swap(x1, x2);
            swap(y1, y2);
        }
        int v = x1 * (n + 1) + y1, u = x2 * (n + 1) + y2;
        int d = x2 - x1;
        for (int i = lg; i > -1 && d > 0; --i)
            if ((1 << i) <= d) {
                d -= 1 << i;
                v = dp[i][v];
            }
        if (u == v) {
            cout << v / (n + 1) << " " << v % (n + 1) << "\n";
            continue;
        }
        for (int i = lg; i > -1; --i)
            if (dp[i][v] != dp[i][u]) {
                v = dp[i][v];
                u = dp[i][u];
            }

        v = p[v];
        cout << v / (n + 1) << " " << v % (n + 1) << "\n";
    }
}
