#include <bits/stdc++.h>
  
using namespace std;
  
const int maxn = 5e5 + 5, R = 1 << 19;
  
int t[R * 2];
  
int pp[maxn], _pp[maxn];

void build() {
    for (int i = R * 2 - 1; i > 0; --i) {
        t[i] = 0;
    }
}

void change(int pos) {
    for (pos += R; pos > 0; pos /= 2) {
        t[pos]++;
    }
}
  
int get(int l, int r) {
    l += R;
    r += R;
    int ans = 0;
    while (l < r) {
        if (l & 1) {
            ans += t[l++];
        }
        if (r & 1) {
            ans += t[--r];
        }
        l >>= 1;
        r >>= 1;
    }
    return ans;
}
  
int n;

pair<int, int> a[maxn][2], p[maxn][2];
 
int l[maxn][2], r[maxn][2];

vector<pair<int, int>> qs[maxn];

int mn[R * 2];
 
void build_mn() {
    for (int i = R - 1; i > 0; --i) {
        mn[i] = min(mn[i * 2], mn[i * 2 + 1]);
    }
}
 
int get_mn(int l, int r) {
    l += R;
    r += R;
    int ans = n + 10;
    while (l < r) {
        if (l & 1) {
            ans = min(ans, mn[l++]);
        }
        if (r & 1) {
            ans = min(ans, mn[--r]);
        }
        l >>= 1;
        r >>= 1;
    }
    return ans;
}

int get_pos(int cnt, int node = 1, int nl = 0, int nr = R) {
    if (cnt == 0) {
        return nl - 1;
    }
    if (nl == nr - 1) {
        return nl;
    }
    int nm = (nl + nr) / 2;
    if (t[node * 2] < cnt) {
        return get_pos(cnt - t[node * 2], node * 2 + 1, nm, nr);
    }
    return get_pos(cnt, node * 2, nl, nm);
}
  
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> pp[i];
        pp[i]--;
        _pp[pp[i]] = i;
        mn[i + R] = pp[i];
    }
    build_mn();
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        cin >> a[i][0].first >> a[i][0].second >> a[i][1].first >> a[i][1].second;
        qs[a[i][0].first].emplace_back(i, 0);
        qs[a[i][1].first].emplace_back(i, 1);
    }
    build();
    for (int i = 0; i <= n; ++i) {
        for (auto [j, k] : qs[i]) {
            p[j][k].second = min(get_pos(a[j][k].first - a[j][k].second + 1), n);
            p[j][k].first = min(get_pos(a[j][k].first - a[j][k].second), n) + 1;
        }
        qs[i].clear();
        if (i != n) {
            change(_pp[i]);
        }
    }
    for (int i = 0; i < q; ++i) {
        // cout << '!' << p[i][0].first << ' ' << p[i][0].second << ' ' << p[i][1].first << ' ' << p[i][1].second << '\n';
        if ((p[i][0].first <= p[i][1].first && p[i][1].second <= p[i][0].second) || (p[i][1].first <= p[i][0].first && p[i][0].second <= p[i][1].second)) {
            continue;
        } else {
            int ans = get_mn(min(p[i][0].second, p[i][1].second), max(p[i][0].first, p[i][1].first));
            qs[ans].emplace_back(i, 0);
            // cout << ans << ' ' << ans - get(0, max(p[i][0].first, p[i][1].first), ans) << '\n';
        }
    }
    build();
    vector<int> val(q, 0);
    for (int i = 0; i <= n; ++i) {
        for (auto [j, k] : qs[i]) {
            val[j] = get(0, max(p[j][0].first, p[j][1].first));
        }
        qs[i].clear();
        if (i != n) {
            change(_pp[i]);
        }
    }
    for (int i = 0; i < q; ++i) {
        if ((p[i][0].first <= p[i][1].first && p[i][1].second <= p[i][0].second) || (p[i][1].first <= p[i][0].first && p[i][0].second <= p[i][1].second)) {
            cout << min(a[i][0], a[i][1]).first << ' ' << min(a[i][0], a[i][1]).second << '\n';
        } else {
            int ans = get_mn(min(p[i][0].second, p[i][1].second), max(p[i][0].first, p[i][1].first));
            cout << ans << ' ' << ans - val[i] << '\n';
        }
    }
    return 0;
}
