#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector <vector <pair <int, int>>> gr;

int main() {
    int n;
    cin >> n;
    vector <int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    gr.resize(n+1);
    for (int r = 0; r <= n; ++r) {
        gr[r].resize(r+1);
    }
    gr[0][0] = {-1, -1};
    vector <int> curr(n, 1);
    int r = 0;
    int c = 0;
    for (int j = 0; j < n; ++j) {
        gr[r+1][c+1] = {r, c};
        r++; c++;
    }
    for (int i = 0; i < n; i++) {
        curr[a[i]-1] = 0;
        r = 0;
        c = 0;
        for (int j = 0; j < n; ++j) {
            gr[r+1][c+curr[j]] = {r, c};
            r++; c += curr[j];
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        vector <pair <int, int>> p1, p2;
        while (r1 != -1) {
            p1.emplace_back(r1, c1);
            auto [rn, cn] = gr[r1][c1];
            r1 = rn;
            c1 = cn;
        }
        while (r2 != -1) {
            p2.emplace_back(r2, c2);
            auto [rn, cn] = gr[r2][c2];
            r2 = rn;
            c2 = cn;
        }
        reverse(p1.begin(), p1.end());
        reverse(p2.begin(), p2.end());
        pair <int, int> ans = {-1, -1};
        for (int i = 0; i < min(p1.size(), p2.size()); ++i) {
            if (p1[i] == p2[i]) {
                ans = p1[i];
            } else {
                break;
            }
        }
        cout << ans.first << ' ' << ans.second << '\n';
    }
    return 0;
}