#include <bits/stdc++.h>

using namespace std;

#define vc vector
typedef int ll;
typedef pair<ll, ll> pll;
typedef vc<ll> vll;
typedef vc<pll> vpll;
typedef vc<vll> vvll;
typedef vc<vpll> vvpll;

bool made[9200005];

vll go[9200005];

map<pll, ll> real;
pll unreal[9200005];

ll d[9200005];

ll up[26][9200005];

void cfs(ll v, ll dd = 0) {
    d[v] = dd;
    for (auto to: go[v]) {
        up[0][to] = v;
        cfs(to, dd + 1);
    }
}

void upp(ll &v, ll x) {
    for (ll j = 25; j >= 0; --j) {
        if (x >= (1 << j)) {
            x -= (1 << j);
            v = up[j][v];
        }
    }
}

ll lca(ll v, ll u) {
    upp(u, max(0, d[u] - d[v]));
    upp(v, max(0, d[v] - d[u]));
    for (ll j = 25; j >= 0; --j) {
        if (up[j][v] != up[j][u]) {
            v = up[j][v];
            u = up[j][u];
        }
    }
    if (v != u) {
        v = up[0][v];
        u = up[0][u];
    }
    assert(v == u);
    return v;
}

int main() {
    ios_base::sync_with_stdio(false);
    ll n;
    cin >> n;
    vll a(n);
    for (auto &i: a) cin >> i;
    for (ll i = 0; i < n; ++i) {
        go[i * (n + 1) + i].push_back((i + 1) * (n + 1) + i + 1);
    }
    for (auto xx: a) {
        made[xx - 1] = true;
        ll nw = 0;
        for (ll i = 0; i < n; ++i) {
            go[i * (n + 1) + nw].push_back((i + 1) * (n + 1) + nw + (!made[i]));
            nw += !made[i];
        }
    }
    for (ll i = 0; i <= n; ++i) {
        for (ll j = 0; j <= i; ++j) {
            ::real[{i, j}] = i * (n + 1) + j;
            unreal[i  * (n + 1) + j] = {i, j};
            sort(go[i  * (n + 1) + j].begin(), go[i  * (n + 1) + j].end());
            go[i  * (n + 1) + j].resize(unique(go[i  * (n + 1) + j].begin(), go[i  * (n + 1) + j].end()) - go[i  * (n + 1) + j].begin());
        }
    }
    up[0][0 * (n + 1) + 0] = 0 * (n + 1) + 0;
    cfs(0 * (n + 1) + 0);

    for (ll j = 1; j < 26; ++j) {
        for (ll v = 0; v <= (n + 1) * (n + 1) + (n + 1) * 7; ++v) {
            up[j][v] = up[j - 1][up[j - 1][v]];
        }
    }

    ll q;
    cin >> q;
    while (q--) {
        pll x;
        cin >> x.first >> x.second;
        pll y;
        cin >> y.first >> y.second;
        pll z = unreal[lca(::real[x], ::real[y])];
        cout << z.first << ' ' << z.second << '\n';
    }
}