#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <utility>
using namespace std;


int p[3003 * 3003];


int lca(int a, int b) {
    set<int> path;
    while (a != 0) {
        path.insert(a);
        a = p[a];
    }
    path.insert(0);
    while (b != 0) {
        if (path.find(b) != path.end()) {
            return b;
        }
        b = p[b];
    }
    return 0;
}

int n;


int num(int r, int c) {
    return r * (n + 1) + c;
}

int num(pair<int, int> a) {
    return a.first * (n + 1) + a.second;
}
int k;
pair<int, int> dia(int r, int c) {
    if (r - c <= k) {
        return {0, r - c};
    }
    return {1, c};
}



int dia2(int r, int c) {
    return c;
}


void solve2(int r1, int c1, int r2, int c2) {
    if (c1 == c2) {
        cout << min(r1, r2) << ' ' << min(c1, c2) << '\n';
    } else {
        cout << k + min(c1, c2) << ' ' << min(c1, c2) << '\n';
    }
}


signed main() {
    cin >> n;
    k = n;
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        if (i + 1 != x && k == n) {
            k = i;
        }
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        auto [t1, n1] = dia(r1, c1);
        auto [t2, n2] = dia(r2, c2);
        if (t1 == t2) {
            if (n1 == n2) {
                cout << min(r1, r2) << ' ' << min(c1, c2) << '\n';
            } else {
                if (t1 == 0) {
                    cout << min(n1, n2) << ' ' << 0 << '\n';
                } else {
                    cout << k + min(c1, c2) << ' ' << min(n1, n2) << '\n';
                }
            }
        } else {
            if (t1 == 1) {
                swap(t1, t2);
                swap(n1, n2);
            }
            if (n1 == k) {
                solve2(r1, c1, r2, c2);
            } else {
                cout << n1 << ' ' << 0 << '\n';
            }
        }
    }
    return 0;
}
