#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<set>
#include<string>
#include<map>
#include<queue>
#include<deque>
#include<random>
#include<algorithm>
#include<math.h>

using namespace std;
using ll = long long;
mt19937 rnd(7);
//#define int long long
#define endl '\n'
#define all(v) v.begin(), v.end()
const int N = 1e6 + 9;
const ll INF = 1e18 + 9;

ll c[N];
ll l0[N], r0[N];
vector<ll> g[N];
ll flag = 0;
ll cnt[N];
ll allcnt[N];
ll cnt0[N];
ll allcnt0[N];

void copy(int v)
{
	cnt0[v] = cnt[v];
	allcnt0[v] = allcnt[v];
	for (auto u : g[v])
		copy(u);
}
void ret(int v)
{
	cnt[v] = cnt0[v];
	allcnt[v] = allcnt0[v];
	for (auto u : g[v])
		ret(u);
}


ll dfs_mx(int v, ll x, ll k)
{
	k -= allcnt[v];
	int k0 = k;
	for (auto u : g[v])
	{
		ll res = dfs_mx(u, min(x, c[v]), min(ll(r0[u]), allcnt[u] + k));
		k -= res;
		allcnt[v] += res;
	}
	if (k != 0 && c[v] <= x)
	{
		allcnt[v] += k;
		cnt[v] += k;
		k = 0;
	}
	return k0 - k;
}


ll dfs_last(int v, ll x, ll k)
{
	
	k -= allcnt[v];
	int k0 = k;
	for (auto u : g[v])
	{
		ll res = dfs_last(u, min(x, c[v]), min(ll(r0[u]), allcnt[u] + k));
		k -= res;
		allcnt[v] += res;
	}


	if (k != 0 && c[v] == x)
	{
		allcnt[v] += k;
		cnt[v] += k;
		k = 0;
	}
	return k0 - k;
}

void dfs(int v)
{
	for (auto u : g[v])
	{
		dfs(u);
		if (flag)
			return;
		allcnt[v] += allcnt[u];
		if (allcnt[v] > r0[v])
		{
			flag = 1;
			return;
		}
	}
	if (allcnt[v] < l0[v])
	{
		if (c[v] == 0)
		{
			cnt[v] += l0[v] - allcnt[v];
			allcnt[v] = l0[v];
			return;
		}
		ll L = 0, R = c[v];
		while (L + 1 != R)
		{
			ll m = (L + R) / 2;
			copy(v);
			dfs_mx(v, m, l0[v]);
			if (allcnt[v] == l0[v])
				R = m;
			else
				L = m;
			ret(v);
		}
		dfs_mx(v, L, l0[v]);
		dfs_last(v, R, l0[v]);

	}
}


signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	cin.tie(0);
	ios_base::sync_with_stdio(0);
#endif

	int t;
	cin >> t;
	for (int i = 0; i < t; i++)
	{
		int n;
		cin >> n;
		flag = 0;
		for (int i = 0; i <= n; i++)
		{
			g[i].clear();
			cnt[i] = 0;
			cnt0[i] = 0;
			allcnt[i] = 0;
			allcnt0[i] = 0;
		}
		for (int i = 2; i <= n; i++)
		{
			int v;
			cin >> v;
			g[v].push_back(i);
		}
		for (int i = 1; i <= n; i++)
		{
			cin >> c[i];
		}
		for (int i = 1; i <= n; i++)
		{
			cin >> l0[i] >> r0[i];
		}

		dfs(1);
		if (flag)
		{
			cout << "-1\n";
			continue;
		}
		ll ans = 0;
		for (int i = 1; i <= n; i++)
		{
			ans += ll(cnt[i]) * c[i];
		}
		cout << ans << endl;
		for (int i = 1; i <= n; i++)
		{
			cout << cnt[i] << " ";
		}
		cout << endl;

	}
}