#include <bits/stdc++.h>

using namespace std;

#define int long long
#define vc vector
#define pii pair <int, int>
#define forn(i, n) for (int i = 0; i < n; ++i)
#define sz(a) (int)a.size()
#define pb push_back

const int maxn = 1e5, inf = 1e9 + 7;

using tt = set <pii>;

int c[maxn], l[maxn], r[maxn], pr[maxn], rt[maxn], is = 1;
vc <int> g[maxn];
tt dp[maxn];
int ans[maxn];

void merge (tt &a, tt &b) {
    if (sz(a) < sz(b))
        a.swap(b);
    for (auto &it : b)
        a.insert(it);
}

int all = 0;

struct fw {
    vc <int> t;
    int n;
    fw (int n = 0): n(n) {
        resize(n);
    }
    void resize (int n) {
        this->n = n;
        t.assign(n + 1, 0);
    }
    void upd (int i, int x) {
        for (++i; i <= n; i += i & -i)
            t[i] += x;
    }
    int sum (int i) {
        int res = 0;
        for (++i; i > 0; i -= i & -i)
            res += t[i];
        return res;
    }
    int get (int l, int r) {
        return sum(r - 1) - sum(l - 1);
    }
};

int timer = 0;
int tin[maxn], tout[maxn], h[maxn], start[maxn];
fw tree;

void euler (int u, int p = -1) {
    tin[u] = timer++;
    pr[u] = p;
    for (int v: g[u]) if (v != p) {
        h[v] = h[u] + 1;
        euler(v, u);
    }
    tout[u] = timer;
}

int res (int u) {
    return rt[u] - r[u];
}

int right (int u) {
    int res = inf;
    while (u != -1) {
        res = min(res, r[u]);
        u = pr[u];
    }
    return res;
}

void upd (int u, int x) {
    while (u != -1) {
        r[u] -= x;
        u = pr[u];
    }
}

void dfs (int u, int p = -1) {
    for (int v: g[u]) {
        if (v == p) continue;
        dfs(v, u);
        if (!is) return;
        merge(dp[u], dp[v]);
    }
    if (res(u) > right(u)) {
        is = 0;
        return;
    }
    dp[u].insert({c[u], u});
    while (!dp[u].empty() && res(u) < l[u]) {
        int j = dp[u].begin()->second;
        int need = min(l[u] - res(u), right(j));
        tree.upd(tin[j], need);
        upd(j, need);
        if (res(u) < l[u]) dp[u].erase(dp[u].begin());
    }
    if (res(u) < l[u]) {
        is = 0;
        return;
    }
}

void solve () {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        g[i].clear();
        dp[i].clear();
        ans[i] = tin[i] = tout[i] = c[i] = l[i] = r[i] = ans[i] = 0;
    }
    is = 1;
    timer = 0;
    all = 0;
    for (int i = 1; i < n; ++i) {
        int v;
        cin >> v; --v;
        g[i].pb(v);
        g[v].pb(i);
    }
    forn (i, n) cin >> c[i];
    forn (i, n) cin >> l[i] >> r[i], rt[i] = r[i];
    euler(0);
    tree.resize(n);
    dfs(0);
    if (!is) {
        cout << "-1\n";
        return;
    }
    forn (i, n) {
        ans[i] = tree.get(tin[i], tin[i] + 1);
        all += ans[i] * c[i];
    }
    cout << all << '\n';
    for (int i = 0; i < n; ++i) cout << ans[i] << ' ';
    cout << '\n';
}

signed main () {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    cin >> t;
    while(t--)solve();
}
/*
1
3
1 2
2 1 1
152 152
151 151
150 150
 */