#include <iostream>
#include <algorithm>
#include <vector>
#include <tuple>
#include <deque>
#include <cassert>
#include <set>

using namespace std;
typedef long long ll;
#define endl '\n'

int n, q;
int a[500010]; //level change
int qu[500010][4];
int cross[500010];

int fenw[500010];

inline void add(int i, int v)
{
	for (; i <= n; i = i | (i + 1)) fenw[i] += v;
}

inline int gt(int i)
{
	int ans = 0;
	for (; i >= 0; i = ((i + 1) & i) - 1) ans += fenw[i];
	return ans;
}

pair <int, int> up(pair <int, int> u)
{
	assert(u.first > 0);
	if (u.second > cross[u.first - 1]) u.second--;
	u.first--;
	return u;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n;

	for (int i = 1; i <= n; ++i)
	{
		cin >> a[i];
		--a[i];
	}

	cin >> q;
	for (int i = 1; i <= q; ++i)
	{
		for (int j = 0; j < 4; ++j)
		{
			cin >> qu[i][j];
		}
	}

	for (int i = 1; i <= n; ++i)
	{
		cross[a[i]] = a[i] - gt(a[i]);
		add(a[i], 1);
	}

	for (int i = 1; i <= q; ++i)
	{
		pair <int, int> u = { qu[i][0], qu[i][1] }, v = { qu[i][2], qu[i][3] };
		if (u > v) swap(u, v);

		while (v.first > u.first)
		{
			v = up(v);
		}
		while (u != v)
		{
			u = up(u);
			v = up(v);
		}

		cout << u.first << ' ' << u.second << '\n';
	}

	return 0;
}