#include <bits/stdc++.h>

using namespace std;

const int N = 500500;

int n;
int a[N];
int q;
int r[2 * N], c[2 * N];
int ansr[N], ansc[N];
vector<int> by_r[N];
int p[N];
int f[N];
int dsu[3 * N];
vector<int> have[N];

void add_fen(int i, int val) {
	for (++i; i < N; i += i & -i) {
		f[i] += val;
	}
}

int get_fen(int r) {
	int res = 0;
	for (; r > 0; r -= r & -r) {
		res += f[r];
	}
	return res;
}

int find_kth(int k) {
	int sum = 0;
	int res = 0;
	for (int t = 19; t >= 0; --t) {
		if (res + (1 << t) < N && sum + f[res + (1 << t)] < k) {
			res += (1 << t);
			sum += f[res];
		}
	}
	return res;
}

int get_dsu(int v) {
	return dsu[v] == v ? v : dsu[v] = get_dsu(dsu[v]);
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		--a[i];
	}

	for (int i = 0; i < n; ++i) {
		p[a[i]] = a[i] - get_fen(a[i]);
		add_fen(a[i], 1);
	}

	cin >> q;
	for (int i = 0; i < q; ++i) {
		cin >> r[2 * i] >> c[2 * i] >> r[2 * i + 1] >> c[2 * i + 1];
		ansr[i] = -1;
		ansc[i] = -1;
	}

	for (int i = 0; i < N; ++i) {
		f[i] = 0;
	}

	for (int i = 0; i <= n; ++i) {
		add_fen(i, 1);
	}

	for (int i = 0; i < n + 1 + 2 * q; ++i) {
		dsu[i] = i;
	}

	for (int i = 0; i < q; ++i) {
		if (r[2 * i] == r[2 * i + 1] && c[2 * i] == c[2 * i + 1]) {
			ansr[i] = r[2 * i];
			ansc[i] = c[2 * i];
		} else {	
			by_r[r[2 * i]].push_back(2 * i);
			by_r[r[2 * i + 1]].push_back(2 * i + 1);
		}
	}

	for (int id : by_r[n]) {
		int w = find_kth(c[id] + 1);
		if (get_dsu(n + 1 + (id ^ 1)) == w && ansr[id / 2] == -1) {
			ansr[id / 2] = n;
			ansc[id / 2] = c[id];
		}
		dsu[n + 1 + id] = w;
		have[w].push_back(id);
	}

	for (int i = n - 1; i >= 0; --i) {
		int v = find_kth(p[i] + 1);
		int u = find_kth(p[i] + 2);
		
		if (have[v].size() > have[u].size()) {
			swap(v, u);
		}
		
		for (int id : have[v]) {
			if (get_dsu(n + 1 + (id ^ 1)) == u && ansr[id / 2] == -1) {
				ansr[id / 2] = i;
				ansc[id / 2] = p[i];
			}
			have[u].push_back(id);
		}
		
		dsu[v] = u;
		add_fen(v, -1);

		for (int id : by_r[i]) {
			int w = find_kth(c[id] + 1);
			if (get_dsu(n + 1 + (id ^ 1)) == w && ansr[id / 2] == -1) {
				ansr[id / 2] = i;
				ansc[id / 2] = c[id];
			}
			dsu[n + 1 + id] = w;
			have[w].push_back(id);
		}
	}

	for (int i = 0; i < q; ++i) {
		cout << ansr[i] << " " << ansc[i] << "\n";
	}
	return 0;
}