#include <bits/stdc++.h>

using namespace std;

const int N = 100100;

int n, w, h;
int x[N], y[N];

long long go() {	
	vector<int> xs = {0, w};
	for (int i = 0; i < n; ++i) {
		xs.push_back(x[i]);
	}
	sort(xs.begin(), xs.end());
	xs.erase(unique(xs.begin(), xs.end()), xs.end());
	int sz = xs.size();
	vector<int> ord;
	for (int i = 0; i < n; ++i) {
		ord.push_back(i);
	}
	sort(ord.begin(), ord.end(), [&](int i, int j) {
		return x[i] < x[j];
	});
	vector<int> mx(sz - 1, 0);
	long long res = 0;
	int ptr = 0;
	for (int i = 0; i < n; ++i) {
		long long sum = 0;
		for (int j = 0; j < sz - 1; ++j) {
			sum += (xs[j + 1] - xs[j]) * 1ll * (xs[j + 1] <= x[ord[i]] ? max(mx[j], y[ord[i]]) : mx[j]);
		}
		res = max(res, sum);
		while (xs[ptr] < x[ord[i]]) {
			++ptr;
		}
		for (int j = ptr; j < sz - 1; ++j) {
			mx[j] = max(mx[j], y[ord[i]]);
		}
	}
	return res;
}

void solve() {
	cin >> n >> w >> h;
	for (int i = 0; i < n; ++i) {
		cin >> x[i] >> y[i];
		y[i] = h - y[i];
	}
	long long ans = go();
	for (int i = 0; i < n; ++i) {
		x[i] = w - x[i];
	}
	ans = max(ans, go());
	cout << ans << "\n";
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	int k;
	cin >> k;
	vector<int> dirs(k);
	for (int i = 0; i < k; ++i) {
		cin >> dirs[i];
	}
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}
