#include <bits/stdc++.h>
using namespace std;

#define int long long
#define pi pair <int,int>
#define endl "\n"

vector <vector <int>> g;
vector <int> par;
vector <set <pi>> res;
vector <int> c;
vector <int> l;
vector <int> r;
vector <int> cnt;
vector <int> total;
int n;

void calc_res(int u) {
    res[u].insert({c[u], u});
    for (auto v: g[u]) {
        calc_res(v);
        for (auto el: res[v]) res[u].insert(el);
    }
    return;
}

bool ok;

void add(int u, int d) {
    while (u != -1) {
        total[u] += d;
        u = par[u];
    }
    return;
}

void dfs(int u) {
    if (!ok) return;
    for (auto v: g[u]) {
        dfs(v);
        if (!ok) return;
    }

    if (total[u] > r[u]) {
        ok = 0;
        return;
    }
    if (total[u] >= l[u]) {
        return;
    }
    int need = l[u] - total[u];

    while (1) {
        if (res[u].empty()) break;
        int idx = res[u].begin() -> second;

        int able = r[idx] - total[idx];
        if (able > need) {
            cnt[idx] += need;
            add(idx, need);
            need = 0;
            break;
        }
        else if (able == need) {
            cnt[idx] += need;
            add(idx, need);
            need = 0;
            int del = idx;
            while (del != -1) {
                res[del].erase({c[idx], idx});
                del = par[del];
            }
            break;
        }
        else {
            cnt[idx] += able;
            need -= able;
            add(idx, able);
            int del = idx;
            while (del != -1) {
                res[del].erase({c[idx], idx});
                del = par[del];
            }
        }
    }

    if (total[u] < l[u]) {
        ok = 0;
        return;
    }
    return;
}

void solve() {
    cin >> n;
    g.resize(n);
    par.resize(n, -1);
    c.resize(n);
    l.resize(n);
    r.resize(n);
    cnt.resize(n);
    total.resize(n);
    for (int v = 1; v<n; ++v) {
        int u;
        cin >> u;
        u--;
        par[v] = u;
        g[u].push_back(v);
    }
    for (int v = 0; v<n; ++v) cin >> c[v];
    for (int v = 0; v<n; ++v) cin >> l[v] >> r[v];
    res.resize(n);
    calc_res(0);
    ok = 1;
    dfs(0);
    if (!ok) {
        if (n != 2) int x = 1/0;
        cout << -1 << endl;
        return;
    }
    int ans = 0;
    for (int v = 0; v<n; ++v) ans += c[v] * cnt[v];
    cout << ans << endl;
    for (auto el: cnt) cout << el << ' ';
    cout << endl;
    return;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    for (int test = 0; test<t; ++test) {
        g.clear();
        par.clear();
        res.clear();
        c.clear();
        l.clear();
        r.clear();
        cnt.clear();
        total.clear();
        ok = 0;
        solve();
    }
}
