#include <bits/stdc++.h>
#define int long long
#define endl "\n"
using namespace std;
int INF = 1e9;

template <class T>
istream& operator >> (istream& in, vector <T> &a) {
    for (auto &el: a) in >> el;
    return in;
}

template <class T>
ostream& operator << (ostream& out, vector <T> &a) {
    for (auto &el: a) out << el << " ";
    return out;
}

vector <vector <int> > gr;
vector <int> ans, cost, par, ind;
vector <pair <int, int> > need, dp;
int can = 1;


vector <set <pair <int, int> > > mp;
void dfs(int v) {
    if (!can) return;
    pair <int, int> best = {-1, -1};
    dp[v] = {0, 0};
    for (auto u: gr[v]) {
        dfs(u);
        best = max(best, {mp[ind[u]].size(), u});
        dp[v].first += dp[u].first;
        dp[v].second += dp[u].second;
    }
    if (dp[v].second > need[v].second) can = 0;
    if (best.first == -1) {
        ind[v] = mp.size();
        mp.push_back(*(new set <pair <int, int> >));
    } else {
        ind[v] = ind[best.second];
    }

    int now = ind[v];
    for (auto u: gr[v]) {
        if (u == best.second) continue;
        for (auto el: mp[ind[u]]) {
            mp[now].insert(el);
        }
    }
    mp[now].insert({cost[v], v});

    while (mp[now].size() && dp[v].second < need[v].first) {
        int u = mp[now].begin() -> second;
        int k = INF;
        for (int i = u; i != v; i = par[i]) k = min(k, need[i].second - dp[i].second);

        int d = min(need[v].first - dp[v].second, k);
        dp[v].first += d * cost[u];
        dp[v].second += d;
        ans[u] += d;

        for (int i = u; i != v; i = par[i]) {
            dp[i].second += d;
        }
        if (k == d) mp[now].erase(mp[now].begin());
    }
    if (dp[v].second < need[v].first) can = 0;
}

void solve() {
    int n;
    cin >> n;
    can = 1;
    gr.clear();
    ans.resize(n);
    dp.resize(n);
    ind.resize(n);
    cost.resize(n);
    need.resize(n);
    par.resize(n);
    gr.resize(n);
    mp.clear();

    ind.assign(n, 0);
    ans.assign(n, 0);
    dp.assign(n, {0, 0});

    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        p--;
        gr[p].push_back(i);
        par[i] = p;
    }

    cin >> cost;
    for (int i = 0; i < n; i++) cin >> need[i].first >> need[i].second;

    dfs(0);
    if (!can) {
        cout << -1 << endl;
        return;
    }

    cout << dp[0].first << endl;
    cout << ans << endl;
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t;
    cin >> t;
    while(t--) {
        solve();
    }
}