#include <bits/stdc++.h>
#pragma GCC optimize ("O3,unroll-loops")
//#pragma GCC target("")
//#define int long long
#define ll long long
#define ld long double
#define all(x) x.begin(),x.end()
using namespace std;

inline int getV(int &r,int &c){
    return r*(r+1)/2 + c;
}

inline int getV(pair<int,int> pr){
    auto [r,c] = pr;
    return r*(r+1)/2 + c;
}

const int MAXN = 3000*3000+1;

vector<int> g[MAXN];

vector<int> arr2;
vector<int> arr_res1,arr_res2;
int end_v;

void dfs_find1(int v,int p){
    if((int)arr_res1.size()>0) return;
    arr2.push_back(v);
    if(v == end_v){
        arr_res1 = arr2;
        return;
    }
    for(auto to:g[v]){
        if(to==p) continue;
        if((int)arr_res1.size()>0) return;

        dfs_find1(to,v);
    }
    arr2.pop_back();
}

void dfs_find2(int v,int p){
    if((int)arr_res2.size()>0) return;
    arr2.push_back(v);
    if(v == end_v){
        arr_res2 = arr2;
        return;
    }
    for(auto to:g[v]){
        if(to==p) continue;
        if((int)arr_res2.size()>0) return;

        dfs_find2(to,v);
    }
    arr2.pop_back();
}

signed main() {
    ios::ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef MY_DEBUG
    freopen("input.txt","r",stdin);
#endif

    int n;
    cin>>n;

    vector<int> a(n);
    vector<int> b(n,1);
    vector<pair<int,int> > arr;
    for(int i=0;i<n+1;i++){
        arr.push_back({i,i});
        if(i>0){
            g[getV(arr[i-1])].push_back(getV(arr[i]));
            g[getV(arr[i])].push_back(getV(arr[i-1]));
        }
    }

    pair<int,int> prev_pr,new_pr;
    for(int i=0;i<n;i++){
        cin>>a[i];
        b[a[i]-1] = 0;

        for(int j=a[i];j<=n;j++){
            prev_pr = arr[j-1];
            if(b[j-1] == 1){
                new_pr = {j,prev_pr.second + 1};
            }else{
                new_pr = {j,prev_pr.second};
            }

            arr[j] = new_pr;
            g[getV(arr[j-1])].push_back(getV(arr[j]));
            g[getV(arr[j])].push_back(getV(arr[j-1]));
        }
    }

    int q;
    cin>>q;

    int res;
    for(int _i=0;_i<q;_i++){
        int r1,c1,r2,c2;
        cin>>r1>>c1>>r2>>c2;

        int v1,v2;
        v1 = getV(r1,c1), v2  = getV(r2,c2);

        arr_res1.clear();arr_res2.clear();
        arr2.clear();
        end_v = v1;
        dfs_find1(0,-1);
        end_v = v2;
        arr2.clear();
        dfs_find2(0,-1);

        int id = 0;
        for(int i=0;i<min((int)arr_res1.size(),(int)arr_res2.size());i++){
            if(arr_res1[i]==arr_res2[i]){
                id = i;
            }else{
                break;
            }
        }

        res = arr_res1[id];

        int r = 0;
        while(r*(r+1)/2-1<res){
            r++;
        }

        cout<<r-1<<" "<<res-(r*(r-1)/2)<<"\n";
    }
}
