#include "bits/stdc++.h"

using namespace std;

typedef long long ll;

vector<vector<int>> g;
vector<int> path;
int n;

void build_for_path(int v, int k) {
    int c = v / (n + 1);
    int r = v % (n + 1);
    if(r == n) return;
    r += 1;
    if(path[k] == 1) {
        c += 1;
    }

    int u = c*(n + 1) + r;
    if(g[v].size() == 0 || (g[v].size() == 1 && g[v][0] != u)){
        g[v].push_back(u);
    }
    build_for_path(u, k + 1);
}

vector<int> t;

void dfs(int v) {
    //cout << v << '\n';
    t.push_back(v);
    for(auto u: g[v]) {
        dfs(u);
        t.push_back(v);
    }
    if(g[v].empty()) t.push_back(v);
}


pair<int, int> d[100000000];

void build(int v, int l, int r) {
    if(l + 1 == r) {
        d[v] = {t[l] % (n + 1), l};
        return;
    }
    int m = (l + r) / 2;
    build(2*v + 1, l, m);
    build(2*v + 2, m, r);
    d[v] = min(d[2*v + 1], d[2*v + 2]);
}

pair<int, int> get(int v, int l, int r, int askl, int askr) {
    if(askl <= l && r <= askr) {
        return d[v];
    }
    if(askr <= l || r <= askl) {
        return {1000000000, 0};
    }
    int m = (l + r) / 2;
    return min(get(2*v + 1, l, m, askl, askr), get(2*v + 2, m, r, askl, askr));
}

int main() {
    //cin.tie(); cout.tie(); ios_base::sync_with_stdio(false);
    cin >> n;
    vector<int> a(n);
    for(int i = 0; i < n; ++i) cin >> a[i];
    for(int i = 0; i < n; ++i) path.push_back(1);
    g.resize((n + 1)*(n+1), vector<int>());
    build_for_path(0, 0);
    for(int i = 0; i < n; ++i) {
        path[a[i] - 1] = 0;
        build_for_path(0, 0);
    }

    dfs(0);
    vector<int> cnt(g.size(), 0);
    for(auto x: t) cnt[x]++;

    int k; cin >> k;

    build(0, 0, t.size());

    vector<int> fi(g.size()), se(g.size());

    vector<int> cn(g.size(), 0);

    for(int i = 0; i < t.size(); ++i) {
        cn[t[i]] ++;
        if(cn[t[i]] == 1) fi[t[i]] = i;
        if(cn[t[i]] == cnt[t[i]]) se[t[i]] = i;
    }

    for(int q = 0; q < k; ++q) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        int v = c1*(n + 1) + r1;
        int u = c2*(n + 1) + r2;

        int cnt1 = 0, cnt2 = 0;

        int left = min(fi[v], fi[u]);
        int right = max(se[v], se[u]);

        pair<int, int> pos = get(0, 0, t.size(), left, right + 1);
        int r = t[pos.second] % (n + 1);
        int c = t[pos.second] / (n + 1);

        cout << r << ' ' << c << '\n';
    }

    return 0;
}
/*
3
2 3 1
5
3 3 3 0
2 2 2 1
1 0 3 1
3 1 3 2
2 2 2 2

 */