#include<iostream>
#include<vector>
#include<algorithm>
#include<set>

#define int long long

using namespace std;

int total_cost = 0;

bool fail = false;

set<pair<int, pair<int, int>>> DFS(int v, vector<vector<int>> &g, vector<int> &c, vector<int> &left, vector<int> &right, vector<int> &ans){
    int cnt = 0;
    set<pair<int, pair<int, int>>> p_buy;
    for (int u : g[v]){
        auto res = DFS(u, g, c, left, right, ans);
        for (auto p : res){
            p_buy.insert(p);
        }
        cnt += left[u];
    }
    if (cnt > right[v]){
        fail = true;
        return p_buy;
    }
    p_buy.insert({c[v], {right[v], v}});
    while (cnt < left[v]){
        if (p_buy.size() == 0){
            fail = true;
            return p_buy;
        }
        pair<int, pair<int, int>> p = *p_buy.begin();
        p_buy.erase(p_buy.begin());
        int x = min(left[v] - cnt, p.second.first);
        if (p.second.first > left[v] - cnt){
            p_buy.insert({p.first, {p.second.first - left[v] + cnt, p.second.second}});
        }
        ans[p.second.second] += x;
        cnt += x;
        total_cost += x * p.first;
    }
    return p_buy;
}

signed main(){
    int t;
    cin >> t;
    while(t--){
        int n;
        cin >> n;
        vector<vector<int>> g(n);
        for (int i = 1; i < n; ++i){
            int p;
            cin >> p;
            g[p - 1].push_back(i);
        }
        vector<int> c(n);
        vector<int> left(n);
        vector<int> right(n);
        for (int i = 0; i < n; ++i){
            cin >> c[i];
        }
        for (int i = 0; i < n; ++i){
            cin >> left[i] >> right[i];
        }
        vector<int> ans(n);
        total_cost = 0;
        fail = false;
        DFS(0, g, c, left, right, ans);
        if (fail){
            cout << -1;
            continue;
        }
        cout << total_cost << endl;
        for (int i = 0; i < n; ++i){
            cout << ans[i] << " ";
        }
        cout << endl;
    }
    return 0;
}
/*
2
3
1 1
3 1 2
5 7
1 2
2 4
2
1
5 5
0 1
2 2
*/
