#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define len(x) (int)x.size()

struct st {
  int n;
  vector<int> a;
  st() {}
  st(int n): n(n), a(vector<int>(2 * n)) {}
  void add(int i) {
    for (int j = i + n; j > 0; j /= 2) a[j]++;
  }
  int get(int l, int r, int pos, int tl, int tr) {
  if (r <= l) return 0;
    if (l <= tl && r >= tr) return a[pos];
    int tm = (tl + tr) / 2;
    int res = 0;
    if (l < tm) res += get(l, r, 2 * pos, tl, tm);
    if (r > tm) res += get(l, r, 2 * pos + 1, tm, tr);
    return res;
  }
  int lb(int x) {
    int l = -1, r = x;
    while (r - l > 1) {
      int m = (l + r) / 2;
      if (get(m, x, 1, 0, n) > 0) l = m;
      else r = m;
    }
    return l;
  }
};

void sol() {
  int n;
  cin >> n;
  n++;
  vector<int> a(n), b(n);
  for (int i = 1; i < n; ++i) { cin >> a[i]; b[a[i]] = i; }
  vector<int> p(n), r(n), c(n);
  vector<vector<int>> g(n);
  int k = 1 << (32 - __builtin_clz(n + 1));
  st s(k);
  for (int i = 0; i < n; ++i) {
    p[b[i]] = s.lb(b[i]);
    r[b[i]] = max(0, i - 1);
    c[b[i]] = i - 1 - s.get(0, b[i], 1, 0, k) + 1;
    s.add(b[i]);
    if (p[b[i]] != -1) g[p[b[i]]].push_back(b[i]);
  }
  vector<int> tin(n), h(n), sz(n, 1);
  int timer = 0;
  function<void(int)> dfs = [&](int u) {
    tin[u] = timer++;
    for (auto &v : g[u]) {
      h[v] = h[u] + 1;
      dfs(v);
      sz[u] += sz[v];
      if (sz[v] > sz[g[u][0]]) swap(v, g[u][0]);
    }
  };
  dfs(0);
  int q;
  cin >> q;
  for (int i = 0; i < q; ++i) {
    int r1, c1, r2, c2;
    cin >> r1 >> c1 >> r2 >> c2;
    int p1 = 0, p2 = 0;
    if (r1 == c1) {
      p1 = 0;
    } else {
      for (int i = 1; i < n; ++i) {
        if (a[i] <= r1) p1++;
        if (p1 == r1 - c1) {
          p1 = i;
          break;
        }
      }
    }
    if (r2 == c2) {
      p2 = 0;
    } else {
      for (int i = 1; i < n; ++i) {
        if (a[i] <= r2) p2++;
        if (p2 == r2 - c2) {
          p2 = i;
          break;
        }
      }
    }
    while (p1 != p2) {
      if (h[p1] >= h[p2]) {
        r1 = r[p1];
        c1 = c[p1];
        p1 = p[p1];
      } else {
        r2 = r[p2];
        c2 = c[p2];
        p2 = p[p2];
      }
    }
    cout << (r1 < r2 ? to_string(r1) + " " + to_string(c1) : to_string(r2) + " " + to_string(c2)) << endl;
  }
}

int32_t main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  sol();
  return 0;
}
