#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
using namespace std;

struct dot {
	int x, y;
	dot() {}
	dot(int x, int y) : x(x), y(y) {}
};

int main() {
	int k, nth;
	cin >> k >> nth;

	int t;
	cin >> t;
	while(t--){
		int n, w, h;
		cin >> n >> w >> h;
		vector<pair<int, int>> crd; // -x, y
		for (int i = 0; i < n; i++) {
			int x, y;
			cin >> x >> y;
			crd.push_back({ -x, y });
		}
		sort(crd.begin(), crd.end());
		int px = -1;
		vector <pair<long long,pair<int, int>>> st;
		long long S = 0;
		for (auto c : crd) {
			long long x = -c.first;
			long long y = c.second;
			if (px == x)
				continue;
			px = x;
			while (!st.empty() && st.back().second.second > y) {
				S -= st.back().first;
				st.pop_back();
			}
			long long dh = h - y;
			long long dw = (st.empty() ? w : st.back().second.first) - x;
			S += dw * dh;
			st.push_back({ dw * dh, {x, y} });
		}
		cout << S;
	}

}
