#pragma GCC optimize("Ofast", "unroll-loops")
#pragma GCC targer("avx2", "popcnt")
#include<bits/stdc++.h>

using namespace std;

//#define int long long
#define fi first
#define se second
#define pii pair<int, int>
#define pb push_back
#define forn(i, n) for (int i = 0; i < n; i++)
#define ld long double
#define sz(x) (int) (x).size()
#define all(x) (x).begin(), (x).end()

struct node {
    int x, d = 0, l = 0, r = 0;
    node() {}
};

const int M = 2e7;
node mas[M];
int c = 0;
vector<int> root;

int create() {
    c++;
    mas[c].d = 0;
    return c;
}

int build(int l, int r) {
    int v = create();
    if (l + 1 == r) {
        mas[v].x = l;
        return v;
    }
    int m = (l + r) / 2;
    mas[v].l = build(l, m);
    mas[v].r = build(m, r);
    return v;
}

void update(int v, int l, int r, int l1, int r1) {
    if (l1 >= r || l >= r1) {
        return;
    }
    if (l1 <= l && r <= r1) {
        mas[v].d -= 1;
        return;
    }
    int m = (l + r) / 2;
    update(mas[v].l, l, m, l1, r1);
    update(mas[v].r, m, r, l1, r1);
}

int get(int v, int l, int r, int i) {
    int res = mas[v].d;
    if (l + 1 == r) {
        //cout << v << "F" << endl;
        return res + mas[v].x;
    }
    int m = (l + r) / 2;
    if (i < m) {
        return res + get(mas[v].l, l, m, i);
    } else {
        return res + get(mas[v].r, m, r, i);
    }
}

const int N = 500022, K = 20;
int n, q, a[N];
pii dp[N][K];
int lg[N];

int get(pii x) {
    if (x.se == x.fi) {
        return 0;
    }
    int l = 0, r = n;
    while (l + 1 < r) {
        int m = (l + r) / 2;
        if (get(root[m], 0, n + 1, x.fi) > x.se) {
            l = m;
        } else {
            r = m;
        }
    }
    return r;
}

int get2(pii x) {
    int l = 0, r = n + 1;
    while (l + 1 < r) {
        int m = (l + r) / 2;
        if (get(root[m], 0, n + 1, x.fi) >= x.se) {
            l = m;
        } else {
            r = m;
        }
    }
    return l;
}

pii getmin(int l, int r) {
    int g = lg[r - l + 1];
    return min(dp[l][g], dp[r - (1 << g) + 1][g]);
}

pii V[N], U[N];
int calct[N][2], calct2[N][2], id[N], pos[N];
pii answer[N];
vector<int> qu[N];

struct seg {
    int t[4 * N], d[4 * N];
    seg() {}

    void build() {
        fill(t, t + 4 * N, 0);
    }

    void update(int v, int l, int r, int i, int x) {
        if (l + 1 == r) {
            t[v] += x;
            return;
        }
        int m = (l + r) / 2;
        if (i < m) update(v * 2 + 1, l, m, i, x);
        else update(v * 2 + 2, m, r, i, x);
        t[v] = t[v * 2 + 1] + t[v * 2 + 2];
    }

    int solve(int v, int l, int r, int x) {
        if (l + 1 == r) {
            if (t[v] < x) return n + 1;
            return l;
        }
        int m = (l + r) / 2;
        if (t[v * 2 + 1] >= x) {
            return solve(v * 2 + 1, l, m, x);
        } else {
            return solve(v * 2 + 2, m, r, x - t[v * 2 + 1]);
        }
    }
};

seg T;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    root.pb(build(0, n + 1));
    //forn (i, n + 1) cout << get(root[0], 0, n + 1, i) << " "; cout << endl;
    forn (i, n) {
        cin >> a[i];
        pos[a[i]] = i + 1;
        update(root.back(), 0, n + 1, a[i], n + 1);
        dp[i][0] = {a[i] - 1, get(root.back(), 0, n + 1, a[i] - 1)};
    }
    //for (auto v : root) {
        //forn (i, n + 1) cout << get(v, 0, n + 1, i) << " "; cout << endl;
    //}
    //return 0;
    for (int i = 2; i < N; i++) lg[i] = lg[i / 2] + 1;
    for (int j = 1; j <= lg[n]; j++) {
        for (int i = 0; i + (1 << j) - 1 < n; i++) {
            dp[i][j] = min(dp[i][j - 1], dp[i + (1 << (j - 1))][j - 1]);
        }
    }
    cin >> q;
    forn (i, q) {
        pii v, u;
        cin >> v.fi >> v.se >> u.fi >> u.se;
        if (v.fi > u.fi) swap(v, u);
        V[i] = v, U[i] = u;
        //calct[i][0] = get(v), calct[i][1] = get(u);
        //calct2[i][0] = get2(v), calct2[i][1] = get(u);
    }
    iota(id, id + q, 0);
    sort(id, id + q, [&] (int i, int j) {
        return V[i].fi < V[j].fi;
    });
    T.build();
    int j = 0;
    for (int x = 1; x <= n; x++) {
        T.update(0, 0, n + 1, pos[x], 1);
        while (j < q && V[id[j]].fi <= x) {
            pii v = V[id[j]];
            if (v.fi == v.se) {
                calct[id[j]][0] = 0;
            } else {
                int need = v.fi - v.se;
                calct[id[j]][0] = T.solve(0, 0, n + 1, need);
            }
            j++;
        }
    }
    iota(id, id + q, 0);
    sort(id, id + q, [&] (int i, int j) {
        return U[i].fi < U[j].fi;
    });
    T.build();
    j = 0;
    for (int x = 1; x <= n; x++) {
        T.update(0, 0, n + 1, pos[x], 1);
        while (j < q && U[id[j]].fi <= x) {
            pii v = U[id[j]];
            if (v.fi == v.se) {
                calct[id[j]][1] = 0;
            } else {
                int need = v.fi - v.se;
                //cout << x << " " << id[j] << " F " << need << endl;
                calct[id[j]][1] = T.solve(0, 0, n + 1, need);
                if (id[j] == 0) {
                    //cout << T.solve(0, 0, n + 1, need) << endl;
                }
            }
            j++;
        }
    }
    iota(id, id + q, 0);
    sort(id, id + q, [&] (int i, int j) {
        return V[i].fi < V[j].fi;
    });
    T.build();
    j = 0;
    for (int x = 1; x <= n; x++) {
        T.update(0, 0, n + 1, pos[x], 1);
        while (j < q && V[id[j]].fi <= x) {
            pii v = V[id[j]];
            int need = v.fi - v.se;
            calct2[id[j]][0] = T.solve(0, 0, n + 1, need + 1) - 1;
            j++;
        }
    }
    iota(id, id + q, 0);
    sort(id, id + q, [&] (int i, int j) {
        return U[i].fi < U[j].fi;
    });
    T.build();
    j = 0;
    for (int x = 1; x <= n; x++) {
        T.update(0, 0, n + 1, pos[x], 1);
        while (j < q && U[id[j]].fi <= x) {
            pii v = U[id[j]];
            int need = v.fi - v.se;
            calct2[id[j]][1] = T.solve(0, 0, n + 1, need + 1) - 1;
            j++;
        }
    }
    forn (i, q) {
        int t = calct[i][0], t2 = calct[i][1];
        pii v = V[i], u = U[i];
        //cout << v.fi << " " << v.se << " " << calct2[i][0] << endl;
        //cout << u.fi << " " << u.se << " " << calct2[i][1] << endl;
        //assert(calct2[i][0] == slowget2(v));
        //assert(calct2[i][1] == slowget2(u));
        if (t == t2) {
            answer[i] = v;
            continue;
        }
        if (t > t2) {
            swap(t, t2);
            swap(v, u);
            swap(calct2[i][0], calct2[i][1]);
        }
        V[i] = v;
        qu[t2].push_back(i);
        t = calct2[i][0];
        //assert(t == slowget2(v));
        //cout << v.fi << " A " << v.se << endl;
        //cout << t << " " << t2 << endl;
        int L = t, R = t2 - 1;
        if (L > R) continue;
        pii ans = getmin(L, R);
        answer[i] = ans;
    }
    root.back() = build(0, n + 1);
    //forn (i, n + 1) cout << get(root[0], 0, n + 1, i) << " "; cout << endl;
    forn (i, n + 1) {
        if (i) update(root.back(), 0, n + 1, a[i - 1], n + 1);
        for (auto j : qu[i]) {
            pii v = V[j];
            if (get(root.back(), 0, n + 1, v.fi) == v.se) {
                answer[j] = v;
            }
        }
    }
    forn (i, q) {
        pii ans = answer[i];
        cout << ans.fi << " " << ans.se << '\n';
    }
}
