#include <bits/stdc++.h>
using namespace std;

int t = 0;
const int lg = 25;
vector <vector <int>> g;
vector <int> tin, tout;

void dfs(int v, int p) {
    tin[v] = t;
    t += 1;

    for (auto u : g[v]) {
        if (u != p) {
            dfs(u, v);
        }
    }
    tout[v] = t;
    t += 1;
}

bool check(int v, int u) {
    return tin[v] <= tin[u] && tout[u] <= tout[v];
}

long long get(int k, int u, int v, int p) {
    for (auto h : g[k]) {
        if (h != p && check(h, u) && check(h, v)) {
            return get(h, u, v, k);
        }
    }
    return k;
}

bool ok(int u, int v) {
    for (auto i : g[u]) {
        if (v == i) {
            return false;
        }
    }
    return true;
}

int main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(0);
    //cout.tie(0);
    long long n;
    cin >> n;

    vector <long long> a(n);
    n += 1;
    for (int i = 0; i < n - 1; ++i) {
        cin >> a[i];
    }
    vector <int> c(n, 1);
    g.resize(n * n);
    long long k = 0;
    for (int i = 1; i < n; ++i) {
        g[(i - 1) * n + i - 1].push_back(i * n + i);
        g[i * n + i].push_back((i - 1) * n + i - 1);
    }
    for (int i = 0; i < n - 1; ++i) {
        c[a[i] - 1] ^= 1;
        k = 0;
        long long h = 0;
        for (int j = 0; j < n - 1; ++j) {
            if (c[j] == 1) {
                if (ok(k * n + h, (k + 1) * n + h + 1)) {
                    g[k * n + h].push_back((k + 1) * n + h + 1);
                    g[k * n + h + n + 1].push_back(k * n + h);
                }
                h += 1;
            }
            else {
                if (ok(k * n + h, (k + 1) * n + h)) {
                    g[k * n + h].push_back((k + 1) * n + h);
                    g[(k + 1) * n + h].push_back(k * n + h);
                }
            }
            k += 1;
        }
    }

    tin.resize(n * n);
    tout.resize(n * n);
    dfs(0, 0);
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int x, y, k, h;
        cin >> x >> y >> k >> h;
        long long p = get(0, x * n + y, k * n + h, -1);
        cout << p / n << ' ' << p % n << '\n';
    }
}
