#include <bits/stdc++.h>

using namespace std;

#define int long long

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n;
	cin >> n;

	vector<int> xx(n);
	for(int& x: xx) {
		cin >> x;
		x--;
	}

	auto yy = xx;
	sort(yy.begin(), yy.end());
	vector<int> pos_of(n);
	for(int i = 0; i < n; i++) {
		pos_of[yy[i]] = i;
	}

	vector<int> max_pos_b(n);
	for(int b = 0; b < n; b++) {
		auto yy = xx;
		sort(yy.begin() + b, yy.end());
		max_pos_b[b] = find(yy.begin(), yy.end(), xx[b]) - yy.begin();
	}

	int ans = 0;
	for(int a = 0; a < n; a++) {
		auto yy = xx;
		sort(yy.begin(), yy.begin() + a + 1);
		int min_pos_a = find(yy.begin(), yy.end(), xx[a]) - yy.begin();

		for(int b = a + 1; b < n; b++) {
			int cur = 0;

			// Case 1: sort nothing
			cur = max(cur, b - a);

			// Case 2: sort segment containing b
			cur = max(cur, b - min_pos_a);

			// // Case 3: sort segment containing b
			cur = max(cur, max_pos_b[b] - a);

			// Case 4: sort segment containing both a and b
			cur = max(cur, abs(pos_of[xx[b]] - pos_of[xx[a]]));

			ans += cur;
		}
	}

	cout << ans << endl;

	return 0;
}