#ifdef LOCAL
//#define _GLIBCXX_DEBUG
#endif
#pragma GCC optimize("Ofast,unroll-loops,fast-math,inline,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

#define int ll

const int INF = 1e18;

#define endl '\n'

vector<int> allowed;
vector<vector<int>> all;

vector<int> cur;

void gen(int n) {
    if (n == 0) {
        all.push_back(cur);
    } else {
        for (int el : allowed) {
            cur.push_back(el);
            gen(n - 1);
            cur.pop_back();
        }
    }
}

void solve() {
    assert(allowed.size() == 4);
    int n, w, h;
    cin >> n >> w >> h;
    vector<pair<int, int>> arr(n);
    for (int i = 0; i < n; i++) {
        cin >> arr[i].first >> arr[i].second;
    }
    all.clear();
    ll max_ans = 0;
    if (n >= 4) {
        cout << (ll) w * h << endl;
        return;
    }
    gen(n);    
    for (auto dir : all) {
        vector<array<int, 4>> qq;
        for (int i = 0; i < n; i++) {
            if (dir[i] == 1) {
                qq.push_back({arr[i].first, w, arr[i].second, h});
            } else if (dir[i] == 2) {
                qq.push_back({0, arr[i].first, arr[i].second, h});
            } else if (dir[i] == 3) {
                qq.push_back({0, arr[i].first, 0, arr[i].second});
            } else if (dir[i] == 4) {
                qq.push_back({arr[i].first, w, 0, arr[i].second});
            } else {
                assert(false);
            }
        }
        ll ans = 0;
        for (int mask = 1; mask < (1 << n); mask++) {
            char b = false;
            int mnx = INF;
            int mny = INF;
            int mxx = -INF;
            int mxy = -INF;
            for (int i = 0; i < n; i++) {
                if (mask & (1 << i)) {
                    b ^= 1;
                    mxx = max(mxx, qq[i][0]);
                    mxy = max(mxy, qq[i][2]);
                    mnx = min(mnx, qq[i][1]);
                    mny = min(mny, qq[i][3]);
                }
            }
            ll area = max(0LL, mnx - mxx) * max(0LL, mny - mxy);
            if (b) {
                ans += area;
            } else {
                ans -= area;
            }
        }
        max_ans = max(max_ans, ans);
    }
    cout << max_ans << endl;
    //assert(max_ans == w * h);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int k;
    cin >> k;
    allowed.resize(k);
    for (int &el : allowed)
        cin >> el;
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
