#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

typedef long long ll;
typedef long double ld;

const int SZ = 3010;
int bst[SZ][SZ];

int main() {
	fastInp;

	ll n;
	cin >> n;

	vector<ll> vec(n);
	for (auto& c : vec) {
		cin >> c;
		c--;
	}

	vector<ll> cur = vec;

	for (int i = 0; i < cur.size() - 1; i++) {
		int t = i;
		for (int j = i; j > 0; j--) {
			if (cur[j] < cur[j - 1]) {
				swap(cur[j], cur[j - 1]);
				t--;
			}
		}

		for (int j = i; j >= 0; j--) {
			bst[cur[i + 1]][cur[j]] = max(bst[cur[i + 1]][cur[j]], i + 1 - j);
 		}

		for (int j = i; j < n; j++) {
			bst[cur[t]][cur[j]] = max(bst[cur[t]][cur[j]], j - t);
		}
	}

	cur = vec;

	reverse(cur.begin(), cur.end());

	for (int i = 0; i < cur.size() - 1; i++) {
		int t = i;
		for (int j = i; j > 0; j--) {
			if (cur[j] > cur[j - 1]) {
				swap(cur[j], cur[j - 1]);
				t--;
			}
		}

		for (int j = i; j >= 0; j--) {
			bst[cur[i + 1]][cur[j]] = max(bst[cur[i + 1]][cur[j]], i + 1 - j);
		}

		for (int j = i; j < n; j++) {
			bst[cur[t]][cur[j]] = max(bst[cur[t]][cur[j]], j - t);
		}
	}

	sort(cur.begin(), cur.end());

	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			int c = bst[cur[i]][cur[j]];
			c = max(c, bst[cur[j]][cur[i]]);
			bst[cur[i]][cur[j]] = max(c, j - i);
		}
	}

	ll ans = 0;

	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) ans += bst[i][j];
	}

	cout << ans << endl;

	return 0;
}

/*
5
5 2 4 1 3
*/