#include <iostream>
#include <algorithm>
#include <math.h>
#include <map>
#include <vector>
#include <cstring>
#include <queue>
#include <set>
using namespace std;
#define ll long long
#define ld long double
#define vl vector<ll>
#define vvl vector<vl>
#define ii pair<ll, ll>
#define vp vector<ii>
#define vvp vector<vp>
const ll INF = (ll)1e17;
const ll MOD = (ll)1e9 + 7;
vvl matrix;
ll price[100001];
ii zn[100001];
bool really = true;
vvl dp;
vector<vvl> tec_dp;
vector<vvp> per;
ll get_ans[100001];
ll n;
void dfs(ll v) {
	ll maxs = zn[v].second;
	tec_dp[v].resize((ll)matrix[v].size() + 1, vl(maxs+1, INF));
	dp[v].resize(maxs + 1);
	per[v].resize((ll)matrix[v].size() + 1, vp(maxs+1));
	for (ll i = 0; i <= maxs; i++) tec_dp[v][0][i] = price[v] * i;
	ll j = 1;
	for (auto i : matrix[v]) {
		dfs(i);
		for (ll last_val = 0; last_val <= maxs; last_val++) {
			for (ll f = zn[i].first; f <= zn[i].second; f++) {
				if (last_val + f > maxs || dp[i][f] >= INF) continue;
				if (tec_dp[v][j - 1][last_val] + dp[i][f] < tec_dp[v][j][last_val + f]) {
					tec_dp[v][j][last_val + f] = min(tec_dp[v][j][last_val + f], tec_dp[v][j - 1][last_val] + dp[i][f]);
					per[v][j][last_val + f] = { i, f };
				}
			}
		}
		j++;
	}
	for (ll i = zn[v].first; i <= zn[v].second; i++) dp[v][i] = tec_dp[v][(ll)matrix[v].size()][i];
}
void get_val(ll v, ll val) {
	ll tec_val = val;
	for (ll j = (ll)matrix[v].size(); j >= 1; j--) {
		get_val(per[v][j][tec_val].first, per[v][j][tec_val].second);
		tec_val -= per[v][j][tec_val].second;
	}
	get_ans[v] = tec_dp[v][0][tec_val] / price[v];
}

bool fl = true;
vector<vector<pair<ll, ll>>> result;
vector<multiset<ii>> mb;
void dfs2(ll v) {
	for (auto i : matrix[v]) {
		dfs2(i);
		for (auto j : result[i]) {
			result[v].push_back(j);
		}
		for (auto j : mb[i]) {
			mb[v].insert(j);
			if ((ll)result[v].size() + (ll)mb[v].size() > zn[v].second) mb[v].erase(--mb[v].end());
		}
	}
	if (zn[v].second) mb[v].insert({ price[v], v });
	if ((ll)result[v].size() + (ll)mb[v].size() > zn[v].second) mb[v].erase(--mb[v].end());
	while ((ll)result[v].size() < zn[v].first && !mb[v].empty()) {
		auto add = *mb[v].begin();
		if (zn[v].second && make_pair(price[v], v) < add) add = min(add, { price[v], v });
		else mb[v].erase(--mb[v].end());
		result[v].push_back(add);
	}
	if ((ll)result[v].size() > zn[v].second || (ll)result[v].size() < zn[v].first) {
		fl = false;
		return;
	}
}

void solve2() {
	result.clear();
	mb.clear();
	result.resize(n + 1);
	mb.resize(n + 1);
	matrix.clear();
	matrix.resize(n + 1);
	tec_dp.clear();
	tec_dp.resize(n + 1);
	per.clear();
	per.resize(n + 1);
	for (ll i = 2; i <= n; i++) {
		ll x;
		cin >> x;
		matrix[x].push_back(i);
	}
	really = true;
	for (ll i = 1; i <= n; i++) cin >> price[i];
	for (ll i = 1; i <= n; i++) {
		ll l, r;
		cin >> l >> r;
		zn[i] = { l, r };
	}
	fl = true;
	dfs2(1);
	if (!fl) {
		cout << -1 << '\n';
		return;
	}
	ll ans_x = 0;
	vl zn(n + 1);
	for (auto i : result[1]) {
		ans_x += i.first;
		zn[i.second] = 1;
	}
	cout << ans_x << '\n';
	for (ll i = 1; i <= n; i++) cout << zn[i] << ' ';
	cout << '\n';
}
void solve() {
	cin >> n;
	if (n > 500) {
		solve2();
		return;
	}
	matrix.clear();
	matrix.resize(n + 1);
	tec_dp.clear();
	tec_dp.resize(n + 1);
	per.clear();
	per.resize(n + 1);
	for (ll i = 2; i <= n; i++) {
		ll x;
		cin >> x;
		matrix[x].push_back(i);
	}
	really = true;
	for (ll i = 1; i <= n; i++) cin >> price[i];
	for (ll i = 1; i <= n; i++) {
		ll l, r;
		cin >> l >> r;
		zn[i] = { l, r };
	}
	dp.clear();
	dp.resize(n + 1);
	dfs(1);
	ll ans = INF;
	ll val = -1;
	for (ll i = zn[1].first; i <= zn[1].second; i++) {
		if (dp[1][i] < ans) {
			ans = min(ans, dp[1][i]);
			val = i;
		}
	}
	if (ans >= INF) {
		cout << -1 << '\n';
		return;
	}
	cout << ans << '\n';
	get_val(1, val);
	for (ll i = 1; i <= n; i++) cout << get_ans[i] << ' ';
	cout << '\n';
}
int main()
{
	ll t;
	cin >> t;
	while (t--)
		solve();
}