#include <iostream>
#include <iomanip>

#include <algorithm>

#include <vector>
#include <string>
#include <set>
#include <map>

#include <unordered_map>

using namespace std;

#define sz(x) ((int)(x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;

int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);

	int n; cin >> n;
	vector<int> a(n);
	for (auto& c : a) {
		cin >> c;
	}
	int q; cin >> q;
	while (q--) {
		int r1, c1; cin >> r1 >> c1;
		int r2, c2; cin >> r2 >> c2;

		int x1 = c1 + n - r1, x2 = c2 + n - r2;
		if (x1 == x2) {
			if (r1 < r2) {
				cout << r1 << ' ' << c1 << '\n';
			}
			else {
				cout << r2 << ' ' << c2 << '\n';
			}
		}
		else {
			if (x1 > x2) {
				swap(r1, r2);
				swap(c1, c2);
				swap(x1, x2);
			}

			cout << 0 << ' ' << x2 - n << '\n';
		}
	}
	return 0;
}