#include <iostream>
#include <vector>

using namespace std;

const int INF = int(1e9) + 7;

void print_ans(int r, int c) {
	cout << r << " " << r - c << "\n";
}

int main() {
	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		a[i]--;
	}
	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		int r1, c1, r2, c2;
		cin >> r1 >> c1 >> r2 >> c2;
		c1 = r1 - c1, c2 = r2 - c2;
		int cnt_less_1 = 0, cnt_less_2 = 0, mn1 = INF, mx1 = -INF, mn2 = INF, mx2 = -INF;
		if (c1 == 0) {
			mn1 = mx1 = 0;
		}
		if (c2 == 0) {
			mn2 = mx2 = 0;
		}
		for (int j = 0; j < n; j++) {
			if (a[j] < r1) {
				cnt_less_1++;
			}
			if (a[j] < r2) {
				cnt_less_2++;
			}
			if (cnt_less_1 == c1) {
				mn1 = min(mn1, j + 1);
				mx1 = max(mx1, j + 1);
			}
			if (cnt_less_2 == c2) {
				mn2 = min(mn2, j + 1);
				mx2 = max(mx2, j + 1);
			}
		}
		// cout << "t1 = {" << mn1 << ", " << mx1 << "}\n";
		// cout << "t2 = {" << mn2 << ", " << mx2 << "}\n";
		if (max(mn1, mn2) <= min(mx1, mx2)) {
			if (r1 < r2) {
				print_ans(r1, c1);
			}
			else {
				print_ans(r2, c2);
			}
		}
		else {
			int r = max(mn1, mn2), l = min(mx1, mx2), res = l;
			for (int j = l; j < r; j++) {
				if (a[j] < a[res]) {
					res = j;
				}
			}
			int c = 0;
			for (int j = 0; j < res; j++) {
				c += (a[j] < a[res]);
			}
			print_ans(a[res], c);
		}
	}
}
