#include <bits/stdc++.h>
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;

int mdist(int l1, int r1, int l2, int r2) {
    if (l1 > r1)
        swap(l1, r1);
    if (l2 > r2)
        swap(l2, r2);
    return max(abs(l1 - r2), abs(r1 - l2));
}

signed main() {
    int n;
    cin >> n;
    vector<int> p(n);
    for (int & i : p)
        cin >> i;
    vector<int> mxpos(n);
    for (int i = 0; i < n; ++i) {
        int less = 0;
        for (int j = i + 1; j < n; ++j) {
            less += p[j] < p[i];
        }
        mxpos[i] = i + less;
    }
    vector<int> mnpos(n);
    for (int i = 0; i < n; ++i) {
        int more = 0;
        for (int j = i - 1; j >= 0; --j) {
            more += p[j] > p[i];
        }
        mnpos[i] = i - more;
    }
    long long sum = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            int mx = mdist(mnpos[i], mnpos[i], j, j);
            mx = max(mx, mdist(i, i, mxpos[j], mxpos[j]));
            mx = max(mx, abs(p[i] - p[j]));
            sum += mx;
        }
    }
    cout << sum << '\n';
}
