#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("avx2")

typedef long long ll;
typedef long double ld;

#define int ll

#define pb push_back
#define f first
#define s second
#define pii pair<int, int>

const int N = 1e5 + 10, inf = 1e18;
vector<int> g[N];
set<pii > cs[N];
int c[N], l[N], r[N], kolvo[N], par[N], sum[N];
bool bl = 0;

int get_kolvo(int u, int v) {
    int mn = inf;
    while (u != v) {
        mn = min(mn, r[u] - kolvo[u]);
        u = par[u];
    }
    mn = min(mn, r[u] - kolvo[u]);
    return mn;
}

void do_sum(int u, int v, int k){
    while (u != v) {
        kolvo[u] += k;
        u = par[u];
    }
    kolvo[u] += k;
}

void dfs(int v) {
    for (auto u: g[v])
        dfs(u);
    for (auto u: g[v]) {
        kolvo[v] += kolvo[u];
        sum[v] += sum[u];
    }
    int now = -1;
    for (auto u: g[v]) {
        if (now == -1)
            now = u;
        else {
            if (cs[now].size() < cs[u].size())
                now = u;
        }
    }
    swap(cs[now], cs[v]);
    cs[v].insert({c[v], v});
    for (auto u: g[v]) {
        if (now == u)
            continue;
        for (auto x: cs[u])
            cs[v].insert(x);
    }
    if (kolvo[v] > r[v]){
        bl = 1;
        return;
    }
    while (kolvo[v] < l[v]) {
        auto u = cs[v].begin()->s;
        int k = get_kolvo(u, v);
        if (kolvo[v] + k <= l[v]) {
            do_sum(u, v, k);
            cs[v].erase({c[u], u});
            sum[v] += k * c[u];
        } else {
            k = l[v] - kolvo[v];
            do_sum(u, v, k);
            sum[v] += k * c[u];
        }
    }
}

void del(int v){
    for (auto u : g[v])
        kolvo[v] -= kolvo[u];
    for (auto u : g[v])
        del(u);
}

void solve() {
    int n, p;
    cin >> n;
    bl = 0;
    for (int i = 0; i < n; i++) {
        g[i].clear();
        cs[i].clear();
        c[i] = l[i] = r[i] = sum[i] = par[i] = kolvo[i] = 0;
    }
    for (int i = 1; i < n; i++) {
        cin >> p;
        p--;
        par[i] = p;
        g[p].pb(i);
    }
    for (int i = 0; i < n; i++) {
        cin >> c[i];
    }
    for (int i = 0; i < n; i++)
        cin >> l[i] >> r[i];
    dfs(0);
    del(0);
    if (bl){
        cout << -1 << endl;
        return;
    }
    cout << sum[0] << endl;
    for (int i = 0; i < n; i++)
        cout << kolvo[i] << ' ';
    cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
