#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("avx2")

typedef long long ll;
typedef long double ld;

#define int ll

#define pb push_back
#define f first
#define s second
#define pii pair<int, int>

const int N = 1e5 + 10, inf = 1e18;
vector<int> g[N];
set<pii > cs[N];
int c[N], l1[N], r1[N], kolvo[N], par[N], sum[N], answer[N];
bool bl = 0;
int my_t[N], sz[N], num[N], sz_comp[N];
vector<int> t[N];
vector<int> add[N];
vector<int> arr[N];

void build_t(int v, int l, int r, int tp) {
    if (l == r - 1) {
        t[tp][v] = arr[tp][l];
    } else {
        int mid = (r + l) / 2;
        build_t(2 * v + 1, l, mid, tp);
        build_t(2 * v + 2, mid, r, tp);
        t[tp][v] = min(t[tp][2 * v + 1], t[tp][2 * v + 2]);
    }
}

int get(int v, int l, int r, int tl, int tr, int tp) {
    push(v, l, r, tp);
    if (tl <= l && tr >= r) {
        return t[tp][v];
    }
    if (tl >= r || tr <= l)
        return inf;
    int mid = (r + l) / 2;
    return min(get(2 * v + 1, l, mid, tl, tr, tp), get(2 * v + 2, mid, r, tl, tr, tp));
}

void push(int v, int l, int r, int tp) {
    t[tp][v] += add[tp][v];
    if (l != r - 1) {
        add[tp][2 * v + 1] += add[tp][v];
        add[tp][2 * v + 2] += add[tp][v];
    }
    add[tp][v] = 0;
}

void update(int v, int l, int r, int tl, int tr, int val, int tp) {
    push(v, l, r, tp);
    if (tl <= l && tr >= r) {
        add[tp][v] += val;
        push(v, l, r, tp);
        return;
    }
    if (tl >= r || tr <= l)
        return;
    int mid = (r + l) / 2;
    update(2 * v + 1, l, mid, tl, tr, val, tp);
    update(2 * v + 2, mid, r, tl, tr, val, tp);
    t[tp][v] = min(t[tp][2 * v + 1], t[tp][2 * v + 2]);
}

void build(int v) {
    sz[v] = 1;
    for (auto u: g[v])
        build(u);
    for (auto u: g[v])
        sz[v] += sz[u];
}

void give_t(int v, int p, int i) {
    my_t[v] = p;
    arr[my_t[v]].pb(r1[v]);
    sz_comp[my_t[v]]++;
    num[v] = i;
    for (auto u: g[v]) {
        if (sz[u] * 2 >= sz[v])
            give_t(u, p, i + 1);
        else
            give_t(u, u, 0);
    }
}

int get_kolvo(int u, int v) {
    int mn = inf;
    while (my_t[u] != my_t[v]) {
        mn = min(mn, get(0, 0, sz_comp[my_t[u]], 0, num[u] + 1, my_t[u]));
        u = par[my_t[u]];
    }
    mn = min(mn, get(0, 0, sz_comp[my_t[u]], min(num[v], num[u]), max(num[v], num[u]) + 1, my_t[u]));
//    while (u != v) {
//        mn = min(mn, get(0, 0, sz_comp[my_t[u]], num[u], num[u] + 1, my_t[u]));
//        u = par[u];
//    }
//    mn = min(mn, get(0, 0, sz_comp[my_t[u]], num[u], num[u] + 1, my_t[u]));
    return mn;
}

void do_sum(int u, int v, int k) {
    while (my_t[u] != my_t[v]) {
        update(0, 0, sz_comp[my_t[u]], 0, num[u] + 1, -k, my_t[u]);
        u = par[my_t[u]];
    }
    update(0, 0, sz_comp[my_t[u]], min(num[v], num[u]), max(num[v], num[u]) + 1, -k, my_t[u]);
//    while (u != v) {
//        update(0, 0, sz_comp[my_t[u]], num[u], num[u] + 1, -k, my_t[u]);
//        u = par[u];
//    }
//    update(0, 0, sz_comp[my_t[u]], num[u], num[u] + 1, -k, my_t[u]);
}

void dfs(int v) {
//    cout << v << endl;
    for (auto u: g[v])
        dfs(u);
    for (auto u: g[v]) {
        kolvo[v] += kolvo[u];
        sum[v] += sum[u];
    }
    int now = -1;
    for (auto u: g[v]) {
        if (now == -1)
            now = u;
        else {
            if (cs[now].size() < cs[u].size())
                now = u;
        }
    }
    swap(cs[now], cs[v]);
    cs[v].insert({c[v], v});
    for (auto u: g[v]) {
        if (now == u)
            continue;
        for (auto x: cs[u])
            cs[v].insert(x);
    }
    if (kolvo[v] > r1[v] || bl) {
        bl = 1;
        return;
    }
    int tp = my_t[v];
    update(0, 0, sz_comp[tp], num[v], num[v] + 1, -kolvo[v], tp);
    while (kolvo[v] < l1[v]) {
        auto u = cs[v].begin()->s;
        int k = get_kolvo(u, v);
        if (kolvo[v] + k <= l1[v]) {
            kolvo[v] += k;
            answer[u] += k;
            do_sum(u, v, k);
            cs[v].erase({c[u], u});
            sum[v] += k * c[u];
        } else {
            k = l1[v] - kolvo[v];
            kolvo[v] += k;
            answer[u] += k;
            do_sum(u, v, k);
            sum[v] += k * c[u];
        }
    }
}

void del(int v) {
    for (auto u: g[v])
        kolvo[v] -= kolvo[u];
    for (auto u: g[v])
        del(u);
}

void clear(int n) {
    for (int i = 0; i < n; i++) {
        g[i].clear();
        cs[i].clear();
        t[i].clear();
        add[i].clear();
        arr[i].clear();
        c[i] = l1[i] = r1[i] = sum[i] = par[i] = kolvo[i] = my_t[i] = sz[i] = num[i] = sz_comp[i] = answer[i] = 0;
    }
}

void solve() {
    int n, p;
    cin >> n;
    bl = 0;
    clear(n);
    for (int i = 1; i < n; i++) {
        cin >> p;
        p--;
        par[i] = p;
        g[p].pb(i);
    }
    for (int i = 0; i < n; i++) {
        cin >> c[i];
    }
    for (int i = 0; i < n; i++)
        cin >> l1[i] >> r1[i];
    build(0);
    give_t(0, 0, 0);
    for (int i = 0; i < n; i++) {
        if (sz_comp[i]) {
            for (int j = 0; j < 4 * sz_comp[i]; j++)
                t[i].pb(0);
            for (int j = 0; j < 4 * sz_comp[i]; j++)
                add[i].pb(0);
            build_t(0, 0, sz_comp[i], i);
        }
    }
    dfs(0);
    if (bl) {
        cout << -1 << endl;
        return;
    }
    cout << sum[0] << endl;
    for (int i = 0; i < n; i++)
        cout << answer[i] << ' ';
    cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
