#include <bits/stdc++.h>

using namespace std;

#define int long long
#define vi vector<int>
#define pii pair<int, int>

const int N = 2e5;

vi a[N];
vi c, l, r;
vi par, cnt;

pair<int, pii> find(int v) {
    pair<int, pii> ans = {c[v], {v, r[v] - cnt[v]}};
    for (auto u : a[v]) {
        if (cnt[u] == r[u]) continue;
        ans = min(ans, find(u));
    }
    ans.second.second = min(ans.second.second, r[v] - cnt[v]);
    return ans;
}

bool bad = 0;

void dfs(int v) {
    int suml = 0;
    for (auto u : a[v]) {
        suml += l[u];
        dfs(u);
        if (bad) return;
    }
    if (suml > l[v]) {
        bad = 1;
        return;
    }
    for (auto u : a[v]) {
        cnt[v] += cnt[u];
    }
    while (cnt[v] < l[v]) {
        auto res = find(v);
        res.second.second = min(res.second.second, l[v] - cnt[v]);
        int x = res.second.first;
        while (x != par[v]) {
            cnt[x] += res.second.second;
            x = par[x];
        }
    }

}

void solve() {
    int n; cin >> n;
    for (int i = 0; i < n; ++i) {
        a[i].clear();
    }
    bad = 0;
    cnt = l = r = c = vi(n);
    par = vi(n, -1);
    for (int i = 1; i < n; ++i) {
        int p; cin >> p;
        a[--p].push_back(i);
        par[i] = p;
    }
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    dfs(0);
    if (bad) cout << "-1\n";
    else {
        vi res(n);
        int ans = 0;
        for (int i = 0; i < n; ++i) {
            res[i] = cnt[i];
            for (auto j : a[i]) {
                res[i] -= cnt[j];
            }
            ans += res[i] * c[i];
        }
        cout << ans << '\n';
        for (int i = 0; i < n; ++i) {
            cout << res[i] << ' ';
        }
        cout << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    int t; cin >> t;
    while (t--) {
        solve();
    }
}
