#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <stack>
#include <map>
#include <cstdlib>

using namespace std;
#define int long long

vector<int> fenw;

void addp(int beg, int v) {
    for (int i = beg; i < fenw.size(); i = i | (i + 1)) {
        fenw[i] += v;
    }
}

int getp(int beg) {
    int x = 0;
    for (int i = beg; i >= 0; i = (i & (i + 1)) - 1) {
        x += fenw[i];
    }
    return x;
}

void addrng(int l, int r, int v) {
    if (r < 0) return;
    if (l < fenw.size() && l >= 0) addp(l, v);
    if (r >= 0 && r < fenw.size() - 1) addp(r + 1, -v);
}

signed main() {
    int n;
    cin >> n;
    vector<int> mas(n);
    fenw.resize(n, 0);
    int ans = 0;
    //map<pair<int, int>, int> deb;
    vector<int> vi(n + 1);
    for (int i = 0; i < n; i++) {
        cin >> mas[i];
        vi[mas[i]] = i;
    }

    vector<int> ma(n);
    vector<int> mb(n);
    for (int v = n; v >= 1; v--) {
        ma[vi[v]] = getp(vi[v]);
        addrng(vi[v] + 1, n, 1);
    }
    fenw.assign(n, 0);
    for (int v = 1; v <= n; v++) {
        mb[vi[v]] = getp(vi[v]);
        addrng(0, vi[v] - 1, 1);
    }

    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            int a = mas[i];
            int b = mas[j];
            int mova = ma[i];
            int movb = mb[j];
            if (mova != ma[i] || movb != mb[j]) {
                int xxx = 3;
            }
            int add = max(j - i + mova, j - i + movb);
            add = max(add, abs(a - b));
            //deb[{min(a, b), max(a, b)}] = add;
            ans += add;
        }
    }
    /*for (auto& p : deb) {
        cout << p.first.first << ' ' << p.first.second << ' ' << p.second << '\n';
    }*/
    cout << ans;
    return 0;
}
