#include <bits/stdc++.h>
#define int long long
#define x first
#define y second
#pragma GCC optimize("unroll-loops")

using namespace std;

class Node {
public:
    int val;
    int left;
    int right;
    Node *l;
    Node *r;
    Node() {}
    Node(int i, int val):
    val(val),
    left(i),
    right(i + 1),
    l(nullptr),
    r(nullptr)
    {}

    Node(Node* l, Node* r):
    l(l),
    r(r)
    {this->assign();}

    void assign() {
        this->left = this->l->left;
        this->right = this->r->right;
        this->val = this->l->val + this->r->val;
    }
};

Node* build(int n) {
    if (n == 1) {
        return new Node(0LL, 1LL);
    }
    int ns = 1;
    while (ns <= n) {
        ns <<= 1;
    }
    vector<Node*> tree(ns);
    for (int i = 0; i < ns; ++i) {
        tree[i] = new Node(i, 1LL);
    }
    for (int i = ns - 1; i; --i) {
        tree[i] = new Node(tree[(2 * i) % ns], tree[(2 * i + 1) % ns]);
    }
    return tree[1];
}

int gett(Node *v, int left, int right) {
    if (!v) {
        return 0;
    }
    if (v->left >= right || v->right <= left) {
        return 0;
    }
    if (v->left >= left && v->right <= right) {
        return v->val;
    }
    return gett(v->l, left, right) + gett(v->r, left, right);
}

Node* sett(Node* v, int i) {
    if (!v) {
        return v;
    }
    if (v-> left > i || v->right <= i) {
        return v;
    }
    if (v-> left == i && v->right == i + 1) {
        return new Node(i, 0LL);
    }
    return new Node(sett(v->l, i), sett(v->r, i));
}

vector<Node*> tim;
int n;
vector<int> a;

int getTime(int x, int y) {
    int L = -1;
    int R = n;
    int m;
    while (R - L > 1) {
        m = (L + R) / 2;
        if (gett(tim[m], 0, x) > y) {
            L = m;
        } else {
            R = m;
        }
    }
    return R;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n;
    a.resize(n);
    tim.resize(n + 1);
    tim[0] = build(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        tim[i + 1] = sett(tim[i], a[i] - 1);
    }
    int q;
    for (cin >> q; q; --q) {
        int x1, y1;
        int x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        int t1 = getTime(x1, y1);
        int t2 = getTime(x2, y2);
        int L = 0;
        int R = min(x1, x2) + 1;
        int m;
        while (R - L > 1) {
            m = (R + L) / 2;
            if (gett(tim[t1], 0, m) == gett(tim[t2], 0, m)) {
                L = m;
            } else {
                R = m;
            }
        }
        cout << L << " " << gett(tim[t1], 0, L) << "\n";
    }
}