#include <iostream>
#include <vector>
#include <list>
#include <algorithm>
using namespace ::std;

struct node;


vector<node> vect;

bool isItPosible = 1;
long long sum = 0;

typedef pair<int, int> pairIntInt;
vector<int> ansVect;

template <typename T>
void meergList(list<T>& lst1, const list<T>& lst2)
{
	list<T> ans;
	auto L1 = lst1.begin();
	auto L2 = lst2.begin();
	while (L1 != lst1.end() && L2 != lst2.end())
	{
		if (*L1 > *L2)
		{
			ans.push_back(*L2);
			++L2;
		}
		else
		{
			ans.push_back(*L1);
			++L1;
		}
	}
	while (L1 != lst1.end())
	{
		ans.push_back(*L1);
		++L1;
	}
	while (L2 != lst2.end())
	{
		ans.push_back(*L2);
		++L2;
	}
	lst1 = ans;
}

struct node
{
	int n;
	int allredyBuy, price;
	int L, R;
	vector<int> child;
	list<pair<int, int>> priceAndN;

	void buy(int _n)
	{
		ansVect[n] += _n;
		allredyBuy += _n;
		sum += (long long)price * _n;
	}

	int askForBuy()
	{
		return R - allredyBuy;
	}

	void updateBuy()
	{

		while (allredyBuy < L)
		{
			auto it = priceAndN.begin();
			int howManyCanIBuy = vect[(*it).second].askForBuy();
			if (howManyCanIBuy > L - allredyBuy)
			{
				vect[(*it).second].buy(L - allredyBuy);
				allredyBuy = L;
			}
			else
			{
				vect[(*it).second].buy(howManyCanIBuy);
				allredyBuy += howManyCanIBuy;
				priceAndN.pop_front();
			}
		}
	}

	void update()
	{
		if (child.empty())
		{
			buy(L);
			priceAndN.push_back(pairIntInt(price, n));
			return;
		}
		priceAndN.push_back(pairIntInt(price, n));
		for (int i = 0; i < child.size(); i++)
		{
			vect[child[i]].update();
			meergList(priceAndN, vect[child[i]].priceAndN);
			allredyBuy += vect[child[i]].allredyBuy;
		}
		updateBuy();
		if (allredyBuy > R)
		{
			isItPosible = 0;
			return;
		}
	}

};




void doWork()
{
	int N;
	cin >> N;
	vect = vector<node>(N);
	ansVect = vector<int>(N);
	for (int i = 0; i < N-1; i++)
	{
		int x;
		cin >> x;
		--x;
		vect[x].child.push_back(i + 1);
	}
	for (int i = 0; i < N; i++)
	{
		vect[i].n = i;
		cin >> vect[i].price;
	}
	for (int i = 0; i < N; i++)
	{
		cin >> vect[i].L >> vect[i].R;
	}
	vect[0].update();
	if (!isItPosible)
	{
		cout << "-1\n";
		return;
	}
	cout << sum << "\n";
	for (int i = 0; i < N; i++)
	{
		cout << ansVect[i] << " ";
	}
	cout << "\n";

}


int main()
{
	int t;
	cin >> t;
	while (t--)
	{
		doWork();
	}



	return 0;
}