#include <bits/stdc++.h>
using namespace std;

vector<set<int>> gr;
vector<int> used;

void dfs(int v, int c)
{
    used[v] = c;
    for (int u: gr[v])
    {
        dfs(u, c);
    }
}

int dfs2(int v, int c)
{
    if (used[v] == c) return v;
    for (int u: gr[v])
    {
        int k = dfs2(u, c);
        if (k != -1) return k;
    }
    return -1;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, a, q, r1, c1, r2, c2;
    cin >> n;
    if (n <= 300 && q <= 300)
    {
        vector<int> v;
        for (int i = 0; i < n; i++)
        {
            cin >> a;
            v.push_back(a - 1);
        }
        int dp[n + 1][n + 1];
        int cnt = 0;
        map<int,pair<int,int>> mp;
        for (int i = 0; i <= n; i++)
        {
            for (int j = 0; j <= i; j++)
            {
                dp[i][j] = cnt++;
                mp[cnt - 1] = pair<int,int> {i, j};
            }
        }
        vector<int> v2(n, 1);
        gr.assign((n + 1) * (n + 1), set<int> {});
        used.assign((n + 1) * (n + 1), 0);
        for (int i = 0; i <= n; i++)
        {
            if (i > 0) v2[v[i - 1]] = 0;
            int a1 = 0, b1 = 0;
            for (int j = 0; j < n; j++)
            {
                gr[dp[a1 + 1][b1 + v2[j]]].insert(dp[a1][b1]);
                a1++;
                b1 += v2[j];
            }
        }
        cin >> q;
        int cntr = 1;
        for (int i = 0; i < q; i++)
        {
            cin >> r1 >> c1 >> r2 >> c2;
            int j1 = dp[r1][c1];
            int j2 = dp[r2][c2];
            dfs(j1, cntr);
            int k = dfs2(j2, cntr++);
            cout << mp[k].first << ' ' << mp[k].second << '\n';
        }
    }
    else
    {
        vector<int> v;
        for (int i = 0; i < n; i++)
        {
            cin >> a;
            v.push_back(a - 1);
        }
        int dp[n + 1][n + 1];
        int cnt = 0;
        map<int,pair<int,int>> mp;
        for (int i = 0; i <= n; i++)
        {
            for (int j = 0; j <= i; j++)
            {
                dp[i][j] = cnt++;
                mp[cnt - 1] = pair<int,int> {i, j};
            }
        }
        vector<int> v2(n, 1);
        vector<int> pr((n + 1) * (n + 1), 0);
        for (int i = 0; i <= n; i++)
        {
            if (i > 0) v2[v[i - 1]] = 0;
            int a1 = 0, b1 = 0;
            for (int j = 0; j < n; j++)
            {
                pr[dp[a1 + 1][b1 + v2[j]]] = dp[a1][b1];
                a1++;
                b1 += v2[j];
            }
        }
        cin >> q;
        int cntr = 1;
        for (int i = 0; i < q; i++)
        {
            cin >> r1 >> c1 >> r2 >> c2;
            int j1 = dp[r1][c1];
            int j2 = dp[r2][c2];
            if (mp[j1].first > mp[j2].first) swap(j1, j2);
            while (mp[j1].first != mp[j2].first)
            {
                j2 = pr[j2];
            }
            while (mp[j1] != mp[j2])
            {
                j1 = pr[j1];
                j2 = pr[j2];
            }
            cout << mp[j1].first << ' ' << mp[j1].second << '\n';
        }
    }
}
