//#define _CRT_SECURE_NO_WARNINGS
//#pragma GCC target ("avx, avx2, sse, sse2, sse3, sse4, fma, popcnt")
//#pragma GCC optimize ("-Ofast, unroll-loops, fast-math")
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <random>

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, q;
	cin >> n;
	vector<int> a(n);
	bool f = true;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		--a[i];
		f &= (a[i] == i);
	}
	if (f) {
		cin >> q;
		while (q--) {
			int x1, y1, x2, y2;
			cin >> x1 >> y1 >> x2 >> y2;
			if (x1 - y1 == x2 - y2) {
				if (x1 < x2)
					cout << x1 << ' ' << y1 << '\n';
				else
					cout << x2 << ' ' << y2 << '\n';
			}
			else {
				cout << min(x1 - y1, x2 - y2) << " 0\n";
			}
		}
	}
}