#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <deque>
#include <stack>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <time.h>
#include <math.h>
#include <random>
#include <string>
#include <iomanip>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pll;

ll w, h;

ll process(vector<pll> d, ll n, ll minx = 0) {
	vector<pll> right, left;
	sort(d.begin(), d.end());
	for (int i = 0; i < n; i++)
		if (i > 0 && right.back().second <= d[i].second)
			left.push_back(d[i]);
		else right.push_back(d[i]);
	int mnleft = h;
	for (pll t : left)
		mnleft = min((ll)mnleft, t.second);
	ll ans = (h - mnleft) * (w - minx);
	n = right.size();
	ll y = mnleft;
	for (int i = 0; i < n; i++) {
		if (right[i].second >= y)
			continue;
		ans += (y - right[i].second) * (w - max(minx, right[i].first));
		y = right[i].second;
	}
	return ans;
}

int32_t main() {
	cin.tie(0); cout.tie(0); cin.sync_with_stdio(0); cout.sync_with_stdio(0);
	int t, n;
	cin >> t >> t >> t >> t;
	while (t--) {
		cin >> n >> w >> h;
		vector<pll> d(n);
		for (int i = 0; i < n; i++)
			cin >> d[i].first >> d[i].second;
		ll ans = process(d, n);
		for (int ind = 0; ind < n; ind++) {
			vector<pll> dots1;
			bool bad = 0;
			for (int i = 0; i < n; i++)
				if (i != ind) {
					if (d[i].first <= d[ind].first && d[i].second <= d[ind].second)
						bad = 1;
					dots1.push_back(d[i]);
				}
			if (bad) continue;
			ll ans1 = process(dots1, n - 1, d[ind].first) + d[ind].first * (h - d[ind].second);
			ans = max(ans, ans1);
		}
		cout << ans;
	}
}