#include <bits/stdc++.h>

#define int int64_t

void solve() {
    int n, w, h;
    std::cin >> n >> w >> h;
    std::vector<std::pair<int, int>> a(n);
    for (auto &[x, y] : a)
        std::cin >> x >> y;
    std::sort(a.begin(), a.end(), [] (auto a, auto b) {
        return a.first < b.first || a.first == b.first && a.second > b.second;
    });
    std::vector<std::pair<int, int>> st;
    for (int i = 0; i < n; ++i) {
        if (st.empty() || st.back().second > a[i].second) {
            st.emplace_back(a[i]);
        }
    }
    int ans = 0;
    int curh = h, curx = 0;
    for (auto &[x, y] : st) {
        ans += (x - curx) * (h - curh);
        curx = x, curh = y;
    }
    ans += (w - curx) * (h - curh);
    std::cout << ans << "\n";
}

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    int k;
    std::cin >> k;
    std::vector<int> can(k);
    for (auto &x : can)
        std::cin >> x;
    int tests_num;
    std::cin >> tests_num;
    while (tests_num--) {
        solve();
    }
    return 0;
}
