#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <tuple>
#include <cassert>

using namespace std;

using ll = long long;
template<typename T>
using v = vector<T>;
template <typename T1, typename T2>
using pa = pair<T1, T2>;

template<typename T>
istream& operator>>(istream& in, v<T>& a) {
	for (T& x : a) {
		in >> x;
	}
	return in;
}

ll k;
v<ll> x;

void solve() {
	v<ll> ox(1, 1);
	assert(x == ox);
	ll n, w, h;
	cin >> n >> w >> h;
	v<pa<ll, ll>> a(n);
	for (ll i = 0; i < n; ++i) {
		cin >> a[i].first >> a[i].second;
	}
	sort(a.begin(), a.end());
	ll miy = h;
	ll res = 0;
	for (pa<ll, ll> p : a) {
		if (p.second < miy) {
			res += (miy - p.second) * (w - p.first);
			miy = p.second;
		}
	}
	cout << res << '\n';
}

int main() {
	cin >> k;
	x = v<ll>(k);
	cin >> x;
	ll t = 1;
	cin >> t;
	for (ll i = 0; i < t; ++i) {
		solve();
	}
}//