#include <bits/extc++.h>
using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define sfor(i, l, r) for (int i = l; i <= r; ++i)
#define bfor(i, r, l) for (int i = r; i >= l; --i)
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

struct Node {
    Node *left = nullptr, *right = nullptr;
    ll s = 0, add = 0;
};

const ll R = ((ll)1 << 40);
Node *root = new Node;

void Push(Node *v, ll len) {
    if (v->left == nullptr) {
        v->left = new Node;
        v->right = new Node;
    }
    if (v->add != 0) {
        v->left->s += v->add * len;
        v->left->add += v->add;
        v->right->s += v->add * len;
        v->right->add += v->add;
        v->add = 0;
    }
}

void Add(ll al, ll ar, ll x, Node *v = root, ll l = 0, ll r = R) {
    if (al >= r || l >= ar)
        return;
    if (al <= l && r <= ar) {
        v->s += x * (r - l);
        v->add += x;
        return;
    }
    ll m = (l + r) / 2;
    Push(v, m - l);
    Add(al, ar, x, v->left, l, m);
    Add(al, ar, x, v->right, m, r);
    v->s = v->left->s + v->right->s;
}

ll Sum(ll sl, ll sr, Node *v = root, ll l = 0, ll r = R) {
    if (sl >= r || l >= sr)
        return 0;
    if (sl <= l && r <= sr)
        return v->s;
    ll m = (l + r) / 2;
    Push(v, m - l);
    return Sum(sl, sr, v->left, l, m) + Sum(sl, sr, v->right, m, r);
}

int main() {
    fast;
    int n, q;
    cin >> n >> q;
    vector<pair<ll, int>> c(n);
    sfor(i, 0, n - 1) {
        cin >> c[i].first;
        c[i].second = i;
    }
    sort(all(c));
    vector<ll> cl;
    vi e(n);
    int cnt = 0;
    cl.push_back(c[0].first);
    sfor(i, 0, n - 1) {
        if (i > 0 && c[i].first > c[i - 1].first) {
            ++cnt;
            cl.push_back(c[i].first);
        }
        e[c[i].second] = cnt;
    }
    int m = cl.size();
    vector<ll> r(m - 1), s(m - 1);
    sfor(i, 1, m - 1) r[i - 1] = s[i - 1] = cl[i] - cl[i - 1];
    sort(all(s));
    vector<ll> ans(q);
    vector<pair<ll, int>> a2;
    vector<vector<pair<ll, int>>> a3(m);
    sfor(i, 0, q - 1) {
        int t;
        ll k;
        cin >> t >> k;
        if (t == 1)
            ans[i] = m - (upper_bound(all(s), k) - s.begin());
        else if (t == 2)
            a2.emplace_back(k, i);
        else {
            int j;
            cin >> j;
            a3[e[j - 1]].emplace_back(k, i);
        }
    }
    vector<ll> ct(m, 0);
    sfor(i, 0, n - 1) ++ct[e[i]];
    ll x = 0, y = 0;
    vector<ll> prf(m);
    prf[0] = ct[0];
    x += ct[0] * (m - 1);
    sfor(i, 1, m - 1) {
        prf[i] += prf[i - 1] + ct[i];
        x += ct[i] * (m - i - 1);
    }
    sfor(i, 0, m - 2) a2.emplace_back(r[i], -i - 1);
    sort(all(a2));
    ll prv = 0;
    for (auto p: a2) {
        y += x * (p.first - prv);
        prv = p.first;
        if (p.second < 0) {
            int i = -p.second - 1;
            x -= prf[i];
        }
        else
            ans[p.second] = y;
    }
    bfor(i, m - 1, 0) {
        if (i < m - 1)
            Add(0, r[i], 1);
        for (auto p: a3[i])
            ans[p.second] = cl[i] + Sum(0, p.first);
    }
    sfor(i, 0, q - 1) cout << ans[i] << '\n';
}
