#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <deque>
#define int long long
using namespace std;
vector <vector <int> > g;
vector <int> usd;
vector <int> usd2;
set <int> nxt;
int c = 1;
void dfs(int v, int nz,int c) {
	usd2[v] = c;
	for (auto u : g[v]) {
		if (u == nz) {
			nxt.insert(v);
		}
		if (u != nz && usd2[u]!=c) {
			dfs(u, nz, c);
		}
	}
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	for (int q = 0; q < t; ++q) {
		int n, m;
		cin >> n >> m;
		g.clear();
		g.resize(n);
		usd.clear();
		usd.resize(n);
		for (int i = 0; i < m; ++i) {
			int u, v;
			cin >> u >> v;
			u--;
			v--;
			g[v].push_back(u);
			g[u].push_back(v);
		}
		deque <int> d;
		d.push_back(0);
	
		vector <int> dist(n, -1);
		dist[0] = 0;
		while (d.size()) {
			int v = d.front();
			d.pop_front();
			usd2.clear();
			usd2.resize(n);
			nxt.clear();
			for (auto u : g[v]) {
				dfs(v, u,c);
				c++;
			}
			for (auto x : nxt) {
				if (dist[x] == -1) {
					dist[x] = dist[v] + 1;
					d.push_back(x);
				}
			}
		}
		for (int i = 1; i < n; ++i) {
			if (dist[i] == -1) {
				cout << "-1 ";
			}
			else {
				cout << dist[i]*2 << " ";
			}
		}
		cout << "\n";
	}
}
/*
6 1
5 4 4 2 2 2
2 2
*/