#include "bits/stdc++.h"
using namespace std;
#define int long long
#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")
#pragma GCC target("avx")
#define pii pair<int, int>
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) (int)(a.size())
#define F first
#define S second
#define ll long long
mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());
vector<ll> get_delta(vector<ll> &x){
    vector<ll> d = x;
    sort(all(d));
    d.erase(unique(all(d)), d.end());
    vector<ll> delta(sz(x));
    for(int i = 0;i < sz(x);i++){
        int pos = upper_bound(all(d), x[i]) - d.begin();
        delta[i] = sz(d) - pos;
    }
    return delta;
}
struct query {
    int type, i, k, ind;
    void in(int _type, int _k, int _ind, int _i = -1){
        type = _type;
        k = _k;
        i = _i;
        ind = _ind;
    }
    bool operator < (const query &other) const{
        if(k == other.k){
            return false;
        }
        return k < other.k;
    }
};
const int MAXN = 5e3 + 100;
int ans[MAXN];
void solve(){
    int n, q;
    cin >> n >> q;
    vector<ll> c(n);
    for(int i = 0;i < n;i++){
        cin >> c[i];
    }
    vector<int> dist;
    vector<ll> t;
    for(int i = 0;i < n;i++){
        t.push_back(c[i]);
    }
    sort(all(t));
    for(int i = 0;i < n;i++){
        for(int j = i + 1;j < n;j++){
            dist.push_back(t[j] - t[i]);
        }
    }
    vector<query> d(q);
    for(int i = 0;i < q;i++){
        int type, k;
        cin >> type >> k;
        if(type == 3){
            int j;
            cin >> j;
            j--;
            d[i].in(type, k, i, j);
        } else {
            d[i].in(type, k, i);
        }
    }
    sort(all(d));
    int ptr = 0;
    int last = 0;
    int sum = 0;
    vector<int> delta = get_delta(c);
    for(int i = 0;i < sz(dist);i++){
        int now = dist[i];
        ll btw = now - last;
        while(i < sz(dist) && dist[i] == now){
            i++;
        }
        while(ptr < sz(d) && d[ptr].k >= last && d[ptr].k < now){
            //ans on query
            ptr++;
        }
        int cur = ;
        for(int j = 0;j < sz(c);j++){
            c[j] += delta[j] * btw;
            cur += delta[j] * btw;
        }

        last = now;
        sum += cur;
    }
    for(int i = 0;i < q;i++){
        cout << ans[i] << '\n';
    }
}
signed main() {
    solve();
    return 0;
}
/*
314599
17713

931459

931549
 */