#include <iostream>
#include <vector>
#include<set>
#include<algorithm>
#include<deque>
typedef long long ll;
typedef long double ld;
#define ft first
#define sc second
#define all(x) x.begin(),x.end()
const int N=4*3*1e5;
using namespace std;
bool cmp(pair<ll, ll> a, pair<ll, ll> b) {
    return a<b;
}
vector<ll> tr[N], pref[N];
vector<ll> x;
void build(int i, int l, int r) {
    if (l+1 == r) tr[i]={x[l]};
    else {
        int k=(l+r)/2;
        build(2*i+1, l, k);
        build(2*i+2, k, r);
        merge(all(tr[2*i+1]), all(tr[2*i+2]), back_inserter(tr[i]));
        pref[i].resize(tr[i].size()+1, 0);
        for (int j=0;j<tr[i].size();j++) {
            pref[i][j+1]=pref[i][j]+tr[i][j];
        }
    }
}
pair<ll, ll> ask(int i, int l, int r, int ql, int qr, int v) {
    if (qr <= l || r <= ql) return {0, 0};
    if (ql <= l && r <= qr) {
        int j= upper_bound(all(tr[i]), v)-tr[i].begin();
        return {j, pref[i][j]};
    }
    int k=(l+r)/2;
    auto q=ask(2*i+1, l, k, ql, qr, v), w=ask(2*i+2, k, r, ql, qr, v);
    return {q.ft+w.ft, q.sc+w.sc};
}
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n, q;
    cin >> n >> q;
    vector<ll> c(n);
    ll t, k;
    for (int i=0;i<n;i++) cin >> c[i];

    vector<ll> cs=c, cu, cntu;
    ll start=0;
    sort(all(cs));
    for (int i=0;i<n;i++) {
        if (i == 0 || cs[i] != cs[i-1]) {
            if (i != 0) x.push_back(cs[i]-cu.back());
            cu.push_back(cs[i]);
            cntu.push_back(0);
        }
        cntu.back()++;
    }
    for (int i=0;i<cu.size();i++) start += cntu[i]*(cu.size()-1-i);
    vector<pair<ll, ll>> xs(x.size());
    for (int i=0;i<x.size();i++) {
        if (i == 0) xs[i] = {x[i], cntu[i]};
        else xs[i]={x[i], cntu[i]+xs[i-1].sc};
    }
    sort(all(xs));
    vector<ll> prefa(xs.size()+1, 0), prefax(xs.size()+1, 0);
    for (int i=0;i<xs.size();i++) {
        prefa[i+1]=prefa[i]+xs[i].sc;
        prefax[i+1]=prefax[i]+xs[i].ft*xs[i].sc;
    }
    build(0, 0, x.size());
    while (q--) {
        cin >> t >> k;
        int j;
        if (t == 1) {
            j=upper_bound(all(xs), make_pair(k, 1e18), cmp)-xs.begin();
            cout << cu.size() - j << "\n";
        }
        if (t == 2) {
            j=upper_bound(all(xs), make_pair(k, 1e18), cmp)-xs.begin();
            cout << k*start-k*prefa[j]+prefax[j] << "\n";
        }
        if (t == 3) {
            int i;
            cin >> i; i--;
            j=lower_bound(all(cu), c[i])-cu.begin();
            if (j == cu.size()-1) {
                cout << c[i] << "\n";
                continue;
            }
            ll ans=k*(cu.size()-1-j);
            auto A=ask(0, 0, x.size(), j, x.size(), k);
            ans -= (k*A.ft-A.sc);
            /*for (int y=j;y<x.size();y++) {
                if (x[y] <= k) {
                    ans -= (k-x[y]);
                }
            }*/
            cout << c[i]+ans << "\n";
        }
    }
}