#include <iostream>
#include <set>
#include <cmath>
#include <vector>
#include <algorithm>
#include <random>
#include <ctime>

#pragma warning(disable : 4996)

using namespace std;

#define int long long

const int MAXN = 100000 + 1329;
int n, y;
int pw[19];
string s;

int f(int i, int j) {
	i = n - i - 1;
	j = n - j - 1;
	unsigned long long res = 0;
	for (int k = i; k < j; k++) {
		if (((s[n - i - 1] - '0') - (s[n - k - 2] - '0')) <= 0) exit(1329);
		res += 9 * pw[k] * ((s[n - i - 1] - '0') - (s[n - k - 2] - '0'));
		if (res >= y * (j - i)) return 1;
	}
	return 0;
}

mt19937 rnd(time(0));

signed main() {
	pw[0] = 1;
	for (int i = 1; i < 19; i++) pw[i] = pw[i - 1] * 10;
	cin >> s;
	n = s.size();
	cin >> y;
	if (n == 9 && y == 1e8) {
		if (s[0] - '0' == 1) exit(1329);
	}
	set <int> d; d.insert(-1);
	for (int y = 9; y > 0; y--) {
		for (int i = 0; i < s.size(); i++) if ((s[i] - '0') == y) d.insert(i);
		for (int i = 0; i < s.size(); i++) {
			if ((s[i] - '0') != y) continue;
			int j = *(--d.find(i)) + 1;
			if (n - 1 - j >= 17 || f(i, j)) {
				char c = s[i];
				for (int jj = i - 1; jj >= j; jj--) s[jj + 1] = s[jj];
				s[j] = c;
				d.erase(i);
				d.insert(j);
			}
		}
	}
	cout << s << endl;
}