#include <iostream>
#include <set>
#include <cmath>
#include <vector>
#include <algorithm>
#include <queue>

#pragma warning(disable : 4996)

using namespace std;

//#define int long long

const int MAXN = 5001;
const int K = 10001;
const int inf = 1e9;

vector <int> g[MAXN];
vector <int> h[MAXN];
int d[MAXN];

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t; cin >> t;
	while (t--) {
		int n, m; cin >> n >> m;
		for (int i = 0; i < n; i++) g[i].clear();
		for (int i = 0; i < n; i++) h[i].clear();
		for (int i = 0; i < n; i++) d[i] = inf;
		for (int i = 0; i < m; i++) {
			int fr, to; cin >> fr >> to; fr--; to--;
			h[fr].push_back(to);
			h[to].push_back(fr);
		}
		for (int i = 0; i < n; i++) {
			for (int u : h[i]) {
				for (int j : h[u]) {
					g[i].push_back(j);
					//g[j].push_back(i);
				}
			}
		}
		d[0] = 0;
		queue <int> q; q.push(0);
		while (q.size()) {
			int v = q.front(); q.pop();
			for (int u : g[v]) {
				if (d[u] > d[v] + 1) {
					d[u] = d[v] + 1;
					q.push(u);
				}
			}
		}
		for (int i = 1; i < n; i++) {
			if (d[i] == inf) cout << "-1 ";
			else cout << d[i] << ' ';
		}
		cout << endl;
	}
}