#include <bits/stdc++.h>

using namespace std;

//#define int long long

int n, m;
vector <vector <int> >a;
vector <int> ok;
vector <int> dist, used2, used3;
int cur = 0;
int inf = 1e9;

void dfs(int v){
    used3[v] = 1;
    ok[v] = 1;

    for(auto to : a[v]){
        if(!used3[to]){
            dfs(to);
        }
    }
}

void bfs(int v){
    vector <int> used(n, 0);
    dist.assign(n, inf);
    queue <int> q;

    q.push(v);
    used[v] = 1;
    dist[v] = 0;
    while(!q.empty()){
        while(!q.empty() && used[v]){
            v = q.front();
            q.pop();
        }

        used[v] = 1;

        for(auto to : a[v]){
            /*if(!used2[to]) {*/
                used2[to] = 1;
                used3.assign(n, 0);
                ok.assign(n, 0);
                used3[to] = 1;

                dfs(v);

                for (auto u : a[to]) {
                    if(ok[u] && dist[u] > dist[v] + 2){
                        dist[u] = dist[v] + 2;
                        q.push(u);
                    }
                }
            //}
        }
    }
}

void solve(){
    cin >> n >> m;

    a.clear();
    ok.clear();
    dist.clear();
    used3.clear();
    used2.clear();

    a.resize(n);
    ok.resize(n);
    dist.resize(n);
    used2.resize(n);
    used3.resize(n);

    for(int i = 0; i < m; ++i){
        int x, y;
        cin >> x >> y;
        --x; --y;
        a[x].push_back(y);
        a[y].push_back(x);
    }

    bfs(0);

    for(int i = 1; i < n; ++i){
        if(dist[i] == inf){
            cout << -1 << " ";
        }else{
            cout << dist[i] << " ";
        }
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    //solve();

    int tests;
    cin >> tests;
    while(tests--){
        solve();
    }
}
