#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>

using namespace std;

const int BASE = 10;
const int THRESHOLD = 9;

int main() {
    string s; cin >> s;
    int n = s.length();
    int y; cin >> y;
    vector<int> cnt(BASE);
    for (int i = 0; i < n; i++) {
        cnt[s[i] - '0']++;
    }
    vector<int> rem_cnt(BASE);
    int total_digs = min(n, THRESHOLD);
    for (int d = 0; d < BASE; d++) {
        int take = min(total_digs, cnt[d]);
        rem_cnt[d] += take;
        total_digs -= take;
    }
    string t(n, 'a');
    int ptr = n - 1;
    for (int i = n - 1; i >= 0; i--) {
        if (rem_cnt[s[i] - '0'] > 0) {
            t[ptr] = s[i];
            ptr--;
            rem_cnt[s[i] - '0']--;
        }
    }
    for (int i = 0; i < n - THRESHOLD; i++) {
        int d = BASE - 1;
        while (cnt[d] == 0) d--;
        t[i] = d + '0';
        cnt[d]--;
    }
    
    string t_end = t.substr(max(0, n - THRESHOLD), min(THRESHOLD, n));
    assert(t_end == s);
    int64_t ans = 0;
    string ans_s = t_end;
    string t_end_copy = t_end;
    do {
        string cur = t_end_copy;
        int swaps = 0;
        for (int i = 0; i < n; i++) {
            int j = i;
            for (; j < n; j++) {
                if (cur[j] == t_end[i]) break;
            }
            for (int k = j; k > i; k--) {
                swap(cur[k], cur[k - 1]);
                swaps++;
            }
        }
        int64_t cur_ans = stoi(t_end) - y * 1ll * swaps;
        if (cur_ans > ans || (cur_ans == ans && t > ans_s)) {
            ans = cur_ans;
            ans_s = t_end;
        }
    } while (next_permutation(t_end.begin(), t_end.end()));
    cout << t.substr(0, max(0, n - THRESHOLD)) + ans_s << endl;
}
