#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, q; cin >> n >> q;
    vector<int64_t> as(n);
    for (int i = 0; i < n; i++) {
        cin >> as[i];
    }
    sort(as.begin(), as.end());
    // as.resize(unique(as.begin(), as.end()) - as.begin());
    vector<int64_t> deltas;
    for (int i = 0; i < n - 1; i++) {
        deltas.push_back(as[i + 1] - as[i]);
    }
    sort(deltas.begin(), deltas.end());

    while (q--) {
        int t; cin >> t;
        if (t == 1) {
            int64_t k; cin >> k;
            int idx = upper_bound(deltas.begin(), deltas.end(), k) - deltas.begin();
            cout << n - idx << endl;
        }
    }
}
