#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define ll long long
#define pii pair<int, int>
#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)
#define mp(x, y) make_pair(x, y)
#define mt make_tuple
#define sz(x) (int) size(x)

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

template<typename T>
bool ckmx(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}


template<typename T>
bool ckmn(T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

#define int ll

const int infI = 1e9 + 7;
const ll infL = 2e18;
const ll mod = 98244353;
const int N = (300000) + 1;

struct quest {
    int type = -1, i = -1, I = -1;
    ll k;

    quest() = default;

    quest(int a, ll b, int c, int d) {
        type = a, k = b, i = c, I = d;
    }
};

bool cmp(quest a, quest b) {
    if (a.k != b.k) return a.k < b.k;
    return a.type < b.type;
}

ll ans[N];

struct dsu {
    vector<int> p, sz;
    vector<ll> sum, gg;
    ll ssum = 0;

    void init(int n, vector<ll> &siz) {
        p.resize(n);
        iota(all(p), 0);
        sz.resize(n);
        fill(all(sz), 1);
        sum.resize(n);
        ll y = 0;
        for (int i = 0; i < n; ++i) {
            sum[i] = y;
            ssum += sum[i];
            y += siz[i];
        }
        gg = siz;
    }

    int get(int a) {
        return (a == p[a] ? a : p[a] = get(p[a]));
    }

    bool mrg(int a, int b) {
        a = get(a);
        b = get(b);
        if (a == b) return false;
        if (sz[a] < sz[b]) swap(a, b);
        sz[a] += sz[b];
        p[b] = a;
        ssum -= sum[b];
        sum[a] -= gg[b];
        gg[a] += gg[b];
        return true;
    }
};

void solve() {
    int n, q;
    cin >> n >> q;
    vector<ll> c(n), yy;
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }
    yy = c;
    sort(all(yy));
    yy.resize(unique(all(yy)) - yy.begin());
    vector<int> pos(n);
    int m = sz(yy);
    vector<ll> siz(m);
    for (int i = 0; i < n; ++i) {
        pos[i] = lower_bound(all(yy), c[i]) - yy.begin();
        ++siz[pos[i]];
    }
    vector<ll> pref(m);
    pref[0] = siz[0];
    for (int i = 1; i < m; ++i) pref[i] = pref[i - 1] + siz[i];
    vector<quest> v;
    for (int i = 0; i < m - 1; ++i) {
        v.emplace_back(-1, yy[i + 1] - yy[i], i, -1);
    }
    vector<quest> Q(q);
    for (int i = 0; i < q; ++i) {
        cin >> Q[i].type >> Q[i].k;
        if (Q[i].type == 3) {
            cin >> Q[i].i;
            --Q[i].i;
        }
        Q[i].I = i;
        v.emplace_back(Q[i]);
    }
    sort(all(v), cmp);
    int cnt = 0;
    ll added = 0;
    ll last = 0;
    dsu d;
    d.init(m, siz);
    for (auto tt: v) {
        if (tt.type == 1) {
            ans[tt.I] = m - cnt;
        } else if (tt.type == -1) {
            ++cnt;
            added +=  d.ssum * (tt.k - last);
            last = tt.k;
            d.mrg(tt.i, tt.i + 1);
        } else if (tt.type == 2) {
            ans[tt.I] = added + d.ssum * (tt.k - last);
            last = tt.k;
        }
    }
    for (int i = 0; i < q; ++i) {
        cout << ans[i] << '\n';
    }
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}