#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm> 
#include <deque>


using namespace std;
typedef long long ll;

ll bin_pow(ll a, ll n) {
	if (n == 0)
		return 1;
	if (n & 1)
		return a * bin_pow(a, n - 1);
	ll b = bin_pow(a, n / 2);
	return b * b;
}

ll to_ll(string s) {
	ll ans = 0;
	for (int i = 0; i < s.size(); i++) {
		ans *= 10;
		ans += s[i] - '0';
	}
	return ans;
}
string change(string s, int i, int j) {
	for (j; j - 1 >= i; j--)
		swap(s[j], s[j - 1]);
	return s;
}

void solve() {
	string s; cin >> s;
	ll y;
	cin >> y;
	int n = s.size();
	for (int i = 0; i < s.size(); i++) {
		ll win = 0, J = -1;
		ll me = to_ll(s);
		for (int j = i + 1; j < s.size(); j++) {
			string nw = change(s, i, j);
			ll now = -(j - i) * y + to_ll(nw) - me;
			if (now > win) {
				win = now, J = j;
			}
		}
		if (J != -1) {
			for (int k = J; k - 1 >= i; k--) {
				swap(s[k], s[k - 1]);
			}
		}
	}
	cout << s;
}

int main() {
	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}