#include <iostream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <algorithm>
#include <queue>
#include <cmath>
#include <iomanip>
#include <deque>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

struct R {
	ll l, r, c, t;
	R get(ll x) {
		if (t == 1) return { min(l, x), max(r, x), c, t };
		return { l, r, c, t };
	}
	void input() {
		cin >> l >> r >> c >> t;
	}
};

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll t;
	cin >> t;
	while (t--) {
		ll n, m;
		cin >> n >> m;
		vector<ll> a(n);
		for (ll i = 0; i < n; i++) cin >> a[i];
		R r;
		r.input();
		for (ll x = 0; x < n; x++) {
			R p = r.get(x);
			ll k = 0;
			for (ll i = p.l; i <= p.r; i++) {
				k += a[i];
			}
			cout << min(k, r.c) << " ";
		}
		cout << "\n";
	}
	return 0;
}