#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
#define rep(i, a, b) for(int i = a; i < b; i++)
#define ordered_set tree<pair<ll, ll>, null_type, less<pair<ll, ll> >, rb_tree_tag, tree_order_statistics_node_update>

const int maxn = 5017;
vector<int> g[maxn];
vector<int> G[maxn];
int good[maxn][maxn];
int comp[maxn];
bool used[maxn];
int d[maxn];

void dfs(int ban, int v, int cmp)
{
    used[v] = 1;
    comp[v] = cmp;
    for(auto x : g[v]) if(x != ban && !used[x]) dfs(ban, x, cmp);
}

int main()
{
    rep(i, 0, 5017) rep(j, 0, 5017) good[i][j] = -1;
    int tests;
    cin >> tests;
    rep(I, 0, tests)
    {
        int n, m;
        cin >> n >> m;
        rep(i, 0, n) g[i].clear();
        rep(i, 0, n) G[i].clear();
        rep(i, 0, m)
        {
            int a, b;
            cin >> a >> b;
            a--; b--;
            g[a].push_back(b);
            g[b].push_back(a);
        }
        for(int ban = 0; ban < n; ban++)
        {
            int num = 0;
            rep(i, 0, n) used[i] = 0;
            rep(i, 0, n) comp[i] = -1;
            rep(i, 0, n) if(i != ban && !used[i]) dfs(ban, i, num++);

            rep(i, 0, g[ban].size()) rep(j, i + 1, g[ban].size())
            if(comp[g[ban][i]] == comp[g[ban][j]])
            {good[g[ban][i]][g[ban][j]] = good[g[ban][j]][g[ban][i]] = I;}
        }
        //rep(i, 0, n) {rep(j, 0, n) cout << good[i][j] << " "; cout << endl;}
        rep(i, 0, n) rep(j, 0, n) if(good[i][j] == I) G[i].push_back(j);

        rep(i, 0, n) used[i] = 0;
        queue<int> q;
        rep(i, 0, n) d[i] = -1;
        d[0] = 0;
        q.push(0);
        while(!q.empty())
        {
            int x = q.front();
            q.pop();
            for(auto u : G[x]) if(!used[u])
                {
                used[u] = 1;
                d[u] = d[x] + 1;
                q.push(u);
                }
        }
        rep(i, 1, n) cout << d[i] * (1 + (d[i] != -1)) << " ";
        cout << endl;
    }
    return 0;
}
