#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef __int128 lll;

#define all(a) a.begin(),a.end()
#define FastIO ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define pb push_back
#define eb emplace_back
#define endl '\n'

const int INT_INF = 2e9;
const ll INF = 2e18;
const double PI = acos(-1);

int cnt(vector<pair<ll, int>> &r, ll k) {
	int n = r.size();
	int lt = -1;
	int rt = n - 1;
	while (rt - lt > 1) {
		int m = (lt + rt) / 2;
		if (r[m].first <= k) lt = m;
		else rt = m;
	}
	return rt;
}

struct SegmentTree{
	int n;
	vector<ll> d;
	SegmentTree(vector<ll> &a) {
		int tn = a.size();
		n = (1 << (int) ceil(log2(tn)));
		d.resize(n * 2 - 1);
		for (int i = 0; i < tn; i++) d[n + i - 1] = a[i];
		for (int i = n - 2; i >= 0; i--) d[i] = d[i * 2 + 1] + d[i * 2 + 2];
	}
	ll get(int lt, int rt, int L, int R, int u) {
		if (R <= lt || rt <= L) return 0;
		if (lt <= L && R <= rt) return d[u];
		int m = (L + R) / 2;
		return get(lt, rt, L, m, u * 2 + 1) + get(lt, rt, m, R, u * 2 + 2);
	}
	ll get(int lt, int rt) { return get(lt, rt, 0, n, 0); }
};

int main() {
	FastIO;

	int n, q;
	cin >> n >> q;

	vector<ll> c(n);
	for (auto &it : c) {
		cin >> it;
	}
	sort(all(c));

	vector<pair<ll, int>> r(n - 1);
	for (int i = 0; i < n - 1; i++) {
		r[i].first = c[i + 1] - c[i];
		r[i].second = i + 1;
	}
	sort(all(r));
	r.eb(INF, -1);

	vector<ll> pr(n);
	vector<ll> hv(n);
	ll sm = n * 1ll * (n - 1) / 2;
	ll al = 0;
	pr[0] = sm;
	hv[0] = al;
	for (int i = 0; i < n - 1; i++) {
		al += sm * (r[i].first - (i ? r[i - 1].first : 0));
		sm -= r[i].second;
		while (r[i].first == r[i + 1].first) {
			sm -= r[i + 1].second;
			++i;
		}
		hv[i + 1] = al;
		pr[i + 1] = sm;
		
	}

	for (int i = 0; i < q; i++) {
		int t;
		cin >> t;
		ll k;
		cin >> k;
		int tmp = cnt(r, k);
		if (t == 1) cout << n - tmp << endl;
		if (t == 2) {
		   	cout << hv[tmp] + pr[tmp] * (k - (tmp == 0 ? 0 : r[tmp - 1].first) << endl;
	   	}
	}
	return 0;
}

