#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef __int128 lll;

#define all(a) a.begin(),a.end()
#define FastIO ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define pb push_back
#define eb emplace_back
#define endl '\n'

const int INT_INF = 2e9;
const ll INF = 2e18;
const double PI = acos(-1);

int cnt(vector<pair<ll, int>> &r, ll k) {
	int n = r.size();
	int lt = -1;
	int rt = n - 1;
	while (rt - lt > 1) {
		int m = (lt + rt) / 2;
		if (r[m].first <= k) lt = m;
		else rt = m;
	}
	return rt;
}

int main() {
	FastIO;

	int n, q;
	cin >> n >> q;

	vector<ll> c(n);
	ll mx = -1;

	for (auto &it : c) {
		cin >> it;
		mx = max(mx, it);
	}

	vector<ll> nc = c;
	map<ll, int> dct;
	sort(all(c));
	for (int i = 0; i < n; i++) dct[c[i]] = i;

	vector<pair<ll, int>> r(n - 1);
	vector<ll> nr(n - 1);
	for (int i = 0; i < n - 1; i++) {
		nr[i] = c[i + 1] - c[i];
		r[i].first = c[i + 1] - c[i];
		r[i].second = i + 1;
	}
	sort(all(r));
	r.eb(INF, -1);

	vector<ll> pr(n);
	vector<ll> hv(n);
	ll sm = n * 1ll * (n - 1) / 2;
	ll al = 0;
	pr[0] = sm;
	hv[0] = al;
	for (int i = 0; i < n - 1; i++) {
		al += sm * (r[i].first - (i ? r[i - 1].first : 0));
		sm -= r[i].second;
		while (r[i].first == r[i + 1].first) {
			sm -= r[i + 1].second;
			++i;
		}
		hv[i + 1] = al;
		pr[i + 1] = sm;
		
	}

	for (int i = 0; i < q; i++) {
		int t;
		cin >> t;
		ll k;
		cin >> k;
		int tmp = cnt(r, k);
		if (t == 1) cout << n - tmp << endl;
		if (t == 2) {
		   	cout << hv[tmp] + pr[tmp] * (k - (tmp == 0 ? 0 : r[tmp - 1].first)) << endl;
	   	}
		if (t == 3) {
			int ind;
			cin >> ind;
			ind = dct[nc[ind - 1]];
			ll rr = 0;
			for (int i = ind; i < n - 1; i++) if (nr[i] >= k) rr += nr[i] - k;
			cout << mx - rr << endl;
		}
	}
	return 0;
}

