#include <bits/stdc++.h>
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;

typedef long long ll;

const int INF = 1e9 + 7;



signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
   int t;
   cin >> t;
   while (t--) {
       int n, m;
       cin >> n >> m;
       vector<vector<int>> g(n), dp(n, vector<int> (n, INF));
       queue<pair<int, int>> q;
       for (int i = 0; i < m; i++) {
           int u, v;
           cin >> u >> v;
           g[--u].push_back(--v);
           g[v].push_back(u);
       }
       dp[0][0] = 0;
       q.push({0, 0});
       while (!q.empty()) {
           auto [rob, box] = q.front();
           q.pop();
           auto time = dp[rob][box];
           if (rob == box) {
               for (auto i : g[rob]) {
                   if (dp[rob][i] == INF) {
                       dp[rob][i] = time + 1;
                       q.push({rob, i});
                   }
               }
           } else {
               for (auto i : g[rob]) {
                   if (i == box) {
                       if (dp[rob][rob] == INF) {
                           dp[rob][rob] = time + 1;
                           q.push({rob, rob});
                       }
                   } else {
                       if (dp[i][box] == INF) {
                           dp[i][box] = time;
                           q.push({i, box});
                       }
                   }
               }
           }
       }
       for (int i = 1; i < n; i++) {
           if (dp[i][i] == INF) cout << "-1 ";
           else cout << dp[i][i] << ' ';
       }
       cout << '\n';
   }
}
