#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cassert>

using namespace std;
typedef long long ll;
#define int long long

string s;
int y;

int cst(string s, string t, int y)
{
	int n = s.size();
	int ans = 0;
	for (auto i : t) ans = 10 * ans + i - '0';
	auto z = s;
	for (int i = 0; i < n; ++i)
	{
		auto j = find(z.begin() + i, z.end(), t[i]) - z.begin();
		z.erase(z.begin() + j);
		z.insert(z.begin() + i, t[i]);

		ans -= abs(i - j) * y;
	}
	return ans;
}

string solve(string s, int y)
{
	int n = s.size();
	pair <int, string> an;
	an = { -1, "" };

	auto t = s;
	sort(t.begin(), t.end());
	do
	{
		pair <int, string> ans = { cst(s, t, y), t };

		an = max(an, ans);

	} while (next_permutation(t.begin(), t.end()));

	return an.second;
}


string sm(string s, int y)
{
	int n = s.size();
	pair <int, string> an;
	an = { -1, "" };

	auto t = s;

	for (int i = 0; i < n- 1; ++i)
	{
		pair <int, string> ans = { cst(s, t, y), t };
		an = max(an, ans);

		string lst = t;
		for (char c = t[i] + 1; c <= '9'; ++c)
		{
			int gt = find(t.begin() + i, t.end(), c) - t.begin();
			if (gt == n) continue;
			auto f = t;
			f.erase(f.begin() + gt);
			f.insert(f.begin() + i, c);

			pair <int, string> ans = { cst(s, f, y), f };
			an = max(an, ans);
			lst = f;
		}
		t = lst;
	}
	return an.second;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> s;
	int y;
	cin >> y;
	auto ans1 = solve(s, y);
	auto ans2 = sm(s, y);
	assert(ans1 == ans2);
	cout << ans1;
	return 0;
}