#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cassert>
#include <map>
#include <deque>

using namespace std;
typedef long long ll;
#define int long long

const int inf = 1e9 + 10;

int n, m;
int a[200010];
int d[200010];
int l[200010];
int r[200010];
int c[200010];
int h[200010];
int b[200010];
int xl[200010];
int xr[200010];


inline void solve()
{
	cin >> n >> m;

	for (int i = 1; i <= n; ++i)
	{
		cin >> a[i];
	}

	for (int i = 1; i <= m; ++i)
	{
		cin >> l[i] >> r[i] >> c[i] >> h[i];
	}

	for (int i = 1; i <= n; ++i)
	{
		for (int j = 1; j <= m; ++j)
		{
			b[j] = c[j];
			xl[j] = min(i, l[j]);
			xr[j] = max(i, r[j]);
		}

		for (int j = 1; j <= n; ++j)
		{
			d[j] = a[j];
		}

		int ans = 0;
		int j = 1;
		for (int k = 1; k <= n; ++k)
		{
			while (j <= m)
			{
				if (xr[j] < k)
				{
					++j;
					continue;
				}
				if (xl[j] > k)
				{
					break;
				}
				if (b[j] <= d[i])
				{
					d[i] -= b[j];
					++j;
					continue;
				}
				else
				{
					b[j] -= d[i];
					d[i] = 0;
					break;
				}
			}
			ans += a[k] - d[k];
		}

		cout << ans << ' ';
	}
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	int t;
	cin >> t;
	while (t--) solve();

	return 0;
}