#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <iomanip>
#include <map>
#include <random>
#include <algorithm>
#include <queue>
#include <bitset>

#define ll long long
#define ld long double 
#define int ll

using namespace std;

mt19937 rnd;

signed main()
{
	int n, q;
	cin >> n >> q;
	vector<int>a(n);
	vector<pair<int, int>>a1;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		a1.push_back({ a[i], i });
	}
	sort(a.begin(), a.end());
	sort(a1.begin(), a1.end());
	vector<int>r_ind(n);
	for (int i = 0; i < n; ++i) {
		r_ind[a1[i].second] = i;
	}
	vector<int>cnt;
	vector<pair<int, int>>r;
	r.push_back({ 0, 0 });
	for (int i = 0; i < n;) {
		int j = i;
		while (i < n && a[i] == a[j]) ++i;
		cnt.push_back(i - j);
		if (i < n) r.push_back({ a[i] - a[j], i });
	}
	sort(r.begin(), r.end());
	set<int>r1;
	for (int i = 1; i < r.size(); ++i) {
		r1.insert(r[i].first);
	}
	vector<int>r2;
	for (auto it = r1.begin(); it != r1.end(); ++it) {
		r2.push_back(*it);
	}
	vector<ll>psh(r2.size() + 1);
	for (int i = 0; i < cnt.size(); ++i) {
		psh[0] += cnt[i] * (cnt.size() - i - 1);
	}
	vector<bool>used(n + 2);
	vector<vector<int>>indr(n);
	for (int i = 0; i < r2.size() - 1; ++i) {
		for (int j = 0; j < r.size(); ++j) {
			if (r[j].first == r2[i]) {
				used[r[j].second] = 1;
				indr[r[j].first].push_back(j);
			}
		}
		int rd = r2[i];
		int k = 0;
		int ind = n;
		if (i > 0) rd -= r2[i - 1];
		for (int j = cnt.size() - 1; j >= 0; --j) {
			psh[i + 1] += k * cnt[j] * rd;
			ind -= cnt[j];
			if (!used[ind]) k += 1;
		}
	}
	for (int ii = 0; ii < q; ++ii) {
		int t;
		cin >> t;
		if (t == 1) {
			int k;
			cin >> k;
			int l1 = 0;
			int r1 = r.size();
			while (r1 - l1 > 1) {
				int md = (l1 + r1) / 2;
				if ((r[md].first <= k)) l1 = md;
				else r1 = md;
			}
			int ans = cnt.size() - l1;
			cout << ans << '\n';
		}
		else if (t == 2) {
			int k;
			cin >> k;
			ll ans = 0;
			vector<int>used1(n + 2);
			for (int i = 0; i < r2.size(); ++i) {
				if (r2[i] <= k) {
					ans += psh[i];
					for (auto j : indr[r2[i]]) {
						used1[r[j].second] = 1;
					}
				}
				else {
					int kk = 0;
					int ind = n;
					for (int j = cnt.size() - 1; j >= 0; --j) {
						if (i > 0) ans += kk * cnt[i] * (k - r2[i - 1]);
						else ans += kk * cnt[i] * k;
						ind -= cnt[j];
						if (!used1[ind]) kk += 1;
					}
					break;
				}
			}
			cout << ans << '\n';
		}
		else {
			int k, ind;
			cin >> k >> ind;
			ind = r_ind[ind - 1];
			int cnt1 = cnt.size() - 1;
			int cnt2 = n - cnt[0];
			int indc = 0;
			while (n - cnt2 <= ind) {
				++indc;
				cnt2 -= cnt[indc];
				cnt1 -= 1;
			}
			int ans = a[ind];
			for (int i = 1; i < r.size(); ++i) {
				if (r[i].first <= k) {
					ans += cnt1 * (r[i].first - r[i - 1].first);
					if (r[i].second > ind) cnt1--;
				}
				else {
					ans += cnt1 * (k - r[i - 1].first);
					break;
				}
			}
			cout << ans << '\n';
		}
	}
}