#include<bits/stdc++.h>

using namespace std;

const int N = 100005;

const int INF = 2e9;

int tin[N], fup[N], timer = 0;
bool used[N], brid[N], cut[N];
vector<pair<int, int>> g[N];

void dfs(int v, int p) {
    int ch = 0;
    tin[v] = fup[v] = timer++;
    used[v] = 1;
    for (auto i : g[v]) {
        int to = i.first;
        if (to == p) continue;
        if (used[to]) {
            fup[v] = min(fup[v], tin[to]);
        }
        else {
            ++ch;
            dfs(to, v);
            fup[v] = min(fup[v], fup[to]);
            if (fup[to] > tin[v]) {
                brid[i.second] = 1;
            }
            if (p != -1 && fup[to] >= tin[v]) {
                cut[v] = 1;
            }
        }
    }
    if (p == -1 && ch > 1) {
        cut[v] = 1;
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    timer = 0;
    for (int i = 0; i < n; ++i) {
        used[i] = 0;
        brid[i] = 0;
        tin[i] = 0;
        fup[i] = 0;
        cut[i] = 0;
        g[i].clear();
    }
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        g[u].push_back({v, i});
        g[v].push_back({u, i});
    }
    dfs(0, -1);
    for (int i = 0; i < n; ++i) {
        cout << "L " << i + 1 << ' ' << cut[i] << '\n';
    }
    set<pair<int, int>> s;
    vector<int> ans(n, INF);
    ans[0] = 0;
    s.insert({0, 0});
    for (int i = 1; i < n; ++i) {
        s.insert({INF, i});
    }
    while (!s.empty()) {
        pair<int, int> cur = *s.begin();
        s.erase(cur);
        int v = cur.second;
        for (auto i : g[v]) {
            int to1 = i.first;
            if (brid[i.second]) continue;
            if (cut[to1]) continue;
            for (auto j : g[to1]) {
                int to2 = j.first;
                if (brid[j.second]) continue;
                if (ans[to2] > ans[v] + 2) {
                    s.erase({ans[to2], to2});
                    ans[to2] = ans[v] + 2;
                    s.insert({ans[to2], to2});
                }
            }
        }
    }
    for (int i = 1; i < n; ++i) {
        if (ans[i] == INF) cout << -1 << ' ';
        else cout << ans[i] << ' ';
    }
    cout << '\n';
}

signed main() {
    int T;
    cin >> T;
    while (T--) solve();
}
