#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx,avx2,abm,popcnt")
//#define int long long
#define ll long long
#define sz(a)(int)a.size()
#define all(a)a.begin(),a.end()
const int inf = 1e9;

void solve() {
    string s, y;
    cin >> s >> y;
    int n = sz(s), m = sz(y);
    if (n < m) {
        cout << s << "\n";
        return;
    }
    int iters = max(0, n - m - 1);
    string l = s, r;
    sort(all(l), greater<>());
    l.erase(iters, n - iters);
    vector<int> cnt(10);
    for (auto c: l)
        cnt[c - '0']++;
    for (int i = 0; i < n; ++i)
        if (cnt[s[i] - '0'] == 0)
            r.push_back(s[i]);
        else
            cnt[s[i] - '0']--;
    ll L = stoll(y);
    int len = n - iters;
    vector<int> t(len);
    for (int i = 0; i < len; ++i)
        t[i] = i;
    pair<ll, string> best = {0, r};
    do {
        string cur(len, '0');
        for (int i = 0; i < len; ++i)
            cur[i] = r[t[i]];
        string u = r;
        ll cnt = 0;
        for (int i = 0; i < len; ++i) {
            int fnd = 0;
            for (int j = i; j < len; ++j)
                if (u[j] == cur[i]) {
                    fnd = j;
                    break;
                }

            for (int j = fnd; j > i; --j) {
                swap(u[j], u[j - 1]);
                ++cnt;
            }
        }
        best = max(best, {stoll(cur) - L * cnt, cur});
    } while (next_permutation(all(t)));
    cout << l << best.second << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}