#include <iostream>
#include <bits/stdc++.h>
using namespace std;
#define ll unsigned long long
int n, m;
vector <vector <int>> g;
bitset<5000> is_sh, used;
vector <int> tin, tout, fup;
int t = 0;
vector <int> match_cs;
int num = 1;
void dfs(int v, int e, bool is_root = 1){
    used[v] = 1;
    tin[v] = t++;
    fup[v] = tin[v];
    int md = 0;
    bool has_t = 0;
    for (int i: g[v]){
        if (i == e) continue;
        if (used[i]){
            fup[v] = min(fup[v], tin[i]);
        }
        else{
            dfs(i, v, 0);
            md++;
            if (fup[i] >= tin[v]) has_t = 1;
            fup[v] = min(fup[v], fup[i]);
        }
    }
    if ((is_root && md >= 2) || (!is_root && has_t)) is_sh[v] = 1;
}
void dfs_match(int v){
    match_cs[v] = num;
    for (int i: g[v]){
        if (match_cs[i] == -1 && !is_sh[i]) dfs_match(i);
    }
}
const int maxn = 5001;
bitset<maxn> g2[maxn];
void solve(){
    cin >> n >> m;
    for (int i = 0; i <= n; i++) g2[i].reset();
    g.clear();
    g.assign(n + 1, vector <int> ());
    for (int i = 0; i < m; i++){
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    is_sh.reset();
    used.reset();
    tin.assign(n + 1, 0);
    tout.assign(n + 1, 0);
    fup.assign(n + 1, 0);
    t = 0;
    dfs(1, -1);
    match_cs.assign(n + 1, -1);
    for (int i = 1; i <= n; i++){
        if (match_cs[i] == -1 && !is_sh[i]) {
            dfs_match(i);
            num++;
        }
    }
    for (int v = 1; v <= n; v++){
        for (int i1: g[v]) for (int i2: g[v]){
            if (!is_sh[v]) {
                g2[i1][i2] = 1;
                g2[i2][i1] = 1;
                continue;
            }
            if (match_cs[i1] == match_cs[i2]) {
                g2[i1][i2] = 1;
                g2[i2][i1] = 1;
            }
        }
    }
    vector <int> dist(n + 1, -1);
    dist[1] = 0;
    queue<int> q;
    q.push(1);
    while (!q.empty()){
        int v = q.front();
        q.pop();
        for (int i = 1; i <= n; i++){
            if (g2[v][i] && dist[i] == -1) {
                dist[i] = dist[v] + 2;
                q.push(i);
            }
        }
    }
    for (int i = 2; i <= n; i++) cout << dist[i] << ' ';
    cout << '\n';
}
int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int te; cin >> te;
    while (te--) solve();
    return 0;
}
