#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

long long pow(long long a, long long b)
{
	if (b == 0) return 1;
	if (b % 2 == 0)
	{
		long long tmp = pow(a, b / 2);
		return tmp * tmp;
	}
	return pow(a, b - 1) * a;
}

int main()
{
	string s;
	cin >> s;
	int n = s.size();
	vector<int> a(n);
	for (int i = 0; i < n; i++)
	{
		a[i] = s[i] - '0';
	}
	long long k;
	cin >> k;
	vector<vector<int>> ind(10, vector<int>(0));
	for (int i = 0; i < n; i++)
	{
		ind[a[i]].push_back(i);
	}

	for (int i = 0; i < 10; i++)
	{
		reverse(ind[i].begin(), ind[i].end());
	}

	vector<vector<int>> curind;

	sort(a.begin(), a.end());

	vector<int> bestres;
	long long bestadd = -1e18;
	do
	{
		curind = ind;
		long long curadd = 0;
		long long cursub = 0;
		for (int i = 0; i < n; i++)
		{
			curadd += a[i] * pow(10, n - 1 - i);
			cursub += abs(curind[a[i]].back() - i) * k;
			curind[a[i]].pop_back();
		}
		curadd -= cursub / 2;
		if (curadd > bestadd)
		{
			bestres = a;
			bestadd = curadd;
		}
	} while (next_permutation(a.begin(), a.end()));

	for (int i = 0; i < n; i++)
	{
		cout << bestres[i];
	}
	return 0;
}