#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define len(x) (int) (x).size()
#define endl "\n"
#define int long long
#define li __int128_t


using namespace std;


const int N = 5e5 + 100;
vector <int> g[N];


void solve() {
    int n, m;
    cin >> n >> m;

    for (int i = 0; i < n; i++) {
        g[i].clear();
    }

    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }

    set <int> used;
    deque <int> q;
    map <int, int> dist;
    for (int i : g[0]) {
        dist[i] = 1;
        q.push_back(i);
    }
    used.insert(0);

    while (!q.empty()) {
        int v = q.front();
        q.pop_front();

        for (int i : g[v]) {
            if (used.count(i)) {
                continue;
            }

            used.insert(i);
            for (int j : g[i]) {
                if (!dist.count(j)) {
                    dist[j] = dist[v] + 2;
                    q.push_back(j);
                }
            }
        }
    }

    for (int i = 1; i < n; i++) {
        int mx = INT_MAX;
        for (int j : g[i]) {
            if (dist.count(j)) {
                mx = min(mx, dist[j] + 1);
            }
        }
        if (mx == INT_MAX) {
            cout << -1 << " ";
        } else {
            cout << mx << " ";
        }
    }
    cout << endl;
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int q;
    cin >> q;
    while (q--) {
        solve();
    }
    return 0;
}
