#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <queue>
#include <set>
#include <unordered_map>

using namespace std;

#define all(a) (a).begin(), (a).end()

typedef long long ll;


signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

	int t;
	cin >> t;

	for (; t; t--) {
		int n, m;
		cin >> n >> m;

		vector < vector < int > > g(n), can(n, vector < int >(n, 0));
		for (; m; m--) {
			int u, v;
			cin >> u >> v;

			g[--u].push_back(--v);
			g[v].push_back(u);
			can[u][v] = 1;
			can[v][u] = 1;
		}

		vector < vector < int > > dp(n, vector < int >(n, -1)), used(n, vector < int >(n, 0));
		dp[0][0] = 0;
		queue < pair < int, int > > q1;
		vector < pair < int, int > > q2;
		q1.push({ 0, 0 });
		q2.push_back({ 0, 0 });
		for (; !q1.empty(); ) {
			for (; !q1.empty(); q1.pop()) {
				int x = q1.front().first, y = q1.front().second;
				if (x == y)
					continue;

				for (int to : g[x]) {
					if (to != y && dp[to][y] == -1) {
						dp[to][y] = dp[x][y];
						q1.push({ to, y });
						q2.push_back({ to, y });
					}
				}
			}

			vector < pair < int, int > > tmp;
			for (pair < int, int > cur : q2) {
				int x = cur.first, y = cur.second;
				if (x == y) {
					for (int to : g[x]) {
						if (dp[x][to] == -1) {
							dp[x][to] = dp[x][y] + 1;
							q1.push({ x, to });
							tmp.push_back({ x, to });
						}
					}
				}
				else if (can[x][y] && dp[x][x] == -1) {
					dp[x][x] = dp[x][y] + 1;
					q1.push({ x, x });
					tmp.push_back({ x, x });
				}
			}
			q2 = tmp;
		}

		for (int i = 1; i < n; i++)
			cout << dp[i][i] << " ";
		cout << "\n";
	}

	return 0;
}
