#include <bits/stdc++.h>

using namespace std;
#define all(x) x.begin(),x.end()
#define ll long long
#define int long long
struct Point{
    int l,r,c,t;

    Point(int l,int r,int c,int t):l(l),r(r),c(c),t(t){};

    Point(){};
};

bool operator <(const Point &a,const Point &b){
    return a.r<b.r;
}

bool comp(const Point &a,const Point &b){
    return a.l<b.l;
}

int main() {
    ios::ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef MY_DEBUG
    freopen("input.txt","r",stdin);
#endif

    int t;
    cin>>t;

    for(int _i=0;_i<t;_i++){
        int n,m;
        cin>>n>>m;

        vector<int> a(n);
        for(int i=0;i<n;i++){
            cin>>a[i];
        }

        vector<Point> b(m);
        for(int i=0;i<m;i++){
            cin>>b[i].l>>b[i].r>>b[i].c>>b[i].t;
            b[i].l--;b[i].r--;
        }

        sort(all(b),comp);
        for(int x=0;x<n;x++){
            vector<Point> b2 = b;
            vector<int> arr;
            for(int j=0;j<m;j++){
                if(b2[j].t==1){
                    b2[j].l = min(b2[j].l,x);
                    b2[j].r = max(b2[j].r,x);
                    arr.push_back(b2[j].l);
                    arr.push_back(b2[j].r);
                }else{
                    arr.push_back(b2[j].l);
                    arr.push_back(b2[j].r);
                }
            }
            sort(all(arr));
            arr.erase(unique(all(arr)),arr.end());

            vector<pair<int,int> > a3;
            int last = 0;
            for(int i=0;i<arr.size();i++){
                int sm = 0;
                for(int j=last;j<arr[i];j++){
                    sm+=a[j];
                }
                a3.push_back({sm,arr[i]-1});
                a3.push_back({a[arr[i]],arr[i]});
                last = arr[i]+1;
            }
            int sm = 0;
            for(int j = last;j<n;j++){
                sm+=a[j];
            }
            a3.push_back({sm,n-1});

            int v= 0;
            multiset<Point> st;
            ll ans = 0;
            for(int i=0;i<a3.size();i++){
                int id = a3[i].second;
                while(v<b2.size()&&b2[v].l<=id){
                    st.insert(b2[v]);
                    v++;
                }

                while(!st.empty()&&a3[i].first>0){
                    Point p = *st.begin();
                    st.erase(st.begin());
                    if(p.r<id){
                        continue;
                    }

                    if(p.c>a3[i].first){
                        ans+=a3[i].first;
                        p.c-=a3[i].first;
                        a3[i].first= 0;
                        st.insert(p);
                    }else{
                        ans+=p.c;
                        a3[i].first-=p.c;
                    }
                }
            }

            cout<<ans<<" ";
        }
    }

}