#include <bits/stdc++.h>

using namespace std;

//#define int long long

const int MN = (int)(3e5) + 5, INF = (int)(1e18) + 5, MC = (int)(1e7) + 5;
int n, q, c[MN], tr[MC];
vector<int> ans;
vector<tuple<int, int, int, int>> ques;

void change(int x, int delta)
{
    for (; x < MC; x |= x + 1)
    {
        tr[x] += delta;
    }
}

int get_sum(int r)
{
    int res = 0;
    for (; r >= 0; r = (r & (r + 1)) - 1)
    {
        res += tr[r];
    }
    return res;
}

int get_sum(int l, int r)
{
    return get_sum(r) - get_sum(l - 1);
}

void solve()
{
    cin >> n >> q;
    ques.resize(q);
    ans.resize(q);
    int sum = 0, diff = 0;
    for (int i = 0; i < n; i++)
    {
        cin >> c[i];
        if (get_sum(c[i], c[i]) == 0)
        {
            diff++;
            change(c[i], 1);
        }
    }
//    cout << diff << " = diff\n";
    for (int i = 0; i < q; i++)
    {
        int t, k, x = -1;
        cin >> t >> k;
        if (t == 3)
        {
            cin >> x;
            x--;
        }
        ques[i] = {k, t, x, i};
//        cout << "k = " << k << "\n";
    }
    sort(ques.begin(), ques.end());
    int j = 0;
    for (int now = 0; now < MC && j < q; now++)
    {
//        cout << "now = " << now << "\n";
        while (j < q && get<0>(ques[j]) == now)
        {
//            cout << "j now get<0>(ques[j]) = " << j << " " << now << " " << get<0>(ques[j]) << "\n";
            int t = get<1>(ques[j]), x = get<2>(ques[j]), num = get<3>(ques[j]);
            if (t == 1)
            {
//                cout << "diff = " << diff << "\n";
                ans[num] = diff;
            }
            else if (t == 2)
            {
                ans[num] = sum;
            }
            else
            {
                ans[num] = c[x];
            }
            j++;
        }
        vector<int> a(n);
        for (int i = 0; i < n; i++)
        {
            int temp = get_sum(c[i] + 1, MC);
            a[i] = c[i] + temp;
            sum += temp;
        }
        for (int i = 0; i < n; i++)
        {
            if (get_sum(c[i], c[i]) == 1)
            {
                change(c[i], -1);
            }
            c[i] = a[i];
        }
        diff = 0;
        for (int i = 0; i < n; i++)
        {
            if (get_sum(c[i], c[i]) == 0)
            {
                diff++;
                change(c[i], 1);
            }
        }
//        cout << "now j = " << now << " " << j << "\n";
//        for (int i = 0; i < n; i++)
//        {
//            cout << c[i] << " ";
//        }
//        cout << "\n";
    }
    for (int i = 0; i < q; i++)
    {
        cout << ans[i] << "\n";
    }
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
