#include<bits/stdc++.h>
#define f first
#define s second
#define _ << ' ' <<
#define mp make_pair
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define Time() clock() / (ld) CLOCKS_PER_SEC
//#define int long long

//#pragma GCC optimize("O3,ofast")
//#pragma target ("sse,sse2,sse3,ssse4,avx,avx2")

#ifdef LOCAL
    #define cerr cout
#else
    #define cerr if(0) cerr
#endif // LOCAL

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<long long, long long> pll;
typedef pair<long double, long double> pld;

const int MAXN = 3e5 + 10, MAXM = MAXN * 4, MAXQ = 8e6 + 10;
const ll X = 1e12 + 10;

ll tree[MAXM], add[MAXM];

void build(int v, int l, int r) {
    add[v] = 0;
    if (l == r - 1) {
        tree[v] = l;
        return;
    }
    int m = (l + r) / 2;
    build(v * 2 + 1, l, m);
    build(v * 2 + 2, m, r);
    tree[v] = tree[v * 2 + 1] + tree[v * 2 + 2];
}

void upd(int v, int l, int r, int val) {
    tree[v] += 1ll * val * (r - l);
    add[v] += val;
}

void push(int v, int l, int r) {
    int m = (l + r) / 2;
    upd(v * 2 + 1, l, m, add[v]);
    upd(v * 2 + 2, m, r, add[v]);
    add[v] = 0;
}

void update(int v, int l, int r, int ql, int qr, int val) {
    if (ql <= l && r <= qr) {
        upd(v, l, r, val);
        return;
    }
    if (l >= qr || ql >= r) return;
    push(v, l, r);
    int m = (l + r) / 2;
    update(v * 2 + 1, l, m, ql, qr, val);
    update(v * 2 + 2, m, r, ql, qr, val);
    tree[v] = tree[v * 2 + 1] + tree[v * 2 + 2];
}

ll treen[MAXQ];
int addn[MAXQ];

int lef[MAXQ], rig[MAXQ];

int nxtv = 1;

int makeNode() {
    assert(nxtv < MAXQ);
    return nxtv++;
}

void updN(int v, ll l, ll r, int val) {
    treen[v] += val * (r - l);
    addn[v] += val;
}

void pushN(int v, ll l, ll r) {
    ll m = (l + r) / 2;
    if (!lef[v]) lef[v] = makeNode();
    if (!rig[v]) rig[v] = makeNode();
    updN(lef[v], l, m, addn[v]);
    updN(rig[v], m, r, addn[v]);
    addn[v] = 0;
}

void updateN(int v, ll l, ll r, ll ql, ll qr, int val) {
    if (ql <= l && r <= qr) {
        //cerr << "update" _ ql _ qr _ l _ r _ val << endl;
        updN(v, l, r, val);
        return;
    }
    if (l >= qr || ql >= r) return;
    int m = (l + r) / 2;
    if (!lef[v]) lef[v] = makeNode();
    if (!rig[v]) rig[v] = makeNode();
    pushN(v, l, r);
    updateN(lef[v], l, m, ql, qr, val);
    updateN(rig[v], m, r, ql, qr, val);
    treen[v] = treen[lef[v]] + treen[rig[v]];
}

ll getSumN(int v, ll l, ll r, ll ql, ll qr) {
    if (ql <= l && r <= qr) {
        //cerr << "getSum" _ ql _ qr _ l _ r _ treen[v]<< endl;
        return treen[v];
    }
    if (ql >= r || l >= qr) return 0;
    int m = (l + r) / 2;
    if (!lef[v]) lef[v] = makeNode();
    if (!rig[v]) rig[v] = makeNode();
    pushN(v, l, r);
    return getSumN(lef[v], l, m, ql, qr) + getSumN(rig[v], m, r, ql, qr);
}

pair<ll, int> b[MAXN];
ll a[MAXN];
int revp[MAXN];

pair<ll, int> events[MAXN];
int esz = 0;

ll ans[MAXN];

pair<ll, int> query[2][MAXN];
int szq[2];

vector<pair<ll, int> > q3[MAXN];

ll mergeNext[MAXN];

void solve() {
    int n, q;
    cin >> n >> q;
    for (int i = 0; i < n; i++) {
        cin >> b[i].f;
        b[i].s = i;
    }
    sort(b, b + n);
    for (int i = 0; i < n; i++) {
        a[i] = b[i].f;
        revp[b[i].s] = i;
    }
    /*cerr << "new a:" << endl;
    for (int i = 0; i < n; i++) cerr << a[i] << ' ';
    cerr << endl;*/
    ll d = 0;
    esz = n - 1;
    for (int i = 0; i < n - 1; i++) {
        events[i] = {a[i + 1] - a[i], i};
        mergeNext[i] = a[i + 1] - a[i];
        //cerr << "merge next" _ i + 1 _ "int time" _ mergeNext[i] << endl;
    }
    mergeNext[n - 1] = X;
    sort(events, events + esz);
    int type;
    ll x;
    int ind;
    for (int i = 0; i < q; i++) {
        cin >> type >> x;
        type--;
        if (type < 2) query[type][szq[type]++] = {x, i};
        else {
            cin >> ind;
            q3[revp[--ind]].push_back({x, i});
        }
    }
    for (int i = 0; i < 3; i++) sort(query[i], query[i] + szq[i]);
    int cnt = n;
    ind = 0;
    //first query
    for (int i = 0; i < szq[0]; i++) {
        while (ind < esz && events[ind].f <= query[0][i].f) {
            cnt--;
            ind++;
        }
        ans[query[0][i].s] = cnt;
    }
    //cerr << "first!" << endl;
    //second query
    ll sum = 0;
    ind = 0;
    build(0, 0, n);
    ll ptime = 0;
    for (int i = 0; i < szq[1]; i++) {
        while (ind < esz && events[ind].f <= query[1][i].f) {
            sum += (events[ind].f - ptime) * tree[0];
            ptime = events[ind].f;
            update(0, 0, n, 0, events[ind].s + 1, -1);
            ind++;
        }
        ans[query[1][i].s] = sum + (query[1][i].f - ptime) * tree[0];
    }
    //third query
    for (int i = n - 1; i >= 0; i--) {
        updateN(0, 0, X, mergeNext[i], X, -1);
        //cerr << "del from" _ mergeNext[i] << endl;
        for (auto [x, ind] : q3[i]) {
            //cerr << "query" _ 0 _ x _ a[i]<< endl;
            ans[ind] = getSumN(0, 0, X, 0, x) + a[i];
        }
        //cerr << "add all" << endl;
        updateN(0, 0, X, 0, X, 1);
    }
    /*
    for (int i = 0; i < n; i++) {
        sort(all(q3[i]));
        ind = 0;
        ptime = 0;
        int v = n - i - 1;
        sum = 0;
        for (auto [x, j] : q3[i]) {
            //cerr << "query" _ i + 1 _ x << ":" << endl;
            while (ind < esz && events[ind].f <= x) {
                if (i > events[ind].s) {
                    ind++;
                    continue;
                }
                sum += 1ll * (events[ind].f - ptime) * v;
                v--;
                //cerr << "time" _ events[ind].f _ "sum" _ sum _ "v" _ v << endl;
                ptime = events[ind].f;
                ind++;
            }
            ans[j] = sum + 1ll * v * (x - ptime) + a[i];
        }
    }*/
    for (int i = 0; i < q; i++) cout << ans[i] << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
    }
    return 0;
}
