#include <bits/stdc++.h>

using namespace std;

struct Robot {
    long long l;
    long long r;
    long long t;
    long long c;
    Robot(long long _l=0, long long _r=0, long long type=0, long long _c=0) {
        l = _l;
        r = _r;
        t = type;
        c = _c;
    }
    pair<long long, long long> get_lr(long long x);
};

pair<long long, long long> Robot::get_lr(long long x) {
    if (t == 0) {
        return {l, r};
    }
    return {min(l, x), max(r, x)};
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    long long t;
    cin >> t;
    for (long long ui = 0; ui < t; ++ui) {
        long long n, m;
        cin >> n;
        cin >> m;
        long long data[n];
        for (long long i = 0; i < n; ++i) {
            cin >> data[i];
        }
        Robot robots[m];
        for (long long i = 0; i < m; ++i) {
            long long l, r, c, type;
            cin >> l;
            cin >> r;
            cin >> c;
            cin >> type;
            l--;
            r--;
            robots[i] = Robot(l, r, type, c);
        }
        for (long long x = 0; x < n; ++x) {
            long long ans[n];
            fill(ans, ans + n, 0);
            vector<pair<pair<long long, long long>, long long> > edges(m);
            for (long long i = 0; i < m; ++i) {
                auto pr = robots[i].get_lr(x);
                edges[i] = {{pr.second - pr.first, pr.first}, i};
            }
            sort(edges.begin(), edges.end());
            for (auto e: edges) {
                //cout << e.first.first << ' ' << e.first.second << ' ' << e.second << endl;
                long long already = 0;
                for (long long p = e.first.second; p <= e.first.second + e.first.first; ++p) {
                    long long can = robots[e.second].c - already;
                    if (can + ans[p] <= data[p]) {
                        ans[p] += can;
                        already += can;
                    }
                    else {
                        already += data[p] - ans[p];
                        ans[p] = data[p];
                    }
                }
                /*for (long long i = 0; i < n; ++i) {
                    cout << ans[i] << ' ';
                }
                cout << endl;*/
            }
            long long s = 0;
            for (long long i = 0; i < n; ++i) {
                s += ans[i];
                //cout << ans[i] << ' ';
            }
            cout << s << ' ';
            //cout << endl;
        }
        cout << endl;
    }
    return 0;
}
