#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
typedef long long ll;
typedef long double ld;

set<ll> posses[10];

ll bpow(ll a, ll p) {
	if (p == 0) return 1ll;
	if (p % 2) return (bpow(a, p - 1) * a);
	ll b = bpow(a, p / 2);
	return b * b;
}

const ll SZ = (1ll << 21);
pair<ll, vector<ll>> dp[SZ];
ll y;

vector<ll> stupid(vector<ll> vec) {
	for (int i = 1; i < (1ll << (vec.size())); i++) {
		ll cnter = 0;
		for (int j = vec.size() - 1; j >= 0; j--) {
			if ((i >> j) & 1) {
				pair<ll, vector<ll>> nd = dp[(i ^ (1ll << j))];
				nd.second.push_back(vec[j]);
				nd.first -= cnter * y;
				nd.first += bpow(10, vec.size() - nd.second.size()) * vec[j];

				dp[i] = max(dp[i], nd);
				cnter++;
			}
		}
	}

	return dp[(1ll << vec.size()) - 1].second;
}

int main() {
	fastInp;
	string s;
	cin >> s;
	vector<ll> vec;
	for (auto c : s) {
		vec.push_back(c - '0');
	}

	cin >> y;

	vector<ll> vec2;

	set<pair<ll, ll>> st;
	for (int i = 0; i < vec.size(); i++) {
		st.insert({ vec[i], -i });
	}

	vec.clear();
	while (st.size() > 17) {
		pair<ll, ll> v = (*st.rbegin());
		vec.push_back(v.first);
		st.erase(--st.end());
	}
	
	vector<pair<ll, ll>> hlp;
	for (auto c : st) {
		hlp.push_back({ c.second, c.first });
	}
	sort(hlp.rbegin(), hlp.rend());
	for (auto c : hlp) vec2.push_back(c.second);

	sort(vec.rbegin(), vec.rend());

	vec2 = stupid(vec2);
	/*for (int i = 0; i < vec2.size(); i++) {
		for (int j = 0; j < vec2.size() - 1; j++) {
			ll ind = vec2.size() - j - 1;
			ll t = (vec2[j] * bpow(10, ind) + vec2[j + 1] * bpow(10, ind - 1));
			ll get = (vec2[j + 1] * bpow(10, ind) + vec2[j] * bpow(10, ind - 1)) - t;
			if (vec2[j] < vec2[j + 1] && (ind >= 17 || get >= y)) {
				swap(vec2[j], vec2[j + 1]);
			}
		}
	}*/

	for (auto c : vec) cout << c;
	for (auto c : vec2) cout << c;

	return 0;
}

/*
314599
17713
*/