#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
typedef long long ll;
typedef long double ld;

#define int ll

const ll SZ = 3e5 + 100, INF = 1e9 * 1e9 + 100, MX = 1'000'000'000'000 + 1000;
ll n, q;
vector<ll> vec, ans, death;
ll uni = 0;
ll tomax[SZ];

ll rnd(ll a, ll b) {
	if (a == 0) return 0;
	return (a - 1) / b + 1;
}
void pretypeone() {
	vector<ll> cur = vec;

	sort(cur.begin(), cur.end());
	auto it = unique(cur.begin(), cur.end());
	cur.erase(it, cur.end());
	uni = cur.size();

	for (int i = 0; i < cur.size() - 1; i++) {
		ll speed = cur.size() - i - 1;
		death.push_back(cur[i + 1] - cur[i]);
	}

	sort(death.begin(), death.end());
}

map<ll, ll> pos;
vector<pair<ll, ll>> sv;
vector<ll> prefSm, prefSm2;

void pretypetwo() {
	vector<ll> cur = vec;

	for (int i = 0; i < cur.size(); i++) pos[cur[i]] = i;

	for (int i = cur.size() - 2; i >= 0; i--) {
		sv.push_back({ cur[i + 1] - cur[i], i + 1 });
	}

	sort(sv.begin(), sv.end());
	prefSm.push_back(0);
	prefSm2.push_back(0);
	for (auto c : sv) prefSm.push_back(prefSm.back() + c.second);
	for (auto c : sv) prefSm2.push_back(prefSm2.back() + c.second * c.first);
}

struct node {
	int sum = 0;
	node* l = 0, *r = 0;

	void upd(int segl, int segr, int pos, int val) {
		if (segl == segr - 1) {
			sum += val;
		}
		else {
			int mid = (segl + segr) / 2;
			if (!l) l = new node();
			if (!r) r = new node();

			if (pos < mid) {
				l->upd(segl, mid, pos, val);
			}
			else {
				r->upd(mid, segr, pos, val);
			}

			sum = l->sum + r->sum;
		}
	}

	ll ask(int segl, int segr, int askl, int askr) {
		if (askl == askr) return 0;
		if (!l) l = new node();
		if (!r) r = new node();
		if (segl >= askr || segr <= askl) return 0;

		if (askl <= segl && segr <= askr) return sum;

		int mid = (segl + segr) / 2;
		return l->ask(segl, mid, askl, askr) + r->ask(mid, segr, askl, askr);
	}
};

node* root = new node();
node* root2 = new node();

vector<pair<ll, ll>> qs[SZ];

void pretypethree() {
	for (int i = vec.size() - 1; i >= 0; i--) {
		if (i != ll(vec.size()) - 1) root->upd(0, MX, vec[i + 1] - vec[i], 1);
		if (i != ll(vec.size()) - 1) root2->upd(0, MX, vec[i + 1] - vec[i], vec[i + 1] - vec[i]);

		for (auto c : qs[i]) {
			ll t = root->ask(0, MX, c.first + 1, MX);
			ans[c.second] = t * c.first + root2->ask(0, MX, 0, c.first + 1) + vec[i];
		}


	}
}

signed main() {
	fastInp;

	cin >> n >> q;
	vec.resize(n);
	for (auto& c : vec) cin >> c;

	vector<ll> def = vec;
	sort(vec.begin(), vec.end());
	vector<ll> pref(1);
	for (auto c : vec) pref.push_back(c + pref.back());
	pretypeone();
	pretypetwo();

	ans.resize(q);
	for (int i = 0; i < q; i++) {
		ll t;
		cin >> t;

		if (t == 1) {
			ll k;
			cin >> k;

			ans[i] = uni - (upper_bound(death.begin(), death.end(), k) - death.begin());
		}
		else if (t == 2) {
			ll k;
			cin >> k;

			ll smaller = upper_bound(sv.begin(), sv.end(), make_pair(k, INF)) - sv.begin();
			ans[i] = prefSm2[smaller] + k * (prefSm.back() - prefSm[smaller]);
		}
		else {
			ll k;
			ll j;
			cin >> k >> j;
			j--;

			qs[pos[def[j]]].push_back({ k, i });
		}
	}

	pretypethree();

	for (auto c : ans) cout << c << "\n";

	return 0;
}

/*
5 4
0 3 5 4 2
1 0
1 1
2 1
3 1 1

6 6
5 4 4 2 2 2
1 0
1 1
1 2
2 1
2 2
3 1 5


*/