#include <bits/stdc++.h>
using namespace std;

#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;

typedef long long ll;
typedef pair<int, int> pii;

template<typename T> using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

#define ff first
#define ss second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define print(x) {for(auto &__val: x) cout << __val << ' '; cout << '\n';}

struct query{
    int t;
    ll k;
    int i;
    int ind;
};

bool comp(query &a, query &b) {
    return a.k < b.k;
}

void solve() {
    int n, q;
    cin >> n >> q;
    vector<ll> a(n);
    for(auto &i: a) cin >> i;
    vector<query> slv;
    for(int j=0;j<q;j++) {
        int t;
        cin >> t;
        if(t == 1){
            ll k;
            cin >> k;
            slv.pb({t, k, -1, j});
        } else if(t == 2) {
            ll k;
            cin >> k;
            slv.pb({t, k, -1, j});
        } else {
            ll k;
            int i;
            cin >> k >> i;
            slv.pb({t, k, i-1, j});
        }
    }
    vector<ll> ans(q);
    vector<ll> nw = a;
    vector<ll> u = a;
    sort(all(u));
    u.resize(unique(all(u)) - u.begin());
    ll nk = 0;
    sort(all(slv), comp);
    int pos = 0;
    while(pos < slv.size()) {
        int m = (int)u.size();
        ll mn = 1e9;
        for(int i=1;i<m;i++) {
            mn = min(mn, u[i] - u[i-1]);
        }
        vector<ll> chng(n);
        for(int i=0;i<n;i++) chng[i] = (m - 1 - (int)(lower_bound(all(u), nw[i]) - u.begin()));
        while(pos < slv.size() && slv[pos].k < nk + mn) {
            ll k = slv[pos].k;
            if(slv[pos].t == 1) {
                ans[slv[pos].ind] = m;
            } else if(slv[pos].t == 2){
                ll tans = 0;
                for(int i=0;i<n;i++) tans += nw[i] + (k - nk) * chng[i];
                for(auto &i: a) tans -= i;
                ans[slv[pos].ind] = tans;
            } else {
                ll val = nw[slv[pos].i];
                ll add = -1;
                for(int i=0;i<m;i++) {
                    if(u[i] == val) {
                        add = m - i - 1;
                        break;
                    }
                }
                ans[slv[pos].ind] = val + (k - nk) * add;
            }
            pos++;
        }
        for(int i=0;i<n;i++) nw[i] += mn * chng[i];
        for(int i=0;i<m;i++) u[i] += mn * (m - i - 1);
        u.resize(unique(all(u)) - u.begin());
        nk += mn;
    }
    for(auto &i: ans) cout << i << '\n';
}
/*
4 6
1 3 5 10
1 0
1 1
1 2
1 3
1 4
1 5
*/
signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    int t = 1;
    //cin >> t;
    while(t--) {
        solve();
    }
}
