#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

int main() {
	int n, q;
	cin >> n >> q;
	vector<pair<ll, int>> c(n);
	for (int i = 0; i < n; i++) {
		cin >> c[i].first;
		c[i].second = i;
	}
	sort(c.begin(), c.end());
	vector<pair<ll, int>> dc;
	for (int i = 0; i + 1 < n; i++) {
		dc.push_back({ c[i + 1].first - c[i].first, i });
	}
	dc.push_back({ 0, -1 });
	sort(dc.begin(), dc.end());
	vector<ll> sum(n);
	sum[0] = 0;
	ll add = n * (n - 1) / 2;
	for (int i = 1; i < n; i++) {
		// cout << "add = " << add << "\n";
		sum[i] = sum[i - 1] + (dc[i].first - dc[i - 1].first) * add;
		// cout << "sum[" << i << "] = " << sum[i] << "\n";
		add -= dc[i].second + 1;
	}
	for (int x = 0; x < q; x++) {
		int t;
		ll k;
		cin >> t >> k;
		if (t == 1) {
			cout << dc.end() - lower_bound(dc.begin(), dc.end(), make_pair(k + 1, -1)) + 1 << "\n";
		}
		else if (t == 2) {
			int i = lower_bound(dc.begin(), dc.end(), make_pair(k + 1, -1)) - dc.begin();
			if (i == n) {
				cout << sum.back() << "\n";
			}
			else {
				cout << sum[i - 1] + (k - dc[i - 1].first) * (n - i + 1) * (n - i) / 2 << "\n";
			}
		}
	}
}
