#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;

typedef long long ll;
typedef long double ld;

using vi = vector<int>;
using vl = vector<ll>;
using vvi = vector<vi>;

const int INFi = 2e9;
const ll INF = 2e18;
const int maxN = 1e5;

void solve() {
    int n, m;
    cin >> n >> m;
    vi a(n);
    rep(i, n) cin >> a[i];
    vector<ar<int, 4>> b(m);
    rep(i, m) rep(j, 4) cin >> b[i][j];
    vi xx;
    rep(i, m) {
        b[i][0]--;
        b[i][1]--;
        xx.push_back(b[i][0]);
        xx.push_back(b[i][1]);
    }
    xx.push_back(0);
    xx.push_back(n - 1);
    sort(all(xx));
    xx.resize(unique(all(xx)) - xx.begin());
    auto solve1 = [&](int x) {
        vector<int> c(m);
        vector<int> l(m), r(m);
        vvi Lq(n), Rq(n);
        rep(i, m) {
            l[i] = b[i][0];
            r[i] = b[i][1];
            if (b[i][3] == 1) {
                l[i] = min(l[i], xx[x]);
                r[i] = max(r[i], xx[x]);
            }
            Lq[l[i]].push_back(i);
            Rq[r[i]].push_back(i);
            c[i] = b[i][2];
        }
        ll ans = 0;
        {
            set<pair<int, int>> have;
            for (int i = 0; i <= xx[x]; ++i) {
                for (auto &j: Lq[i]) have.insert({r[j], j});
                int y = a[i];
                while (!have.empty() && y > 0) {
                    auto[p, v] = *have.begin();
                    have.erase(have.begin());
                    int t = min(c[v], y);
                    c[v] -= t;
                    y -= t;
                    ans += t;
                    if (c[v] > 0) {
                        have.insert({r[v], v});
                    }
                }
                for (auto &j: Rq[i]) have.erase({r[j], j});
            }
        }
        {
            set<pair<int, int>> have;
            for (int i = n - 1; i > xx[x]; --i) {
                for (auto &j: Rq[i]) have.insert({-l[j], j});
                int y = a[i];
                while (!have.empty() && y > 0) {
                    auto[p, v] = *have.begin();
                    have.erase(have.begin());
                    int t = min(c[v], y);
                    c[v] -= t;
                    y -= t;
                    ans += t;
                    if (c[v] > 0) {
                        have.insert({-l[v], v});
                    }
                }
                for (auto &j: Lq[i]) have.erase({-l[j], j});
            }
        }
        return ans;
    };
    vector<ll> answ(n), ost(n);
    answ[0] = solve1(0);
    for (int x = 0; x + 1 < (int) xx.size(); ++x) {
        answ[xx[x + 1]] = solve1(x + 1);
        if (xx[x + 1] == xx[x] + 1) continue;
        vector<int> c(m);
        vector<int> l(m), r(m);
        vvi Lq(n), Rq(n);
        rep(i, m) {
            l[i] = b[i][0];
            r[i] = b[i][1];
            if (b[i][3] == 1) {
                l[i] = min(l[i], xx[x + 1] - 1);
                r[i] = max(r[i], xx[x] + 1);
            }
            Lq[l[i]].push_back(i);
            Rq[r[i]].push_back(i);
            c[i] = b[i][2];
        }
        ll ans = 0;
        {
            set<pair<int, int>> have;
            for (int i = 0; i <= xx[x]; ++i) {
                for (auto &j: Lq[i]) have.insert({r[j], j});
                int y = a[i];
                while (!have.empty() && y > 0) {
                    auto[p, v] = *have.begin();
                    have.erase(have.begin());
                    int t = min(c[v], y);
                    c[v] -= t;
                    y -= t;
                    ans += t;
                    if (c[v] > 0) {
                        have.insert({r[v], v});
                    }
                }
                for (auto &j: Rq[i]) have.erase({r[j], j});
            }
        }
        {
            set<pair<int, int>> have;
            for (int i = n - 1; i >= xx[x + 1]; --i) {
                for (auto &j: Rq[i]) have.insert({-l[j], j});
                int y = a[i];
                while (!have.empty() && y > 0) {
                    auto[p, v] = *have.begin();
                    have.erase(have.begin());
                    int t = min(c[v], y);
                    c[v] -= t;
                    y -= t;
                    ans += t;
                    if (c[v] > 0) {
                        have.insert({-l[v], v});
                    }
                }
                for (auto &j: Lq[i]) have.erase({-l[j], j});
            }
        }
        ll haveL = 0;
        ll haveR = 0;
        ll have = 0;
        rep(i, m) {
            if (l[i] <= xx[x] && r[i] >= xx[x + 1]) {
                have += c[i];
                continue;
            }
            if (b[i][3] == 1) {
                if (l[i] == xx[x + 1] - 1) {
                    haveR += c[i];
                } else {
                    assert(r[i] == xx[x] + 1);
                    haveL += c[i];
                }
            } else {
                assert(r[i] <= xx[x] || l[i] >= xx[x + 1]);
            }
        }
        ll full = 0;
        for (int i = xx[x] + 1; i < xx[x + 1]; ++i) full += a[i];
        {
            ll val = 0;
            for (int i = xx[x] + 1; i < xx[x + 1]; ++i) {
                answ[i] += val;
                ost[i] += haveL;
                ll t = min(haveL, 1ll * a[i]);
                val += t;
                haveL -= t;
            }
        }
        {
            ll val = 0;
            for (int i = xx[x + 1] - 1; i > xx[x]; --i) {
                answ[i] += val;
                ost[i] += haveR;
                ll t = min(haveR, 1ll * a[i]);
                val += t;
                haveR -= t;
            }
        }
        for (int i = xx[x] + 1; i < xx[x + 1]; ++i) {
            answ[i] += min(1ll * a[i], ost[i]);
            answ[i] = min(answ[i] + have, full);
            answ[i] += ans;
        }
    }
    rep(i, n) cout << answ[i] << ' ';
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    cin >> t;
    rep(_, t) {
        solve();
    }
    return 0;
}