#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("avx2")

typedef long long ll;
typedef long double ld;

#define int ll

#define pb push_back
#define f first
#define s second
#define pii pair<int, int>

const int N = 5e5 + 10;
vector<int> g[N], g1[N];

map<pii, int> blocked;

int tin[N], fup[N], timer = 0, used[N];
int t_s[N];

void dfs(int v, int p = -1) {
    used[v] = 1;
    tin[v] = fup[v] = timer++;
    int kolvo = 0;
    for (auto u: g[v]) {
        if (u == p)
            continue;
        if (used[u]) {
            fup[v] = min(fup[v], tin[u]);
        } else {
            kolvo++;
            dfs(u, v);
            fup[v] = min(fup[v], fup[u]);
        }
        if (fup[u] > tin[v]) {
            blocked[{u, v}] = blocked[{v, u}] = 1;
        }
        if (fup[u] >= tin[v]){
            t_s[v] = 1;
        }
    }
    if (kolvo == 1 && p == -1){
        t_s[v] = 1;
    }
}

void dfs1(int v, int bl){
    used[v] = 1;
    for (auto u : g1[v]){
        if (used[u] || u == bl)
            continue;
        dfs1(u, bl);
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    timer = 0;
    blocked.clear();
    for (int i = 0; i < n; i++){
        g[i].clear();
        g1[i].clear();
        used[i] = tin[i] = fup[i] = t_s[i] = 0;
    }
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].pb(b);
        g[b].pb(a);
    }
    dfs(0);
    for (int i = 0; i < n; i++) {
        for (auto u: g[i]) {
            if (!blocked[{i, u}]) {
                g1[i].pb(u);
            }
        }
    }
    int d[n][2], par[n][2];
    const int inf = 1e9;
    for (int i = 0; i < n; i++) {
        d[i][0] = d[i][1] = inf;
        par[i][0] = par[i][1] = inf;
    }
    d[0][1] = 0;
    set<pair<int, pair<int, int>>> st;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < 2; j++)
            st.insert({d[i][j], {i, j}});
    }
    int ans[n];
    for (int i = 0; i < n; i++)
        ans[i] = -1;
    while (!st.empty()) {
        pii v = st.begin() -> s;
        if (d[v.f][v.s] == inf){
            break;
        }
        st.erase({d[v.f][v.s], v});
        for (auto u : g1[v.f]){
            pii u1 = {u, 1 - v.s};
            if (v.s == 1) {
                if (st.count({d[u1.f][u1.s], u1})) {
                    st.erase({d[u1.f][u1.s], u1});
                    d[u1.f][u1.s] = min(d[u1.f][u1.s], d[v.f][v.s] + 1);
                    if (d[u1.f][u1.s] == d[v.f][v.s] + 1){
                        par[u1.f][u1.s] = v.f;
                    }
                    st.insert({d[u1.f][u1.s], u1});
                }
            }else{
                for (int j = 0; j < n; j++)
                    used[j] = 0;
                dfs1(par[v.f][v.s], v.f);
                if(used[u1.f]) {
                    st.erase({d[u1.f][u1.s], u1});
                    d[u1.f][u1.s] = min(d[u1.f][u1.s], d[v.f][v.s] + 1);
                    if (d[u1.f][u1.s] == d[v.f][v.s] + 1){
                        par[u1.f][u1.s] = v.f;
                    }
                    st.insert({d[u1.f][u1.s], u1});
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (d[i][1] == inf)
            continue;
        ans[i] = d[i][1];
    }
    for (int i = 1; i < n; i++)
        cout << ans[i] << ' ';
    cout << endl;
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}