#include <bits/stdc++.h>

using namespace std;

#define int long long
#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>

const int inf = 1e9;
const int N = 2e6;

void solve() {
    int n, m; cin >> n >> m;
    vi a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    vector<pair<pii, pii>> b;
    for (int i = 0; i < m; ++i) {
        int l, r, x, t; cin >> l >> r >> x >> t;
        --l, --r;
        b.push_back({{l, r}, {x, t}});
    }
    for (int i = 0; i < n; ++i) {
        vector<pair<pii, int>> rob;
        vi f(n);
        for (int j = 0; j < m; ++j) {
            int l = b[j].first.first, r = b[j].first.second;
            int x = b[j].second.first;
            if (b[j].second.second) {
                rob.push_back({{min(l, i), max(r, i)}, x});
            } else {
                rob.push_back({{l, r}, x});
            }
        }
        f = a;
        int ans = 0;
        sort(rob.begin(), rob.end(), [](pair<pii, int> a, pair<pii, int> b) {
            return a.first.second < b.first.second;
        });
        for (int j = 0; j < m; ++j) {
            for (int i = rob[j].first.first; i <= rob[j].first.second; ++i) {
                int can = min(f[i], rob[j].second);
                rob[j].second -= can;
                f[i] -= can;
                ans += can;
                if (!rob[j].second) break;
            }
        }
        cout << ans << ' ';
    }
    cout << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int t; cin >> t;
    while (t--) {
        solve();
    }
}