#pragma GCC optimize("Ofast")
//#pragma GCC target("avx2,sse4,popcnt")

#include <bits/stdc++.h>

#define sq(x) ((x)*(x))
#define err(x) cerr << "["#x"]  " << (x) << '\n'
#define errv(x) {cerr << "["#x"]  ["; for(const auto& i : (x))  cerr << i << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (int i = 0; i < (n); ++i) cerr << (x)[i] << ", "; cerr << "]\n";}
#define errf() cerr << "\n\n"

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
inline ll getrnd(ll l, ll r) {
    return uniform_int_distribution<ll>(l, r)(rng);
}

template<typename T1, typename T2>
inline bool relax(T1& a, const T2& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T1, typename T2>
inline bool strain(T1& a, const T2& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

// :::::::::::::::::::::::::::::::::::

void solve() {
    string s;
    cin >> s;
    ll cost;
    cin >> cost;
    int n = s.size();

    vector<queue<int>> pos(10);
    vector<int> used(n);
    for (int i = 0; i < n; ++i)
        pos[s[i] - '0'].push(i);

    int sz = 18;
    relax(sz, n);
    string tmp = s;
    sort(tmp.rbegin(), tmp.rend());
    string res;
    for (int i = 0; i < n - sz; ++i) {
        res += tmp[i];
        int c = tmp[i] - '0';
        int ps = pos[c].front();
        pos[c].pop();
        used[ps] = 1;
    }

    string lft;
    for (int i = 0; i < n; ++i)
        if (!used[i])
            lft += s[i];
//    err(lft);
    const ll INF = 5e18;
//    ll ans = -INF;
//    string ansi;
//    vector<int> ord(sz);
//    iota(ord.begin(), ord.end(), 0);
//    do {
//        ll cur = 0, pw = 1;
//        for (int i = 0; i < sz - 1; ++i)
//            pw *= 10;
//        string tmp;
//        for (int i = 0; i < sz; ++i) {
//            tmp += lft[ord[i]];
//            cur += pw * (lft[ord[i]] - '0');
//            pw /= 10;
//        }
//        for (int i = 0; i < sz; ++i) {
//            for (int j = 0; j < i; ++j) {
//                if (ord[j] > ord[i])
//                    cur -= cost;
//            }
//        }
//        if (ans < cur) {
//            ans = cur;
//            ansi = tmp;
//        } else if (ans == cur) {
//            strain(ansi, tmp);
//        }
//    } while (next_permutation(ord.begin(), ord.end()));
    vector<ll> pws(sz);
    pws[0] = 1;
    for (int i = 1; i < sz; ++i)
        pws[i] = pws[i - 1] * 10;

    vector<vector<pair<ll, string>>> dp(1 << sz, vector<pair<ll, string>>(sz, {-INF, ""}));
    for (int i = 0; i < sz; ++i) {
        dp[1 << i][i].first = pws[sz - 1] * (lft[i] - '0');
        dp[1 << i][i].second = lft[i];
    }
    for (int msk = 0; msk < (1 << sz); ++msk) {
        for (int lst = 0; lst < sz; ++lst) {
            if (!((msk >> lst) & 1)) continue;
            ll inv = 0;
            for (int j = lst + 1; j < sz; ++j) {
                if ((msk >> j) & 1)
                    ++inv;
            }
            for (int prv = 0; prv < sz; ++prv) {
                int nmsk = msk ^ (1 << lst);
                if (!((nmsk >> prv) & 1)) continue;
                auto res = dp[nmsk][prv];
                int len = __builtin_popcount(msk);
                res.first += pws[sz - len] * (lft[lst] - '0');
                res.first -= cost * inv;
                res.second += lft[lst];
                strain(dp[msk][lst], res);
            }
        }
    }
//    err(ans);
    pair<ll, string> bst = {-INF, ""};
    for (int i = 0; i < sz; ++i)
        strain(bst, dp[(1 << sz) - 1][i]);
    cout << res << bst.second << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1;
//    cin >> t;
    while (t--)
        solve();
    return 0;
}

