#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
//#define double long double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

typedef tree<pair<int, int>, null_type, less<pair<int, int>>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int MAXN = 4e5 + 7;
const int INF = 1e9 + 7;

int n;
int f1[MAXN];
int f2[MAXN];
int f3[MAXN];

void update(int *f, int i, int x) {
    while (i < n) {
        f[i] += x;
        i |= i + 1;
    }
}

int get_ans(int *f, int i) {
    int ans = 0;
    while (i >= 0) {
        ans += f[i];
        i &= i + 1;
        i--;
    }
    return ans;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q; cin >> n >> q;
    vector<int> vec(n);
    for (int i = 0; i < n; ++i) cin >> vec[i];
    sort(all(vec));
    ordered_set o;
    for (int i = 1; i < n; ++i) {
        o.insert({vec[i] - vec[i - 1], i});
    }
    vector<pair<int, int>> zap;
    for (int i = n - 2; i >= 0; --i) {
        //if (vec[i] == vec[i + 1]) continue;
        int e = vec[i + 1] - vec[i];
        zap.push_back({e, i + 1});
    }
    sort(all(zap));
    //for (auto it: zap) cout << it.first << " " << it.second << endl;
    vector<int> pr(zap.size());
    for (int i = 0; i < zap.size(); ++i) {
        pr[i] = zap[i].first * zap[i].second;
        if (i > 0) pr[i] += pr[i - 1];
    }
    vector<int> sf(zap.size());
    for (int i = (int)zap.size() - 1; i >= 0; --i) {
        sf[i] = zap[i].second;
        if (i < (int)zap.size() - 1) sf[i] += sf[i + 1];
    }
    vector<int> ans(q);
    vector<vector<int>> zz(q);
    vector<vector<pair<int, int>>> ee(n);
    for (int i = 0; i < q; ++i) {
        int t, k; cin >> t >> k;
        if (t == 3) {
            int h; cin >> h;
            zz[i] = {t, k, h};
            h--;
            ee[h].push_back({k, i});
        }
        else zz[i] = {t, k};
    }
    for (int i = 0; i < q; ++i) {
        int t = zz[i][0];
        if (t == 1) {
            int k = zz[i][1];
            ans[i] = n - o.order_of_key({k, INF});
        }
        else if (t == 2) {
            int k = zz[i][1];
            int l = -1, r = zap.size();
            while (r - l > 1) {
                int m = (l + r) / 2;
                if (zap[m].first <= k) l = m;
                else r = m;
            }
            int x = 0;
            if (l != -1) x += pr[l];
            if (r < zap.size()) x += sf[r] * k;
            ans[i] = x;
        }
    }
    for (auto it: ans) cout << it << '\n';
}

/*
6 5
5 4 4 2 2 2
1 0
1 1
1 2
2 1
2 2

*/
