#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
// #pragma GCC optimize("O3")
// #pragma GCC optimize("fast-math")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC optimize("Ofast")
// #pragma GCC target("avx2,popcnt,lzcnt,bmi,bmi2")
#endif

#include <algorithm>
#include <cassert>
#include <chrono>
#include <cstdlib>
#include <cstring>
#include <deque>
#include <iomanip>
#include <iostream>
#include <map>
#include <numeric>
#include <queue>
#include <random>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;
using ll = long long;

const int INF = 0x3f3f3f3f;
const ll INFLL = 0x3f3f3f3f3f3f3f3fll;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    int l, r, c, t;
    cin >> l >> r >> c >> t;
    l--;
    for (int i = 0; i < n; i++) {
        int L, R;
        if (t == 0) {
            L = l, R = r;
        } else {
            L = min(l, i), R = max(r, i + 1);
        }
        ll sm = 0;
        for (int j = L; j < R; j++) {
            sm += a[j];
        }
        cout << min(sm, (ll)c) << ' ';
    }
    cout << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int t = 1;
    cin >> t;
    while (t--) solve();
}