//#pragma GCC optimize("O3,unroll-loops,rename-register,rename-registers,fast-math")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,avx,avx2")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

#define int long long

using ll = long long;
#define all(a) a.begin(), a.end()
using pii = std::pair<int, int>;
const ll INFLL = 0x3f3f3f3f3f3f3f3f;

struct query {
    int type, k, i, ind;

    query() = default;
};

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);

    int n, q;
    std::cin >> n >> q;
    std::vector<ll> a(n);
    for (auto &i: a) std::cin >> i;

    std::vector<query> qs(q);
    int iddd = 0;
    for (auto &i: qs) {
        std::cin >> i.type >> i.k;
        if (i.type == 3) {
            std::cin >> i.i;
            i.i--;
        }
        i.ind = iddd++;
    }

    std::vector<int> ans(q);
    std::sort(all(qs), [&](auto l, auto r) { return l.k < r.k; });

    std::vector<pii> b(n);
    for (int i = 0; i < n; i++) b[i] = std::make_pair(a[i], i);
    std::sort(all(b));

    std::vector<std::pair<int, std::vector<int>>> groups;
    std::vector<std::pair<int, std::vector<int>>> groups1;

    for (int i = 0; i < n; i++) {
        if (groups.empty() || groups.back().first != b[i].first) {
            groups.emplace_back();
            groups.back().first = b[i].first;
        }
        groups.back().second.push_back(b[i].second);
    }
    ll added = 0;
    ll time = 0;

    int opss = 0;
    for (auto &[type, k, i, ind]: qs) {
        while (groups.size() > 1) {
            auto it1 = ++groups.begin();
            auto it = groups.begin();
            std::pair<ll, ll> mini = {INFLL, INFLL};
            while (it1 != groups.end()) {
                if (it1->first - it->first < mini.first) {
                    mini = std::make_pair(it1->first - it->first, it->first);
                }
                ++it1;
                ++it;
            }
            assert(mini.first != INFLL);
            time += mini.first;
            if (time > k) {
                time -= mini.first;
                break;
            }
            int sz = groups.size();
            for (auto &i: groups) {
                sz--;
                added += mini.first * i.second.size() * sz;
            }

            groups1.clear();
            int add = groups.size();
            for (auto &[cn, ids]: groups) {
                add--;
                for (auto &i: ids) {
                    int to = cn + add * mini.first;
                    if (groups1.empty() || groups1.back().first != to) {
                        groups1.emplace_back();
                        groups1.back().first = to;
                    }
                    groups1.back().second.push_back(i);
                    opss++;
                }
            }
            groups = groups1;
        }

        if (type == 1) {
            ans[ind] = groups.size();
        } else if (type == 2) {
            int sz = groups.size();
            ll res = added;
            for (auto &i: groups) {
                sz--;
                res += (k - time) * i.second.size() * sz;
            }

            ans[ind] = res;
        } else {
            int sz = groups.size();
            for (auto &j: groups) {
                sz--;
                if (std::count(all(j.second), i)) {
                    ans[ind] = j.first + (k - time) * sz;
                }
            }
        }
    }

    for (auto &i: ans) std::cout << i << '\n';
    std::cout << '\n';

    std::cerr << opss << ' ' << groups.size() << '\n';
}