#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
int size(long long y) {
    int ans = 0;
    while (y) {
        y /= 10;
        ++ans;
    }
    return ans;
}
long long to_int(string & x) {
    long long ans = 0;
    for (auto c : x)
        ans = 10 * ans + c - '0';
    return ans;
}
long long val, y;
void solve(string & x, long long & ans, string p, string & q) {
    long long res = 0;
    for (auto c : x) {
        int i = p.find(c);
        if (i == string::npos)
            return;
        p.erase(i, 1);
        res += i * y;
    }
    p = x + p;
    res = to_int(p) - val - res;
    if (res >= ans) {
        ans = res;
        q = p;
    }
}
int main() {
    string s, t, q, p;
    long long ans = 0;
    cin >> s >> y;
    vector<int> count(10);
    int n = s.size();
    int m = size(y) + 2;
    for (auto c : s)
        ++count[c - '0'];
    int j = 9;
    for (int i = 0; i + m < n; ++i) {
        while (!count[j])
            --j;
        t.push_back('0' + j);
        --count[j];
    }
    for (int i = n - 1; i >= 0; --i)
        if (count[s[i] - '0']) {
            p.push_back(s[i]);
            --count[s[i] - '0'];
        }
    reverse(p.begin(), p.end());

    q = p;
    val = to_int(p);
    string x(3, '0');
    for (x[0] = '0'; x[0] <= '9'; ++x[0])
        for (x[1] = '0'; x[1] <= '9'; ++x[1])
            for (x[2] = '0'; x[2] <= '9'; ++x[2])
                solve(x, ans, p, q);
    cout << q;
    return 0;
}
