#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ckmin(a, b) a = min(a, b)
#define ckmax(a, b) a = max(a, b)
#define pii pair<int, int>
#define fi first
#define se second
#define ld long double
#define sz(x) (int)x.size()
#define int long long

const int inf = 1e18;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<vector<int>> g(n);
        vector<vector<bool>> con(n, vector<bool>(n));
        for (int i = 0; i < m; ++i) {
            int v, u;
            cin >> v >> u;
            g[--v].push_back(--u);
            g[u].push_back(v);
            con[v][u] = true;
            con[u][v] = true;
        }

        vector<vector<int>> d(n, vector<int>(n, inf));
        set<pair<int, pii>> dij;
        dij.insert({0, {0,0 }});
        d[0][0] = 0;


        while (!dij.empty()) {
            auto V = *dij.begin();
            dij.erase(V);
            int a = V.se.fi, b = V.se.se;

            if (a == b) {
               for(int u : g[a]){
                   if(d[a][u] > d[a][b] + 1){
                       dij.erase({d[a][u], {a, u}});
                       d[a][u] = d[a][b] + 1;
                       dij.insert({d[a][u], {a, u}});
                   }
               }
            }else{
                for(int u : g[a]){
                    if(u == b)
                        continue;
                    if(d[u][b] > d[a][b]){
                        dij.erase({d[u][b], {u, b}});
                        d[u][b] = d[a][b];
                        dij.insert({d[u][b], {u, b}});
                    }
                }

                if(con[a][b] && d[a][a] > d[a][b] + 1){
                    dij.erase({d[a][a], {a, a}});
                    d[a][a] = d[a][b] + 1;
                    dij.insert({d[a][a], {a, a}});
                }
            }
        }

        for(int i = 1; i < n; ++i){
            if(d[i][i] == inf)
                d[i][i] = -1;
            cout << d[i][i] << " ";
        }
        cout << '\n';
    }
}