#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, q;
    cin >> n >> q;
    vector<long long> c(n);
    vector<long long> d;
    map<long long, long long> mp;
    for(int i = 0; i < n; ++i){
        cin >> c[i];
        if(mp.find(c[i]) == mp.end()){
            mp[c[i]] = 0;
            d.push_back(c[i]);
        }
    }
    sort(d.begin(), d.end());
    vector<long long> t1(d.size() - 1);
    for(int i = 0; i < d.size() - 1; ++i){
        mp[d[i]] = d[i+1] - d[i];
        t1[i] = (d[i+1] - d[i]);
    }
    sort(t1.begin(), t1.end());
    for(int i = 0; i < q; ++i){
        int t;
        long long k;
        cin >> t >> k;
        if(t == 1){
            if(k < t1[0]){
                cout << t1.size() + 1 << endl;
            }else{
                int l = 0;
                int r = t1.size();
                while(r - l > 1){
                    int mid = (l + r)/2;
                    if(t1[mid] > k){
                        r = mid;
                    }else{
                        l = mid;
                    }
                }
                cout << t1.size() - l << endl;
            }
        }else if(t == 2){
            cout << -1 << endl;
        }else{
            int num;
            cin >> num;
            cout << -1 << endl;
        }
    }
    return 0;
}
