#include <iostream>
#include <algorithm>
#include <bitset>
#include <vector>
#include <string>
#include <cstring>
#include <array>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <cmath>
#include <random>
#include <chrono>
#define ar array
using namespace std;
typedef long long ll;
typedef long double ld;
const int N = 2e5 + 5;

int n, a[N];
vector<int> pos[10];
bool used[N];
ll Y;

ld fp(ld x, int n) {
	ld ans = 1;
	while (n) {
		if (n & 1) {
			ans *= x;
		}
		n >>= 1;
		x *= x;
	}
	return ans;
}

void solve() {
	string s;
	cin >> s;
	n = s.size();
	for (int i = 0; i < n; ++i) {
		a[i] = s[i] - '0';
	}
	cin >> Y;
	for (int i = n - 1; i >= 0; --i) {
		pos[a[i]].push_back(i);
	}
	vector<int> ans;
	int m = n;
	for (int i = 9; i >= 0; --i) {
		for (auto& x : pos[i]) {
			if (m <= 20) {
				break;
			}
			ans.push_back(i);
			used[x] = 1;
			--m;
		}
	}
	vector<int> b;
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			b.push_back(a[i]);
		}
	}
	vector<int> tail = b;
	ld num = -1;
	for (int cnt = 0; cnt <= 400; ++cnt) {
		int cur = cnt;
		vector<int> c = b;
		for (int i = 0; i < m; ++i) {
			int now = i;
			for (int j = i + 1; j < m; ++j) {
				if (c[j] > c[now] && j - i <= cur) {
					now = j;
				}
			}
			cur -= (now - i);
			for (int j = now; j > i; --j) {
				swap(c[j], c[j - 1]);
			}
		}
		ld new_num = -Y * cnt;
		for (int i = 0; i < m; ++i) {
			new_num += fp(10, m - 1 - i) * c[i];
		}
		if (new_num >= num) {
			num = new_num;
			swap(tail, c);
		}
	}
	for (auto& x : tail) {
		ans.push_back(x);
	}
	for (auto& x : ans) {
		cout << x;
	}
}

void clear() {
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1;
	while (t--) {
		solve();
		clear();
		cout << "\n";
	}
}