#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//using namespace __gnu_pbds;
using namespace std;
#define int long long
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
//typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
mt19937_64 rnd(time(0));

struct fenwick {
    vector<int> b;

    fenwick(int n) {
        b.resize(n);
    }

    void add(int pos, int val) {
        while (pos < sz(b)) {
            b[pos] += val;
            pos = ((pos + 1) | pos);
        }
    }

    int get(int pos) {
        int ans = 0;
        while (pos >= 0) {
            ans += b[pos];
            pos = ((pos) & (pos + 1)) - 1;
        }
        return ans;
    }
};

signed main() {
    cin.tie();
    cout.tie();
    ios_base::sync_with_stdio(false);
#ifdef foo
    freopen("input.txt", "r", stdin);
#endif
    int n, q;
    cin >> n >> q;
    vector<int> c(n);
    vector<pair<int, int>> sorted_ids;
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
        sorted_ids.push_back({c[i], i});
    }
    sort(all(sorted_ids));
    sort(all(c));
    int pos[n];
    for (int i = 0; i < sz(sorted_ids); ++i) {
        pos[sorted_ids[i].second] = i;
    }
    fenwick fw = fenwick(n);
    fenwick fw2 = fenwick(n);
    vector<pair<int, pair<int, pair<int, int>>>> events;
    for (int i = 0; i < sz(c) - 1; ++i) {
        events.push_back({c[i + 1] - c[i], {-1, {i, -1}}});
    }
    int ans[q];
    for (int i = 0; i < q; ++i) {
        int t, k;
        cin >> t >> k;
        int op = -1;
        if (t == 3) {
            cin >> op;
            op--;
            op = pos[op];
        }
        events.push_back({k, {t, {i, op}}});
    }
    sort(all(events));
    int time_now = -1;
    int cnt_all = n;
    int sum_arif = 0;
    int deltas = (n) * (n - 1) / 2;
    for (int i = 0; i < events.size(); ++i) {
        int tm = events[i].first;
        sum_arif += (deltas) * (tm - time_now - 1);
        if (events[i].second.first == -1) {
            cnt_all--;
            deltas -= events[i].second.second.first + 1;
            fw.add(events[i].second.second.first, tm);
            fw2.add(events[i].second.second.first, 1);
        } else {
            int id = events[i].second.second.first;
            if (events[i].second.first == 1) {
                ans[id] = cnt_all;
            }
            if (events[i].second.first == 2) {
                ans[id] = sum_arif;
            }
            if (events[i].second.first == 3) {
                int ind = events[i].second.second.second;
                int cnt_time = fw2.get(n - 1) - fw2.get(ind - 1);
                int sum_time = fw.get(n - 1) - fw.get(ind - 1);
                int res = (n - ind - 1) * tm - (tm * cnt_time - sum_time);
                ans[id] = res + c[ind];
            }
        }
        time_now = tm - 1;
    }
    for (int i = 0; i < q; ++i) {
        cout << ans[i] << "\n";
    }
}
