#include <bits/stdc++.h>

#define F first
#define S second
#define all(a) a.begin(), a.end()

using namespace std;
using ll = long long;
using pi = pair<int, int>;

template<class T> bool ckmin(T &a, T b) {return a > b ? a = b, true : false; }
template<class T> bool ckmax(T &a, T b) {return a < b ? a = b, true : false; }

void case1() {
    int n, m; cin >> n >> m;
    vector<int> a(n); for (auto &x : a) cin >> x;
    vector<ll> ps(n); ps[0] = a[0];
    for (int i = 1; i < n; ++i) ps[i] = ps[i-1]+a[i];
    int l, r, c, t; cin >> l >> r >> c >> t; l--; r--;
    assert(m == 1);
    for (int x = 0; x < n; ++x) {
        int tl = l, tr = r;
        if (t == 1) tl = min(l, x), tr = max(r, x);
        cout << min((ll)c, ps[tr] - (tl ? ps[tl-1] : 0)) << " ";
    }
    cout << "\n";
}

struct seg{
    int l, r, c, t, id;
};

void solve() {
    int n, m; cin >> n >> m;
    vector<int> a(n); for (auto &x : a) cin >> x;
    vector<seg> v(m);
    for (int q = 0; q < m; ++q) {
        int l, r, c, t; cin >> l >> r >> c >> t;
        v[q] = {l-1, r-1, c, t, q};
    }
    for (int x = 0; x < n; ++x) {
        vector<seg> d;
        for (int q = 0; q < m; ++q) {
            int tl = v[q].l, tr = v[q].r;
            if (v[q].t == 1) {
                tl = min(tl, x); tr = max(tr, x);
            }
            d.push_back({tl, tr, v[q].c, 1, q});
            d.push_back({tr, tr, v[q].c, -1, q});
           // cout << tl << ", " << tr << "\n";
        }
        //for (auto x : d) cout << x.l << "! "; cout << "\n";
        sort(all(d), [](seg a, seg b) { return a.l != b.l ? a.l < b.l : a.t > b.t; });
        int q = 0;
        set<pair<int, pair<int, int>>> st;
        ll ans = 0;
        for (int i = 0; i < n; ++i) {
            ll cur = 0;
            while (q < d.size() && d[q].l == i && d[q].t == 1) {
                st.insert({d[q].id, {d[q].r, d[q].c}}); q++;
            }
            //cout << a[i] << ": ";
            //for (auto x : st) cout << x.F.F << ", " << x.F.S << "\n"; 
            while (st.size() && cur < a[i]) {
                int x = st.begin() -> S.S;
                int r = st.begin() -> S.F;
                int id = st.begin() -> F;
                st.erase(st.begin());
                if (cur+x < a[i]) cur += x;
                else  {
                    st.insert({id, {r, cur+x-a[i]}});
                    cur = a[i];
                }
            }
            while (q < d.size() && d[q].l == i && d[q].t == -1) {
                //auto pr = 
                auto it = st.lower_bound({d[q].id, {-1, -1}});
                if (it != st.end() && it -> F == d[q].id) st.erase(it);
                q++;
            }
            ans += cur;
        }
        cout << ans << " ";
    } cout << "\n";
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    int t; cin >> t;
    while (t--) solve();
    return 0;
}
