#include <bits/stdc++.h>

using namespace std;

#define int long long
#define f first
#define s second
#define eb emplace_back
#define pb push_back

int qqq = 1;

typedef long long ll;

const ll INF = 2e18;

vector <vector <int>> g;
vector <int> tin, fup, cl;
vector <bool> used;
int timer, color;

void init_br(int v, int pr = -1){
    tin[v] = fup[v] = timer++;
    used[v] = true;

    for (auto to: g[v]){
        if (to == pr)
            continue;

        if (used[to]){
            fup[v] = min(fup[v], tin[to]);
        }
        else{
            init_br(to, v);
            fup[v] = min(fup[v], fup[to]);
        }
    }
}

void colorize(int v, int col, int pr = -1){
    cl[v] = col;
    used[v] = true;

    for (auto to: g[v]){
        if (to == pr || used[to] == true)
            continue;

        if (fup[to] > tin[v]){
            colorize(to, color++, v);
        }
        else{
            colorize(to, col, v);
        }
    }
}

vector <vector <int>> dp;

void bfs(int v){
    int n = dp.size();
    vector <bool> used(n, false);

    dp[v][0] = 0;
    queue <int> q;
    q.push(v);
    used[v] = true;

    while (!q.empty()){
        int cur = q.front();
        used[cur] = false;
        q.pop();

        for (auto to: g[cur]){
            if (dp[to][0] > dp[cur][1] + 1 || dp[to][1] > dp[cur][0] + 1){
                dp[to][0] = min(dp[to][0], dp[cur][1] + 1);
                dp[to][1] = min(dp[to][1], dp[cur][0] + 1);

                if (!used[to]){
                    used[to] = true;
                    q.push(to);
                }
            }
        }
    }

}

void solve(){
    int n, m;
    cin >> n >> m;

    g.assign(n, vector <int> (0));
    timer = color = 0;
    tin.assign(n, 0);
    fup.assign(n, 0);
    used.assign(n, 0);
    cl.assign(n, 0);
    dp.assign(n, vector <int> (2, INF));

    for (int i = 0; i < m; i++){
        int l, r;
        cin >> l >> r;
        l--, r--;

        g[l].eb(r);
        g[r].eb(l);
    }

    init_br(0);

    fill(used.begin(), used.end(), 0);
    colorize(0, color++);

    bfs(0);

   /* for (int i = 0; i < n; i++){
        cout << cl[i] << ' ';
    }
    cout << '\n';*/

    for (int i = 1; i < n; i++){
        if (cl[0] != cl[i] || dp[i][0] == INF)
            cout << -1 << ' ';
        else
            cout << dp[i][0] << ' ';
    }
    cout << '\n';

}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    cin >> qqq;
    while (qqq--){
        solve();
    }

    return 0;
}
