#include <bits/stdc++.h>
using namespace std;

#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
#define x first
#define y second
using ll = long long;
using ld = long double;

const int N = 5e3 + 10, INF = 0x3f3f3f3f;

vector<int> g[N];
int dst[N][N];

signed main() {
	cin.tie(0)->sync_with_stdio(0);
	int testcases;
	cin >> testcases;
	while (testcases--) {
		int n, m;
		cin >> n >> m;
		for (int i = 0; i < n; ++i) {
			g[i].clear();
		}
		for (int i = 0; i < m; ++i) {
			int u, v;
			cin >> u >> v;
			g[--u].push_back(--v);
			g[v].push_back(u);
		}
		for (int i = 0; i < n; ++i) {
			fill(dst[i], dst[i] + n, +INF);
		}
		dst[0][0] = 0;
		deque<pair<int, int>> bfs;
		bfs.push_back({0, 0});
		while (sz(bfs)) {
			auto [u, w] = bfs.front();
			bfs.pop_front();
			if (u == w) {
				for (int v : g[u]) {
					if (dst[u][v] > dst[u][w] + 1) {
						dst[u][v] = dst[u][w] + 1;
						bfs.push_back({u, v});
					}
				}
			} else {
				for (int v : g[u]) {
					if (v != w) {
						if (dst[v][w] > dst[u][w]) {
							dst[v][w] = dst[u][w];
							bfs.push_front({v, w});
						}
					} else {
						if (dst[u][u] > dst[u][w] + 1) {
							dst[u][u] = dst[u][w] + 1;
							bfs.push_back({u, u});
						}
					}
				}
			}
		}
		for (int i = 1; i < n; ++i) {
			if (dst[i][i] == +INF) {
				cout << "-1 ";
			} else {
				cout << dst[i][i] << " ";
			}
		}
		cout << "\n";
	}
}