#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <deque>

using namespace std;

#define v vector
#define int long long
#define ll __int128
#define len(a) (int)a.size()
#define all(a) a.begin(), a.end()

//const int INF = 1e17;

int n, m;
v<v<int>> g;

v<int> d;

void bfs() {
    d.clear();
    d.resize(n, -1);
    d[0] = 0;
    v<int> used(n, 0);
    deque<int> q;
    q.push_back(0);
    used[0] = 1;

    v<int> b(n, 0);
    v<v<int>> pos(n);
    for (int i = 0; i < n; i++) {
        for (auto j : g[i]) {
            pos[j].push_back(i);
        }
    }



    while (len(q) > 0) {
        auto i = q.front();
        q.pop_front();
        for (auto index : pos[i]) {
            if (b[index]) continue;
            b[index] = 1;
            for (auto j : g[index]) {
                if (!used[j]) {
                    q.push_back(j);
                    d[j] = d[i] + 1;
                    used[j] = 1;
                }
            }
        }
    }

    for (int i = 1; i < n; i++) {
        if (d[i] != -1) {
            cout << d[i] * 2 << " ";
        } else {
            cout << -1 << " ";
        }
    }
    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t; cin >> t;
    while (t--) {
        cin >> n >> m;
        g.clear();
        g.resize(n);
        for (int i = 0; i < m; i++) {
            int u, to; cin >> u >> to;
            u--; to--;
            g[u].push_back(to);
            g[to].push_back(u);
        }

        bfs();
    }
    return 0;
}
