#pragma GCC optimize("O3, unroll-loops")
#pragma GCC target("avx2,sse3,sse4")
#include <iostream>
#include <fstream>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <deque>
#include <string>
#include <algorithm>
#include <random>

using namespace std;

typedef long long ll;

ll y, skipped = 0;
__int128 mx = -1;

inline __int128 check(string &s, string &shift, int n){
    int swaps = 0;
    __int128 cost = 0;
    for (ll i = 0; i < n; i++){
        cost *= 10;
        cost += shift[i] - '0';
    }
    if (cost < mx){
        skipped++;
        return 0;
    }
    string work = s;
    for (ll i = 0; i < n; i++){
        for (ll j = i; j < n; j++) {
            if (work[j] == shift[i]) {
                swaps += j - i;
                for (ll k = j; k > i; k--)
                    work[k] = work[k - 1];
                work[i] = shift[i];
                break;
            }
        }
    }
    cost -= y * swaps;
    return cost;
}

inline void solve(string s){
    ll n = s.size();
    ll times = 1;
    for (ll i = 2; i <= n; i++)
        times *= i;
    string shift = s, shift2 = s;
    string ans = s;
    for (ll t = 0; t < times; t++){
        if ((t - skipped) * n * n > 150000000)
            break;
        __int128 cost = check(s, shift, n);
        if (cost > mx || (cost == mx && shift > ans)){
            mx = cost;
            ans = shift;
        }
        prev_permutation(shift.begin(), shift.end());
    }
    cout << ans;
}

const int k = 11;

int32_t main() {
	cin.tie(0); cout.tie(0); cin.sync_with_stdio(0); cout.sync_with_stdio(0);
	string s, t;
	int n;
	cin >> s >> y;
	n = s.size();
    int pos = 0;
    if (n > k){
        pos = n - k;
        int cnt[10];
        for (int i = 0; i < 10; i++)
            cnt[i] = 0;
        for (int i = 0; i < n; i++)
            cnt[s[i] - '0']++;
        for (int i = 0; i < pos; i++)
            for (int c = 9; c >= 0; c--)
                if (cnt[c]){
                    cnt[c]--;
                    cout << c;
                    break;
                }
        t = "";
        for (int i = 0; i < n; i++)
            if (cnt[s[i] - '0']){
                cnt[s[i] - '0']--;
                t += s[i];
                pos++;
            }
    }
    else t = s;
    solve(t);
}