#include<bits/stdc++.h>

#define fi first
#define se second
#define mp make_pair
#define sz(v) (int) v.size()
#define all(v) v.beign(), v.end()

using namespace std;

typedef long long int64;
typedef long double float64;
typedef pair<int, int> pii;

const int N = 2e5 + 5, M = 2e5 + 5;

int n, m, a[N], a1[N];
pii b[M], c[M];
int d[M], t[M];

void read() {
    cin >> n >> m;
    for (int i = 1; i <= n; ++i) cin >> a[i];
    for (int i = 1; i <= m; ++i) cin >> b[i].fi >> b[i].se >> d[i] >> t[i];
}

int order[M], s[M];
int64 ans[N];

void solve() {
    for (int i = 1; i <= n; ++i) a1[i] = a[i];
    for (int x = 1; x <= n; ++x) {
        for (int i = 1; i <= n; ++i) a[i] = a1[i];
        for (int i = 1; i <= m; ++i) {
            if (t[i] == 0) c[i] = b[i];
            else c[i] = mp(min(x, b[i].fi), max(x, b[i].se));
            s[i] = d[i];
        }
        iota(order + 1, order + m + 1, 1);
        sort(order + 1, order + m + 1, [&](int i, int j) {
            return mp(c[i].se, c[i].fi) < mp(c[j].se, c[j].fi);
        });
        int64 sum = 0;
        set<pii> S;
        for (int i = 1; i <= n; ++i) {
            S.emplace(i, a[i]);
        }
        for (int oi = 1; oi <= m; ++oi) {
            int i = order[oi];
            auto it = S.lower_bound(mp(c[i].fi, -1));
            while (it != S.end() && s[i]) {
                pii curr = *it;
                if (curr.fi > c[i].se) break;
                ++it;
                S.erase(curr);
                int go = min(s[i], curr.se);
                curr.se -= go;
                s[i] -= go;
                sum += go;
                if (curr.se) {
                    S.emplace(curr);
                }
            }
        }
        ans[x] = sum;
    }
}

void write() {
    for (int i = 1; i <= n; ++i) {
        cout << ans[i] << " ";
    }
    cout << "\n";
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tests;
    cin >> tests;
    while (tests--) {
        read();
        solve();
        write();
    }
    return 0;
}