#include <bits/stdc++.h>

using namespace std;

bool lexmore(vector<int> &a, vector<int> &b)
{
    for(int i = 0; i < a.size(); i++)
    {
        if(a[i] != b[i]) return a[i] > b[i];
    }
    return false;
}

int main()
{
    string s;
    cin >> s;
    int n = (int)(s.size());

    vector<int> a(n), as(n);
    for(int i = 0; i < n; i++)
    {
        as[i] = a[i] = s[i] - '0';
    }
    sort(as.begin(), as.end());
    long long y, mcost = -1000000000000000000;
    cin >> y;
    vector<int> aa(n);

    do
    {
        vector<int> ax(n);
        for(int i = 0; i < n; i++) ax[i] = as[i];
        long long cost = 0;

        for(int i = 0; i < n; i++)
        {
            for(int j = i; j < n; j++)
            {
                if(ax[j] == a[i])
                {
                    int j2 = j;
                    while(j2 != i)
                    {
                        swap(ax[j2], ax[j2 - 1]);
                        j2--;
                        cost -= y;
                    }
                    break;
                }
            }
        }

        long long p10 = 1;
        for(int i = n - 1; i >= 0; i--)
        {
            cost += p10 * as[i];
            p10 *= 10;
        }

        if(cost > mcost || (cost == mcost && lexmore(as, aa)))
        {
            mcost = cost;
            for(int i = 0; i < n; i++) aa[i] = as[i];
        }
    }
    while(next_permutation(as.begin(), as.end()));

    //cout << "COST: " << mcost << "\n";
    for(int i = 0; i < n; i++) cout << aa[i];
    cout << "\n";
}
