#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx,avx2,fmi,bmi2")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/rope>

#define endl '\n'
#define all(arr) arr.begin(), arr.end()
#define int long long
#define out(x) cout << (x) << endl, exit(0)

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;

typedef pair<int, int> ipair;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> treap;

int n, k;
string s;

void build() {
	n = s.size();
	assert(n <= 9);
}

int cost(string s, string t) {
	int ans = stoll(t);
	for (int i = 0; i < n; ++i) {
		auto it = find(s.begin() + i, s.end(), t[i]);
		ans -= (it - s.begin() - i) * k;
		s.erase(it);
		s.insert(s.begin() + i, t[i]);
	}
	return ans;
}

string brute() {
	string t = s;
	pair<int, string> ans {stoll(s), s};
	for (int i = 0; i < n; ++i) {
		auto it = max_element(s.begin() + i, s.end());
		char c = *it;
		s.erase(it);
		s.insert(s.begin() + i, c);
		ans = max(ans, {cost(t, s), s});
	}
	/*
	sort(all(t));
	do {
		ans = max(ans, {cost(s, t), t});
	} while (next_permutation(all(t)));*/
	return ans.second;
}

string solve() {
	int cur = 0;
	ipair ans {stoll(s), stoll(s)};
	for (int i = 0; i < n; ++i) {
		auto it = max_element(s.begin() + i + 1, s.end());
		if (it == s.end() || *it <= s[i]) continue;
		cur -= (it - s.begin() - i) * k;
		char c = *it;
		s.erase(it);
		s.insert(s.begin() + i, c);
		cerr << "s: " << s << endl;
		ans = max(ans, {stoll(s) + cur, stoll(s)});
	}
	return to_string(ans.second);
}

int32_t main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);
	cout.setf(ios::fixed), cout.precision(10);
	cin >> s >> k;
	build();
	string ans = brute();
	ans = string(n - ans.size(), '0') + ans;
	cout << ans << endl;
}