#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx,avx2,fmi,bmi2")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/rope>

#define endl '\n'
#define all(arr) arr.begin(), arr.end()
#define int long long
#define out(x) cout << (x) << endl, exit(0)

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;

typedef pair<int, int> ipair;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> treap;

int n, k;
string s, t;

void build() {
	n = s.size();
	t = s;
	assert(n <= 9);
}

int cost(string s, string t) {
	int ans = stoll(t);
	for (int i = 0; i < n; ++i) {
		auto it = find(s.begin() + i, s.end(), t[i]);
		ans -= (it - s.begin() - i) * k;
		s.erase(it);
		s.insert(s.begin() + i, t[i]);
	}
	return ans;
}

string brute() {
	sort(all(t));
	pair<int, string> ans {stoll(s), s};
	do {
		ans = max(ans, {cost(s, t), t});
	} while (next_permutation(all(t)));
	return ans.second;
}

/*
string solve(string s) {
	int cur = 0;
	ipair ans {stoll(s), stoll(s)};
	for (int i = 0; i < n; ++i) {
		auto it = max_element(s.begin() + i + 1, s.end());
		if (it == s.end() || *it <= s[i]) continue;
		cur -= (it - s.begin() - i) * k;
		char c = *it;
		s.erase(it);
		s.insert(s.begin() + i, c);
		ans = max(ans, {stoll(s) + cur, stoll(s)});
	}
	string res = to_string(ans.second);
	res = string(n - res.size(), '0') + res;
	return res;
}*/

pair<int, string> go(string s, int i, int j) {
	char c = s[j];
	s.erase(s.begin() + j);
	s.insert(s.begin() + i, c);
	return {cost(t, s), s};
}

string solve(string s) {
	pair<int, string> ans {stoll(s), s};
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j)
			ans = max(ans, go(s, i, j));
		auto it = max_element(s.begin() + i + 1, s.end());
		if (it == s.end() || *it <= s[i]) continue;
		char c = *it;
		s.erase(it);
		s.insert(s.begin() + i, c);
		ans = max(ans, {cost(t, s), s});
	}
	return ans.second;
}

int32_t main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);
	cout.setf(ios::fixed), cout.precision(10);
	/*
	n = 5;
	do {
		k = rand() % 1000;
		s = string(5, '0');
		for (int i = 0; i < n; ++i)
			s[i] = rand() % 10 + '0';
	} while (brute() == solve(s));
	cout << s << ' ' << k << endl;*/
	
	cin >> s >> k;
	build();
	cout << solve(s) << endl;
//	cout << brute() << endl;
}