#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx,avx2,fmi,bmi2")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/rope>

#define endl '\n'
#define all(arr) arr.begin(), arr.end()
#define int long long
#define out(x) cout << (x) << endl, exit(0)

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;

typedef pair<int, int> ipair;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> treap;

const int C = 15;

int n, k;
string s;
int po[C];

void build() {
	n = s.size();
	assert(n <= 9);
	*po = 1;
	for (int i = 1; i < C; ++i)
		po[i] = po[i - 1] * 10;
}

inline int val(int x, int i) {
	return po[n - i - 1] * x;
}

pair<int, string> go(string s, int i, int c) {
	auto it = find(s.begin() + i, s.end(), c);
	if (it == s.end()) return {-1, "#"};
	int cost = -(it - s.begin() - i) * k;
	if (it != s.begin() + i) {
		int x = stoll(s.substr(i, it - s.begin() - i));
		cost -= x * po[n - i - 1];
		cost += x * po[n - i - 2];
	}
	cost -= val(c - '0', it - s.begin());
	cost += val(c - '0', i);
//	cerr << i << ' ' << c << ' ' << cost << endl;
	s.erase(it);
	s.insert(s.begin() + i, c);
	return {cost, s};
}

string solve() {
	pair<int, string> ans {-1, "#"};
	for (int i = 0; i < n; ++i) {
		ans.first = -1;
		for (char c = '0'; c <= '9'; ++c)
			ans = max(ans, go(s, i, c));
		s = ans.second;
	}
	return s;
}

int32_t main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);
	cout.setf(ios::fixed), cout.precision(10);
	cin >> s >> k;
	build();
	cout << solve() << endl;
}