#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_map>
#include <map>
using namespace std;
typedef long long ll;
int n;
vector <int> a;
vector <bool> x;
vector <set <int>> g;
vector <int> tin, tout, pr;
vector <bool> used;
int getnmb(int a, int b) {
	return (a * (a + 1) / 2) + b;
}
pair <int, int> getnmb1(int x) {
	int cnt = 1, a = 0;
	while (x >= cnt) {
		x -= cnt;
		a++;
		cnt++;
	}
	return { a, x };
}
int t = 0;
void build(int i, int j) {
	for (int i1 = 0; i1 < n; i1++) {
		if (x[i1] == 1) {
			g[getnmb(i, j)].insert(getnmb(i + 1, j + 1));
			g[getnmb(i + 1, j + 1)].insert(getnmb(i, j));
			i++; j++;
		}
		else {
			g[getnmb(i, j)].insert(getnmb(i + 1, j));
			g[getnmb(i + 1, j)].insert(getnmb(i, j));
			i++;
		}
	}
}
void dfs(int v) {
	used[v] = 1;
	tin[v] = t++;
	for (auto i : g[v]) {
		if (!used[i]) {
			pr[i] = v;
			dfs(i);
		}
	}
	tout[v] = t++;
}
bool ispr(int x, int y) {
	return (tin[x] <= tin[y] && tout[x] >= tout[y]);
}
int main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);
	cin >> n;
	a.resize(n);
	x.resize(n, 1);
	g.resize((n + 1) * (n + 2) / 2);
	for (int i = 0; i < n; i++) cin >> a[i];
	for (int i = 0; i <= n; i++) {
		build(0, 0);
		if (i != n) x[a[i] - 1] = 0;
	}
	used.resize(g.size(), 0);
	pr.resize(g.size());
	tin.resize(g.size());
	tout.resize(g.size());
	dfs(0);
	pr[0] = 0;
	vector <vector <int>> binup(g.size(), vector <int>(24));
	for (int i = 0; i < g.size(); i++) binup[i][0] = pr[i];
	for (int k = 1; k < 24; k++) {
		for (int i = 0; i < g.size(); i++) {
			binup[i][k] = binup[binup[i][k - 1]][k - 1];
		}
	}
	int q; cin >> q;
	while (q--) {
		int r1, c1, r2, c2; cin >> r1 >> c1 >> r2 >> c2;
		int x = getnmb(r1, c1), y = getnmb(r2, c2);
		int ans;
		if (ispr(x, y)) ans = x;
		else if (ispr(y, x)) ans = y;
		else {
			for (int k = 23; k >= 0; k--) {
				if (!ispr(binup[x][k], y)) x = binup[x][k];
			}
			ans = pr[x];
		}
		pair <int, int> ansx = getnmb1(ans);
		cout << ansx.first << ' ' << ansx.second << "\n";
	}
	return 0;
}