#include <bits/extc++.h>
using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define sfor(i, l, r) for (int i = l; i <= r; ++i)
#define bfor(i, r, l) for (int i = r; i >= l; --i)
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

const int INF = 1e9 + 10;

struct S {
    int c, x, i;
    S(int c = INF, int x = 0, int i = -1): c(c), x(x), i(i) {}
    friend bool operator<(S a, S b) {
        return a.c < b.c;
    }
};

vector<vi> g;
vi a, b, c, l, r;
vector<set<S>> s;

void Dfs(int u = 0) {
    int mx = -1;
    for (int v: g[u]) {
        Dfs(v);
        a[u] += a[v];
        if (mx == -1 || s[v].size() > s[mx].size())
            mx = v;
    }
    if (mx != -1)
        s[u].swap(s[mx]);
    ll sum = 0;
    for (int v: g[u]) {
        sum += r[v] - a[v];
        for (auto x: s[v])
            s[u].insert(x);
        s[v].clear();
    }
    while (!s[u].empty() && (--s[u].end())->c >= c[u]) {
        sum -= (--s[u].end())->x;
        s[u].erase(--s[u].end());
    }
    while (!s[u].empty() && a[u] < l[u]) {
        S x = *s[u].begin();
        sum -= x.x;
        s[u].erase(s[u].begin());
        if (a[u] + x.x > l[u]) {
            b[x.i] += l[u] - a[u];
            sum += x.x - l[u] + a[u];
            s[u].emplace(x.c, x.x - l[u] + a[u], x.i);
            a[u] = l[u];
        }
        else {
            b[x.i] += x.x;
            a[u] += x.x;
        }
    }
    if (a[u] < l[u]) {
        b[u] += l[u] - a[u];
        a[u] = l[u];
    }
    while (!s[u].empty() && a[u] + sum > r[u]) {
        S x = *(--s[u].end());
        sum -= x.x;
        s[u].erase(--s[u].end());
        if (a[u] + sum < r[u]) {
            s[u].emplace(x.c, r[u] - a[u] - sum, x.i);
            sum = r[u] - a[u];
        }
    }
    if (a[u] + sum < r[u])
        s[u].emplace(c[u], r[u] - a[u] - sum, u);
}

int main() {
    fast;
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        g.assign(n, vi(0));
        a.assign(n, 0);
        b.assign(n, 0);
        c.resize(n);
        l.resize(n);
        r.resize(n);
        s.assign(n, set<S>{});
        sfor(i, 1, n - 1) {
            int p;
            cin >> p;
            g[p - 1].push_back(i);
        }
        sfor(i, 0, n - 1) cin >> c[i];
        sfor(i, 0, n - 1) cin >> l[i] >> r[i];
        Dfs();
        bool ch = true;
        ll ans = 0;
        sfor(i, 0, n - 1) {
            if (a[i] < l[i] || a[i] > r[i]) {
                ch = false;
                break;
            }
            ans += (ll)b[i] * c[i];
        }
        if (ch) {
            cout << ans << '\n';
            sfor(i, 0, n - 1) cout << b[i] << ' ';
            cout << '\n';
        }
        else
            cout << "-1\n";
    }
}
