#include <bits/stdc++.h>

using namespace std;
int n;
const int MAXSZ = 1e7;

int all[MAXSZ][3];
int cha = 0;

inline void update(int v, int i) {
    int l = 0, r = n - 1, num = cha++;
    while (l <= r) {
        for (int j = 0; j < 3; ++j) all[num][j] = all[v][j];
        all[num][0]++;
        if (l == r) break;
        int m = ((l + r) >> 1);
        if (i <= m) {
            all[num][1] = cha++;
            num = all[num][1];
            v = all[v][1];
            r = m;
        } else {
            all[num][2] = cha++;
            num = all[num][2];
            v = all[v][2];
            l = m + 1;
        }
    }
}

int build(int l, int r) {
    if (l == r) {
        int num = cha++;
        return num;
    }
    int num = cha++;
    int m = (l + r) / 2;
    all[num][1] = build(l, m);
    all[num][2] = build(m + 1, r);
    return num;
}

int get_sum(int v, int l, int r, int A, int B) {
    if (l > B || A > r) return 0;
    if (A <= l && r <= B) return all[v][0];
    int m = (l + r) / 2;
    return get_sum(all[v][1], l, m, A, B) + get_sum(all[v][2], m + 1, r, A, B);
}

signed main() {
    if (1) {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        cout.tie(nullptr);
    }
    cin >> n;
    vector <int> v(n + 1);
    v[0] = build(0, n - 1);
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x; --x;
        v[i + 1] = cha;
        update(v[i], x);
    }
    int q;
    cin >> q;
    while (q--){
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        y1 = x1 - y1;
        y2 = x2 - y2;
        int num1, num2, l = -1, r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (get_sum(v[m], 0, n - 1, 0, x1 - 1) >= y1) r = m;
            else l = m;
        }
        num1 = r;
        l = -1;
        r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (get_sum(v[m], 0, n - 1, 0, x2 - 1) >= y2) r = m;
            else l = m;
        }
        num2 = r;
        l = 0;
        r = min(x1, x2) + 1;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (get_sum(v[num1], 0, n - 1, 0, m - 1) == get_sum(v[num2], 0, n - 1, 0, m - 1)) l = m;
            else r = m;
        }
        int y = get_sum(v[num1], 0, n - 1, 0, l - 1);
        cout << l << " " << l - y << "\n";
    }
    return 0;
}

/*
 1
3
1 2 
5 7 8
10 10
5 10
0 7

 */