#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
vector<vector<long long> > a;
vector<long long> tin, tout;

vector<long long> c;

vector<long long> ls, rs;

vector<int> cc;
vector<pair<int, int> > ddd;
vector<int> ccc;

vector<pair<int, int> > dd;
pair<int, int> mrg(pair<int, int> l, pair<int, int> r) {
	if (l.first <= r.first) {
		return l;
	}
	return r;
}
void build(int v, int l, int r) {
	if (l == r) {
		dd[v] = { 0,l };
		ddd[v] = { c[l],l };
		return;
	}
	else {
		build(2 * v + 1, l, (l + r) / 2);
		build(2 * v + 2, (l + r) / 2 + 1, r);
		dd[v] = mrg(dd[2 * v + 1], dd[2 * v + 2]);
		ddd[v] = mrg(ddd[2 * v + 1], ddd[2 * v + 2]);
	}
}
void push(int v) {
	cc[2 * v + 1] += cc[v];
	cc[2 * v + 2] += cc[v];
	cc[v] = 0;
}

void update(int v) {
	pair<int, int> ll = dd[2 * v + 1];
	ll.first += cc[2 * v + 1];
	pair<int, int> rr = dd[2 * v + 2];
	rr.first += cc[2 * v + 2];
	dd[v] = mrg(ll,rr);
}
void add(int v, int l, int r, int askl, int askr, int val) {
	if (l > askr || r < askl) {
		return;
	}
	if (l >= askl && r <= askr) {
		cc[v] += val;
		return;
	}
	push(v);
	add(2 * v + 1, l, (l + r) / 2, askl, askr, val);
	add(2 * v + 2, (l + r) / 2 + 1,r, askl, askr, val);
	update(v);
}
pair<int,int> ask(int v, int l, int r, int askl, int askr) {
	if (l > askr || r < askl) {
		return { 1e9,0 };
	}
	if (l >= askl && r <= askr) {
		return { dd[v].first + cc[v],dd[v].second };
	}
	push(v);
	auto aa = ask(2 * v + 1, l, (l + r) / 2, askl, askr);
	auto bb = ask(2 * v + 2, (l + r) / 2 + 1,r, askl, askr);
	update(v);
	return mrg(aa, bb);
}

void push2(int v) {
	ccc[2 * v + 1] |= ccc[v];
	ccc[2 * v + 2] |= ccc[v];
}
void update2(int v) {
	ddd[v] = { 1e9,0 };
	if (!ccc[2 * v + 1]) {
		ddd[v] = mrg(ddd[v], ddd[2 * v + 1]);
		
	}
	if (!ccc[2 * v + 2]) {
		ddd[v] = mrg(ddd[v], ddd[2 * v + 2]);
	}
	
}
void add2(int v, int l, int r, int askl, int askr) {
	if (l > askr || r < askl) {
		return;
	}
	if (l >= askl && r <= askr) {
		ccc[v] = 1;
		return;
	}
	push2(v);
	add2(2 * v + 1, l, (l + r) / 2, askl, askr);
	add2(2 * v + 2, (l + r) / 2 + 1, r, askl, askr);
	update2(v);
}
pair<int, int> ask2(int v, int l, int r, int askl, int askr) {
	if (l > askr || r < askl) {
		return { 1e9,0 };
	}
	if (l >= askl && r <= askr) {
		if (ccc[v]) {
			return { 1e9,0 };
		}
		else {
			return ddd[v];
		}
	}
	push2(v);
	auto aa = ask2(2 * v + 1, l, (l + r) / 2, askl, askr);
	auto bb = ask2(2 * v + 2, (l + r) / 2 + 1, r, askl, askr);
	update2(v);
	return mrg(aa, bb);
}




int counter = -1;
vector<int> revtin;

long long ctr = 0;
vector<long long> sz;
vector<long long> p;

void dfs(long long v) {
	sz[v] = 1;
	tin[v] = ++counter;;
	revtin[counter] = v;
	
	for (auto h : a[v]) {
		dfs(h);
		sz[v] += sz[h];
	}
	if (a[v].size() > 0) {
		long long bpos = 0;
		for (long long i = 0; i < a[v].size(); i++) {
			if (sz[a[v][i]] > sz[a[v][bpos]]) {
				bpos = i;
			}
		}
		swap(a[v][0], a[v][bpos]);
	}
	tout[v] = counter;
}
vector<long long> from;
vector<long long> pos,revpos;
vector<int> lvl;
int n;
void dfs1(long long v, long long to,int level) {
	from[v] = to;
	lvl[v] = level;
	revpos[ctr] = v;
	pos[v] = ctr++;
	if (a[v].size() > 0) {
		dfs1(a[v][0], to,level+1);
		for (long long i = 1; i < a[v].size(); i++) {
			dfs1(a[v][i], a[v][i],level+1);
		}
	}
}

void addin(int up, int down, int val) {
	while (lvl[from[down]] > lvl[up]) {
		add(0, 0, n - 1, pos[from[down]], pos[down], val);
		down = p[from[down]];
	}
	add(0, 0, n - 1, pos[up], pos[down], val);
	
}
pair<int,int>  minim(int up, int down) {
	pair<int, int> ans = { 1e9,0 };
	while (lvl[from[down]] > lvl[up]) {
		auto hh=ask(0, 0, n - 1, pos[from[down]], pos[down]);
		ans = mrg(ans, hh);
		down = p[from[down]];
	}
	auto hh=ask(0, 0, n - 1, pos[up], pos[down]);
	ans = mrg(hh, ans);;
	return ans;

}


vector<long long> vals;
long long findmin(long long v) {
	auto ans = ask2(0, 0, n - 1, tin[v], tout[v]);
	if (ans.first >= 1e9) {
		return -1;
	}
	return revtin[ans.second];
}
unsigned long long ans = 0;
vector<long long> bought;

long long dfs2(long long v) {
	long long curval = 0;
	for (auto h : a[v]) {
		long long val = dfs2(h);
		if (val == -1) {
			return -1;
		}
		curval += val;
		if (curval > rs[v]) {
			return -1;
		}
	}
	if (curval > rs[v]) {
		return -1;
	}
	else if (curval >= ls[v]) {
		addin(v, v, rs[v]-curval);
		return vals[v] = curval;
	}
	else {
		addin(v, v, rs[v] - curval);
		vals[v] = curval;
		while (curval < ls[v]) {
			long long need = ls[v] - curval;
			long long mnm = findmin(v);
			if (mnm == -1) {
				return -1;
			}
			else {
				long long have = need;
				long long cur = mnm;
				/*while (cur != v) {
					have = min(have, rs[cur] - vals[cur]);
					cur = p[cur];
				}
				cur = mnm;
				while (cur != v) {
					vals[cur] += have;
					cur = p[cur];
				}
				vals[v] += have;*/
				pair<int,int>  result = minim(v, mnm);
				if (need < result.first) {
					have = need;
					addin(v, mnm, -have);
					curval += have;
				}
				else {
					have = result.first;
					addin(v, mnm, -have);
					curval += have;
					add2(0, 0, n - 1, tin[result.second], tout[result.second]);
				}


				ans += (long long)c[mnm] * have;
				bought[mnm] += have;
			}
		}
		return curval;


	}
}

int main() {
	long long t;
	cin >> t;
	for (long long tt = 0; tt < t; tt++) {
		cin >> n;
		a.clear();
		p.clear();
		vals.clear();
		bought.clear();
		c.clear();
		ls.clear();
		sz.clear();
		rs.clear();
		dd.clear();
		cc.clear();
		pos.clear();
		revpos.clear();
		lvl.clear();
		from.clear();
		tin.clear();
		tout.clear();
		revtin.clear();
		ddd.clear();
		ccc.clear();
		ctr = 0;
		counter = -1;

		ans = 0;

		a.resize(n);
		p.resize(n);
		from.resize(n);
		vals.resize(n);
		bought.resize(n);
		sz.resize(n);
		c.resize(n);
		ls.resize(n);
		rs.resize(n);
		pos.resize(n);
		revpos.resize(n);
		dd.resize(4*n);
		cc.resize(4 * n);
		lvl.resize(n);
		tin.resize(n);
		tout.resize(n);
		revtin.resize(n);
		ddd.resize(4 * n);
		ccc.resize(4 * n);
		p[0] = -1;
		for (long long i = 1; i < n; i++) {
			long long x;
			cin >> x;
			x--;
			a[x].push_back(i);
			p[i] = x;

		}
		for (long long i = 0; i < n; i++) {
			cin >> c[i];
		}
		for (long long i = 0; i < n; i++) {
			cin >> ls[i] >> rs[i];
		}
		build(0, 0, n - 1);
		dfs(0);
		dfs1(0,0,0);
		long long anss = dfs2(0);
		if (anss == -1) {
			cout << -1 << '\n';
			continue;

		}
		cout << ans << '\n';
		for (long long i = 0; i < n; i++) {
			cout << bought[i] << ' ';
		}
		cout << '\n';

	}
}