#include <bits/stdc++.h>
using namespace std;

#define int long long

bool cmp(pair<int, int> a, pair<int, int> b) {
    if (a.second == b.second) return a.first < b.first;
    else return a.second < b.second;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int k;
    cin >> k;
    vector<int> allowed(k);
    for (int i = 0; i < k; i++) cin >> allowed[i];
    if (allowed.size() == 1) {
        int t;
        cin >> t;
        for (int useless = 0; useless < t; useless++) {
            int n, w, h;
            cin >> n >> w >> h;
            vector<pair<int, int>> lights(n);
            for (int i = 0; i < n; i++) cin >> lights[i].first >> lights[i].second;
            sort(lights.begin(), lights.end());
            vector<pair<int, int>> new_lights;
            new_lights.push_back(lights[0]);
            for (int i = 1; i < n; i++) {
                if (lights[i].first != new_lights.back().first) new_lights.push_back(lights[i]);
            }
            n = new_lights.size();
            vector<int> pref_min(n);
            pref_min[0] = new_lights[0].second;
            while (!new_lights.empty() && new_lights.back().first == w) new_lights.pop_back();
            n = new_lights.size();
            new_lights.push_back({w, 0});
            for (int i = 1; i < n; i++) pref_min[i] = min(pref_min[i - 1], new_lights[i].second);
            int ans = w * h;
//        for (auto i : new_lights) cout << i.first << " " << i.second << "\n";
            for (int i = n - 1; i >= 0; i--) {
                ans -= pref_min[i] * (new_lights[i + 1].first - new_lights[i].first);
            }
            ans -= h * (new_lights[0].first);
            cout << ans << "\n";
        }
    }
    else {
        int t;
        cin >> t;
        for (int useless = 0; useless < t; useless++) {
            int n, w, h;
            cin >> n >> w >> h;
            vector<pair<int, int>> lights(n);
            for (int i = 0; i < n; i++) cin >> lights[i].first >> lights[i].second;
            sort(lights.begin(), lights.end(), cmp);
            int two = n;
            int ans = 0;
            for (int i = 1; i < n; i++) {
                if (lights[i].second == lights[i - 1].second) {
                    two = i - 1;
                    ans += w * (h - lights[i].second);
                    h = lights[i].second;
                    break;
                }
            }
            if (two == 0) {
                cout << ans << "\n";
                continue;
            }
            vector<pair<int, int>> new_lights;
            for (int i = 0; i < two; i++) new_lights.push_back(lights[i]);
            lights = new_lights;
            n = lights.size();
            int l = 0, r = w;
            int curr = 0;
            int mx = 0;
            for (int i = 1; i < n; i++) {
                if (lights[i].first < l) lights[i].first = l;
                if (lights[i].first > r) lights[i].first = r;
                if (lights[i].first >= lights[i - 1].first) {
                    mx = max(mx, curr + (h - lights[i - 1].second) * (r - l) -
                                 lights[i - 1].first * (lights[i].second - lights[i - 1].second));
                    curr += (h - lights[i - 1].second) * (lights[i - 1].first - l);
                    l = lights[i - 1].first;
                } else {
                    mx = max(mx, curr + (h - lights[i - 1].second) * (r - l) -
                                 (r - lights[i - 1].first) * (lights[i].second - lights[i - 1].second));
                    curr += (h - lights[i - 1].second) * (r - lights[i - 1].first);
                    r = lights[i - 1].first;
                }
            }
            if (lights.back().first < l) lights.back().first = l;
            if (lights.back().first > r) lights.back().first = r;
            mx = max(mx, curr + (h - lights.back().second) * (lights.back().first - l));
            mx = max(mx, curr + (h - lights.back().second) * (r - lights.back().first));
            cout << ans + mx << "\n";
        }
    }
}