#include <iostream>
#include <bits/stdc++.h>

using namespace std;
#define all(a) a.begin(), a.end()
#define sz(a) (ll) a.size()
#define pll pair<ll, ll>
#define pikachu push_back
typedef long long ll;
typedef long double ld;

void run();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    run();
}

void debug_out() {
    cerr << endl;
}

template<typename Head, typename... Tail>
void debug_out(Head H, Tail... T) {
    cerr << " " << to_string(H);
    debug_out(T...);
}

#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)

void merge(set<pll > &a, set<pll > &b) {
    if (sz(a) < sz(b)) swap(a, b);
    for (auto e: b) a.insert(e);
}

template<typename A, typename B>
bool cmax(A& a, const B& b){
    if (a < b){
        a = b;
        return true;
    }
    return false;
}

template<typename A, typename B>
bool cmin(A& a, const B& b){
    if (a > b){
        a = b;
        return true;
    }
    return false;
}
const ll INFL = 1e18 + 666;

void run() {
    ll n;
    cin >> n;
    ++n;
    vector<ll> pred(n * n);
    auto idx = [&](ll x, ll y){
        return x * n + y;
    };
    vector<ll> c;
    auto calc = [&](){
        ll s = 0;
        for (auto e: c){
            ll v = s;
            if (e) ++s;
            s += n;
            pred[s] = v;
        }
    };
    vector<ll> a(n - 1);
    for(auto& e: a) cin >> e, --e;
    for(ll i = 0; i < n - 1; ++i) c.pikachu(1);
    calc();
    for(auto e: a){
        c[e] ^= 1;
        calc();
    }
    auto lca = [&](ll a, ll b){
        vector<ll> A, B;
        while(a) A.pikachu(a), a = pred[a];
        A.pikachu(0);
        while(b) B.pikachu(b), b = pred[b];
        B.pikachu(0);
        ll ans;
        reverse(all(A));
        reverse(all(B));
        for(ll i = 0; i < min(sz(A), sz(B)); ++i){
            if (A[i] == B[i]) ans = A[i];
        }
        return ans;
    };
    ll q;
    cin >> q;
    while(q--){
        ll r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        ll ans = lca(r1 * n + c1, r2 * n + c2);
        cout << ans / n << ' ' << ans % n << '\n';
    }
}
