#include <iostream>
#include <bits/stdc++.h>

using namespace std;
#define all(a) a.begin(), a.end()
#define sz(a) (ll) a.size()
#define pll pair<ll, ll>
#define pikachu push_back
typedef long long ll;
typedef long double ld;

void run();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    run();
}

void debug_out() {
    cerr << endl;
}

template<typename Head, typename... Tail>
void debug_out(Head H, Tail... T) {
    cerr << " " << to_string(H);
    debug_out(T...);
}

#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)

void merge(set<pll > &a, set<pll > &b) {
    if (sz(a) < sz(b)) swap(a, b);
    for (auto e: b) a.insert(e);
}

template<typename A, typename B>
bool cmax(A &a, const B &b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<typename A, typename B>
bool cmin(A &a, const B &b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}
ll type;
ll calc(vector<pll> t){
    sort(all(t));
    vector<pll> stk;
    for(auto[x, y]: t){
        while(sz(stk) && stk.back().second <= y) stk.pop_back();
        stk.pikachu({x, y});
    }
    ll ans = 0, last = 0;
    for(auto[x, y]: stk){
        ans += (x - last) * y;
        last = x;
    }
    return ans;
}
void task(){
    ll n, w, h;
    cin >> n >> w >> h;
    vector<pll> kek;
    for(ll i = 0; i < n; ++i){
        ll x, y;
        cin >> x >> y;
        kek.pikachu({x, y});
    }
    if (type == 1){
        for(auto&[x, y]: kek) x = w - x, y = h - y;
    }
    if (type == 2){
        for(auto&[x, y]: kek) x = w - x;
    }
    if (type == 4){
        for(auto&[x, y]: kek) y = h - y;
    }
    cout << calc(kek) << '\n';
}

void run() {
    ll t;
    cin >> t >> type;
    cin >> t;
    while(t--){
        task();
    }
}
