#pragma GCC optimize(3)

#include <bits/stdc++.h>

using namespace std;

#define vc vector
typedef int ll;
typedef pair<ll, ll> pll;
typedef vc<ll> vll;
typedef vc<pll> vpll;
typedef vc<vll> vvll;
typedef vc<vpll> vvpll;

bool made[9200005];

vll go[9200005];

ll d[9200005];

ll up[9200005];

void cfs(ll v, ll dd = 0) {
    d[v] = dd;
    for (auto to: go[v]) {
        up[to] = v;
        cfs(to, dd + 1);
    }
}

void upp(ll &v, ll x) {
    while (x--) {
        v = up[v];
    }
}

ll lca(ll v, ll u) {
    upp(u, max(0, d[u] - d[v]));
    upp(v, max(0, d[v] - d[u]));
    while (up[v] != up[u]) {
        v = up[v];
        u = up[u];
    }
    if (v != u) {
        v = up[v];
        u = up[u];
    }
    assert(v == u);
    return v;
}

int main() {
    ios_base::sync_with_stdio(false);
    ll n;
    cin >> n;
    vll a(n);
    for (auto &i: a) cin >> i;
    for (ll i = 0; i < n; ++i) {
        go[i * (n + 1) + i].push_back((i + 1) * (n + 1) + i + 1);
    }
    for (auto xx: a) {
        made[xx - 1] = true;
        ll nw = 0;
        for (ll i = 0; i < n; ++i) {
            bool fl = true;
            for (auto x: go[i * (n + 1) + nw]) {
                if (x == (i + 1) * (n + 1) + nw + (!made[i])) {
                    fl = false;
                    break;
                }
            }
            if (fl) {
                go[i * (n + 1) + nw].push_back((i + 1) * (n + 1) + nw + (!made[i]));
            }
            nw += !made[i];
        }
    }
    for (ll i = 0; i <= n; ++i) {
        for (ll j = 0; j <= i; ++j) {
            sort(go[i * (n + 1) + j].begin(), go[i * (n + 1) + j].end());
            go[i * (n + 1) + j].resize(
                    unique(go[i * (n + 1) + j].begin(), go[i * (n + 1) + j].end()) - go[i * (n + 1) + j].begin());
        }
    }
    up[0] = 0 * (n + 1) + 0;
    cfs(0 * (n + 1) + 0);


    ll q;
    cin >> q;
    while (q--) {
        pll x;
        cin >> x.first >> x.second;
        pll y;
        cin >> y.first >> y.second;
        ll wow = lca(x.first * (n + 1) + x.second, y.first * (n + 1) + y.second);
        pll z = {wow / (n + 1), wow % (n + 1)};
        cout << z.first << ' ' << z.second << '\n';
    }
}