#include <iostream>
#include <vector>

using namespace std;
#define int long long

void solve() {
  int n;
  cin >> n;
  vector<int> a(n);
  for (auto &x : a) {
    cin >> x;
    --x;
  }
  vector<int> pos(n);
  for (int i = 0; i < n; i++) {
    pos[a[i]] = i;
  }
  vector<int> posMin(n), posMax(n);
  for (int i = 0; i < n; i++) {
    posMin[i] = pos[i];
    int cnt_less = 0;
    for (int j = pos[i]; j >= 0; j--) {
      if (a[j] < i) {
        cnt_less++;
      }
      posMin[i] = min(posMin[i], j + cnt_less);
    }
  }
  for (int i = 0; i < n; i++) {
    posMax[i] = pos[i];
    int cnt_greater = 0;
    for (int j = pos[i]; j < n; j++) {
      if (a[j] > i) {
        cnt_greater++;
      }
      posMax[i] = max(posMax[i], j - cnt_greater);
    }
  }
  int res = 0;
  for (int i = 0; i < n; i++) {
    for (int j = i + 1; j < n; j++) {
      int add = j - i;
      if (pos[i] < pos[j]) {
        add = max(add, max(pos[j] - posMin[i], posMax[j] - pos[i]));
      } else {
        add = max(add, max(pos[i] - posMin[j], posMax[i] - pos[j]));
      }
      res += add;
    }
  }

  cout << res;
}

signed main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  solve();
  return 0;
}
