#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define pb push_back
#define eb emplace_back
#define lb lower_bound
#define ub upper_bound
#define debug(x) cerr << #x << ' ' << x << '\n';
#define fi first
#define se second
const int inf = (int)1e9 + 1;
const ll infll = (ll)1e18 + 1;
const int mod = (int)1e9 + 7;
template<typename T1, typename T2>
bool chmin(T1 &a, T2 b){
    if (a > b){
        a = b;
        return true;
    }
    return false;
}
template<typename T1, typename T2>
bool chmax(T1 &a, T2 b){
    if (a < b){
        a = b;
        return true;
    }
    return false;
}
const int maxn = 1e5 + 1;
vector<int> g[maxn];
ll c[maxn], l[maxn], r[maxn];
int sz[maxn];
int par[maxn];
int ind[2 * maxn], fv[maxn], sv[maxn];
int timer = 0;
void sizes(int v, int p){
    sz[v] = 1;
    par[v] = p;
    fv[v] = timer++;
    for (int u : g[v]){
        if (u == p) continue;
        sizes(u, v);
        sz[v] += sz[u];
    }
    sv[v] = timer;
}
ll cnt[maxn];
ll ans = 0;
ll cur[maxn];
bool ok = true;
int ost[2 * maxn];
bool ancestor(int a, int b){
    return fv[a] <= fv[b] && sv[a] >= sv[b];
}
int n;
void dfs(int v, int p){
    if (!ok) return;
    for (int u : g[v]){
        if (u == p) continue;
        dfs(u, v);
        if (!ok) return;
        cur[v] += cur[u];
    }
    if (cur[v] > r[v]){
        ok = false;
        return;
    }
    while (cur[v] < l[v]){
        int mi = -1;
        for (int i = fv[v]; i < sv[v]; i++){
            if (ost[i] == 0) continue;
            if (mi == -1 || c[ind[mi]] > c[ind[i]]) mi = i;
        }
        if (mi == -1){
            ok = false;
            break;
        }
        int need = l[v] - cur[v];
        int u = ind[mi];
        if (ost[mi] >= need){
            cnt[u] += need;
            ans += 1ll * need * c[u];
            for (int i = 0; i < n; i++){
                if (ancestor(i, u) && ancestor(v, i)){
                    ost[fv[i]] -= need;
                }
            }
            cur[v] += need;
        }
        else{
            ans += 1ll * ost[mi] * c[u];
            cnt[u] += ost[mi];
            cur[v] += ost[mi];
            int o = ost[mi];
            for (int i = 0; i < n; i++){
                if (ancestor(i, u) && ancestor(v, i)){
                    ost[fv[i]] -= o;
                }
            }
        }
    }
    for (int i = fv[v]; i < sv[v]; i++){
        chmin(ost[i], r[v] - cur[v]);
    }
}
void solve(){
    cin >> n;
    ok = true;
    fill(cnt, cnt + n, 0);
    fill(sz, sz + n, 0);
    fill(cnt, cnt + n, 0);
    fill(cur, cur + n, 0);
    ans = 0;
    for (int i = 0; i < n; i++){
        g[i].clear();
    }
    for (int i = 1; i < n; i++){
        int x;
        cin >> x;
        x--;
        g[x].pb(i);
        g[i].pb(x);
    }
    for (int i = 0; i < n; i++){
        cin >> c[i];
    }
    for (int i = 0; i < n; i++){
        cin >> l[i] >> r[i];
    }
    sizes(0, 0);
    for (int i = 0; i < n; i++){
        ind[fv[i]] = i;
        ost[fv[i]] = r[i];
    }
    dfs(0, 0);
    if (!ok){
        cout << -1 << '\n';
        return;
    }
    cout << ans << '\n';
    for (int i = 0; i < n; i++){
        cout << cnt[i] << ' ';
    }
    cout << '\n';
}
int32_t main(){
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int t;
    cin >> t;
    while (t--){
        solve();
    }
}