#include <iostream>
#include <vector>
#include <set>
#define int long long

using namespace std;

const int maxn = 1e5;

vector<vector<int>> g;
vector<int> l, r, c, moo, t, pr;

int ans = 0;
bool f = true;

set<pair<int, int>> dfs(int v, int p = -1){
    set<pair<int, int>> option, son;
    for (auto u : g[v]){
        if (u == p) continue;
        son = dfs(u, v);
        if (!f) return {};
        for (auto x : son){
            option.insert(x);
        }
        t[v] += t[u];
    }

    if (r[v] - t[v] > 0) {
        option.insert({c[v], v});
    }

    if (t[v] > r[v]){
        f = false;
        return {};
    }

    while (t[v] < l[v] && (int)option.size()){
        pair<int, int> p1 = *option.begin();
        option.erase(option.find(p1));
        int u = p1.second;
        if (r[u] - t[u] == 0){
            continue;
        }
        if (r[u] - t[u] < 0){
            f = false;
            continue;
        }

        if (t[v] + (r[u] - t[u]) <= l[v]){
            int delta = r[u] - t[u];
            ans += p1.first * delta;
            moo[u] += (r[u] - t[u]);

            while (true){
                t[u] += delta;
                if (t[u] > r[u]){
                    f = false;
                }
                if (u == v) break;
                u = pr[u];
            }

        } else {

            int delta = l[v] - t[v];
            ans += p1.first * delta;
            moo[u] += delta;

            while (true){
                t[u] += delta;
                if (t[u] > r[u]){
                    f = false;
                }
                if (u == v) break;
                u = pr[u];
            }

            option.insert(p1);
        }
    }

    if (t[v] < l[v]){
        f = false;
        return {};
    }

    return option;
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int z;
    cin >> z;

    while (z --) {

        int n;
        cin >> n;

        f = true;
        ans = 0;

        g.assign(n, vector<int>());
        t.assign(n, 0);
        l.assign(n, 0);
        r.assign(n, 0);
        c.assign(n, 0);
        pr.assign(n, 0);
        moo.assign(n, 0);

        int p;
        for (int i = 0; i < n - 1; i++) {
            cin >> p;
            p --;
            pr[i + 1] = p;
            g[p].push_back(i + 1);
        }

        for (int i = 0; i < n; i++) {
            cin >> c[i];
        }

        for (int i = 0; i < n; i++) {
            cin >> l[i] >> r[i];
        }

        ans = 0;
        dfs(0);

        if (!f){
            cout << -1 << endl;
        } else {
            cout << ans << endl;
            for (int i = 0; i < n; i ++){
                cout << moo[i] << " ";
            }
            cout << endl;
        }
    }
}
