#include <bits/stdc++.h>

using namespace std;
#define int long long

const int N = 100005;

vector<int> gr[N];
int pred[N];
int cost[N];

pair<int, int> vec[N];

int summ[N];
int ans[N];
bool fl = false;
int res = 0;

int ost[N];

set<pair<int, int>> dfs(int u) {
    set<pair<int, int>> st;
    st.insert({cost[u], u});
    ost[u] = vec[u].second;
    for (auto c: gr[u]) {
        set<pair<int, int>> st2 = dfs(c);
        if (st2.size() < st.size()) {
            for (auto c2: st2) st.insert(c2);
        } else {
            for (auto c2: st) st2.insert(c2);
            st.swap(st2);
        }
        summ[u] += summ[c];
    }
    ost[u] -= summ[u];
    if (summ[u] > vec[u].second) fl = true;
    if (summ[u] >= vec[u].first) return st;
    while (summ[u] < vec[u].first) {
        if (st.empty()) {
            fl = true;
            return st;
        }
        pair<int, int> now = *st.begin();
        int can = vec[u].first - summ[u];
        int v = now.second;
        can = min(can, ost[v]);
        while (v != u) {
            v = pred[v];
            can = min(can, ost[v]);
        }
        if (can == 0) {
            st.erase(now);
            continue;
        }
        v = now.second;
        ans[v] += can;
        res += cost[v] * can;
        summ[u] += can;
        ost[v] -= can;
        while (v != u) {
            v = pred[v];
            ost[v] -= can;
        }
    }
    return st;

}

void solve() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    fl = false;
    res = 0;
    for (int i = 0; i < n; ++i) {
        gr[i].clear();
        ans[i] = 0;
        summ[i] = 0;
    }
    for (int i = 1; i < n; ++i) {
        int a;
        cin >> a;
        a--;
        gr[a].push_back(i);
        pred[i] = a;
    }
    for (int i = 0; i < n; ++i) {
        cin >> cost[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> vec[i].first >> vec[i].second;
    }
    dfs(0);
    if (fl) {
        cout << "-1\n";
        return;
    }
    cout << res << "\n";
    for (int i = 0; i < n; ++i) {
        cout << ans[i] << " ";
    }
    cout << "\n";


}

signed main() {

    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
