#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct add {
    ll cost, cnt, it;
    add(ll c, ll k, ll t) {
        cost = c, cnt = k, it = t;
    }
};

vector <int> v[100100];
vector <add> t[100100];
ll res[100100], l[100100], r[100100], cost[100100], b[100100];

bool cmp(add a, add b) {
    return a.cost > b.cost;
}

void dfs(int u) {
    if (v[u].size() == 0) {
        res[u] = l[u] * cost[u];
        t[u].push_back(add(cost[u], r[u] - l[u], u));
        b[u] = l[u];
        return;
    }
    ll sl = 0;
    for (int w : v[u]) {
        dfs(w);
        sl += l[w];
        res[u] += res[w];
        if (res[w] == -1) {
            res[u] = -1;
            return;
        }
        for (auto k : t[w]) {
            t[u].push_back(k);
        }
        t[w].clear();
    }
    if (sl > r[u]) {
        res[u] = -1;
        return;
    }
    l[u] = max(l[u], sl);
    if (l[u] > r[u]) {
        res[u] = -1;
        return;
    }
    t[u].push_back(add(cost[u], r[u] - sl, u));
    ll k = l[u] - sl;
    sort(t[u].begin(), t[u].end(), cmp);
    while (k > 0) {
        int sz = t[u].size() - 1;
        if (t[u][sz].cnt > k) {
            t[u][sz].cnt -= k;
            res[u] += t[u][sz].cost * k;
            b[t[u][sz].it] += k;
            k = 0;
        } else {
            k -= t[u][sz].cnt;
            res[u] += (t[u][sz].cost) * (t[u][sz].cnt);
            b[t[u][sz].it] += t[u][sz].cnt;
            t[u].pop_back();
        }
    }
    vector <add> tmp;
    k = l[u];
    while (k < r[u] && !t[u].empty()) {
        int sz = t[u].size() - 1;
        if (t[u][sz].cnt + k < r[u]) {
            tmp.push_back(t[u][sz]);
            k += t[u][sz].cnt;
        } else {
            tmp.push_back(add(t[u][sz].cost, r[u] - k, t[u][sz].it));
            k = r[u];
        }
        t[u].pop_back();
    }
    t[u].clear();
    for (add w : tmp) {
        t[u].push_back(w);
    }
}

void solve() {
    int n;
    cin >> n;
    for (int i = 1; i <= n; ++i) {
        b[i] = 0;
        v[i].clear();
        t[i].clear();
        res[i] = 0;
    }
    for (int i = 2; i <= n; ++i) {
        int p;
        cin >> p;
        v[p].push_back(i);
    }
    for (int i = 1; i <= n; ++i) {
        cin >> cost[i];
    }
    for (int i = 1; i <= n; ++i) {
        cin >> l[i] >> r[i];
    }
    dfs(1);
    cout << res[1] << '\n';
    if (res[1] != -1) {
        for (int i = 1; i <= n; ++i) {
            cout << b[i] << ' ';
        }
        cout << '\n';
    }
}

int main() {
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        solve();
    }
    return 0;
}
