#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,avx2,mmx,abm,fma")

#include <bits/stdc++.h>
using namespace std;

using ll = long long;

#define int long long
const int N = 100010;
int c[N];
pair<int, int> lr[N];

ll ns[N];
int pr[N];

pair<pair<int, ll>, int> dfs1(int v, vector<vector<int>>& g, int p = -1) {
    ll cost = 0;
    ll cou = 0;
    int min_se = v;
    for (auto to : g[v]) {
        if (to != p) {
            auto ans = dfs1(to, g, v);
            if (ans.first.first == -1) {
                return {{-1, -1}, ans.second};
            }
            cost += ans.first.second;
            cou += ans.first.first;
            if (c[ans.second] < c[min_se]) {
                min_se = ans.second;
            }
        }
    }
    int l = lr[v].first;
    int r = lr[v].second;
    if (cou > r) {
        return {{-1, -1}, min_se};
    }
    if (cou < l) {
        cost += 1ll * c[min_se] * (l - cou);
        ns[min_se] += (l - cou);
        cou = l;
    }
    return {{cou, cost}, min_se};
}

void solve() {
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<vector<int>> g(n);
        fill(ns, ns + n, 0);
        for (int i = 1; i < n; ++i) {
            int p;
            cin >> p;
            pr[i] = p - 1;
            g[p - 1].push_back(i);
            g[i].push_back(p - 1);
        }
        for (int i = 0; i < n; ++i) {
            cin >> c[i];
        }
        for (int i = 0; i < n; ++i) {
            cin >> lr[i].first >> lr[i].second;
        }

        auto ans = dfs1(0, g);
        if (ans.first.first == -1) {
            cout << "-1\n";
        } else {
            cout << ans.first.second << '\n';
            for (int i = 0; i < n; ++i) {
                cout << ns[i] << ' ';
            }
            cout << '\n';
        }
    }
}

signed main() {
#ifdef Debugg
    freopen("C:\\Users\\roi\\CLionProjects\\untitled\\ain.txt", "r", stdin);
    freopen("C:\\Users\\roi\\CLionProjects\\untitled\\aout.txt", "w", stdout);
#endif
    solve();
    return 0;
}
