#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define all(v) v.begin(), v.end()

void dfs(int v, vector<vector<int> > &p, vector<bool> &used) {
    if (used[v])
        return;
    used[v] = 1;
    for (int u : p[v]) {
        if (u == -1)
            continue;
        dfs(u, p, used);
    }
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int &x : a) {
        cin >> x;
        --x;
    }
    int q;
    cin >> q;
    if (n <= 3000 && q <= 3000) {
        vector<vector<int> > b(n + 1, vector<int>(n + 1));
        vector<pair<int, int> > c;
        int it = 0;
        for (int i = 0; i <= n; ++i) {
            for (int j = 0; j <= i; ++j) {
                b[i][j] = it++;
            }
        }
        c.resize(it);
        for (int i = 0; i <= n; ++i) {
            for (int j = 0; j <= i; ++j) {
                c[b[i][j]] = {i, j};
            }
        }
        vector<bool> cur(n, 1);
        vector<bool> l(it, 0);
        vector<bool> r(it, 0);
        for (int i = 0; i <= n; ++i) {
            if (i) {
                cur[a[i - 1]] = 0;
            }
            int x = 0, y = 0;
            for (int j = 0; j < n; ++j) {
                if (cur[j]) {
                    r[b[x][y]] = 1;
                    ++x;
                    ++y;
                } else {
                    l[b[x][y]] = 1;
                    ++x;
                }
            }
        }
        vector<vector<int> > p(it, vector<int>(2, -1));
        vector<vector<int> > g(it, vector<int>(2, -1));
        for (int i = 0; i < it; ++i) {
            if (l[i]) {
                int vl = b[c[i].first + 1][c[i].second];
                p[vl][1] = i;
                g[i][0] = vl;
            }
            if (r[i]) {
                int vr = b[c[i].first + 1][c[i].second + 1];
                p[vr][0] = i;
                g[i][1] = vr;
            }
        }
        while (q--) {
            int x1, y1, x2, y2;
            cin >> x1 >> y1 >> x2 >> y2;
            int v = b[x1][y1];
            int u = b[x2][y2];
            vector<bool> used1(it, 0);
            vector<bool> used2(it, 0);
            dfs(v, p, used1);
            dfs(u, p, used2);
            int best = b[0][0];
            for (int i = 0; i < it; ++i) {
                if (used1[i] && used2[i]) {
                    if (c[best].first < c[i].first)
                        best = i;
                }
            }
            cout << c[best].first << ' ' << c[best].second << '\n';
        }
    }
    return 0;
}
