#pragma GCC optimize("Ofast", "no-stack-protector")

#include <bits/stdc++.h>
#define endl "\n"
#define ll long long
//#define int long long
#define pii pair<int, int>
#define X first
#define Y second
#define all(a) a.begin(), a.end()
#define fast ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);
using namespace std;

template<typename T>
bool rmax (T& a, T b) {
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
bool rmin (T& a, T b) {
    if (a > b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto &it : a)
        in >> it;

    return in;
}

template<typename T>
ostream& operator << (ostream& in, vector<T>& a) {
    for (auto &it : a)
        in << it << ' ';

    return in;
}


unordered_map<int, pii> ret;

int hash_pair (pii a) {
    int num = a.X * (a.X + 1) / 2;
    return num + a.Y;
}

vector<int> num;
vector<int> ans;
void make_down (int id) {
    int x = 0;
    int y = 0;
    pii prev = {x, y};
    ans[hash_pair(prev)] = id;

    for (auto &it : num) {
        x++;
        if (it == 1) {
            y++;
        }

        pii ns = {x, y};
        ans[hash_pair(ns)] = id;
    }
}


void solve () {
    int n;
    cin >> n;

    int id = 0;

    for (int r = 0; r <= n; r++) {
        for (int c = 0; c <= r; c++) {
            ret[hash_pair({r, c})] = {r, c};
            id++;
        }
    }

    num.assign(n, 1);

    ans.resize(1e7);
    make_down(0);

    vector<vector<int>> numbers;
    numbers.push_back(num);

    for (int i = 0; i < n; i++) {
        int f;
        cin >> f;
        --f;

        num[f] = 0;
        make_down(i + 1);
        numbers.push_back(num);
    }



    int q;
    cin >> q;

    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;

        int u = hash_pair({r1, c1});
        int v = hash_pair({r2, c2});

        u = ans[u];
        v = ans[v];

        int pos_1 = n;
        for (int i = 0; i < n; i++) {
            if (numbers[u][i] != numbers[v][i]) {
                pos_1 = i;
                break;
            }
        }

        int x = 0, y = 0;

        for (int i = 0; i < pos_1; i++) {
            x++;
            if (numbers[u][i] == 1)
                y++;
        }

        if (x > r1) {
            x = r1;
            y = c1;
        }

        if (x > r2) {
            x = r2;
            y = c2;
        }

        cout << x << ' ' << y << endl;
    }

}

signed main () {
    fast;

#if defined(LOCAL_CLION)
    freopen("../input.txt", "r", stdin);
#elif defined(LOCAL)
    freopen("./input.txt", "r", stdin);
#endif

    int t = 1;
//    cin >> t;

    while (t--)
        solve();
}