#pragma GCC optimize("Ofast", "no-stack-protector")

#include <bits/stdc++.h>
#define endl "\n"
#define ll long long
#define int long long
#define pii pair<int, int>
#define X first
#define Y second
#define all(a) a.begin(), a.end()
#define fast ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);
using namespace std;

template<typename T>
bool rmax (T& a, T b) {
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
bool rmin (T& a, T b) {
    if (a > b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto &it : a)
        in >> it;

    return in;
}

template<typename T>
ostream& operator << (ostream& in, vector<T>& a) {
    for (auto &it : a)
        in << it << ' ';

    return in;
}



void solve () {
    int n, w, h;
    cin >> n >> w >> h;

    vector<pii> a(n);

    for (auto &it : a) {
        cin >> it.X >> it.Y;
        it.X = w - it.X;
        it.Y = h = it.Y;
    }

    sort(all(a));

    vector<pii> rect;

    for (auto &it : a) {
        while (rect.size() != 0 && it.Y >= rect.back().Y)
            rect.pop_back();

        rect.push_back(it);
    }

    ll ans = 0;

    int prev_x = 0;

    for (auto &it : rect) {
        ans += (it.X - prev_x) * it.Y;
        prev_x = it.X;
    }

    cout << ans << endl;
}


signed main () {
    fast;

#if defined(LOCAL_CLION)
    freopen("../input.txt", "r", stdin);
#elif defined(LOCAL)
    freopen("./input.txt", "r", stdin);
#endif

    int k;
    cin >> k;

    vector<int> f(k);
    cin >> f;

    int t = 1;
    cin >> t;

    while (t--)
        solve();
}