#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

#define int long long
#define all(a) a.begin(), a.end()
#define pb push_back
#define INF (int) 1e18 / 2

using namespace std;

const int N = 5005;

void solve() {
    int n;
    cin >> n;
    vector<int> p(n + 1);
    vector<int> c(n + 1), l(n + 1), r(n + 1);
    vector<int> cnt(n + 1);
    vector<int> has(n + 1);
    for (int i = 2; i <= n; i++)
        cin >> p[i];
    for (int i = 1; i <= n; i++)
        cin >> c[i];
    for (int i = 1; i <= n; i++)
        cin >> l[i] >> r[i];
    vector<pair<int, int>> pa;
    for (int i = 1; i <= n; i++) {
        pa.pb({c[i], i});
    }
    sort(all(pa));
    int ans = 0;
    for (auto[w, v] : pa) {
        int mn = 0, mx = INF;
        int u = v;
        while (u != 0) {
            mx = min(mx, r[u] - cnt[u]);
            mn = max(mn, l[u] - cnt[u]);
            u = p[u];
        }
        mn = min(mn, mx);
        has[v] += mn;
        ans += mn * w;
        u = v;
        while (u != 0) {
            cnt[u] += mn, u = p[u];
        }
    }
    bool ok = true;
    for (int i = 1; i <= n; i++) {
        if (cnt[i] < l[i] || cnt[i] > r[i])
            ok = false;
    }
    if (!ok) {
        cout << -1 << '\n';
        return;
    }
    cout << ans << '\n';
    for (int i = 1; i <= n; i++)
        cout << has[i] << " ";
    cout << '\n';
}

int32_t main() {
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio(false);

    int tt = 1;
    cin >> tt;
    while (tt--)
        solve();
}
