#include <iostream>
#include <vector>
#include <bitset>
#include <cmath>

using namespace std;
//template <typename T>
//using oset = __gnu_pbds::tree<T, __gnu_pbds::null_type, less<T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;
using ll = long long;

constexpr int MAXN = 4504506;
constexpr int LOGMAXN = 23; //

int graph[MAXN][2];
char graph0[MAXN];

short getvx[MAXN], getvy[MAXN];
int lcav[MAXN << 1];
int lcavr = 0;

int min(int a, int b) { return (a < b ? a : b); }
int max(int a, int b) { return (a > b ? a : b); }

int getv(short r, short c) {
    int res = r * (r + 1) / 2 + c;
    getvx[res] = r;
    getvy[res] = c;
    return res;
}

int stek[MAXN];
int stekr = 1;

int occur[MAXN];
/*
void build_lca_dfs(int v) {
    occur[v] = lcavr;
    lcav[lcavr++] = v;
    for (int ch : graph[v]) {
        depth[ch] = depth[v] + 1;
        build_lca_dfs(ch);
        lcav[lcavr++] = v;
    }
}*/
int par[MAXN];
void build_lca_dfs(int u) {
    stek[0] = u;
    while (stekr != 0) {
        int v = stek[--stekr];
        if (v != u) lcav[lcavr++] = par[v];
        occur[v] = lcavr;
        lcav[lcavr++] = v;
        for (int ch = 0; ch < graph0[v]; ++ch) {
            int c = graph[v][ch];
            par[c] = v;
            stek[stekr++] = c;
        }
    }
}

int table[LOGMAXN][MAXN];

void build_lca() {
    build_lca_dfs(0);
    for (int i = 0; i < lcavr; ++i) {
        table[0][i] = lcav[i];
    }
    int n = lcavr;
    int i;
    for (int lvl = 1; lvl < LOGMAXN; ++lvl) {
        for (i = 0; i <= n - (1 << lvl); ++i) {
            table[lvl][i] = min(table[lvl - 1][i], table[lvl - 1][i + (1 << (lvl - 1))]);
        }
    }
}

int get_lca(int u, int v) {
//    if (u == v) return u;
    int mn = min(occur[u], occur[v]);
    int mx = max(occur[v], occur[u]) + 1;
    int lg = log2(mx - mn);
    return min(table[lg][mn], table[lg][mx - (1 << lg)]);
}


/*void build_lca_dfs(int v) {
    stek[0] = v;
    while (stekr != 0) {
        int v = stek[--stekr];
        for (int lvl = 1; lvl < LOGMAXN; ++lvl) {
            up[lvl][v] = up[lvl - 1][up[lvl - 1][v]];
        }
        for (int ch = 1; ch <= graph[v][0]; ++ch) {
            int c = graph[v][ch];
            depth[c] = depth[v] + 1;
            up[0][c] = v;
            stek[stekr++] = c;
        }
    }
}

void build_lca() {
    build_lca_dfs(0);
}

int get_lca(int u, int v) {
    if (depth[u] < depth[v]) {
        swap(u, v);
    }
    int diff = depth[u] - depth[v];
    for (int bit = LOGMAXN - 1; bit >= 0; --bit) {
        if (diff & (1 << bit)) {
            u = up[bit][u];
        }
    }
    if (u == v) return u;
    for (int bit = LOGMAXN - 1; bit >= 0; --bit) {
        if (up[bit][u] != up[bit][v]) {
            u = up[bit][u];
            v = up[bit][v];
        }
    }
    return up[0][u];
}*/

bitset<4096> cor;

int32_t main() {
    // ne rascheska
    int n;
    cin >> n;
    for (int r = 0; r < n; ++r) {
        graph0[getv(r, r)] = 1;
        graph[getv(r, r)][0] = getv(r + 1, r + 1);
    }
    for (int i = 0; i < n; ++i) {
        int nc;
        int now;
        cin >> now;
        cor[now - 1] = true;
        int cury = 0;
        for (int r = 0; r < now - 1; ++r) {
            if (!cor[r]) {
                ++cury;
            }
        }
        for (int r = now - 1; r < n; ++r) {
            nc = cury + !cor[r];
            graph[getv(r, cury)][graph0[getv(r, cury)]] = getv(r + 1, nc);
            ++graph0[getv(r, cury)];
            cury = nc;
        }
    }
    build_lca();
    int q;
    cin >> q;
    int u, v, x, y;
    int aaa;
    while (q --> 0) {
        cin >> u >> v >> x >> y;
        aaa = get_lca(getv(u, v), getv(x, y));
        cout << getvx[aaa] << ' ' << getvy[aaa] << '\n';
    }
    return 0;
}
