#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
int lca(vector<vector<int>>& bl, int a, int b, int r1, int r2) {
	if (r1 < r2) swap(a, b), swap(r1, r2);
	int h = r1 - r2;
	for (int i = 19; i >= 0; --i) {
		if (h >= (1 << i) && bl[i][a] != -1) {
			a = bl[i][a];
			h -= (1 << i);
		}
	}
	for (int i = 19; i >= 0; --i) {
		if (bl[i][a] != bl[i][b] && bl[i][a] != -1 && bl[i][b] != -1) {
			a = bl[i][a];
			b = bl[i][b];
		}
	}
	while (a != b) {
		a = bl[0][a];
		b = bl[0][b];
	}
	return a;
}
int main() {
	int n, q;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; ++i) cin >> a[i];
	if (n <= 3000) {
		vector<int> p((n + 1) * (n + 2) / 2, -1);
		vector<int> r(n, 1);
		for (int i = 0; i <= n; ++i) {
			int R = 0, C = 0;
			for (int j = 0; j < n; ++j) {
				int r1 = R + 1, c1 = C + r[j];
				p[r1 * (r1 + 1) / 2 + c1] = R * (R + 1) / 2 + C;
				R = r1;
				C = c1;
			}
			if (i != n) r[a[i] - 1] = 0;
		}
		vector<vector<int>> bl(20, vector<int>((n + 1) * (n + 2) / 2, -1));
		for (int i = 0; i < 20; ++i) {
			for (int j = 0; j < (n + 1) * (n + 2) / 2; ++j) {
				if (i == 0) bl[i][j] = p[j];
				else {
					if (bl[i - 1][j] != -1) bl[i][j] = bl[i - 1][bl[i - 1][j]];
				}
			}
		}
		cin >> q;
		while (q--) {
			int r1, c1, r2, c2;
			cin >> r1 >> c1 >> r2 >> c2;
			int l = lca(bl, r1 * (r1 + 1) / 2 + c1, r2 * (r2 + 1) / 2 + c2, r1, r2);
			for (int i = 0; i <= n; ++i) {
				if (l - (i * (i + 1) / 2) <= i) {
					cout << i << " " << l - (i * (i + 1) / 2) << "\n";
					break;
				}
			}
		}
	}
	else {
		int k = n;
		for (int i = 0; i < n; ++i) {
			if (a[i] != i + 1) {
				k = i;
				break;
			}
		}
		cin >> q;
		while (q--) {
			int r1, c1, r2, c2;
			cin >> r1 >> c1 >> r2 >> c2;
			if (r1 - c1 < k && r2 - c2 < k) {
				if (r1 - c1 == r2 - c2) cout << min(r1, r2) << " " << min(c1, c2) << "\n";
				else cout << min(r1 - c1, r2 - c2) << " 0\n";
			}
			else if (r1 - c1 >= k && r2 - c2 >= k) {
				if (c1 == c2) cout << min(r1, r2) << " " << min(c1, c2) << "\n";
				else cout << k + min(c1, c2) << " " << min(c1, c2) << "\n";
			}
			else if (r1 - c1 < k) {
				cout << r1 - c1 << " 0\n";
			}
			else {
				cout << r2 - c2 << " 0\n";
			}
		}
	}
}