#include <iostream>
#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define b push back
vector <int> ft;
int n;
#define pii pair<int, int>
vector <vector <pii>> valid;
vector <int> a;
void add(int x){
    for (; x <= n; x = (x | (x + 1))) ft[x]++;
}
int get(int x){
    int ans = 0;
    for (; x > 0; x = (x & (x + 1)) - 1) ans += ft[x];
    return ans;
}
void match_times(){
    valid.assign(n + 1, vector <pii> (n + 1, {-1, -1})); // [l, r)
    vector <pair<int, int>> temp(n + 2);
    for (int i = 0; i <= n; i++) valid[0][i].first = 0;
    ft.assign(n + 1, 0);
    valid[0][0] = {0, n + 1};
    for (int i = 1; i <= n; i++){
        add(a[i]);
        for (int j = a[i]; j <= n; j++){
            int t = get(j);
            valid[t - 1][j - (t - 1)].second = i;
            valid[t][j - t].first = i;
        }
    }
    for (int i = 0; i <= n; i++) {
        valid[i][0].second = n + 1; // Not N cus valid is semi-interval
    }

}
bool segs_intersection(pii s1, pii s2){
    if (s1.first > s2.first) swap(s1, s2);
    return s2.first < s1.second;
}
bool is_anc(pii p, pii v){
    //cout << "called check for " << p.first << ", " << p.second << ' ' << v.first << ", " << v.second << '\n';
    return (segs_intersection(valid[v.first][v.second], valid[p.first][p.second])) && (p.second <= v.second);
}
pii anc(pii v){
    if (v.first == 0) return {v.first, v.second - 1};
    if (v.second == 0) return {v.first - 1, v.second};
    if (is_anc({v.first - 1, v.second}, v)) return {v.first - 1, v.second};
    else return {v.first, v.second - 1};
}
pii query(pii u, pii v){
    //cout << "query [" << u.first << ' ' << u.second << "] [" << v.first << ' ' << v.second << "]\n";
    while (!is_anc(u, v)) {
        u = anc(u);
    }
    return u;
}
int main() {
    cin >> n;
    a.resize(n + 1);
    for (int i = 1; i <= n; i++) cin >> a[i];
    match_times();
    int q; cin >> q;
    while (q--){
        int r1, c1, r2, c2;
         cin >> r1 >> c1 >> r2 >> c2;
         pii res = query({r1 - c1, c1}, {r2 - c2, c2});
         cout << res.first + res.second << ' ' << res.second << '\n';
    }
    return 0;
}
