#ifndef ONPC
#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2")
//#pragma GCC optimize("unroll-loops")
#endif

#include <iostream>
#include <iomanip>
#include <cmath>
#include <utility>
#include <algorithm>
#include <numeric>
#include <vector>
#include <string>
#include <sstream>
#include <limits>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <deque>

using namespace std;
using ll = int64_t;
using ld = long double;
using vi = vector<int>;
using vc = vector<char>;
using vll = vector<ll>;
using vvi = vector<vi>;
using ii = pair<int, int>;
using vii = vector<ii>;

#define all(x) (x).begin(), (x).end()
#define endl '\n'

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n;
    cin >> n;
    vi a(n);
    for (auto &e : a) {
        cin >> e;
        --e;
    }

    vi rev(n);
    for (int i = 0; i < n; ++i) {
        rev[a[i]] = i;
    }
    vvi d(n, vi(n, 0));
    for (int i = 0; i < n - 1; ++i) {
        for (int j = i + 1; j < n; ++j) {
            d[i][j] = j - i;
        }
    }

    vi pref(n), suff(n);
    vi curr;
    curr.reserve(n);
    for (int i = 0; i < n; ++i) {
        auto it = upper_bound(all(curr), a[i]);
        pref[i] = it - curr.begin();
        curr.insert(it, a[i]);
    }
    curr.clear();
    curr.reserve(n);
    for (int i = n - 1; i >= 0; --i) {
        auto it = upper_bound(all(curr), a[i]);
        suff[i] = it - curr.begin();
        curr.insert(it, a[i]);
    }

    for (int i = 0; i < n - 1; ++i) {
        for (int j = i + 1; j < n; ++j) {
            int li = rev[i];
            int ri = rev[j];
            if (li > ri)
                swap(li, ri);
            int cans = ri - li;
//            cans += li - pref[li];
//            cans += suff[ri];
            d[i][j] = max(d[i][j], cans + li - pref[li]);
            d[i][j] = max(d[i][j], cans + suff[ri]);
        }
    }

    ll ans = 0;
    for (int i = 0; i < n - 1; ++i) {
        for (int j = i + 1; j < n; ++j) {
            ans += static_cast<ll>(d[i][j]);
        }
    }
    cout << ans << endl;
}