// #pragma GCC optimize("unroll-loops")

#include <iostream>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cstring>


#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#define x first
#define y second

#define pub push_back
#define pob pop_back
#define puf push_front
#define pof pop_front


using namespace std;


typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;





void solve_solve_solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
    }



    exit(-100);

    int dist[n][n];
    memset(dist, 0, sizeof(dist));

    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            dist[a[i]][a[j]] = dist[a[j]][a[i]] = max(dist[a[i]][a[j]], j - i);
        }
    }

    vector<int> v = a;
    sort(all(a));
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            dist[a[i]][a[j]] = dist[a[j]][a[i]] = max(dist[a[i]][a[j]], j - i);
        }
    }
    a = v;






    vector<int> left(n, n + 10);
    vector<int> right(n, -1);



    // prefix - left
    for (int l = 0; l < n; l++) {
        for (int j = l; j >= 0; j--) {
            vector<int> v = a;
            sort(v.begin() + j, v.begin() + l + 1);

            for (int i = 0; i <= l; i++) {
                if (v[i] == a[l]) {
                    left[v[i]] = min(left[v[i]], i);
                }
            }
        }
        for (int r = l + 1; r < n; r++) {
            dist[a[r]][a[l]] = dist[a[l]][a[r]] = max(dist[a[r]][a[l]], r - left[a[l]]);
        }
    }

    // suffix - right
    for (int l = 0; l < n; l++) {
        for (int j = l; j < n; j++) {
            vector<int> v = a;
            sort(v.begin() + l, v.begin() + j + 1);

            for (int i = l; i < n; i++) {
                if (v[i] == a[l]) {
                    right[v[i]] = max(right[v[i]], i);
                }
            }
        }

        for (int r = 0; r < l; r++) {
            dist[a[r]][a[l]] = dist[a[l]][a[r]] = max(dist[a[r]][a[l]], right[a[l]] - r);
        }
    }



    /*
    for (int l = 0; l < n; l++) {
        for (int r = l + 1; r <= n; r++) {
            vector<int> v = a;
            sort(v.begin() + l, v.begin() + r);

            for (int i = 0; i < n; i++) {
                for (int j = i + 1; j < n; j++) {
                    int x = j - i;
                    x = max(x, dist[v[i]][v[j]]);

                    dist[v[i]][v[j]] = dist[v[j]][v[i]] = x;
                }
            }
        }
    }
    */






    ll ans = 0;


    /*
    cout << "d = \n";
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cout << dist[i][j] << " ";
        }
        cout << "\n";
    }
    cout << "\nEND\n";
    */


    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            ans += dist[i][j];
        }
    }


    cout << ans << "\n";
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int Q = 1;
    //cin >> Q;

    while (Q--) {
        solve_solve_solve();
    }

    return 0;
}
