#include <iostream>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>


#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#define x first
#define y second

#define pub push_back
#define pob pop_back
#define puf push_front
#define pof pop_front


#define int long long



using namespace std;


typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;



const int INF = (int)2e9 + 109;



vector<vector<int> > g;
vector<int> c, l, r;


vector<int> ans;

int flag_pizda;




struct pizda {
    int x, y;
    int ind;
};

struct cmp {

    bool operator() (pizda a, pizda b) const {
        if (a.x == b.x) {
            return a.ind < b.ind;
        }
        return a.x < b.x;
    }

};



struct dot {
    int k;
    ll res;
    set<pizda, cmp> s;

};


vector<int> p;
vector<int> taken;



dot dfs(int v, int p = -1) {

    //cout << "START DFS " << v << " " << p << "\n";

    int k = 0;
    ll res = 0;
    set<pizda, cmp> s;


    vector<dot> sons;
    for (int u : g[v]) {
        if (u == p) {
            continue;
        }

        sons.pub(dfs(u, v));

        if (flag_pizda) {
            return {0, 0, {}};
        }
    }

    for (auto& it : sons) {
        k += it.k;
        res += it.res;

        /*
        if (sz(it.s) > sz(s)) {
            swap(s, it.s);
        }
        */

        for (auto jt : it.s) {
            s.insert(jt);
        }
    }
    s.insert({c[v], INF, v});

           /*
    cout << "OK " << k << " " << res << "\n";

    cout << "s = \n";
    for (auto it : s) {
        cout << it.x << " " << it.y << "\n";
    }
    cout << "\n\n";
            */



    if (k > r[v]) {
        flag_pizda = 1;
        return {0, 0, {}};
    }

    while (k < l[v] && !s.empty()) {

    /*
        cout << "AAAA s = \n";
        for (auto it : s) {
            cout << it.x << " " << it.y << "\n";

        }
        cout << "\n";
        */

        auto it = *s.begin();
        s.erase(s.begin());


        int cur = it.ind;



        //cout << "cur = " << cur << "\n";

        int ok = INF;
        while (true) {
            //cout << "CUR = " << cur << " " << ::p[cur] << "\n";

            ok = min(ok, r[cur] - taken[cur]);
            /*
            if (taken[cur] == r[cur]) {
                ok = 1;
                break;
            }
            */

            if (cur == v) {
                break;
            }

            cur = ::p[cur];
        }

        ok = min(ok, l[v] - k);
        //cout << "FINE " << v << " " << ok << "\n";

        if (!ok) {
            continue;
        }



        it.y -= ok;
        if (it.y) {
            s.insert(it);
        }

        cur = it.ind;
        int highest_dead = -1;

        while (true) {
            taken[cur] += ok;

            if (cur == v) {
                break;
            }

            cur = ::p[cur];
        }
        k += ok;
        res += it.x * ok;
        ans[it.ind] += ok;

        /*
        if (k + it.y <= l[v]) {
            res += it.x * it.y;
            k += it.y;


            ans[it.ind] += it.y;
        } else {
            int d = l[v] - k;
            res += it.x * d;
            it.y -= d;

            s.insert(it);
            k += d;

            ans[it.ind] += d;
        }
        */
    }

    //cout << "!!! " << k << " " << res << "\n";

    if (k < l[v]) {
        flag_pizda = 1;
        return {0, 0, {}};
    }

   // taken[v] = k;

    set<pizda, cmp> t;
    for (auto it : s) {
        t.insert({it.x, min(it.y, r[v] - k), it.ind});
    }
    swap(s, t);
    t.clear();


    /*
    cout << "FINAL " << k << " " << res << "\n";
    for (auto it : s) {
        cout << it.x << " " << it.y << "\n";
    }
    cout << "END\n\n";
    */



    return dot{k, res, s};


}


void solve_solve_solve() {
    int n;
    cin >> n;

    g.clear();
    g.resize(n);

    p.assign(n, -1);
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;

        g[i].pub(p[i]);
        g[p[i]].pub(i);
    }
        /*
    cout << "p = \n";
    for (auto it : p) {
        cout << it << " ";
    }
    cout << "\n\n";
    */

    c.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> c[i];
    }

    l.resize(n);
    r.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
    }

    // root = 0;

    ans.assign(n, 0);
    flag_pizda = 0;


    taken.assign(n, 0);

    auto it = dfs(0);

    if (flag_pizda) {
        cout << "-1\n";
        return;
    }


    //cout << "============================== ANS ==============================\n";

    cout << it.res << "\n";
    for (auto it : ans) {
        cout << it << " ";
    }
    cout << "\n";
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int Q = 1;
    cin >> Q;

    while (Q--) {
        solve_solve_solve();
    }

    return 0;
}
