#include<bits/stdc++.h>
#pragma GCC optimize("O3")
#pragma GCC target("avx2")
#pragma GCC optimize("unroll-loops")
using namespace std;
//#define int long long
#define f first
#define s second
vector<vector<int >> t;
const int maxn = 3e5+1;
int a[maxn];
int n;
void build(int v, int tl, int tr) {
    if (tl + 1 == tr) {
        t[v] = {a[tl]};
    } else {
        int tm = tl + (tr - tl) /2;
        build(2*v+1, tl, tm);
        build(2*v+2, tm, tr);
        merge(t[2*v+1].begin(), t[2*v+1].end(),
              t[2*v+2].begin(), t[2*v+2].end(), back_inserter(t[v]));
    }
}

int get(int v, int tl, int tr, int l, int r, int x) {
    if (tl >= r || l >= tr) {
        return 0;
    } else if (l <= tl && tr <= r) {
        return (upper_bound(t[v].begin(), t[v].end(), x) - t[v].begin());
    } else {
        int tm = tl + (tr - tl) / 2;
        return get(2*v+1, tl, tm, l, r, x)+get(2*v+2, tm, tr, l, r, x);
    }
}

int spysk(int v, int tl, int tr, int kol, int x) {
    if (!kol) {
        return tl;
    }
    if (tl + 1 == tr) {
        return tr;
    }
    int tm = tl + (tr - tl) / 2;
    int kol1 = upper_bound(t[2*v+1].begin(), t[2*v+1].end(), x) - t[2*v+1].begin();
    if (kol1 < kol) {
        return spysk(2*v+2, tm, tr, kol-kol1, x);
    } else {
        return spysk(2*v+1, tl, tm, kol, x);
    }
}

/*int find_ind(int kol, int yk) {
    int l = -1, r = n;
    if (!kol) {
        return 0;
    }
    while (r - l > 1) {
        int m = l+ (r - l) / 2;
        //cout << m << " " << yk << " " << get(0, 0, n, 0, m+1, yk) << endl;
        if (get(0, 0, n, 0, m+1, yk) < kol) {
            l = m;
        } else {
            r = m;
        }
    }
    return r+1;
}*/

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    t.resize(4*n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    build(0, 0, n);
    int q;
    cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        int l = 0, r = min(r1, r2)+1;
        int kol1 = r1-c1;
        int kol2 = r2-c2;
        int gr1 = spysk(0, 0, n, kol1, r1);
        int gr2 = spysk(0, 0, n, kol2, r2);
        //cout << gr1 << " " << gr2 << endl;
        int c_ans=0;
        while (r - l > 1) {
            int m = l + (r - l) / 2;
            int nc1 = get(0, 0, n, 0, gr1, m);
            int nc2 = get(0, 0, n, 0, gr2, m);
            nc1 = m - nc1;
            nc2 = m - nc2;
            if (nc1 == nc2) {
                l = m;
                c_ans = nc1;
            } else {
                r = m;
            }
        }
        cout << l << " " << c_ans << "\n";
    }
}

