#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
using namespace std;

struct dot {
	int r, c;
	dot() {}
	dot(int r, int c) : r(r), c(c) {}
};

int k = 1;

bool inzone(dot a) {
	return (a.c <= a.r - k);
}

int main() {
	int n;
	cin >> n;
	vector <int> a(n);
	int pi = 1;
	for (int& i : a){
		cin >> i;
		if (i == n) {
			k = pi;
		}
		pi = i;
	}

	int q;
	cin >> q;
	while (q--) {
		dot a, b;
		cin >> a.r >> a.c >> b.r >> b.c;
		dot x;
		if (!inzone(a) && !inzone(b)) {
			dot a0 = dot(a.r - a.c, 0);
			dot b0 = dot(b.r - b.c, 0);
			if (a0.r == b0.r) {
				if (a.r < b.r)
					x = a;
				else
					x = b;
			}
			else {
				if (a0.r < b0.r)
					x = a0;
				else
					x = b0;
			}
		}
		else if (inzone(a) && inzone(b)) {
			dot a0 = dot(k + a.c, a.c);
			dot b0 = dot(k + b.c, b.c);
			if (a0.r == b0.r) {
				if (a.r < b.r)
					x = a;
				else
					x = b;
			}
			else {
				if (a0.r < b0.r)
					x = a0;
				else
					x = b0;
			}
		}
		else {
			if (inzone(a))
				swap(a, b);
			x = dot(a.r - a.c, 0);
		}
		cout << x.r << " " << x.c << endl;
	}
}
