#include<bits/stdc++.h>
#define f first
#define s second
#define _ << ' ' <<
#define mp make_pair
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define Time() clock() / (ld) CLOCKS_PER_SEC
//#define int long long

//#pragma GCC optimize("O3,ofast")
//#pragma target ("sse,sse2,sse3,ssse4,avx,avx2")

#ifdef LOCAL
    #define cerr cout
#else
    #define cerr if(0) cerr
#endif // LOCAL

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<long long, long long> pll;
typedef pair<long double, long double> pld;

const int MAXN = 5e3 + 10;

int p[MAXN];

int l[MAXN], r[MAXN], cnt[MAXN], c[MAXN];

int ans[MAXN];

ll cost;

int get(int start) {
    int ans = 0;
    for (int v = start; v >= 0; v = p[v]) {
        ans = max(ans, l[v] - cnt[v]);
    }
    for (int v = start; v >= 0; v = p[v]) {
        ans = min(ans, r[v] - cnt[v]);
    }
    return ans;
}

void update (int start, int x) {
    for (int v = start; v >= 0; v = p[v]) cnt[v] += x;
    cost += 1ll * c[start] * x;
    ans[start] = x;
}

pair<int, int> a[MAXN];

void solve() {
    int n;
    cin >> n;
    p[0] = -1;
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
    }
    for (int i = 0; i < n; i++) {
        cin >> c[i];
        a[i] = {c[i], i};
    }
    for (int i = 0; i < n; i++) cin >> l[i] >> r[i];
    cost = 0;
    fill(cnt, cnt + n, 0);
    sort(a, a + n);
    for (int i = 0; i < n; i++) {
        update(a[i].s, get(a[i].s));
    }
    for (int i = 0; i < n; i++) {
        if (cnt[i] < l[i] || cnt[i] > r[i]) {
            cout << -1 << '\n';
            return;
        }
    }
    cout << cost << '\n';
    for (int i = 0; i < n; i++) cout << ans[i] << ' ';
    cout << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tests = 1;
    cin >> tests;
    while (tests--) {
        solve();
    }
    return 0;
}

