#include <bits/stdc++.h>

#define int long long

using namespace std;
typedef vector<int> vi;

const int maxn = 5001;

vi g[maxn];
int sz[maxn];
int cnt[maxn];
int l[maxn];
int r[maxn];
int c[maxn];
int sum[maxn];
int p[maxn];
int tin[maxn];
int tout[maxn];
int timer = 0;
bool ok = true;

void for_sz(int v, int pp = -1) {
    tin[v] = ++timer;
    sz[v] = 1;
    for (int i: g[v]) {
        for_sz(i, v);
        sz[v] += sz[i];
    }
    tout[v] = timer;
    p[v] = pp;
}

void add(int v, int x) {
    cnt[v] += x;
    while (v != -1) {
        sum[v] += x;
        v = p[v];
    }
}

const int inf = 1e9 + 228;

int get(int v) {
    int res = v;
    while (v != -1) {
        if (r[v] - sum[v] <= r[res] - sum[res])
            res = v;
        v = p[v];
    }
    return res;
}

set<pair<int, int>> alive;

void block(int v, multiset<pair<int, int>> &kek) {
    auto it = alive.lower_bound(make_pair(tin[v], 0));
    vector<int> to_erase;
    while (it != alive.end() && it->first <= tout[v]) {
        to_erase.push_back(it->second);
        kek.erase(make_pair(c[it->second], it->second));
        it++;
    }
    for (int i: to_erase)
        alive.erase(make_pair(tin[i], i));
}

void dfs(int v, multiset<pair<int, int>> &lol) {
    cnt[v] = 0;
    lol.insert(make_pair(c[v], v));
    if (g[v].size() == 0) {
        cnt[v] = l[v];
        sum[v] = cnt[v];
        return;
    }
    int mx = g[v][0];
    for (int i: g[v]) {
        if (sz[i] > sz[mx])
            mx = i;
    }
    for (int i: g[v]) {
        multiset<pair<int, int>> kek;
        dfs(i, kek);
        if (i != mx) {
            for (pair<int, int> j: kek)
                lol.insert(j);
        } else {
            swap(lol, kek);
            for (pair<int, int> j: kek)
                lol.insert(j);
        }
    }
    sum[v] = 0;
    for (int i: g[v]) {
        sum[v] += sum[i];
    }
    if (sum[v] > r[v]) {
        ok = false;
    }
    while (sum[v] < l[v]) {
        int mx = l[v] - sum[v];
        if(lol.empty()){
            ok = false;
            break;
        }
        pair<int, int> it = *lol.begin();
        int u = get(it.second);
        if (r[u] - sum[u] > mx) {
            add(it.second, mx);
        } else {
            add(it.second, r[u] - sum[u]);
            block(u, lol);
        }
    }
}

void solve() {
    int n;
    cin >> n;
    for(int i=0; i<n; i++)
        g[i].clear();
    for (int i = 1; i < n; i++) {
        int a;
        cin >> a;
        a--;
        g[a].push_back(i);
    }
    for (int i = 0; i < n; i++)
        cin >> c[i];
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
    }
    for_sz(0);
    alive.clear();
    for (int i = 0; i < n; i++)
        alive.insert(make_pair(tin[i], i));
    multiset<pair<int, int>> kek;
    ok = true;
    dfs(0, kek);
    int ans = 0;
    for (int i = 0; i < n; i++)
        ans += cnt[i] * c[i];
    if (ok) {
        cout << ans << endl;
        for (int i = 0; i < n; i++)
            cout << cnt[i] << " ";
        cout << endl;
    } else {
        cout << -1 << endl;
    }

}

signed main() {
    int q;
    cin >> q;
    while (q--)
        solve();
    return 0;
}

/*
1
3
1 1
3 1 2
5 7
1 2
2 4
=====
2
3
1 1
3 1 2
5 7
1 2
2 4
2
1
5 5
0 1
2 2
 */