#include <bits/stdc++.h>

using namespace std;

#define int short 

const int MAXN = 3e3 + 10;
const int LG = 13;

vector<vector<pair<int, int>>> graph[MAXN];
vector<pair<int, int>> up[LG][MAXN];
vector<int> used[MAXN];
vector<int> used2[MAXN];
vector<signed> tin[MAXN];
vector<signed> tout[MAXN];
int a[MAXN];
int dir[MAXN];

signed t = 0;

void dfs(int x, int y) {
    used[x][y] = 1;
    tin[x][y] = t++;
    for (auto [a, b] : graph[x][y]) {
        if (!used[a][b]) {
            up[0][a][b] = {x, y};
            dfs(a, b);
        }
    }
    tout[x][y] = t++;
}

inline bool is_par(int x1, int y1, int x2, int y2) {
    return tin[x1][y1] <= tin[x2][y2] && tout[x2][y2] <= tout[x1][y1];
}

pair<int, int> lca(int x1, int y1, int x2, int y2) {
    if (is_par(x1, y1, x2, y2)) return {x1, y1};
    if (is_par(x2, y2, x1, y1)) return {x2, y2};
    for (signed l = LG - 1; l >= 0; --l) {
        // cerr << x1 << ' ' << y1 << ' ' << x2 << ' ' << y2 << endl;
        // auto [a, b] = ;
        if (!is_par(up[l][x1][y1].first, up[l][x1][y1].second, x2, y2)) {
            int x3 = up[l][x1][y1].first;
            y1 = up[l][x1][y1].second;
            x1 = x3;
        }
    }
    return up[0][x1][y1];
}

signed main() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        dir[i] = 1;
    }
    for (int l = 0; l < LG; ++l) {
        for (int i = 0; i <= n; ++i) {
            up[l][i].resize(i + 1);
        }
    }
    for (int i = 0; i <= n; ++i) {
        graph[i].resize(i + 1);
        used[i].resize(i + 1);
        tin[i].resize(i + 1);
        tout[i].resize(i + 1);
        used2[i].resize(i + 1);
    }
    a[n] = n + 1;
    for (int i = 0; i <= n; ++i) {
        int y = 0;
        for (int j = 0; j < n; ++j) {
            if (!used2[j + 1][y + dir[j]]) {
                graph[j][y].push_back({j + 1, y + dir[j]});
                used2[j + 1][y + dir[j]] = 1;
            }
            y += dir[j];
            // up[0][j + 1][y + dir[j]] = {j, y};
        }
        dir[a[i] - 1]--;
    }
    dfs(0, 0);
    up[0][0][0] = {0, 0};
    for (int l = 1; l < LG; ++l) {
        for (int i = 0; i <= n; ++i) {
            for (int j = 0; j <= i; ++j) {
                auto [a, b] = up[l - 1][i][j];
                up[l][i][j] = up[l - 1][a][b];
            }
        }
    }
    // for (int i = 0; i <= n; ++i) {
    //     for (int j = 0; j <= i; ++j) {
    //         cerr << up[0][i][j].first << ' ' << up[0][i][j].second << ": ";
    //     }cerr << endl;
    // }
    // for (int i = 0; i < n; ++i) {
    //     for (int j = 0; j <= i; ++j) {
    //         cerr << tout[i][j] << ' ';
    //     }cerr << endl;
    // }
    signed q;
    cin >> q;
    while (q--) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        auto [a, b] = lca(x1, y1, x2, y2);
        cout << a << ' ' << b << '\n';
    }
    return 0;
}