#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define len(a) int((a).size())
#define all(a) begin(a), end(a)

template<typename Fun>
struct y_combinator {
	const Fun fun;

	y_combinator(const Fun&& fun) : fun(forward<const Fun>(fun)) {}

	template<typename... Args>
	decltype(auto) operator()(Args&&... args) const {
		return fun(ref(*this), forward<Args>(args)...);
	}
};

int main() {
	ios::sync_with_stdio(false), cin.tie(nullptr);

	int n;
	cin >> n;
	vector<int> a(n);
	for (auto &x : a) {
		cin >> x;
	}

	int q;
	cin >> q;
	while (q--) {
		int x1, y1, x2, y2;
		cin >> x1 >> y1 >> x2 >> y2;
		if (x1 == x2 && y1 == y2) {
			cout << x1 << ' ' << y1 << '\n';
			continue;
		}
		if (x1 - y1 > x2 - y2) {
			swap(x1, x2);
			swap(y1, y2);
		}
		if (x1 - y1 == x2 - y2) {
			if (x1 > x2) {
				swap(x1, x2);
				swap(y1, y2);
			}
			cout << x1 << ' ' << y1 << '\n';
			continue;
		}
		cout << x1 - y1 << ' ' << 0 << '\n';
	}
}
