#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

mt19937 rnd(time(0));
#define ioss ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back

template<class T>
T upmin(T &a, T b){return a > b ? a = b, 1 : 0;}
template<class T>
T upmax(T &a, T b){return a < b ? a = b, 1 : 0;}

//struct ST{
//    ST *l = nullptr, *r = nullptr;
//    int vl, vr;
//    int add = 0, sum = 0;
//
//    ST(int vl, int vr){
//        this->vl = vl;
//        this->vr = vr;
//        if(vr > vl + 1){
//            int vm = (vl + vr) / 2;
//            l = new ST(vl, vm);
//            r = new ST(vm, vr);
//        }
//    }
//    bool is_leaf(){
//        return vr == vl + 1;
//    }
//    int size(){
//        return vr - vl;
//    }
//    bool in(int lq, int rq){
//        return lq <= vl && rq >= vr;
//    }
//    bool out(int lq, int rq){
//        return max(lq, vl) >= min(rq, vr);
//    }
//    void push(){
//        if(is_leaf())return;
//        l->add += add;
//        r->add += add;
//        l->sum += add * l->size();
//        r->sum += add * r->size();
//        add = 0;
//    }
//    void insertQry(int lq, int rq,int x){
//        push();
//        if(in(lq, rq)){
//            add += x;
//            sum += x * size();
//            return;
//        }
//        if(out(lq, rq))return;
//        l->insertQry(lq, rq, x);
//        r->insertQry(lq, rq, x);
//        sum = l->sum + r->sum;
//    }
//    int sumQry(int lq, int rq){
//        if(in(lq, rq))return sum;
//        if(out(lq, rq))return 0;
//        push();
//        return l->sumQry(lq, rq) + r->sumQry(lq, rq);
//    }
//};
//
//struct DekartTree{
//
//    struct Node{
//        int x, y, sz;
//        Node *L, *R;
//        Node(int x) : x(x), y((int)rnd()), L(nullptr), R(nullptr), sz(1){}
//    }*root;
//
//    int size(Node *t){
//        return t == nullptr ? 0 : t->sz;
//    }
//
//    void update(Node *t){
//        t->sz = size(t->L) + size(t->R) + 1;
//    }
//
//    Node* merge(Node *a, Node *b){
//        if(a == nullptr || b == nullptr){
//            return b == nullptr ? a : b;
//        }
//        if(a->y > b->y) {
//            a->R = merge(a->R, b);
//            update(a);
//            return a;
//        }else{
//            b->L = merge(b->L, a);
//            update(b);
//            return b;
//        }
//    }
//    pair<Node*, Node*> split(Node *t, int x){
//        if(t == nullptr)
//            return {nullptr, nullptr};
//        if(t->x < x){
//            auto r = split(t->R, x);
//            t->R = r.first;
//            update(t);
//            return {t, r.second};
//        }else{
//            auto l = split(t->L, x);
//            t->L = l.second;
//            update(t);
//            return {l.first, t};
//        }
//    }
//    void add(int x){
//        auto t = split(root, x); // [0, X-1] [X, inf]
//        root = merge(t.first, merge(new Node(x), t.second));
//    }
//};
//
//struct sparse_min{
//    vector<int> H;
//    vector<vector<ll>> sp;
//
//    ll get(int l, int r){
//        int h = H[r - l + 1];
//        return min(sp[h][l], sp[h][r - (1 << h) + 1]);
//    }
//
//    sparse_min(vector<ll> &a){
//        int n = (int)a.size();
//        H.resize(n+1);
//        for(int i = 3; i < n + 1; i++){
//            H[i] = H[i-1] + (((i-1) & (i - 2)) == 0);
//        }
//        int s = 0;
//        while((1<<s) < n)s++;
//        sp.resize(s, vector<ll>(n));
//        for(int i = 0;i<n;i++){
//            sp[0][i] = a[i];
//        }
//        for(int j = 1; j < s; j++){
//            for(int i = 0; i + (1 << j) - 1 < n; j++){
//                sp[j][i] = get(i, i + (1 << j) + 1);
//            }
//        }
//    }
//};

const int maxN = 3001;
int graph[maxN][maxN][2];
int par[maxN][maxN][2];
int deep[maxN][maxN];

void dfs(int r, int c, int par_r, int par_c, int deep_){
    deep[r][c] = deep_;
    par[r][c][0] = par_r;
    par[r][c][1] = par_c;
    if(graph[r][c][0] == 1){
        dfs(r + 1, c, r, c, deep_ + 1);
    }
    if(graph[r][c][1] == 1){
        dfs(r + 1, c + 1, r, c, deep_ + 1);
    }
}
pair<int,int> ans(int r1, int c1, int r2, int c2){
    if(deep[r1][c1] < deep[r2][c2]){
        swap(r1, r2);
        swap(c1, c2);
    }
    while(deep[r1][c1] > deep[r2][c2]){
        int new_r1 = par[r1][c1][0];
        int new_c1 = par[r1][c1][1];
        r1 = new_r1;
        c1 = new_c1;
    }
    if(r1 == r2 && c1 == c2){
        return {r1, c1};
    }
    while(r1 != r2 || c1 != c2){
        int new_r1 = par[r1][c1][0];
        int new_c1 = par[r1][c1][1];
        r1 = new_r1;
        c1 = new_c1;
        int new_r2 = par[r2][c2][0];
        int new_c2 = par[r2][c2][1];
        r2 = new_r2;
        c2 = new_c2;
    }
    return {r1, c1};
}

void solve(){
    int n;
    cin>>n;
    vector<int> a(n);
    for(auto &i : a)cin>>i;
    memset(graph, 0, sizeof(graph));
    memset(par, 0, sizeof(par));
    memset(deep, 0, sizeof(deep));

    vector<int> way(n, 0);
    vector<pair<int,int>> pos(n+1);

    for(int i = 0;i<n;i++){
        pos[i] = {i, i};
        graph[i][i][1] = 1;
    }
    for(int i = 0;i<n;i++){
        way[a[i] - 1] = 1;
        for(int j = a[i] - 1; j < n; j++){
            if(way[j] == 1){
                pos[j+1] = {pos[j].first + 1, pos[j].second};
                graph[pos[j].first][pos[j].second][0] = 1;
            }else{
                pos[j+1] = {pos[j].first + 1, pos[j].second+1};
                graph[pos[j].first][pos[j].second][1] = 1;
            }
        }
    }

    dfs(0, 0, -1, -1, 0);


    int q;
    cin>>q;
    while(q--){
        int r1, c1, r2, c2;
        cin>>r1>>c1>>r2>>c2;
        auto t = ans(r1, c1, r2, c2);
        cout<<t.first<<' '<<t.second<<'\n';
    }

}

signed main() {
    ioss
    int t = 1;
//    cin>>t;
    while(t--){
        solve();
    }
    return 0;
}