#include <iostream>
#include <iomanip>

#include <algorithm>

#include <vector>
#include <string>
#include <set>
#include <map>

using namespace std;

#define sz(x) ((int)(x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;

const ll inf = 1e18;

int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);

	int n; cin >> n;
	vector<int> arr(n);
	for (auto& c : arr) {
		cin >> c;
	}

	ll ans = 0;
	for (int a = 1; a <= n; a++) {
		for (int b = a + 1; b <= n; b++) {
			int mx = 0;
			for (int l = 0; l < n; l++) {
				for (int r = l + 1; r < n; r++) {
					vector<int> tmp = arr;
					sort(tmp.begin() + l, tmp.begin() + r + 1);
					int pa, pb;
					for (int i = 0; i < n; i++) {
						if (tmp[i] == a)
							pa = i;
						if (tmp[i] == b)
							pb = i;
					}

					mx = max(mx, abs(pa - pb));
				}
			}
			ans += mx;
		}
	}

	cout << ans;
	return 0;
}
