#include <iostream>
#include <iomanip>

#include <algorithm>

#include <vector>
#include <string>
#include <set>
#include <map>

#include <unordered_map>

using namespace std;

#define sz(x) ((int)(x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;

const int inf = 1e9 + 1;

void solve() {
	int n, w, h; cin >> n >> w >> h;
	vector<int> xs;
	map<int, int> min_y;
	vector<pair<int, int>> a(n);
	for (auto& c : a) {
		cin >> c.first >> c.second;
		xs.push_back(c.first);
		min_y[c.first] = inf;
	}

	for (auto c : a) {
		min_y[c.first] = min(min_y[c.first], c.second);
	}
	xs.push_back(w);
	sort(all(xs));

	ll ans = 0;
	int mn = inf;
	for (int i = 0; i < sz(xs) - 1; i++) {
		mn = min(mn, min_y[xs[i]]);
		ans += 1ll * (xs[i + 1] - xs[i]) * (h - mn);
	}

	cout << ans << '\n';
}

int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);

	int k; cin >> k;
	vector<int> good(k);
	for (auto& c : good) {
		cin >> c;
	}

	int t; cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}