#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <tuple>
using namespace std;
vector<int> c;
int n;
vector<vector<int>> g;
vector<int> l;
vector<int> r;
vector<bool> vis;
auto cmp = [](tuple<int, int, int> left, tuple<int, int, int> right) { return get<1>(left) > get<1>(right) || get<1>(left) == get<1>(right) && get<0>(left) > get<1>(right) ; };
vector<int> pokupki;
bool fl;
pair<long long, priority_queue<tuple<int, int, int>, vector<tuple<int, int, int>>, decltype(cmp)>> dfs(int i) {
    vis[i] = true;
    vector<tuple<int, int, int>> a;
    long long sum = 0;
    for (auto j: g[i]) {
        if (!vis[j]) {
            auto x = dfs(j);
            sum += x.first;
            while (x.second.size() != 0) {
                a.push_back(x.second.top());
                x.second.pop();
            }
        }
    }
    priority_queue<tuple<int, int, int>, vector<tuple<int, int, int>>, decltype(cmp)> q(cmp, a);
    q.push({r[i], c[i], i});
    int ost = l[i] - sum;
    while(ost > 0 && q.size() > 0){
        tuple<int, int, int> x = q.top();
        q.pop();
        pokupki[get<2>(x)] += min(ost, get<0>(x));
        sum += min(ost, get<0>(x));
        if(get<0>(x) > ost){
            q.push({get<0>(x) - ost, get<1>(x), get<2>(x)});
        }
        ost = l[i] - sum;
    }
    int can = r[i] - sum;
    if(can < 0){
        fl = false;
    }
    vector<tuple<int, int, int>> dop;
    while(true){
        if(can == 0){
            break;
        }
        tuple<int, int, int> x = q.top();
        q.pop();
        if(get<0>(x) < can){
            dop.push_back(x);
            can -= get<0>(x);
        }
        else {
            dop.push_back({can, get<1>(x), get<2>(x)});
            break;
        }
    }
    priority_queue<tuple<int, int, int>, vector<tuple<int, int, int>>, decltype(cmp)> ans(cmp, dop);
    auto t = make_pair(sum, ans);
    return t;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;

    for (int i_ = 0; i_ < t; ++i_) {
        fl = true;
        c.clear();
        n = 0;
        g.clear();
        l.clear();
        r.clear();
        vis.clear();
        pokupki.clear();
        cin >> n;
        g.clear();
        g.resize(n);
        pokupki.clear();
        pokupki.resize(n, 0);
        for (int i = 1; i < n; ++i) {
            int x;
            cin >> x;
            x--;
            g[i].push_back(x);
            g[x].push_back(i);
        }
        c.clear();
        c.resize(n);
        for (int i = 0; i < n; ++i) {
            cin >> c[i];
        }
        l.clear();
        l.resize(n);
        r.clear();
        r.resize(n);
        for (int i = 0; i < n; ++i) {
            cin >> l[i] >> r[i];
        }
        vis.clear();
        vis.resize(n, false);
        fl = true;
        dfs(0);
        if(fl){
            long long sum_cost = 0;
            for(int i = 0; i < n; ++i) sum_cost += pokupki[i] * c[i];
            cout << sum_cost << '\n';
            for(auto i: pokupki) cout << i << ' ';
        }
        else{
            cout << -1;
        }
        cout << '\n';
    }
}