#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>

#define Point std::pair<int, int>

int k;
int direction;
int t;

bool comp(Point a, Point b)
{
	return a.first < b.first;
}

void solve()
{
	int n, w, h;
	std::cin >> n >> w >> h;
	std::vector<Point> a(n);
	
	for (int i = 0; i < n; i++)
	{
		std::cin >> a[i].first >> a[i].second;
	}
	std::sort(a.begin(), a.end(), comp);
	int height = 0;
	int x = 0;
	long long sum = 0;
	for (int i = 0; i < n; i++)
	{
		Point p = a[i];
		sum += ((long long)(p.first - x)) * height;
		height = std::max(h-p.second, height);
		x = p.first;
	}
	sum += ((long long)(w - x)) * height;
	std::cout << sum << std::endl;
	return;
}

int main()
{
	std::cin >> k;
	std::cin >> direction;
	std::cin >> t;
	for (int i = 0; i < t; i++)
	{
		solve();
	}
}