#include<bits/stdc++.h>
#define int long long
#define p pair<int, int>
#define endl '\n'
const int INF = 1000000000000000001;

using namespace std;

vector<vector<int>> d;
vector<int> a, quan;
vector<p> s;

int DFS_check(int vertex) {
    int now = quan[vertex];
    for (int q : d[vertex]) {
        int x = DFS_check(q);
        if (x == -1) {
            return -1;
        }
        now += x;
    }
    return (s[vertex].first <= now && now <= s[vertex].second ? now : -1);
}

vector<vector<int>> gen(int n, int C) {
    if (n == 0) {
        return {{}};
    }
    vector<vector<int>> was = gen(n-1, C), will;
    for (auto &q : was) {
        for (int q1 = 0; q1 <= C; q1++) {
            will.push_back(q);
            will.back().push_back(q1);
        }
    }
    return will;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t1;
    cin >> t1;
    for (int q11 = 0; q11 < t1; q11++) {
        int n;
        cin >> n;
        d.assign(n, {}), a.assign(n, -1), s.assign(n, {});
        for (int q = 1; q < n; q++) {
            int x;
            cin >> x;
            x--;
            d[x].push_back(q);
        }
        for (int q = 0; q < n; q++) {
            cin >> a[q];
        }
        int C = 0;
        for (int q = 0; q < n; q++) {
            cin >> s[q].first >> s[q].second;
            C = max(C, s[q].second);
        }
        int sum1 = INF;
        vector<int> ans;
        vector<vector<int>> all = gen(n, C);
        for (auto &q : all) {
            quan = q;
            int now = 0;
            for (int q1 = 0; q1 < n; q1++) {
                now += quan[q1]*a[q1];
            }
            if (DFS_check(0) != -1 && now < sum1) {
                sum1 = now, ans = quan;
            }
        }
        if (sum1 == INF) {
            cout << -1 << endl;
            continue;
        }
        cout << sum1 << endl;
        for (int q : ans) {
            cout << q << ' ';
        }
        cout << endl;
    }
    return 0;
}
