#include <bits/stdc++.h>

using namespace std;

#define int long long
#define double long double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const int MAXN = 1e5 + 10;
const int INF = 1e9 + 7;

vector<int> g[MAXN];
int pred[MAXN];
int c[MAXN];
pair<int, int> gr[MAXN];
pair<int, int> op[MAXN];
pair<int, int> da[MAXN];

pair<int, int> dfs_otr(int v, int p) {
    int mn = 0;
    int mx = 0;
    for (auto it: g[v]) {
        if (it != p) {
            auto o = dfs_otr(it, v);
            mn += o.first;
            mx += o.second;
        }
    }
    op[v] = {mn, mx};
    mn = max(mn, gr[v].first);
    mx = gr[v].second;
    da[v] = {mn, mx};
    return {mn, mx};
}

void solve() {
    int n; cin >> n;
    pred[0] = -1;
    for (int i = 1; i < n; ++i) {
        int p; cin >> p;
        p--;
        g[p].push_back(i);
        pred[i] = p;
    }
    vector<pair<int, int>> vec(n);
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
        vec[i] = {c[i], i};
    }
    sort(rall(vec));
    for (int i = 0; i < n; ++i) {
        int l, r; cin >> l >> r;
        gr[i] = {l, r};
    }
    dfs_otr(0, -1);
    for (int i = 0; i < n; ++i) {
        if (op[i].first > gr[i].second) {
            cout << -1 << '\n';
            return;
        }
    }
    vector<int> ttt(n, -1);
    int ans = 0;
    vector<int> vvv(n);
    for (auto it: vec) {
        int co = it.first;
        int ind = it.second;
        cout << co << " " << ind << endl;
        int l = gr[ind].first;
        int r = gr[ind].second;
        int aa = max((int)0, l - op[ind].second);
        int bb = r - op[ind].first;
        int mn = max(gr[ind].first, op[ind].first + aa);
        //cout << aa << endl;
        int v = ind;
        //cout << v << " " << pred[v] << endl;
        //cout << 254 << endl;
        while (pred[v] != -1) {
            int p = pred[v];
            if (ttt[p] == -1) break;
            int o1 = da[v].first;
            int r1 = op[p].first + mn - o1 + ttt[p];
            if (r1 > gr[p].first) {
                int k = r1 - gr[p].first;
                aa += k;
                r1 += k;
            }
            mn = r1;
            v = pred[v];
        }
        mn = da[v].first;
        int mx = r;
        da[v].first = max(op[v].first + aa, l);
        da[v].second = min(op[v].second + aa, r);
        v = ind;
        while (pred[v] != -1) {
            int p = pred[v];
            op[p].first += da[v].first - mn;
            op[p].second += da[v].second - mx;
            mn = da[p].first;
            mx = da[p].second;
            if (ttt[p] == -1) {
                da[p].first = max(op[p].first, gr[p].first);
                continue;
            }
            da[p].first = max(op[p].first + ttt[p], gr[p].first);
            da[p].second = min(op[p].second + ttt[p], gr[p].second);
            v = pred[v];
        }
        ttt[ind] = aa;
        ans += aa * co;
    }
    cout << ans << '\n';
    for (auto it: ttt) cout << it << " ";
    cout << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t; cin >> t;
    while (t--) {
        solve();
    }
}
