#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define pb emplace_back
#define ld long double
#define ll long long
#define mp make_pair
#define pii pair<int, int>

const int INF = 1e9 + 1;

vector<int> t, tadd;

void build(int v, int vl, int vr, vector<int> &a) {
    if (vr - vl == 1) {
        t[v] = a[vl];
        return;
    }
    int vm = (vl + vr) / 2;
    build(2 * v + 1, vl, vm, a);
    build(2 * v + 2, vm, vr, a);
    t[v] = min(t[2 * v + 1], t[2 * v + 2]);
}

void push(int v) {
    tadd[2 * v + 1] += tadd[v];
    tadd[2 * v + 2] += tadd[v];
    t[2 * v + 1] += tadd[v];
    t[2 * v + 2] += tadd[v];
    tadd[v] = 0;
}

int get(int v, int vl, int vr, int l, int r) {
    if (vl >= l && vr <= r) return t[v];
    if (r <= vl || l >= vr) return INF;
    int vm = (vl + vr) / 2;
    push(v);
    return min(get(2 * v + 1, vl, vm, l, r), get(2 * v + 2, vm, vr, l, r));
}

void mod(int v, int vl, int vr, int l, int r, int d) {
    if (vl >= l && vr <= r) {
        tadd[v] += d;
        t[v] += d;
        return;
    }
    if (r <= vl || l >= vr) return;
    push(v);
    int vm = (vl + vr) / 2;
    mod(2 * v + 1, vl, vm, l, r, d);
    mod(2 * v + 2, vm, vr, l, r, d);
    t[v] = min(t[2 * v + 1], t[2 * v + 2]);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto &c : a) {
        cin >> c; c--;
    }
    int q;
    cin >> q;
    vector<pii> l(2 * q);
    for (auto &c : l) cin >> c.fi >> c.se;
    vector<pii> border(2 * q, mp(-1, n));
    for (int it = 0; it < 20; it++) {
        vector<pii> kek;
        for (int i = 0; i < 2 * q; i++) {
            if (border[i].fi + 1 < border[i].se) kek.pb((border[i].fi + border[i].se) / 2, i);
        }
        sort(all(kek));
        vector<int> b(n + 1);
        for (int i = 0; i <= n; i++) b[i] = i;
        t.assign(4 * (n + 1), 0);
        tadd.assign(4 * (n + 1), 0);
        build(0, 0, n + 1, b);
        vector<int> ok(2 * q);
        int cur = 0;
        for (auto &c : kek) {
            while (cur < c.fi) {
                mod(0, 0, n + 1, a[cur - 1] + 1, n + 1, -1);
                cur++;
            }
            //if (c.se == 1 && c.fi == 2) cout << get(0, 0, n + 1, l[c.se].fi, l[c.se].fi + 1) << endl;
            if (get(0, 0, n + 1, l[c.se].fi, l[c.se].fi + 1) <= l[c.se].se) ok[c.se] = 1;
        }
        for (int i = 0; i < 2 * q; i++) {
            if (border[i].fi + 1 < border[i].se) {
                int mid = (border[i].fi + border[i].se) / 2;
                if (ok[i]) border[i].se = mid;
                else border[i].fi = mid;
            }
        }
    }
    t.assign(4 * (n + 1), 0);
    tadd.assign(4 * (n + 1), 0);
    build(0, 0, n, a);
    vector<pii> lol;
    for (int i = 0; i < q; i++) {
        int r1 = l[2 * i].fi, c1 = l[2 * i].se;
        int r2 = l[2 * i + 1].fi, c2 = l[2 * i + 1].se;
        int id1 = border[2 * i].se, id2 = border[2 * i + 1].se;
        if (id1 == id2) {

        } else {
            int res = get(0, 0, n, min(id1, id2), max(id1, id2));
            lol.pb(id1, res);
        }
    }
    sort(all(lol));
    t.assign(4 * (n + 1), 0);
    tadd.assign(4 * (n + 1), 0);
    vector<int> b(n + 1);
    for (int i = 0; i <= n; i++) b[i] = i;
    build(0, 0, n + 1, b);
    int cur = 0;
    map<pii, int> ma;
    for (auto &c : lol) {
        while (cur < c.fi) {
            mod(0, 0, n + 1, a[cur - 1] + 1, n + 1, -1);
            cur++;
        }
        ma[c] = get(0, 0, n + 1, c.se, c.se + 1);
    }
    t.assign(4 * (n + 1), 0);
    tadd.assign(4 * (n + 1), 0);
    build(0, 0, n, a);
    for (int i = 0; i < q; i++) {
        int r1 = l[2 * i].fi, c1 = l[2 * i].se;
        int r2 = l[2 * i + 1].fi, c2 = l[2 * i + 1].se;
        int id1 = border[2 * i].se, id2 = border[2 * i + 1].se;
        if (id1 == id2) {
            if (c1 < c2) cout << c1 << " " << r1 << "\n";
            else cout << c2 << " " << r2 << "\n";
        } else {
            int res = get(0, 0, n, min(id1, id2), max(id1, id2));
            cout << res << " " << ma[mp(id1, res)] << "\n";
        }
    }
    return 0;
}
