#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <sstream>
#include <assert.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define input(a) do { for (auto& e : a) cin >> e; } while(0);
#define print(a) do {cerr << #a << ": "; for (auto& e : a) cerr << e << " "; cerr << "\n";} while(0);

mt19937_64 rnd(1231);



int main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	int n;
	cin >> n;
	vector<int> arr(n);
	input(arr);

	vector<int> cntless(n);
	vector<int> cntmore(n);

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < i; j++) {
			if (arr[i] > arr[j]) {
				cntless[i]++;
			}
		}
	}
	for (int i = n - 1; i >= 0; i--) {
		for (int j = i + 1; j < n; j++) {
			if (arr[i] < arr[j])
				cntmore[i]++;
		}
	}

	ll ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			int reali = cntless[i];
			int realj = n - 1 - cntmore[j];
			int d = max(realj - i, j - reali);
			// sort all
			int d2 = abs(arr[i] - arr[j]);
			ans += max(d, d2);
		}
	}
	cout << ans << "\n";
}