#include <bits/stdc++.h>

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

bool per(pair<int, int> a, pair<int, int> b) {
	if (max(a.first, b.first) > min(a.second, b.second))
		return false;
	return true;
}

int main() {
	#ifndef LOCAL
		ios_base::sync_with_stdio(0);
		cin.tie(0);
	#endif

	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	vector<int> it(n + 1);
	iota(all(it), 0);
	vector<vector<pair<int, int>>> seg(n + 1);
	vector<vector<int>> par(n + 1);
	for (int i = 0; i <= n; ++i) {
		seg[i].resize(i + 1, {0, n});
		par[i].resize(i + 1, i - 1);
	}
	for (int i = 0; i < n; ++i) {
		for (int j = a[i]; j <= n; ++j) {
			seg[j][it[j]].second = i;
			seg[j][--it[j]].first = i + 1;
			par[j][it[j]] = it[j - 1]; // opt
		}
	}
	int q;
	cin >> q;
	while (q--) {
		int x1, y1, x2, y2;
		cin >> x1 >> y1 >> x2 >> y2;
		while (true) { // opt
			if (per(seg[x1][y1], seg[x2][y2]) && x1 <= x2)
				break;
			y1 = par[x1][y1];
			--x1;
		}
		cout << x1 << ' ' << y1 << '\n';
	}
}