#include <bits/stdc++.h>

#define mp std::make_pair
using ll = long long;
using pii = std::pair<int, int>;

template<class T, class T1>
bool mx(T &a, const T1 &b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

template<class T, class T1>
bool mn(T &a, const T1 &b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

const int MAXN = 1e5 + 228;
std::vector<int> g[MAXN];
int p[MAXN];
int c[MAXN];
int l[MAXN], r[MAXN];
int take[MAXN], actual[MAXN];
bool del[MAXN];
int h[MAXN];

void deleteVertex(int v, std::multiset<pii> &vals) {
    if (del[v]) return;
    del[v] = true;
    vals.erase(mp(c[v], v));
    for (auto &to: g[v]) {
        if (h[to] > h[v]) {
            deleteVertex(to, vals);
        }
    }
}

ll ans = 0;

std::multiset<pii> dfs(int v, int pred) { // (cost, v)
    std::multiset<pii> now;
    now.emplace(c[v], v);
    for (auto &to: g[v]) {
        if (to == pred) continue;
        h[to] = h[v] + 1;
        auto res = dfs(to, v);
        if (res.size() > now.size()) std::swap(res, now);
        now.merge(res);
        take[v] += take[to];
    }
    if (take[v] >= r[v]) {
        deleteVertex(v, now);
    }
    while (!now.empty() && take[v] < l[v]) {
        int u = now.begin()->second;

        int need = l[v] - take[v];
        while (u != -1 && h[u] >= h[v]) {
            mn(need, r[u] - take[u]);
            u = p[u];
        }

        if (need == 0) {
            assert(0);
        }

        u = now.begin()->second;
        actual[u] += need;
        ans += 1ll * c[u] * need;
        do {
            take[u] += need;
            if (take[u] >= r[u]) deleteVertex(u, now);
            u = p[u];
        } while (u != -1 && h[u] >= h[v]);
    }
    return now;
}

void solve() {
    int n;
    std::cin >> n;
    for (int i = 0; i < n; i++) {
        g[i].clear();
        c[i] = l[i] = r[i] = take[i] = del[i] = p[i] = h[i] = actual[i] = 0;
    }
    p[0] = -1;
    ans = 0;
    for (int i = 1; i < n; i++) {
        std::cin >> p[i];
        p[i]--;
        g[i].push_back(p[i]);
        g[p[i]].push_back(i);
    }
    for (int i = 0; i < n; i++) {
        std::cin >> c[i];
    }
    for (int i = 0; i < n; i++) {
        std::cin >> l[i] >> r[i];
    }
    dfs(0, -1);
    for (int i = 0; i < n; i++) {
        if (take[i] < l[i] || take[i] > r[i]) {
            std::cout << -1 << '\n';
            return;
        }
    }
    std::cout << ans << '\n';
    for (int i = 0; i < n; i++) {
        std::cout << actual[i] << ' ';
    }
    std::cout << '\n';
}

signed main() {
    int TESTS = 1;
    std::cin >> TESTS;
    while (TESTS--) {
        solve();
    }
}
