#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

int get_area(pair<pair<int, int>, pair<int, int>> a) {
    return max(0LL, a.second.first - a.first.first + 1) * max(0LL, a.second.second - a.first.second + 1);
}

pair<pair<int, int>, pair<int, int>>
inter(pair<pair<int, int>, pair<int, int>> a, pair<pair<int, int>, pair<int, int>> b) {
    return {{max(a.first.first, b.first.first),   max(a.first.second, b.first.second)},
            {min(a.second.first, b.second.first), min(a.second.second, b.second.second)}};
}

bool comp(pair<int, int> a, pair<int, int> b) {
    return a.second < b.second;
}

int f(vector<pair<int, int>> a, int w, int h) {
    int n = a.size();
    int ans = 0;
    for (int mask = 0; mask < (1 << (n)); mask++) {
        int mask2 = mask;
        vector<int> dr;
        for (int i = 0; i < n; i++) {
            dr.push_back((mask2 % 2) + 1);
            mask2 /= 2;
        }
        vector<pair<pair<int, int>, pair<int, int>>> ok;
        for (int i = 0; i < n; i++) {
            if (dr[i] == 1) {
                ok.push_back({a[i], {w - 1, h - 1}});
            } else if (dr[i] == 2) {
                ok.push_back({{0,              a[i].second},
                              {a[i].first - 1, h - 1}});
            }
        }
        __int128 area = 0;
        for (int mask3 = 1; mask3 < (1 << n); mask3++) {
            int cnt = 0;
            pair<pair<int, int>, pair<int, int>> now = {{0,     0},
                                                        {w - 1, h - 1}};
            for (int b = 0; b < n; b++) {
                if (mask3 & (1 << b)) {
                    cnt++;
                    now = inter(now, ok[b]);
                }
            }
            if (cnt % 2) {
                area += get_area(now);
            } else {
                area -= get_area(now);
            }
        }
        assert(area >= 0);
        ans = max(ans, (int) area);
    }
    return ans;
}

int f2(vector<pair<int, int>> a, vector<int> dr, int w, int h) {
    int n = a.size();
    int ans = 0;
    vector<pair<pair<int, int>, pair<int, int>>> ok;
    for (int i = 0; i < n; i++) {
        if (dr[i] == 1) {
            ok.push_back({a[i], {w - 1, h - 1}});
        } else if (dr[i] == 2) {
            ok.push_back({{0,              a[i].second},
                          {a[i].first - 1, h - 1}});
        }
    }
    __int128 area = 0;
    for (int mask3 = 1; mask3 < (1 << n); mask3++) {
        int cnt = 0;
        pair<pair<int, int>, pair<int, int>> now = {{0,     0},
                                                    {w - 1, h - 1}};
        for (int b = 0; b < n; b++) {
            if (mask3 & (1 << b)) {
                cnt++;
                now = inter(now, ok[b]);
            }
        }
        if (cnt % 2) {
            area += get_area(now);
        } else {
            area -= get_area(now);
        }
    }
    assert(area >= 0);
    ans = max(ans, (int) area);
    return ans;
}

void sol() {
    int n, w, h;
    cin >> n >> w >> h;
    vector<pair<int, int>> a(n);
    for (auto &el: a) {
        cin >> el.first >> el.second;
    }
    sort(all(a), comp);
    reverse(all(a));
    int ans = 0;
    int val = 0;
    while (!a.empty()) {
        n = a.size();
        if (n == 1) {
            ans = max(ans, val + f(a, w, h));
            break;
        }
        pair<int, int> a1 = a.back();
        a.pop_back();
        pair<int, int> a2 = a.back();
        a.pop_back();
        if (a1.first > a2.first) {
            swap(a1, a2);
        }
        {
            ans = max(ans, val + f2({a1, a2}, {1, 2}, w, h));
            val += f2({a1, a2}, {2, 1}, w, h);
            w = a2.first - a1.first;
            for (auto &el: a) {
                el.second -= max(a1.second, a2.second);
                el.first -= a1.first;
                el.first = max(0LL, min(el.first, w));
            }
            h -= max(a1.second, a2.second) - 1;
        }
    }
    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    {
        int musor;
        cin >> musor;
        vector<int> musor2(musor);
        for (int el: musor2) {
            cin >> el;
        }
    }
    int t;
    cin >> t;
    while (t--) {
        sol();
    }
}

/*
2
1 2
1
4 9 7
3 0
0 5
4 4
1 2
 */