#include <bits/stdc++.h>

using namespace std;

typedef int ll;
typedef long double ld;
typedef vector<ll> v64;
typedef vector<v64> vv64;
typedef pair<ll,ll> p64;
typedef vector<p64> vp64;
typedef vector<vp64> vvp64;

#define forn(i,n) for(ll i = 0;i < n;i++)
#define forsn(i,a,n) for(ll i = a;i < n;i++)
#define rforn(i,n) for(ll i = n;i >= 0;i--)
#define all(v) v.begin(),v.end()
#define fast_cin() ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL)
#define ln '\n'

vv64 gr;
v64 cost;
vp64 def;
vp64 mn;
v64 cnt;
v64 bought;
ll ans;

void dfs(ll v,ll p = -1){
    cnt[v] = 0;
    mn[v] = {cost[v],v};
    for(auto u : gr[v]){
        if(u != p){
            dfs(u,v);
            mn[v] = min(mn[v],mn[u]);
            cnt[v] += cnt[u];
        }
    }

    if(cnt[v] < def[v].first){
        bought[mn[v].second] += (def[v].first - cnt[v]);
        ans += (def[v].first - cnt[v])*mn[v].first;
        cnt[v] = def[v].first;
    }

}

int main() {
    fast_cin();

    ll t;
    cin >> t;
    while (t--){
        ll n;
        cin >> n;
        gr.assign(n,{});
        cost.assign(n,0);
        def.assign(n,{0,0});
        cnt.assign(n,0);
        mn.assign(n,{});
        bought.assign(n,0);
        ans = 0;
        forsn(i,1,n){
            ll a;
            cin >> a;
            --a;
            gr[a].push_back(i);
            gr[i].push_back(a);
        }
        forn(i,n){
            cin >> cost[i];
        }
        forn(i,n){
            cin >> def[i].first >> def[i].second;
        }

        dfs(0);
        cout << ans << ln;
        for(auto x : bought){
            cout << x << " ";
        }
        cout << ln;
    }

    return 0;
}
