#include<bits/stdc++.h>

#pragma GCC optimize("O3")

#define ff first
#define ss second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define _ << " " <<

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int MXN = 500111;
const int MXT = 2e7;

int n;
int a[MXN];
int version[MXN];

int tt = 2;

int t[MXT];
int lt[MXT];
int rt[MXT];

int upd(int i, int l, int r, int x) {
    if (x < l || r <= x) return i;
    if (l + 1 == r) {
        int new_i = tt++;
        t[new_i] = 1;
        return new_i;
    }
    int m = (l + r) / 2;
    int new_i = tt++;
    if (lt[i] == 0) lt[i] = tt++;
    if (rt[i] == 0) rt[i] = tt++;
    lt[new_i] = upd(lt[i], l, m, x);
    rt[new_i] = upd(rt[i], m, r, x);
    t[new_i] = t[lt[new_i]] + t[rt[new_i]];
    return new_i;
}

int get(int i, int l, int r, int q_l, int q_r) {
    if (r <= q_l || q_r <= l || i == 0) return 0;
    if (q_l <= l && r <= q_r) return t[i];
    int m = (l + r) / 2;
    return get(lt[i], l, m, q_l, q_r) + get(rt[i], m, r, q_l, q_r);
}

pii get_lr(int x, int y) {
    int l, r, m;
    int ans_l, ans_r;
    l = -1;
    r = n + 1;
    while (r - l > 1) {
        m = (l + r) / 2;
        int tmp = (x - get(version[m], 0, n + 1, 0, x + 1));
        if (tmp >= y) {
            l = m;
        } else {
            r = m;
        }
    }
    ans_r = l;
    l = -1;
    r = ans_r + 1;
    while (r - l > 1) {
        m = (l + r) / 2;
        int tmp = (x - get(version[m], 0, n + 1, 0, x + 1));
        if (tmp > y) {
            l = m;
        } else {
            r = m;
        }
    }
    ans_l = r;
    return make_pair(ans_l, ans_r);
}

int tree_min[4*MXN];

void build(int i, int l, int r) {
    if (l + 1 == r) {
        tree_min[i] = a[l];
        return;
    }
    int m = (l + r) / 2;
    build(2*i+1, l, m);
    build(2*i+2, m, r);
    tree_min[i] = min(tree_min[2*i+1], tree_min[2*i+2]);
}

int get_min(int i, int l, int r, int q_l, int q_r) {
    if (r <= q_l || q_r <= l) return MXN;
    if (q_l <= l && r <= q_r) return tree_min[i];
    int m = (l + r) / 2;
    return min(get_min(2*i+1, l, m, q_l, q_r), get_min(2*i+2, m, r, q_l, q_r));
}

void solve() {
    cin >> n;
    for (int i = 0; i < n; ++i) cin >> a[i];
    build(0, 0, n);
    int tree = 1;
    version[0] = tree;
    for (int i = 0; i < n; ++i) {
        tree = upd(tree, 0, n + 1, a[i]);
        version[i + 1] = tree;
    }
    int q;
    cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        pii p1 = get_lr(r1, c1);
        pii p2 = get_lr(r2, c2);
        if ((p1.ff <= p2.ff && p2.ff <= p1.ss) || (p1.ff <= p2.ss && p2.ss <= p1.ss)) {
            if (r1 <= r2) {
                cout << r1 _ c1 << endl;
                continue;
            } else {
                cout << r2 _ c2 << endl;
                continue;
            }
        }
        if ((p2.ff <= p1.ff && p1.ff <= p2.ss) || (p2.ff <= p1.ss && p1.ss <= p2.ss)) {
            if (r1 <= r2) {
                cout << r1 _ c1 << endl;
                continue;
            } else {
                cout << r2 _ c2 << endl;
                continue;
            }
        }
        int lft = min(p1.ss, p2.ss);
        int rgt = max(p1.ff, p2.ff);
        int mn = get_min(0, 0, n, lft, rgt);
        cout << mn - 1 _ ((mn - 1) - get(version[lft], 0, n + 1, 0, (mn - 1) + 1)) << "\n";
    }
}

int32_t main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int tests = 1;
    ///cin >> tests;
    while (tests--) {
        solve();
    }
}

