#include <vector>
#include <cassert>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int k;
  cin >> k;
  vector<int> dir(k);
  for (int i = 0; i < k; ++i)
    cin >> dir[i];
  int t;
  cin >> t;
  while (t--) {
    int n, w, h;
    cin >> n >> w >> h;
    vector<pair<int, int>> P(n);
    for (int i = 0; i < n; ++i)
      cin >> P[i].first >> P[i].second;
    if (k == 1) {
      sort(P.begin(), P.end());
      vector<pair<int, int>> stack;
      for (auto t : P) {
        if (!stack.empty() && stack.back().second <= t.second)
          continue;
        stack.emplace_back(t);
      }
      long long ans = 0;
      long long pr = h;
      for (auto t : stack) {
        ans += (w - t.first) * 1ll * (pr - t.second);
        pr = t.second;
      }
      cout << ans << '\n';
    }
  }
  return 0;
}
