#include<algorithm>
#include<iostream>
#include<vector>
#include<cassert>

using namespace std;

int c[100005];
int tin[100005];
int tout[100005];
pair<int, int> b[100005];
int p[100005];
vector<pair<int, int>> vert[100005];
vector<int> gr[100005];
int rem[100005];
long long cnt[100005];

//pair<int, pair<int, int>> dfs(int curr, const vector<vector<int>>& gr, long long& res, vector<int>& ans) {
//	pair<int, int> mmin = { c[curr], curr };
//	int cnt = 0;
//	for (int nxt : gr[curr]) {
//		auto buff = dfs(nxt, gr, res, ans);
//		cnt += buff.first;
//		mmin = min(mmin, buff.second);
//	}
//	if (b[curr].first > cnt) {
//		res += 1LL * (1LL * b[curr].first - cnt) * mmin.first;
//		ans[mmin.second] += b[curr].first - cnt;
//		cnt = b[curr].first;
//	}
//	return { cnt, mmin };
//}

void pre(int curr, int& time) {
	tin[curr] = time++;
	for (int nxt : gr[curr]) {
		pre(nxt, time);
	}
	tout[curr] = time;
}

void decrease(int st, int delt, int fin) {
	while (st != fin) {
		rem[st] -= delt;
		for (int j = tin[st]; j < tout[st]; ++j) {
			rem[j] = min(rem[j], rem[st]);
		}
		st = p[st];
	}
	rem[fin] -= delt;
	for (int j = tin[fin]; j < tout[fin]; ++j) {
		rem[j] = min(rem[j], rem[fin]);
	}
}

bool dfs(int curr, long long& res, vector<int>& ans) {

	vert[curr].push_back({ c[curr], curr });

	for (int nxt : gr[curr]) {
		if (!dfs(nxt, res, ans)) { return false; }
		cnt[curr] += cnt[nxt];
		for (auto k : vert[nxt]) { vert[curr].push_back(k); }

	}
	sort(vert[curr].begin(), vert[curr].end());

	rem[curr] = b[curr].second - cnt[curr];

	if (b[curr].second < cnt[curr]) {
		return false;
	}
	else if (b[curr].first > cnt[curr]) {
		int left = b[curr].first - cnt[curr];

		for (auto cur : vert[curr]) {
			if (rem[cur.second] >= left) {
				res += 1LL * left * cur.first;
				ans[cur.second] += left;
				decrease(cur.second, left, curr);
				left = 0; break;
			}
			else {
				res += 1LL * rem[cur.second] * cur.first;
				ans[cur.second] += rem[cur.second];
				left -= rem[cur.second];
				decrease(cur.second, rem[cur.second], curr);
			}
		}
		assert(left == 0);
		cnt[curr] = b[curr].first;
	}

	return true;
}

void solve() {
	int n; cin >> n;
	for (int i = 0; i < n; ++i) { vert[i].clear(); gr[i].clear(); }
	p[0] = 0;
	for (int i = 1; i < n; ++i) {
		cin >> p[i]; --p[i];
		gr[p[i]].push_back(i);
	}
	for (int i = 0; i < n; ++i) { cin >> c[i]; }
	for (int i = 0; i < n; ++i) { cin >> b[i].first >> b[i].second; }
	fill(tin, tin + n, -1);
	fill(tout, tout + n, -1);
	fill(rem, rem + n, 0);
	fill(cnt, cnt + n, 0);
	int time = 0;
	pre(0, time);

	long long res = 0;
	vector<int> ans(n, 0);

	bool flag = dfs(0, res, ans);

	
	if (flag) {
		cout << res << "\n";
		for (int i = 0; i < n; ++i) {
			cout << ans[i] << " ";
		}
		cout << "\n";
	}
	else {
		cout << "-1\n";
	}
	/*long long res = 0;
	vector<int> ans(n, 0);
	dfs(0, gr, res, ans);
	cout << res << "\n";
	for (int i = 0; i < n; ++i) {
		cout << ans[i] << " ";
	}
	cout << "\n";*/
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int ttt; cin >> ttt;
	for (int _ = 0; _ < ttt; ++_) {
		solve();
	}
}
