#include<algorithm>
#include<iostream>
#include<vector>

using namespace std;

int a[3002];
vector<int> gr[3002 * 3002+2];
int tin[3002 * 3002+2];
int tout[3002 * 3002+2];

void dfs(int curr, int& timer) {
	tin[curr] = timer++;
	for (int nxt : gr[curr]) {
		dfs(nxt, timer);
	}
	tout[curr] = timer;
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n; cin >> n;
	for (int i = 0; i < n; ++i) { cin >> a[i]; }

	vector<int> add(n, 1);
	vector<pair<int, int>> last(1 + n);
	for (int i = 0; i <= n; ++i) {
		last[i] = { i, i };
		if (i < n) {
			gr[i * (n + 1) + i].push_back((i + 1) * (n + 1) + i + 1);
		}
	}

	vector<pair<int, int>> pos;
	for (int i = 0; i < n; ++i) {
		auto curr = last[a[i] - 1];
		add[a[i] - 1] = 0;
		pos.push_back(curr);
		gr[curr.first * (n + 1) + curr.second].push_back((curr.first + 1)*(n + 1)+curr.second);
		curr.first += 1;
		for (int j = a[i]; j < n; ++j) {
			last[j] = curr;
			gr[curr.first * (n + 1) + curr.second].push_back((curr.first + 1) * (n + 1) + curr.second + add[j]);
			curr.first += 1;
			curr.second += add[j];
		}
		last[n] = curr;
	}

	int timer = 0;
	dfs(0, timer);

	int q; cin >> q;
	int r1, c1, r2, c2;
	for (int i = 0; i < q; ++i) {
		cin >> r1 >> c1 >> r2 >> c2;

		int v1 = r1 * (n + 1) + c1;
		int v2 = r2 * (n + 1) + c2;

		if (tin[v1] <= tin[v2] && tout[v2] <= tout[v1]) {
			cout << r1 << " " << c1 << "\n";
		}
		else if (tin[v2] <= tin[v1] && tout[v1] <= tout[v2]) {
			cout << r2 << " " << c2 << "\n";
		}
		else {
			pair<int, int> res = { -1, -1 };
			for (auto cc : pos) {
				int v = cc.first * (n + 1) + cc.second;
				if (tin[v] <= tin[v1] && tout[v1] <= tout[v] && tin[v] <= tin[v2] && tout[v2] <= tout[v]) {
					res = max(res, cc);
				}
			}
			cout << res.first << " " << res.second << "\n";
		}
	}
}
