#include<algorithm>
#include<iostream>
#include<vector>

using namespace std;

void solve() {
	int n, w, h; cin >> n >> w >> h;
	vector<pair<int, int>> p(n);
	for (int i = 0; i < n; ++i) {
		cin >> p[i].first >> p[i].second;
	}
	sort(p.rbegin(), p.rend());

	vector<pair<int, int>> st;
	for (int i = 0; i < n; ++i) {
		while (!st.empty() && st.back().second >= p[i].second) {
			st.pop_back();
		}
		st.push_back(p[i]);
	}
	n = (int)st.size();
	
	long long res = 1LL * (1LL * w - st[0].first) * (1LL * h - st[0].second);
	for (int i = 1; i < n; ++i) {
		res += 1LL * (1LL * h - st[i].second) * (1LL * st[i - 1].first - st[i].first);
	}
	cout << res << "\n";
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int k; cin >> k;
	cin >> k;

	int ttt; cin >> ttt;
	for (int _ = 0; _ < ttt; ++_) {
		solve();
	}
}
