#pragma GCC target("sse,sse2,sse3,sse4,fma,avx,avx2,popcnt")
#pragma GCC optimize("-Ofast,unroll-loops,fast-math")
#include <iostream>
#include <algorithm>
#include <vector>
#include <bitset>
#include <array>
#include <string>
#include <cstring>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <chrono>
#include <random>
#include <list>
#include <cassert>
#define ar array
std::mt19937 rnd(503);
using namespace std;
typedef long long ll;
const int N1 = 305, N = 5e5 + 5;

int n, q, a[N], b[N];
ar<ar<int, 2>, 2> qs[N];

void solve12();

void solve() {
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		--a[i];
	}
	cin >> q;
	for (int i = 0; i < q; ++i) {
		cin >> qs[i][0][0] >> qs[i][0][1];
		cin >> qs[i][1][0] >> qs[i][1][1];
	}
	if (n <= 3000 && q <= 3000) return solve12();
}

vector<int> g12[N1][N1];
int tin12[N1][N1], tout12[N1][N1], timer12 = 0, par12[N1][N1];

void dfs12(int x, int y) {
	tin12[x][y] = timer12++;
	for (auto& z : g12[x][y]) {
		par12[x + 1][z] = y;
		dfs12(x + 1, z);
	}
	tout12[x][y] = timer12++;
}

ar<int, 2> lca12(ar<int, 2> x, ar<int, 2> y) {
	while (tin12[x[0]][x[1]] > tin12[y[0]][y[1]] || tout12[x[0]][x[1]] < tout12[y[0]][y[1]]) {
		x[1] = par12[x[0]][x[1]];
		--x[0];
		assert(x[0] >= 0);
	}
	return x;
}

void solve12() {
	fill(b, b + n, 1);
	for (int i = 0; i < n; ++i) {
		g12[i][i].push_back({ i + 1 });
	}
	for (int i = 0; i < n; ++i) {
		b[a[i]] = 0;
		int x = 0;
		for (int i = 0; i < n; ++i) {
			if (b[i] == 1) {
				g12[i][x].push_back(x + 1);
				++x;
			}
			else {
				g12[i][x].push_back(x);
			}
		}
	}
	dfs12(0, 0);
	for (int i = 0; i < q; ++i) {
		ar<int, 2> x = lca12(qs[i][0], qs[i][1]);
		cout << x[0] << " " << x[1] << "\n";
	}
}

void clear() {
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1;
	while (t--) {
		solve();
		clear();
		cout << "\n";
	}
}