#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//using namespace __gnu_pbds;
using namespace std;
#define int long long
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()

//typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
const int maxn = 1e5;
const int inf = 1e9;
vector<int> g[maxn];
int l[maxn];
int r[maxn];
int c[maxn];
int pr[maxn];
int now[maxn];
pair<int, pair<int, int>> best;
bool bad = false;
int ans = 0;
int up[maxn];

void clear(int n) {
    bad = false;
    ans = 0;
    for (int i = 0; i < n; ++i) {
        g[i].clear();
        now[i] = 0;
        pr[i] = 0;
        c[i] = 0;
        l[i] = 0;
        up[i] = 0;
        r[i] = 0;
    }
}


void calc(int v, int mn) {
    if (now[v] < r[v]) {
        best = min(best, {c[v], {min(mn, r[v] - now[v]), v}});
    } else {
        return;
    }
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i];
        calc(to, min(mn, r[v] - now[v]));
    }
}


pair<int, int> dfs(int v) {
    pair<int, int> mn_c = {c[v], v};
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i];
        auto tmp = dfs(to);
        now[v] += now[to];
        mn_c = min(mn_c, tmp);
    }
    if (now[v] > r[v]) {
        bad = true;
        return mn_c;
    }
    if (now[v] < l[v]) {
        int need = l[v] - now[v];
        now[v] += need;
        ans += mn_c.first * need;
        up[mn_c.second] += need;
        up[v] -= need;
    }
    return mn_c;
}

void calc_up(int v) {
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i];
        calc_up(to);
        up[v] += up[to];
    }
    now[v] += up[v];
}

signed main() {
    cin.tie();
    cout.tie();
    ios_base::sync_with_stdio(false);
#ifdef foo
    freopen("input.txt", "r", stdin);
#endif
    int Z;
    cin >> Z;
    while (Z--) {
        int n;
        cin >> n;
        clear(n);
        pr[0] = -1;
        for (int i = 0; i < n - 1; ++i) {
            cin >> pr[i + 1];
            pr[i + 1]--;
            g[pr[i + 1]].push_back(i + 1);
        }
        for (int i = 0; i < n; ++i) {
            cin >> c[i];
        }
        for (int i = 0; i < n; ++i) {
            cin >> l[i] >> r[i];
        }
        dfs(0);
        calc_up(0);
        if (bad) {
            cout << -1 << '\n';
            continue;
        }
        cout << ans << "\n";
        for (int i = 0; i < n; ++i) {
            int sum = 0;
            for (int j = 0; j < g[i].size(); ++j) {
                sum += now[g[i][j]];
            }
            cout << now[i] - sum << " ";
        }
        cout << '\n';
    }
}
