#include <bits/stdc++.h>

using namespace std;

#define all(x) (x).begin(), (x).end()
#define allr(x) (x).rbegin(), (x).rend()
#define gsize(x) (int)((x).size())
const char nl = '\n';

typedef long long ll;
typedef long double ld;


const int maxn = 500000, logn = 20;
map<pair<int, int>, int> mp;
int dir[maxn];
set<int> g[maxn];
int up[maxn][logn];
int tin[maxn], tout[maxn];
pair<int, int> rmp[5000000];

int timer = 0;

int n;
void f() {
    int r = 0, c = 0;
    int ind;
    if (!mp.count({r, c})) {
        mp[{r, c}] = timer;
        rmp[timer] = {r, c};
        timer++;
    }
    ind = mp[{r, c}];

    for (int i = 0; i < n; i++) {
        r++;
        if (!dir[i]) {
            c++;
        }
        int nind;
        if (!mp.count({r, c})) {
            mp[{r, c}] = timer;
            rmp[timer] = {r, c};
            timer++;
        }
        nind = mp[{r, c}];
        g[ind].insert(nind);
        ind = nind;
    }
}

void dfs(int v) {
    for (int i = 1; i < logn; i++) {
        up[v][i] = up[up[v][i - 1]][i - 1];
    }
    tin[v] = timer++;
    for (int u: g[v]) {
        up[u][0] = v;
        dfs(u);
    }
    tout[v] = timer;
}

bool anc(int u, int v) {
    return tin[u] <= tin[v] && tout[u] >= tout[v];
}

int lca(int u, int v) {
    if (anc(u, v)) return u;
    if (anc(v, u)) return v;
    for (int i = logn - 1; i >= 0; i--) {
        if (!anc(up[v][i], u)) v = up[v][i];
    }
    return up[v][0];
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];

    f();
    for (int i = 0; i < n; i++) {
        dir[a[i] - 1] = 1;
        f();
    }
    int ct = 0;
    int m = timer;
    for (int i = 0; i < timer; i++) {
        ct += gsize(g[i]);
    }

    if (ct != m - 1) {
        cout << "NO" << ' ' << ct << ' ' << m << endl;
        return 0;
    }

    timer = 0;
    dfs(0);

    int q;
    cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        int v = mp[{r1, c1}], u = mp[{r2, c2}];
        int z = lca(u, v);
        cout << rmp[z].first << ' ' << rmp[z].second << nl;
    }
}
