#include <bits/stdc++.h>

using namespace std;

#define all(x) (x).begin(), (x).end()
#define allr(x) (x).rbegin(), (x).rend()
#define gsize(x) (int)((x).size())
const char nl = '\n';

typedef long long ll;
typedef long double ld;

const int maxn = 500000;

int n;
int t[2*maxn];

void upd(int i) {
    for (t[i += n]++; i > 1; i >>= 1) t[i >> 1] = t[i] + t[i ^ 1];
}

int query(int l, int r) {
    int res = 0;
    for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
        if (l & 1) res += t[l++];
        if (r & 1) res += t[--r];
    }
    return res;
}

int t2[maxn * 4];
void update(int v, int tl, int tr, int i) {
    while (tl + 1 != tr) {
        t2[v]++;
        int tm = (tl + tr) / 2;
        if (i < tm) {
            v = 2*v + 1;
            tr = tm;
        } else {
            v = 2*v + 2;
            tl = tm;
        }
    }
    t2[v]++;
}

int f(int v, int tl, int tr, int x) {
    while (tl != tr - 1) {
        int tm = (tl + tr) / 2;
        if (t2[2 * v + 1] >= x) {
            tr = tm;
            v = 2*v + 1;
        } else {
            x -= t2[2 * v + 1];
            tl = tm;
            v = 2 * v + 2;
        }
    }
    if (tl == tr - 1) {
        if (t2[v] > x) return tl;
        else return tr;
    }
}

vector<pair<int, int>> qr[maxn + 1];

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    int q;
    cin >> q;
    vector<pair<pair<int, int>, vector<array<int, 7>>>> b(1);
    b[0].first = {0, n};

    for (int i = 0; i < q; i++) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        qr[r1].emplace_back(r1 - c1, (i + 1));
        qr[r2].emplace_back(r2 - c2, -(i + 1));
        b[0].second.push_back({r1, c1, r2, c2, i, 0, 0}); // TODO: find p1 and p2
    }
    vector<int> ta(n + 1);
    for (int i = 0; i < n; i++) ta[a[i]] = i;

    {
        int ti = 0;
        for (int i = 0; i <= n; i++) {
            if (i) update(0, 0, n, ta[i]);

            for (auto p: qr[i]) {
                int j = f(0, 0, n, p.first);
                int tj = p.second;
                if (tj > 0) {
                    tj -= 1;
                    b[0].second[tj][5] = j;
                } else {
                    tj *= -1;
                    tj -= 1;
                    b[0].second[tj][6] = j;
                }
            }
        }
    }

    vector<pair<int, int>> ans(q, {-1, -1});
    for (int _ = 0; _ < 20; _++) {
        fill(t, t + 2*maxn, 0);
        vector<pair<pair<int, int>, vector<array<int, 7>>>> nb;
        int ti = 1;
        for (auto const &tp: b) {
            int lb = tp.first.first, ub = tp.first.second + 1;
            int tm = (lb + ub) / 2;
            while (ti <= tm) {
                upd(ta[ti]);
                ti++;
            }

            if (lb == ub - 1) {
                for (auto p: tp.second) {
                    ans[p[4]].first = lb;
                    ans[p[4]].second = lb - query(0, p[5]);
                }
                continue;
            }
            vector<array<int, 7>> r1, r2;
            for (auto const &p: tp.second) {
                bool good = false;
                if (min(p[0], p[2]) < tm) {
                    good = true;
                } else {
                    int p1 = p[5], p2 = p[6];
                    if (p1 > p2) swap(p1, p2);
                    if (query(p1, p2) == 0) {
                        good = false;
                    } else {
                        good = true;
                    }
                }
                if (good) {
                    r1.push_back(p);
                } else {
                    r2.push_back(p);
                }
            }
            if (gsize(r1)) {
                nb.push_back({{lb, tm - 1},
                              {}});
                for (auto p: r1) {
                    nb.back().second.push_back(p);
                }
            }
            if (gsize(r2)) {
                nb.push_back({{tm, ub - 1},
                              {}});
                for (auto p: r2) {
                    nb.back().second.push_back(p);
                }
            }
        }
        b = nb;
    }

    for (int i = 0; i < q; i++) {
        cout << ans[i].first << ' ' << ans[i].second << nl;
    }
}
