#include <bits/stdc++.h>
using namespace std;

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
using ll = long long;
using ld = long double;

const int N = 1e5 + 10, INF = 0x3f3f3f3f;

int p_[N], p[N], l[N], r[N];
ll c[N];
vector<int> g_[N], g[N];

int curr[N], sz[N], timer = 0, order[N], tout[N], inv[N], order_[N];

int dfs_sz(int u) {
	sz[u] = 0;
	for (int v : g[u]) {
		sz[u] += dfs_sz(v);
	}
	return sz[u];
}

int link[N];

void dfs_hld(int u, int plink) {
	inv[timer] = u;
	order_[u] = order[u] = timer++;
	link[order[u]] = order[plink];
	sort(all(g_[u]), [](int x, int y) { return sz[x] > sz[y]; });
	bool is_first = true;
	for (int v : g_[u]) {
		dfs_hld(v, is_first ? plink : v);
		is_first = false;
	}
	g[order[u]] = g_[u];
	for (int &v : g[order[u]]) {
		v = order[v];
	}
	if (u) {
		p[order[u]] = order[p_[u]];
	}
	tout[order[u]] = timer;
}

// int dfs(int u) {
// 	if (curr[u] == r[u]) {
// 		return -1;
// 	}
// 	int opt = u;
// 	for (int v : g[u]) {
// 		int crr = dfs(v);
// 		if (crr != -1 && c[opt] > c[crr]) {
// 			opt = crr;
// 		}
// 	}
// 	return opt;
// }

signed main() {
	cin.tie(0)->sync_with_stdio(0);
	int testcases;
	cin >> testcases;
	while (testcases--) {
		int n;
		cin >> n;
		for (int i = 0; i < n; ++i) {
			g[i].clear();
			g_[i].clear();
		}
		fill(curr, curr + n, 0);
		timer = 0;
		p_[0] = -1;
		p[0] = -1;
		for (int i = 1; i < n; ++i) {
			cin >> p_[i];
			g_[--p_[i]].push_back(i);
		}
		dfs_sz(0);
		dfs_hld(0, 0);
		for (int i = 0; i < n; ++i) {
			cin >> c[order[i]];
		}
		for (int i = 0; i < n; ++i) {
			cin >> l[order[i]] >> r[order[i]];
			curr[order[i]] = r[order[i]];
		}
		iota(order, order + n, 0);
		iota(inv, inv + n, 0);
		ll ans = 0;
		for (int i = 0; i < n; ++i) {
			if (!curr[i]) {
				for (int j = i; j < tout[i]; ++j) {
					c[j] = +INF;
				}
			}
		}
		bool flag = false;
		for (int u = n - 1; u >= 0; ) {
			if (r[u] - curr[u] >= l[u]) {
				--u;
				continue;
			}
			// cout << "fixing " << u << endl;
			// cout << u << " " << tout[u] << endl;
			int v = int(min_element(c + u, c + tout[inv[u]]) - c);
			if (c[v] == +INF) {
				flag = true;
				break;
			}
			// cout << "vertex is" << v << endl;
			int at_least = l[u] - r[u] + curr[u];

			int crr = v;
			while (crr != -1) {
				// cout << crr << endl;
				at_least = min(at_least, *min_element(curr + order[link[inv[crr]]], curr + crr + 1));
				crr = p[link[inv[crr]]];
				if (crr != -1) {
					crr = order[crr];
				}
			}
			assert(at_least >= 0);
			if (at_least <= 0) {
				flag = true;
				break;
			}
			// cout << at_least << endl;

			crr = v;
			ans += c[v] * at_least;
			while (crr != -1) {
				for (int j = order[link[inv[crr]]]; j < crr + 1; ++j) {
					curr[j] -= at_least;
					if (!curr[j]) {
						for (int h = j; h < tout[inv[j]]; ++h) {
							c[h] = +INF;
						}
					}
				}
				crr = p[link[inv[crr]]];
				if (crr != -1) {
					crr = order[crr];
				}
			}
		}
		if (flag) {
			cout << "-1\n";
		} else {
			cout << ans << "\n";
			for (int i = 0; i < n; ++i) {
				int cnt = r[order_[i]] - curr[order_[i]];
				for (int j : g[order_[i]]) {
					cnt -= r[j] - curr[j];
				}
				cout << cnt << " ";
			}
			cout << "\n";
		}
	}
}