#include <iostream>
#include <vector>

using namespace std;

#define v vector
#define int long long
#define all(a) a.begin(), a.end()
#define len(a) (int)a.size()

int n;
v<int> a, pos;

v<v<int>> pref, suff;

void build() {
    pref.resize(n, v<int> (n));
    suff.resize(n, v<int> (n));

    v<int> cur;
    for (int i = 0; i < n; i++) {
        cur.push_back(a[i]);
        sort(all(cur));

        for (int j = 0; j <= i; j++) {
            pref[cur[j]][i] = j;
        }
    }

    cur.clear();
    for (int i = n - 1; i >= 0; i--) {
        cur.push_back(a[i]);
        sort(all(cur));

        int index = len(cur) - 1;
        for (int j = n - 1; j >= i; j--) {
            suff[cur[index]][i] = j;
            index--;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
    }

    pos.resize(n);
    for (int i = 0; i < n; i++) pos[a[i]] = i;
    int res = 0;

    build();
    int ans = 0;
    for (int x = 0; x < n; x++) {
        for (int y = x + 1; y < n; y++) {
            int opt = abs(y - x);
            opt = max(opt, abs(pos[x] - pos[y]));

            int l = pos[x], r = pos[y];
            if (l > r) swap(l, r);

            for (int i = l; i < r; i++) {
                int val = r - pref[a[l]][i];
                opt = max(opt, val);
            }

            for (int i = l + 1; i <= r; i++) {
                int val = suff[a[r]][i] - l;
                opt = max(opt, val);
            }
            ans += opt;
            //cout << x + 1 << " " << y + 1 << " " << opt << "\n";
        }
    }
    cout << ans << "\n";
    return 0;
}
