#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <deque>
#include <stack>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <time.h>
#include <math.h>
#include <random>
#include <string>
#include <iomanip>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

int32_t main() {
	cin.tie(0); cout.tie(0); cin.sync_with_stdio(0); cout.sync_with_stdio(0);
	int n, q;
	cin >> n;
	vector<int> a(n);
	int k = -1;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		if (k == -1 && a[i] != i + 1)
			k = i;
	}
	cin >> q;
	while (q--) {
		int r1, c1, r2, c2;
		cin >> r1 >> c1 >> r2 >> c2;
		if (r1 - c1 > k && r2 - c2 > k) {
			if (c1 == c2) {
				cout << min(r1, r2) << " " << c1 << "\n";
				continue;
			}
		}
		if (r1 - c1 > k)
			r1 = k + c1;
		if (r2 - c2 > k)
			r2 = k + c2;
		if (r1 - r2 == c1 - c2)
			cout << min(r1, r2) << " " << min(c1, c2) << "\n";
		else {
			r1 -= c1;
			r2 -= c2;
			cout << min(r1, r2) << " " << 0 << "\n";
		}
	}
}