#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

//#define int long long
#define all(x) x.begin(), x.end()
#define sz(x) ((int)(x.size()))
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
const int N = 5e5 + 228;

int a[N];
int n;

int findPath(int y, int x) {
	int s = 0;
	for (int i = 0; i <= n; ++i) {
		if (s == x) return i;
		if (a[i] < x + y) ++s;
	}
	exit(3);
}

void solve() {
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		--a[i];
	}

	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		int r1, c1, r2, c2;
		cin >> r1 >> c1 >> r2 >> c2;
		int x1 = r1 - c1;
		int y1 = c1;
		int x2 = r2 - c2;
		int y2 = c2;
		int p1 = findPath(y1, x1);
		int p2 = findPath(y2, x2);
		if (p1 > p2) {
			swap(p1, p2);
			swap(x1, x2);
			swap(y1, y2);
			swap(r1, r2);
			swap(c1, c2);
		}
		if (p1 == p2) {
			pi ans = min(make_pair(y1, x1), make_pair(y2, x2));
			cout << ans.first + ans.second << " " << ans.first << "\n";
		}
		else {
			int mn = 1e9;
			for (int i = p1; i < p2; ++i) {
				mn = min(mn, a[i]);
			}
			int y = mn;
			int x = 0;
			for (int i = 0; i < p1; ++i) {
				if (a[i] < mn) {
					--y;
					++x;
				}
			}
			cout << x + y << " " << y << "\n";
		}
	}
}

signed main() {
	int t = 1;
	while (t--) {
		solve();
	}
}