#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>

using namespace std;

#define int int64_t
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()

int32_t main() {
    int n;
    cin >> n;
    vector<int> mas(n), ind(n+1);
    for (auto& i : mas) {
        cin >> i;
    }
    for (int i = 0; i < n; ++i) {
        ind[mas[i]] = i;
    }

    vector<int> mr(n);
    for (int i = 0; i < n; ++i) {
        for (int j = i+1; j < n; ++j) {
            mr[i] += mas[i] > mas[j];
        }
    }
    vector<int> ml(n);
    for (int i = 0; i < n; ++i) {
        for (int j = i-1; j >= 0; --j) {
            ml[i] += mas[i] < mas[j];
        }
    }

    int ans = 0;
    for (int l = 0; l < n; ++l) {
        for (int r = l+1; r < n; ++r) {
            int res = 0;
            res = max(res, abs(mas[r] - mas[l]));
            res = max(res, abs((l-ml[l]) - (r)));
            res = max(res, abs((l) - (r+mr[r])));
            ans += res;
            //cout << l << ' ' << r << ' ' << res << endl;
        }
    }
    cout << ans;
}
