#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

struct q {
    int x, y, z;
};

bool cmp (q a, q  b) {
    return (a.x < b.x) || (a.x == b.x && a.y < b.y) || (a.x == b.x && a.y == b.y && a.z < b.z);
}

int main()
{
    int n;
    string s;
    cin >> s;
    n = s.size();
    vector<ll> a(n);
    for (int i = 0; i < n; i++) {
        a[i] = s[i] - '0';
    }
    ll k;
    cin >> k;
    vector<q> b(n);
    for (int i = 0; i < n; i++) {
        int x = 0;
        for (int j = i - 1; j >= 0; j--) {
            if (a[j] < a[i]) {
                x++;
            }
        }
        b[i] = {a[i], x, i};
    }
    sort(b.begin(), b.end(), cmp);
    ll c = 0;
    ll p = 0;
    ll st = 1;
    for (int i = n - 1; i >= 0; i--) {
        p += st * a[i];
        st *= 10;
    }
    st /= 10;
    ll maxs = p;
    ll ans = 0;
    vector<int> used(n, 0);
    p = 0;
    ll l = 0;
    for (int i = n - 1; i >= 0; i--) {
        used[b[i].z] = 1;
        l += b[i].y;
        p += b[i].x * st;
        st /= 10;
        ll o = 0;
        for (int j = 0; j < n; j++) {
            if (used[j] == 0) {
                o *= 10;
                o += a[j];
            }
        }
        if (maxs < o + p - k * l) {
            maxs = o + p - k * l;
            ans = n - i;
        }
        maxs = max(maxs, o + p - k * l);
    }
    for (int i = 0; i < n; i++) {
        used[i] = 0;
    }
    for (int i = n - i; i > n - i - ans; i--) {
        cout << b[i].x;
        used[b[i].z] = 1;
    }
    for (int i = 0; i < n; i++) {
        if (used[i] == 0) {
            cout << a[i];
        }
    }
}
