#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2,sse4,sse4.1,sse4.2")

#include <bits/extc++.h>
using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define sfor(i, l, r) for (int i = l; i <= r; ++i)
#define bfor(i, r, l) for (int i = r; i >= l; --i)
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

const int INF = 1e9 + 10;
vector<vi> g;
vi c;

void Dfs(int f, int u, int clr) {
    c[u] = clr;
    for (int v: g[u]) {
        if (v != f && c[v] == -1)
            Dfs(f, v, clr);
    }
}

int main() {
    fast;
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        g.assign(n, vi(0));
        sfor(i, 0, m - 1) {
            int u, v;
            cin >> u >> v;
            --u;
            --v;
            g[u].push_back(v);
            g[v].push_back(u);
        }
        vector<vi> ng(n);
        sfor(i, 0, n - 1) {
            c.assign(n, -1);
            int curr = 0;
            sfor(j, 0, n - 1) {
                if (c[j] != -1 || j == i)
                    continue;
                Dfs(i, j, curr);
                ++curr;
            }
            for (int u: g[i]) {
                for (int v: g[i]) {
                    if (u != v && c[u] == c[v])
                        ng[u].push_back(v);
                }
            }
        }
        vi d(n, INF);
        d[0] = 0;
        queue<int> q;
        q.push(0);
        while (!q.empty()) {
            int u = q.front();
            q.pop();
            for (int v: ng[u]) {
                if (d[u] + 1 < d[v]) {
                    d[v] = d[u] + 1;
                    q.push(v);
                }
            }
        }
        sfor(i, 1, n - 1) {
            if (d[i] == INF)
                cout << "-1 ";
            else
                cout << d[i] * 2 << ' ';
        }
        cout << '\n';
    }
}
