#include <bits/stdc++.h>
using namespace std;

#define rep(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define all(x) begin(x), end(x)
#define sz(x) (int)size(x)
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;

template <typename T, typename U>
bool ckmin(T& a, const U& b) {
    return a > b && (a = b, true);
}

template <typename T, typename U>
bool ckmax(T& a, const U& b) {
    return a < b && (a = b, true);
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    cin.exceptions(ios::failbit);

    int n, q;
    cin >> n >> q;
    vector<ll> a(n);
    rep(i, 0, n) cin >> a[i];

    while (q--) {
        int t;
        cin >> t;
        if (t == 1) {
            int k;
            cin >> k;

            set<ll> A{all(a)};
            rep(i, 0, k) {
                set<ll> B;
                int c = 1;
                for (auto en: A) {
                    B.insert(en + sz(A) - c);
                    c++;
                }
                A = B;
            }
            cout << sz(A) << '\n';
        } else if (t == 2) {
            int k;
            cin >> k;

            map<ll, int> A;
            for (auto x: a) A[x]++;

            ll ans = 0;
            rep(i, 0, k) {
                map<ll, int> B;
                int c = 1;
                for (auto en: A) {
                    B[en.first + sz(A) - c] += en.second;
                    ans += 1LL * (sz(A) - c) * en.second;
                    c++;
                }
                A = B;
            }
            cout << ans << '\n';
        } else {
            int k, i;
            cin >> k >> i;
            --i;

            ll ans = a[i];
            map<ll, ll> TO;
            set<ll> A{all(a)};
            rep(j, 0, k) {
                set<ll> B;
                int c = 1;
                for (auto en: A) {
                    B.insert(en + sz(A) - c);
                    TO[en] = en + sz(A) - c;
                    c++;
                }
                A = B;
                ans = TO[ans];
            }
            cout << ans << '\n';
        }
    }
}