#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;

#define int long long
#define endl '\n'

struct T3
{
	int num, i, k;
};

void task()
{
	int n, q;
	cin >> n >> q;

	vector<int> v(n);

	for (int i = 0; i < n; i++)
	{
		cin >> v[i];
	}

	sort(v.begin(), v.end());

	vector<int> diff;

	for (int i = 1; i < n; i++)
	{
		if (v[i] - v[i - 1] > 0)
		{
			diff.push_back(v[i] - v[i - 1]);
		}
	}

	sort(diff.begin(), diff.end());

	vector<pair<int, int>> q1, q2;
	vector<T3> q3;

	vector<int> ans(q);

	for (int i = 0; i < q; i++)
	{
		int t;
		cin >> t;

		if (t == 1)
		{
			int k;
			cin >> k;

			q1.push_back({ i,k });
		}
		else if (t == 2)
		{
			int k;
			cin >> k;

			q2.push_back({ i,k });
		}
		else if (t == 3)
		{
			int p, k;
			cin >> p >> k;

			p--;

			q3.push_back({ i,p,k });
		}
	}

	for (int f = 0; f < q1.size(); f++)
	{
		int k = q1[f].second;

		if (diff.size() == 0)
		{
			ans[q1[f].first] = 1;
			continue;
		}
		else if (diff[0] > k)
		{
			ans[q1[f].first] = diff.size() + 1;
			continue;
		}

		int l = 0;
		int r = diff.size();

		while (r - l > 1)
		{
			int m = (r + l) / 2;

			if (diff[m] <= k)
			{
				l = m;
			}
			else
			{
				r = m;
			}
		}

		ans[q1[f].first] = diff.size() - r + 1;
	}

	for (int i = 0; i < ans.size(); i++)
	{
		cout << ans[i] << endl;
	}
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	task();

	return 0;
}