#include<bits/stdc++.h>

#define For(i, n) for(int i = 0; i < n; i++)
#define FoR(i, j, n) for(int i =  j; i < n; i++)
#define FOR(i, j, n, k) for(int i = j; i < n; i += k)
#define all(a) a.begin(), a.end()
#define pii pair<int, int>
#define x first
#define y second
#define mid(l, r) (l + r) / 2

#define int long long
#define ios ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define endl '\n'

using namespace std;

int inf = 1e18;

bool cmp(pii a, pii b){
    return a.x > b.x;
}

struct st{
    int k, t, K = 0, a;

    st(int k_, int t_, int a_):k(k_), t(t_), a(a_){};
};

struct que{
    int t, k, x, i;

    que(int t_, int k_, int x_, int i_):t(t_), k(k_), x(x_), i(i_){};
};

bool cmp2(que a, que b){
    return a.k < b.k;
}

bool cmp3(st a, st b){
    return a.t < b.t;
}

pii operator+(pii a, pii b){
    return {a.x + b.x, a.y + b.y};
}

struct bintree{
    int sz;
    vector<int> t, k;

    void build(int n){
        sz = n;
        t.assign(sz * 8, 0);
        k.assign(sz * 8, 0);
    }

    void _ins(int i, int l, int r, int x, int y){
        if(l > x or r < x)return;
        if(l == r){
            k[i] = 1;
            t[i] += y;
            return;
        }
        _ins(i * 2, l, mid(l, r), x, y);
        _ins(i * 2 + 1, mid(l, r) + 1, r, x, y);
        k[i] = k[i * 2] + k[i * 2 + 1];
        t[i] = t[i * 2] + t[i * 2 + 1];
        return;
    }

    void ins(int x, int y){
        if(x >= sz)assert(0);
        _ins(1, 0, sz - 1, x, y);
    }

    pii _get(int i, int l, int r, int L, int R){
        if(l > R or r < L)return {0, 0};
        if(l >= L and r <= R)return {t[i], k[i]};
        return _get(i * 2, l, mid(l, r), L, R) + _get(i * 2 + 1, mid(l, r) + 1, r, L, R);
    }

    pii get(int l){
        if(l + 1 >= sz)assert(0);
        return _get(1, 0, sz - 1, l + 1, sz - 1);
    }
};

map<int, pii> mp;

void stupid(){
    int n, k;
    cin >> n >> k;
    vector<pii> a(n);
    vector<que> q(k, que(0, 0, 0, 0));
    For(i, n){
        cin >> a[i].x;
        a[i].y = i;
    }
    sort(all(a), cmp);
    For(i, k){
        int t, K, x;
        cin >> t >> K;
        if(t == 3)cin >> x;
        x--;
        q[i] = que(t, K, x, i);
    }
    sort(all(q), cmp2);
    vector<int> ans(k, -1);
    int j = 0, D = 0;
    For(i, 10001){
        while(q[j].k == i){
            if(q[j].t == 1){
                ans[q[j].i] = 0;
                For(p, n){
                    if(p == 0 or a[p].x != a[p - 1].x)ans[q[j].i]++;
                }
            }
            if(q[j].t == 2){
                ans[q[j].i] = D;
            }
            if(q[j].t == 3){
                For(p, n){
                    if(a[p].y == q[j].x)ans[q[j].i] = a[p].x;
                }
            }
            j++;
        }
        vector<int> na(n);
        For(p, n){
            na[p] = (p == 0 ? 0 : (a[p].x == a[p - 1].x ? na[p - 1] : na[p - 1] + 1));
            D += na[p];
        }
        For(p, n){
            a[p].x += na[p];
        }
    }
    For(i, k){
        cout << ans[i] << endl;
    }
}

void solve(){
    int n, k;
    cin >> n >> k;
    vector<pii> a(n);
    vector<int> b(n);
    For(i, n){
        cin >> a[i].x;
        mp[a[i].x] = {0, 0};
        b[i] = a[i].x;
        a[i].y = i;
    }
    int j = 0;
    for(auto x : mp){
        mp[x.x].x = j;
        j++;
    }
    sort(all(a), cmp);
    int D = 0, d = 0;
    vector<st> v;
    For(i, n){
        if(i == 0){
            v.push_back(st(1, inf, a[i].x));
        }
        else{
            if(a[i].x != a[i - 1].x){
                d++;
                v.push_back(st(1, a[i - 1].x - a[i].x, a[i].x));
            }
            else{
                v[v.size() - 1].k++;
            }
        }
        mp[a[i].x].y = d;
        D += d;
    }
    int N = v.size();
    for(int i = N - 1; i >= 0; i--){
        v[i].K = (i == N - 1 ? 0 : v[i + 1].K) + v[i].k;
    }
    sort(all(v), cmp3);
    vector<que> q(k, que(0, 0, 0, 0));
    For(i, k){
        int t, k, x = 0;
        cin >> t >> k;
        if(t == 3){
            cin >> x;
            x--;
        }
        q[i] = que(t, k, x, i);
    }
    sort(all(q), cmp2);
    int T = 0, DD = 0;
    j = 0;
    vector<int> ans(k, -1);
    bintree t;
    t.build(1e6);
    For(i, N){
        while(j < k and v[i].t > q[j].k){
            if(q[j].t == 2){
                ans[q[j].i] = DD + D * (q[j].k - T);
            }
            if(q[j].t == 1){
                ans[q[j].i] = N - i;
            }
            if(q[j].t == 3){
                int l = b[q[j].x];
                pii X = t.get(mp[l].x);
                int K1 = 0, K2 = 0;
                For(I, i){
                    if(v[I].a > l){
                        K1++;
                        K2 += v[I].t;
                    }
                }
                if(X.x != K2 or X.y != K1 or mp[l].y != mp.size() - mp[l].x - 1)assert(0);
//                cout << "!" << l << ' ' << mp[l].x << ' ' << q[j].k << ' ' << mp[l].y << ' ' << X.y << ' ' << X.x << endl;
                ans[q[j].i] = l + q[j].k * mp[l].y - X.y * q[j].k + X.x;
            }
            j++;
        }
        DD += (v[i].t - T) * D;
        T = v[i].t;
//        cout << "+" << mp[v[i].a].x << ' ' << v[i].t << endl;
        t.ins(mp[v[i].a].x, v[i].t);
        D -= v[i].K;
    }
    For(i, k){
        cout << ans[i] << endl;
    }
}

signed main(){
    ios
    int t = 1;
//    cin >> t;
    while(t--)solve();
}

