#include "iostream"
#include "vector"
#include "string"
#include "set"
#include "algorithm"

using namespace std;

signed main() {
    int n, q; cin >> n >> q;
    set<long long> st;
    for (int i = 0; i < n; ++i) {
        long long x; cin >> x;
        st.insert(x);
    }
    vector<long long> a;
    for (auto el: st) {
        a.push_back(el);
    }
    vector<long long> dif;
    for (int i = 0; i < a.size() - 1; ++i) {
        dif.push_back(a[i + 1] - a[i]);
    }
    sort(dif.begin(), dif.end());
    while (q--) {
        int t; cin >> t;
        if (t == 1) {
            long long k; cin >> k;
            int l = -1, r = dif.size();
            while (r - l > 1) {
                int md = (r + l) / 2;
                if (dif[md] > k) {
                    r = md;
                } else {
                    l = md;
                }
            }
            cout << dif.size() - r + 1 << endl;
        }
    }
}
