#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>

using namespace std;

typedef long long ll;


bool gr(string& s, ll y, int cnt) {
	string p = to_string(y * cnt);

	if (s.size() > p.size()) {
		return true;
	}
	if (s.size() < p.size()) {
		return false;
	}
	for (int i = 0; i < s.size(); i++) {
		if (s[i] > p[i]) {
			return true;
		}
		else if (s[i] < p[i]) {
			return false;
		}
	}
	return true;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	string x;
	cin >> x;
	ll y;
	cin >> y;
	
	int n = x.size();
	
	if (n > 16) {
		sort(x.begin(), x.begin() + n - 16);
		reverse(x.begin(), x.begin() + n - 16);
	}

	for (int i = max(n - 22, 0); i < n; i++) {
		if (x[i] == '2') {
			for (int j = i - 1; j >= 0; j--) {
				if (x[j] == '2' || j == 0) {
					if (x[j] != '1') {
						j++;
					}
					if (j >= i) {
						break;
					}
					string eee = x.substr(j, i - j + 1);
					// cout << x << ' ' << i << ' ' << j << ' ' << eee << '\n';
					swap(eee[0], eee[eee.size() - 1]);


					if (gr(eee, y, j - i)) {
						swap(x[j], x[i]);
					}

					break;
				}
			}
		}
	}

	cout << x << '\n';

	return 0;
}