#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

int compare(string a, string b) {
    int al = a.length(), bl = b.length();
    if (al > bl) return 1;
    if (al < bl) return -1;
    for (int i = 0; i < al; ++i) {
        if (a[i] > b[i]) return 1;
        if (a[i] < b[i]) return -1;
    }
    return 0;
}

string sum(string a, string b) {
    int al = a.length(), bl = b.length();
    if (bl > al) {
        swap(a, b);
        swap(al, bl);
    }
    string c = "0" + a;
    for (int ia = al, ib = bl - 1; ia >= 0; --ia, --ib) {
        if (ib >= 0) c[ia] += b[ib] - '0';
        while (c[ia] > '9') {
            c[ia] -= 10;
            c[ia - 1] += 1;
        }
    }
    if (c[0] == '0') return c.substr(1);
    return c;
}

string subtract(string a, string b) {
    int al = a.length(), bl = b.length();
    if (compare(a, b) <= 0) {
        return "0";
    }
    string c = a;
    for (int ia = al - 1, ib = bl - 1; ia >= 0; --ia, --ib) {
        if (ib >= 0) c[ia] -= b[ib] - '0';
        while (c[ia] < '0') {
            c[ia] += 10;
            c[ia - 1] -= 1;
        }
    }
    int firstNotZero = 0;
    for (; firstNotZero < al; ++firstNotZero) {
        if (c[firstNotZero] != '0') break;
    }
    return c.substr(firstNotZero);
}

void solve() {
    string x, y;
    cin >> x >> y;
    string yy = y, ansNum = x, ansWin = x;
    int xl = x.length();
    for (int i = 1; i < xl; ++i) {
        bool toPrint = true;
        for (int j = i; j > 0 && x[j] > x[j - 1]; --j) {
            swap(x[j], x[j - 1]);
            if (ansWin < subtract(x, yy)) {
                ansNum = x, ansWin = subtract(x, yy), toPrint = false;
            }
            yy = sum(yy, y);
        }
//        if (toPrint) {
//            cout << ansNum;
//            return;
//        }
    }
    cout  << ansNum;
}

int main() {
    solve();
    return 0;
}
