#include <iostream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <algorithm>
#include <queue>
#include <cmath>
#include <iomanip>
#include <deque>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

ll get(const string& s) {
	ll res = 0;
	for (ll i = 0; i < s.size(); i++) {
		res *= 10;
		res += s[i] - '0';
	}
	return res;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	string s;
	cin >> s;
	ll n = s.size();
	vector<vector<ll>> a(10);
	for (ll i = 0; i < s.size(); i++) {
		a[s[i] - '0'].push_back(i);
	}
	ll y;
	cin >> y;
	set<ll> st;
	for (ll i = 0; i < n; i++) st.insert(i);
	string ans = "";
	for (ll x = 9; x > 0; x--) {
		for (ll i : a[x]) {
			ll c = 0;
			if (n - ans.size() >= 21) {
				st.erase(i);
				ans.push_back(s[i]);
			}
			else {
				string s1 = "";
				set<ll>::iterator it = st.begin();
				while (it != st.end() && *it < i) {
					c++;
					s1.push_back(s[*it]);
					it++;
				}
				string s2 = "";
				s2.push_back(s[i]);
				s2 = s2 + s1;
				s1.push_back(s[i]);
				ll x1 = get(s1);
				ll x2 = get(s2);
				ll res = x2 - x1;
				for (ll qq = 0; qq < n - ans.size() - c - 1; qq++) res *= 10;
				if (res >= c * y) {
					st.erase(i);
					ans.push_back(s[i]);
				}
			}
		}
	}
	cout << ans;
	for (ll i : st) {
		cout << s[i];
	}
	cout << "\n";
}