#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <deque>

using namespace std;

#define int long long

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<vector<int>> gr(n);
        for (int i = 0; i < m; ++i) {
            int v, u;
            cin >> v >> u;
            --v;
            --u;
            gr[v].push_back(u);
            gr[u].push_back(v);
        }
        deque<int> now;
        vector<int> d(n, 1e9);
        d[0] = 0;
        now.push_back(0);
        while (now.size()) {
            auto c = *now.begin();
            now.pop_back();
            for (auto u: gr[c]) {
                if (d[u] > d[c] + 1) {
                    d[u] = d[c] + 1;
                    now.push_back(u);
                }
            }
        }
        for (int i = 1; i < n; ++i) {
            cout << now[i] * 2 - 1 << " ";
        }
        cout << "\n";
    }
}