#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define all(x) x.begin(), x.end()

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

struct node {
    ll k;
    ll type;
    ll numbeer_gamer;
    ll ind;

    node(){};
    node(ll type_, ll k_, ll number_gamer_, ll ind_) {
        type = type_;
        k = k_;
        numbeer_gamer = number_gamer_;
        ind = ind_;
    }

    friend bool operator<(const node &a, const node &b);
};

bool operator<(const node &a, const node &b) {
    if (a.k != b.k) return a.k < b.k;
    return a.type < b.type;
}

void solve() {
    ll n, q;
    cin >> n >> q;

    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) cin >> a[i];

    ll iznach_sum = 0;
    for (auto i : a) iznach_sum += i;

    vector<node> zapr(q);
    for (ll i = 0; i < q; ++i) {
        ll type, k, number_gamer = 0;
        cin >> type >> k;

        if (type == 3) cin >> number_gamer;
        --number_gamer;

        zapr[i] = node(type, k, number_gamer, i);
    }

    sort(all(zapr));

    ll ind = 0;
    ll now_time = 0;
    vector<ll> ans(q);

    while (true) {
        set<ll> h;
        for (auto i : a) h.insert(i);

        vector<ll> diff;
        for (auto i : h) diff.push_back(i);

        if (diff.size() == 1) break;

        ll min_razn = (ll)1e18;

        for (ll i = 0; i < diff.size() - 1; ++i) {
            min_razn = min(min_razn, diff[i + 1] - diff[i]);
        }

        ll every_round = 0;
        ll iznach = 0;
        for (auto i : a) {
            every_round += diff.size() - (lower_bound(all(diff), i) - diff.begin()) - 1;
            iznach += i;
        }

        ll new_time = now_time + min_razn;

        while (ind < q && zapr[ind].k < new_time) {
            if (zapr[ind].type == 1) {
                ans[zapr[ind].ind] = diff.size();
            }
            if (zapr[ind].type == 2) {
                ans[zapr[ind].ind] = - iznach_sum + iznach + every_round * (zapr[ind].k - now_time);
            }
            if (zapr[ind].type == 3) {
                ll gh = diff.size() - (lower_bound(all(diff), a[zapr[ind].numbeer_gamer]) - diff.begin()) - 1;
                ans[zapr[ind].ind] = a[zapr[ind].numbeer_gamer] + gh * (zapr[ind].k - now_time);
            }

            ++ind;
        }

        // swap(now_time, new_time);

        for (ll i = 0; i < n; ++i) {
            a[i] += (diff.size() - (lower_bound(all(diff), a[i]) - diff.begin()) - 1) * (new_time - now_time);
        }

        swap(now_time, new_time);
    }

    while (ind < q) {
        if (zapr[ind].type == 1) {
            ans[zapr[ind].ind] = 1;
        }
        if (zapr[ind].type == 2) {
            ans[zapr[ind].ind] = a[0] * n - iznach_sum;
        }
        if (zapr[ind].type == 3) {
            ans[zapr[ind].ind] = a[0];
        }

        ++ind;
    }

    for (auto i : ans) cout << i << '\n';
}

signed main() {
    fast_stream();

    int tests = 1;

    while (tests--) {
        solve();
    }
}
