#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <cstdlib>
#include <ctime>
#include <random>
#include <cassert>
#include <array>
#include <string>
#include <set>
#include <map>


using namespace std;



#define ll long long
#define ld long double
#define flt double
#define pb push_back
#define emb empalce_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbeign(), a.rend()
#define nlpt nullptr
#define prcs cout << fixed << setprecision(20)


mt19937 rnd(1231231);


struct ask {
	int tp;
	ll k;
	int plr;
	int i;

	ask() {}
	ask(int tp, ll k, int plr, int i) : tp(tp), k(k), plr(plr), i(i) {}
};


int n, q;
int k;
vector<ll> c;
vector<pair<ll, int>> a;
vector<ll> d;
vector<ask> asks;
vector<ll> res;



bool operator<(const ask& a1, const ask& a2) {
	return a1.k < a2.k;
}


void solve() {
	res.assign(q, -1);
	map<ll, int> mp;
	for (auto x : c) {
		mp[x] += 1;
	}
	a = vector<pair<ll, int>>(all(mp));
	k = a.size();
	d.resize(k - 1);
	for (int i = 0; i < k - 1; ++i) {
		d[i] = a[i + 1].first - a[i].first;
	}
	sort(all(d));
	for (auto& f : asks) {
		if (f.tp == 1) {
			res[f.i] = k - (upper_bound(all(d), f.k) - d.begin());
		}
	}
}



int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> q;
	c.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> c[i];
	}
	asks.resize(q);
	for (int i = 0; i < q; ++i) {
		int t;
		cin >> t;
		ll k;
		cin >> k;
		int plr = -1;
		if (t == 3) {
			cin >> plr;
			--plr;
		}
		asks[i] = ask(t, k, plr, i);
	}
	solve();
	for (int i = 0; i < q; ++i) {
		cout << res[i] << "\n";
	}
	return 0;
}