#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define int long long

const int inf = 1000000000;
void solve() {
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<vector<int>> g(n);
        for (int i = 0; i < m; ++i) {
            int a, b;
            cin >> a >> b;
            g[a - 1].push_back(b - 1);
            g[b - 1].push_back(a - 1);
        }
        assert(!(n == 2 && m != 1));
        if (n == 2) {
            cout << "-1 \n";
            continue;
        }
        deque<pair<int, int>> bfs;
        vector<vector<int>> dist(n, vector<int>(2, inf));
        dist[0][0] = 0;
        bfs.emplace_back(0, 0);
        while (!bfs.empty()) {
            auto nw = bfs.front();
            bfs.pop_front();
            for (auto to : g[nw.first]) {
                if (dist[nw.first][nw.second] + 1 < dist[to][nw.second ^ 1]) {
                    dist[to][nw.second ^ 1] = dist[nw.first][nw.second] + 1;
                    bfs.emplace_back(to,nw.second ^ 1);
                }
            }
        }
        for (int i = 1; i < n; ++i) {
            if (dist[i][0] == inf && dist[i][1] == inf) {
                cout << "-1 ";
            } else {
                cout << min(dist[i][1] + 3, dist[i][0]) << ' ';
            }
        }
        cout << '\n';
    }
}

signed main() {
#ifdef Debugg
    freopen(R"(C:\Users\roi\CLionProjects\untitled\ain.txt)", "r", stdin);
    freopen(R"(C:\Users\roi\CLionProjects\untitled\aout.txt)", "w", stdout);
#endif
    solve();
    return 0;
}
