#include <bits/stdc++.h>

using namespace std;

long long to_int(string xs) {
	long long res = 0;
	for (char c : xs) {
		res = res * 10 + c - '0';
	}
	return res;
}

string to_str(long long x, int n) {
	string res = "";
	for (int i = 0; i < n; ++i) {
		res.push_back('0' + x % 10);
		x /= 10;
	}
	reverse(res.begin(), res.end());
	return res;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);

	string xs;
	cin >> xs;
	
	int n = xs.size();
	
	long long x = to_int(xs);
	
	long long y;
	cin >> y;
	
	auto nxs = xs;
	sort(nxs.begin(), nxs.end());
	pair<long long, long long> best = {x, x};
	do {
		vector<vector<int>> p(10), np(10);
		for (int i = 0; i < n; ++i) {
			p[xs[i] - '0'].push_back(i);
			np[nxs[i] - '0'].push_back(i);
		}

		vector<int> q(n);
		for (int i = 0; i < 10; ++i) {
			for (int j = 0; j < p[i].size(); ++j) {
				q[p[i][j]] = np[i][j];
			}
		}

		long long invs = 0;
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < i; ++j) {
				if (q[j] > q[i]) {
					++invs;
				}
			}
		}
		best = max(best, make_pair(to_int(nxs) - y * invs, to_int(nxs)));
	} while (next_permutation(nxs.begin(), nxs.end()));

	cout << to_str(best.second, n) << endl;

	return 0;	
}