#include <bits/stdc++.h>

using namespace std;

string solve_small(string x, long long y) {
	int n = x.size();
	
	vector<__int128> pw(n);
	pw[0] = 1;
	for (int i = 1; i < n; ++i) {
		pw[i] = pw[i - 1] * 10;
	}

	vector<__int128> dp(1 << n);
	vector<int> par(1 << n, -1);

	dp[0] = 0;
	for (int mask = 1; mask < (1 << n); ++mask) {
		for (int i = 0; i < n; ++i) {
			if ((mask >> i) & 1) {
				__int128 val = dp[mask - (1 << i)] + __int128(x[i] - '0') * pw[n - __builtin_popcount(mask)];
				for (int j = i + 1; j < n; ++j) {
					if ((mask >> j) & 1) {
						val -= y;
					}
				}
				if (par[mask] == -1 || val > dp[mask]) {
					dp[mask] = val;
					par[mask] = i;
				}
			}
		}
	}

	string res = "";
	int mask = (1 << n) - 1;
	while (mask != 0) {
		res += x[par[mask]];
		mask -= (1 << par[mask]);
	}
	reverse(res.begin(), res.end());
	return res;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);

	string x;
	long long y;
	cin >> x >> y;

	int m = 20;

	if (x.size() <= m) {
		cout << solve_small(x, y) << endl;
		return 0;
	}

	int n = x.size();

	string xx = x;
	sort(xx.rbegin(), xx.rend());

	vector<int> cnt(20, 0);
	for (int i = 0; i < n - m; ++i) {
		++cnt[xx[i] - '0'];
	}

	string smallx = "";
	vector<int> cnt2(20, 0);
	for (int i = 0; i < n; ++i) {
		++cnt2[x[i] - '0'];
		if (cnt2[x[i] - '0'] > cnt[x[i] - '0']) {
			smallx += x[i];
		}
	}

	cout << xx.substr(0, m) << solve_small(smallx, y) << endl;

	return 0;	
}