#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

#define int long long
#define all(a) a.begin(), a.end()
#define pb push_back

using namespace std;

void solve() {
	string s, t;
	cin >> s >> t;
	int n = s.size(), m = t.size();
	if (n <= m) {
		cout << s << '\n';
		return;
	}
	multiset<int> was;
	for (auto c : s) {
		c -= '0';
		was.insert(c);
	}
	vector<int> res;
	vector<int> cnt(10);
	for (int i = 0; i < n - m; i++) {
		int j = *--was.end();
		was.erase(--was.end());
		res.pb(j);
		cnt[j]++;
	}
	for (int i = 0; i < n; i++) {
		if (!cnt[s[i] - '0'])
			res.pb(s[i] - '0');
		else
			cnt[s[i] - '0']--;
	}
	for (int i : res)
		cout << i;
	cout << '\n';
}

int32_t main() {
    cin.tie(0);
	cout.tie(0);
	ios::sync_with_stdio(false);

	solve();
}
