#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr int INF = 0x3f3f3f3f;

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t;
    cin >> t;
    while (t --> 0) {
        int n, m;
        cin >> n >> m;
        vector<int> graph[n];
        for (int i = 0; i < m; ++i) {
            int u, v;
            cin >> u >> v;
            --u, --v;
            graph[u].push_back(v);
            graph[v].push_back(u);
        }
        vector<vector<int>> ans(n, vector<int>(n, INF));
        ans[0][0] = 0;
        deque<pair<int, int>> bfs;
        bfs.push_back({0, 0});
        while (!bfs.empty()) {
            pair<int, int> front = bfs.front();
            bfs.pop_front();
            if (front.first != front.second) {
                for (int child : graph[front.first]) {
                    if (child == front.second) {
                        if (ans[front.first][front.first] == INF) {
                            ans[front.first][front.first] = ans[front.first][front.second] + 1;
                            bfs.push_back({front.first, front.first});
                        }
                    }
                    else {
                        if (ans[child][front.second] == INF) {
                            ans[child][front.second] = ans[front.first][front.second];
                            bfs.push_front({child, front.second});
                        }
                    }
                }
            }
            else {
                for (int child : graph[front.first]) {
                    if (ans[front.first][child] == INF) {
                        ans[front.first][child] = ans[front.first][front.second] + 1;
                        bfs.push_back({front.first, child});
                    }
                }
            }
        }
        for (int i = 1; i < n; ++i) {
            cout << (ans[i][i] == INF ? -1 : ans[i][i]) << ' ';
        }
        cout << '\n';
    }
    return 0;
}
