#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;
struct num {
	vector<int> d;
	num(vector<int> d) : d(d) {};
	num(int x) {
		d = {};
		while (x > 0) {
			d.push_back(x % 10);
			x /= 10;
		}
		reverse(d.begin(), d.end());
	}
	num(string x) {
		d = {};
		for (char c : x) {
			d.push_back(c - '0');
		}
	}
	num operator +(num num2) {
		vector<int> d1 = {};
		for (int i = 0; i < d.size() || i < num2.d.size(); ++i) {
			d1.push_back(0);
			if (i < d.size()) d1[d1.size() - 1] += d[d.size() - 1 - i];
			if (i < num2.d.size()) d1[d1.size() - 1] += num2.d[num2.d.size() - 1 - i];
		}
		int r = 0;
		for (int i = 0; i < d1.size(); ++i) {
			d1[i] += r;
			r = d1[i] / 10;
			d1[i] %= 10;
		}
		if (r) d1.push_back(r);
		reverse(d1.begin(), d1.end());
		return num(d1);
	}
	num operator -(num num2) {
		vector<int> d1 = {};
		for (int i = 0; i < d.size(); ++i) {
			d1.push_back(d[d.size() - 1 - i]);
			if (i < num2.d.size()) d1[d1.size() - 1] -= num2.d[num2.d.size() - 1 - i];
		}
		reverse(d1.begin(), d1.end());
		return num(d1);
	}
	num operator <<(int k) {
		vector<int> d1 = d;
		for (int i = 0; i < k; ++i) d1.push_back(0);
		return num(d1);
	}
	num operator *(long long z) {
		vector<int> d1 = d;
		reverse(d1.begin(), d1.end());
		for (int i = 0; i < d.size(); ++i) d1[i] *= z;
		long long r = 0;
		for (int i = 0; i < d1.size(); ++i) {
			d1[i] += r;
			r = d1[i] / 10;
			d1[i] %= 10;
		}
		while (r) {
			d1.push_back(r);
			r = d1.back() / 10;
			d1[d1.size() - 1] %= 10;
		}
		reverse(d1.begin(), d1.end());
		return num(d1);
	}
	bool operator >(num n2) {
		if (d.size() != n2.d.size()) return d.size() > n2.d.size();
		for (int i = 0; i < d.size(); ++i) {
			if (d[i] != n2.d[i]) return d[i] > n2.d[i];
		}
	}
};
long long to_ll(num n) {
	long long a = 0;
	for (int i = 0; i < n.d.size(); ++i) a = a * 10 + n.d[i];
	return a;
}
int main()
{
	const int k = 25;
	string x;
	long long y;
	cin >> x >> y;
	if (x.size() > k) {
		sort(x.begin(), x.end() - k);
		reverse(x.begin(), x.end() - k);
	}
	string x1 = x;
	if (x.size() > k) x = x.substr(x.size() - k, k);
	int n = x.size();
	
	for (int i = 0; i < n; ++i) {
		vector<pair<int, int>> z = {};
		for (int j = i; j < n; ++j) {
			z.push_back({ x[j] - '0', n - 1 - j });
		}
		sort(z.rbegin(), z.rend());
		for (int j = 0; j < z.size(); ++j) {
			z[j].second = n - 1 - z[j].second;
		}
		if (z[0].second == i) continue;
		vector<int> d1 = {}, d2 = {};
		for (int j = i; j < z[0].second; ++j) {
			d2.push_back(x[j] - '0');
			d1.push_back(z[0].first);
		}
		num n1 = num(d1), n2 = num(d2);
		if (((n1 - n2) * 9) << (n - 1 - z[0].second) > num(d1.size()) * y) {
			for (int j = z[0].second; j > i; --j) swap(x[j], x[j - 1]);
		}
		else break;
	}
	if (x1.size() < k) cout << x;
	else cout << x1.substr(0, x1.size() - k) + x;
}