#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>

typedef int_fast64_t ll;
typedef long double ld;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define input(a) for (auto& _ : a) cin >> _
#define print(a) for (auto _ : a) cout << _ << " "
#define int int_fast64_t

using namespace std;

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, q;
	cin >> n >> q;
	vector<int> a(n);
	vector<int> b;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		b.push_back(a[i]);
	}
	sort(all(b));
	b.erase(unique(all(b)), b.end());
	reverse(all(b));
	map<int, int> mp;
	int m = b.size();
	for (int i = 0; i < m; ++i)
		mp[b[i]] = i;
	vector<int> cl(n);
	for (int i = 0; i < n; ++i)
		cl[i] = mp[a[i]];
	vector<int> now(m);
	for (int i = 0; i < m; ++i)
		now[i] = i;
	vector<pair<int, int>> merges;
	for (int i = 1; i < m; ++i) {
		merges.push_back({ b[i - 1] - b[i], i });
	}
	merges.push_back({ 0, 0 });
	sort(all(merges));
	vector<tuple<int, int, int, int>> qs;
	for (int j = 0; j < q; ++j) {
		int t, k, i = 0;
		cin >> t >> k;
		if (t == 3)
			cin >> i;
		qs.push_back({ t,k,i,j });
	}
	vector<int> ans(q);
	sort(all(qs), [](tuple<int, int, int, int> a, tuple<int, int, int, int> b) {
		return get<1>(a) < get<1>(b);
		});
	int j = 1;
	int sum = 0;
	for (auto [t, k, i, id] : qs) {
		while (j < merges.size() && k >= merges[j].first) {
			for (int i = 0; i < n; ++i) {
				a[i] += now[cl[i]] * (merges[j].first - merges[j - 1].first);
				sum += now[cl[i]] * (merges[j].first - merges[j - 1].first);
			}
			auto [p, num] = merges[j];
			for (int h = m - 1; h >= num; --h)
				now[h]--;
			j++;
		}
		if (t == 1)
			ans[id] = now[m - 1] + 1;
		else if (t == 2) {
			int res = 0;
			for (int i = 0; i < n; ++i) 
				res += now[cl[i]] * (k - merges[j - 1].first);
			ans[id] = sum + res;
		}
		else {
			i--;
			ans[id] = a[i] + now[cl[i]] * (k - merges[j - 1].first);
		}
	}
	print(ans);
	return 0;
}