#include <cassert>
#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>

using namespace std;

#define all(a) (a).begin(), (a).end()

typedef long long ll;


struct At {
	int l, r, c, t;
};


signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

	int t;
	cin >> t;

	for (; t; t--) {
		int n, m;
		cin >> n >> m;

		vector < int > a(n);
		for (int i = 0; i < n; i++)
			cin >> a[i];

		vector < At > d(m);
		for (int i = 0; i < m; i++) {
			cin >> d[i].l >> d[i].r >> d[i].c >> d[i].t;

			d[i].l--;
			d[i].r--;
		}

		for (int x = 0; x < n; x++) {
			vector < vector < pair < int, int > > > cur(n);
			for (At el : d) {
				if (el.t) {
					el.l = min(el.l, x);
					el.r = max(el.r, x);
				}
				cur[el.l].push_back({ el.r, el.c });
			}

			ll res = 0;
			set < int > rt;
			vector < ll > cnt(n, 0);
			vector < int > cur_a = a, p(n + 1, -1);
			for (int i = 0; i < n; i++) {
				for (; p[0] != -1 && p[0] <= i; p[0] = p[p[0]])
					rt.erase(p[0] - 1);
				for (pair < int, int > el : cur[i]) {
					if (!rt.count(el.first)) {
						set < int > ::iterator it = rt.lower_bound(el.first);
						if (it != rt.end())
							p[el.first + 1] = *it + 1;
						else
							p[el.first + 1] = -1;

						if (it != rt.begin()) {
							it--;
							p[*it + 1] = el.first + 1;
						}
						else
							p[0] = el.first + 1;

						rt.insert(el.first);
					}
					cnt[el.first] += el.second;
				}

				for (; p[0] > -1 && cur_a[i] > 0; ) {
					int id = p[0] - 1;
					ll vl = cnt[id];

					if (cur_a[i] >= vl) {
						res += vl;
						cur_a[i] -= vl;
						rt.erase(p[0] - 1);
						cnt[id] = 0;
						p[0] = p[p[0]];
					}
					else {
						res += cur_a[i];
						cnt[id] -= cur_a[i];
						cur_a[i] = 0;
					}
				}
			}

			cout << res << " ";
		}
		cout << "\n";
	}

	return 0;
}
