#ifndef ONPC
#pragma GCC optimize("O3")
#pragma GCC target("avx2")
//#pragma GCC optimize("unroll-loops")
#endif

#include <iostream>
#include <iomanip>
#include <cmath>
#include <utility>
#include <algorithm>
#include <numeric>
#include <string>
#include <sstream>
#include <vector>
#include <stack>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <limits>
#include <random>
#include <functional>

using namespace std;
using ll = int64_t;
using ld = long double;
using vi = vector<int>;
using vll = vector<ll>;
using vc = vector<char>;
using vvi = vector<vi>;
using ii = pair<int,int>;
using vii = vector<ii>;

#define all(x) (x).begin(), (x).end()
#define endl '\n'

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vvi g(n);
        for (int i = 0; i < m; ++i) {
            int u, v;
            cin >> u >> v;
            --u, --v;
            g[u].push_back(v);
            g[v].push_back(u);
        }
        deque<int> q;
        vc used(n, false);
        vc useda(n, false);
        q.push_back(0);
        vi d(n, 2e9), da(n, 2e9);
        d[0] = 0;
        used[0] = true;
        while (!q.empty()) {
            int v = q.front();
            q.pop_front();
            for (int to : g[v]) {
                if (used[to]) {
                    if (d[to] % 2 == d[v] % 2) {
                        da[to] = min(da[to], d[v] + 1);
                        useda[to] = true;
                    }
                    if (useda[v] && d[to] % 2 == da[v] % 2) {
                        da[to] = min(da[to], da[v] + 1);
                        useda[to] = true;
                    }
                } else {
                    d[to] = d[v] + 1;
                    used[to] = true;
                    q.push_back(to);
                }
            }
        }
        for (int i = 1; i < n; ++i) {
            if (d[i] % 2 == 0) {
                cout << d[i] << ' ';
            } else if (useda[i] && da[i] % 2 == 0) {
                cout << da[i] << ' ';
            } else {
                cout << "-1 ";
            }
        }
        cout << endl;
    }
}