#pragma GCC optimize("Ofast")
#pragma GCC target("avx")
//
#include <iostream>
#include <bits/stdc++.h>
using namespace std;
#define ll long long
struct rob
{
    ll l, r, c, t;
};
void solve() {
    int n, m;
    cin >> n >> m;
    vector<ll> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    vector<rob> rb(m);
    for (int i = 0; i < m; ++i) {
        cin >> rb[i].l >> rb[i].r >> rb[i].c >> rb[i].t;
        rb[i].l--;
        rb[i].r--;
    }
    for (ll x = 0; x < n; ++x) {
        ll ans = 0;
        auto a0 = a;
        auto rb1 = rb;
        vector<vector<int>> add(n + 1), del(n + 1);
        for (int i = 0; i < m; ++i) {
            if (rb1[i].t == 1)
                rb1[i].l = min(rb1[i].l, x), rb1[i].r = max(rb1[i].r, x);
            add[rb1[i].l].push_back(i);
            del[rb1[i].r + 1].push_back(i);
        }
        set<pair<ll, ll>> setk;
        for (int i = 0; i < n; ++i) {
            for (auto u: add[i])
                setk.insert({rb1[u].r, u});
            for (auto u: del[i]) {
                setk.erase({rb1[u].r, u});
            }
            while (!setk.empty() && a0[i]) {
                auto u = *setk.begin();
                setk.erase(u);
                ll dd = min(a0[i], rb1[u.second].c);
                ans += dd;
                a0[i] -= dd;
                rb1[u.second].c -= dd;
                if (rb1[u.second].c != 0)
                    setk.insert(u);
            }
        }
        cout << ans << '\n';
    }
}
int main() {
    std::ios_base::sync_with_stdio(0), cin.tie(0);
    int q;
    cin>>q;
    while(q--)
    {
        solve();
    }
    return 0;
}