#include <bits/stdc++.h>

using namespace std;

struct Edge{
    int v,i;
    Edge(int v,int i):v(v),i(i){};

    Edge(){};
};

vector<vector<Edge> > g;
vector<vector<int> > g2;

vector<bool> used,used_edge;
bool dfs(int v,int end){
    if(v==end){
        return true;
    }
    used[v] = true;
    for(auto [to,id]:g[v]){
        if(used[to]||!used_edge[id]) continue;

        if(dfs(to,end)){
            return true;
        }
    }

    return false;
}

int main() {
    ios::ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef MY_DEBUG
    freopen("input.txt","r",stdin);
#endif

    int t;
    cin>>t;

    for(int _i=0;_i<t;_i++){
        int n,m;
        cin>>n>>m;
        g.assign(n,vector<Edge> ());

        for(int i=0;i<m;i++){
            int u,v;
            cin>>u>>v;
            u--;v--;

            g[u].push_back(Edge(v,i));
            g[v].push_back(Edge(u,i));
        }

        for(int i=1;i<n;i++){
            cout<<2<<" ";
        }
        cout<<endl;

    }

}
