#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int MAXN = 2e5 + 5;

vector<tuple<int, int, int, int>> robots;
vector<ll> a;
int n, m;

ll ans(vector<tuple<int, int, int>> bots) {
    set<pair<int, int>> open;
    sort(bots.begin(), bots.end());
    int ind = 0;
    ll ans = 0;
    for (int i = 0; i < n; i++) {
        while (ind < m && get<0>(bots[ind]) <= i) {
            auto[l, r, c] = bots[ind];
            open.insert({r, c});
            ind++;
        }
        ll cnt = 0;
        while (cnt < a[i] && !open.empty()) {
            auto[r, c] = *open.begin();
            open.erase(open.begin());
            if (r < i || c == 0)
                continue;
            if (a[i] - cnt > c) {
                cnt += c;
            } else {
                c -= (a[i] - cnt);
                cnt = a[i];
                open.insert({r, c});
            }
        }
        ans += cnt;
    }
    return ans;
}

void solve() {
    cin >> n >> m;
    robots.resize(m);
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < m; i++) {
        int l, r, c, t;
        cin >> l >> r >> c >> t;
        l--, r--;
        robots[i] = {l, r, c, t};
    }
    for (int i = 0; i < n; i++) {
        vector<tuple<int, int, int>> bots;
        for (auto[l, r, c, t]: robots) {
            if (t == 1) {
                bots.push_back({min(l, i), max(r, i), c});
            } else
                bots.emplace_back(l, r, c);
        }
        cout << ans(bots) << ' ';
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}
