#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MN = 25;
int tr[MN];

void change(int x, int delta)
{
    for (; x < MN; x |= x + 1)
    {
        tr[x] += delta;
    }
}

int get_sum(int r)
{
    int res = 0;
    for (; r >= 0; r = (r & (r + 1)) - 1)
    {
        res += tr[r];
    }
    return res;
}

int get_sum(int l, int r)
{
    return get_sum(r) - get_sum(l - 1);
}

int f(string s)
{
    int res = 0;
    for (char c : s)
    {
        res = res * 10 + c - '0';
    }
    return res;
}

int dist(vector<int> a)
{
    int n = a.size(), res = 0;
    for (int i = 0; i < n; i++)
    {
        res += get_sum(a[i], n);
        change(a[i], 1);
    }
    for (int i = 0; i < n; i++)
    {
        change(a[i], -1);
    }
    return res;
}

void solve()
{
    string num, temp;
    cin >> num >> temp;
    int y = f(temp);
    if (num.size() == 1)
    {
        cout << num << "\n";
        return;
    }
    int mx = f(num);
    string ans = num;
    int n = num.size();
    vector<int> p(n);
    iota(p.begin(), p.end(), 0);
    do {
        string now(n, '0');
        for (int i = 0; i < n; i++)
        {
            now[i] = num[p[i]];
        }
        int cost = f(now) - y * dist(p);
        if (cost > mx)
        {
            mx = cost;
            ans = now;
        }
        else if (cost == mx)
        {
            int x = 0;
            while (x < n && ans[x] == now[x])
            {
                x++;
            }
            if (ans[x] < now[x])
            {
                ans = now;
            }
        }
    } while (next_permutation(p.begin(), p.end()));
    cout << ans << "\n";
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
//    cout << dist({4, 1, 2, 3, 0});
    return 0;
}
