#include<bits/stdc++.h>

using namespace std;

//#define int long long
#define pii pair<int, int>
#define fi first
#define se second
#define forn(i, n) for (int i = 0; i < n; i++)
#define sz(x) (int) (x).size()
#define pb push_back
#define all(x) (x).begin(), (x).end()

void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> g(n);
	forn (i, m) {
		int x, y;
		cin >> x >> y;
		x--, y--;
		g[x].pb(y);
		g[y].pb(x);
	}
	vector<vector<int>> dp(n, vector<int> (n, 1e18));
	deque<pii> tmp;
	for (auto x : g[0]) {
		dp[0][x] = 2;
		tmp.pb({0, x});
	}
	vector<int> used(n);
	int k = 1000;
	if (n > 1000) k = 600;
	while (sz(tmp)) {
		int v, c;
		tie(v, c) = tmp.front();
		tmp.pop_front();
		if (used[v] >= k) continue;
		used[v]++;
		for (auto u : g[v]) {
			if (u != c) {
				if (dp[u][c] > dp[v][c]) {
					dp[u][c] = dp[v][c];
					tmp.push_front({u, c});
				}
			} else {
				for (auto c2 : g[v]) {
					if (c2 != c) {
						if (dp[v][c2] > dp[v][c] + 2) {
							dp[v][c2] = dp[v][c] + 2;
							tmp.pb({v, c2});
						}
					}
				}
			}
		}
	}
	forn (i, n) {
		if (!i) continue;
		int ans = 1e18;
		for (auto j : g[i]) {
			ans = min(ans, dp[i][j]);
		}
		if (ans == (int) 1e18) {
			cout << -1 << " ";
		} else {
			cout << ans << " ";
		}
	}
	cout << '\n';
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}
