#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;

//#define int long long

const int SIZE = 5010;
const int SIZE2 = 3e5 + 10;
const int INF = 1e9 + 9;
const long long INFL = 1e18 + 9;

int used[SIZE];
vector <int> g[SIZE];
vector <vector <int> > ng[SIZE];

int timer = 1;

void DFS(int v)
{
    used[v] = timer;
    for (int to : g[v])
    {
        if (used[to] < timer)
        {
            DFS(to);
        }
    }
}

void Calc(int v)
{
    used[v] = INF;
    int t = timer;
    for (int to : g[v])
    {
        if (used[to] < t)
        {
            DFS(to);
            timer++;
        }
    }
    used[v] = timer - 1;
    ng[v].resize(timer - t);
    for (int to : g[v])
    {
        ng[v][used[to] - t].push_back(to);
    }
}

int dp[SIZE];

void update(int v)
{
    for (int i = 0; i < ng[v].size(); ++i)
    {
        int m = INF;
        for (int to : ng[v][i])
        {
            m = min(m, dp[to]);
        }
        for (int to : ng[v][i])
        {
            dp[to] = min(m + 2, dp[to]);
        }
    }
}

signed main()
{
//    freopen("C:\\Users\\roi\\CLionProjects\\zad1\\input.txt", "r", stdin);

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    while (t --> 0)
    {
        timer = 1;
        for (int i = 0; i < SIZE; ++i)
        {
            g[i].clear();
            used[i] = 0;
            ng[i].clear();
            dp[i] = INF;
        }

        int n, m;
        cin >> n >> m;
        for (int i = 0; i < m; ++i)
        {
            int u, v;
            cin >> u >> v;
            u--; v--;
            g[u].push_back(v);
            g[v].push_back(u);
        }

        for (int i = 0; i < n; ++i)
        {
            Calc(i);
        }
        dp[0] = 0;
        for (int i = 0; i < n; ++i)
        {
            for (int j = 0; j < n; ++j)
            {
                update(j);
            }
        }

        for (int i = 1; i < n; ++i)
        {
            cout << (dp[i] == INF ? -1 : dp[i]) << ' ';
        }
        cout << '\n';
    }

    return 0;
}