#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <deque>

using namespace std;

#define long long long int

void solve() {
    int n, m;
    cin >> n >> m;
    if (m == 1) {
        vector<int> a(n);
        for (int i = 0;i < n;i++) cin >> a[i];
        int l, r, c, t;
        cin >> l >> r >> c >> t;
        if (t == 0) {
            long res = 0;
            for (int i = l - 1;i < r;i++) {
                if (c >= a[i]) {
                    c -= a[i];
                    res += a[i];
                }
                else {
                    res += c;
                }
            }
            for (int i = 0;i < n;i++) cout << res << " ";
            cout << endl;
        }
        else {
            vector<long> ans;
            for (int i = 0;i < n;i++) {
                long res = 0;
                for (int i = min(i, l - 1);i < max(i + 1, r);i++) {
                    if (c >= a[i]) {
                        c -= a[i];
                        res += a[i];
                    }
                    else {
                        res += c;
                    }
                }
                ans[i] = res;
            }
            for (auto i : ans) cout << i << " ";
            cout << endl;
        }
    }
    else {
        cout << "Ievieviev";
    }
}

int main() {
    int t;
    cin >> t;
    while (t--) solve();
}
