#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
using namespace std;

#define SZ(sp) int((sp).size())
#define mp make_pair
#define all(sp) sp.begin(), sp.end()
#define rall(sp) sp.rbegin(), sp.rend()

using ll = long long;

#define int ll

void solve() {
    ll y;
    string s;
    cin >> s >> y;
    int n = SZ(s);
    vector < ll > arr(n);
    set < pair < ll, int >, greater < pair < ll, int > > > mas;
    for (int i = 0; i < n; ++i) {
        arr[i] = s[i] - '0';
        mas.insert(mp(arr[i], i));
    }
    vector < __int128 > sp(25);
    sp[0] = 1;
    for (int i = 1; i < 25; ++i) {
        sp[i] = sp[i - 1] * 10;
    }
    while (!mas.empty()) {
        auto p = *mas.begin();
        mas.erase(mas.begin());
        for (int i = 0; i < p.second; ++i) {
            if (arr[i] >= p.first) {
                continue;
            }
            __int128 a = y * (p.second - i);
            __int128 ch1 = 0;
            __int128 ch2 = 0;
            for (int j = 0; j < n; ++j) {
                if (j == i) {
                    ch1 += p.first * sp[n - j - 1];
                } else if (i < j && j <= p.second) {
                    ch1 += arr[j - 1] * sp[n - j - 1];
                } else {
                    ch1 += arr[j] * sp[n - j - 1];
                }
                ch2 += arr[j] * sp[n - j - 1];
            }
            if (ch1 - a >= ch2) {
                for (int j = p.second; j > i; --j) {
                    if (mas.count(mp(arr[j - 1], j - 1))) {
                        mas.erase(mp(arr[j - 1], j - 1));
                        mas.insert(mp(arr[j - 1], j));
                    }
                    arr[j] = arr[j - 1];
                }
                arr[i] = p.first;
                break;
            }
        }
    }
    for (auto &el : arr) {
        cout << el;
    }
    //cout << endl;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt=1;
    while (tt--) {
        solve();
    }
    return 0;
}
