#include <bits/stdc++.h>
using namespace std;

#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;

//#define int long long

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

template<typename T> using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

#define ff first
#define ss second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define print(x) {for(auto &__val: x) cout << __val << ' '; cout << '\n';}

ll st[19] = {};


int cost(const string &x, const string &y) {
    vector<deque<int>> ind(10);
    ordered_set<pii> q;
    int n = (int)y.size();
    for(int i=0;i<n;i++) {
        q.insert({i, y[i] - '0'});
        ind[y[i] - '0'].pb(i);
    }
    int cst = 0;
    for(auto &i: x) {
        int tmp = i - '0';
        int pos = ind[tmp].front();
        int cnt = (int)q.order_of_key({pos, tmp});
        cst += cnt;
        q.erase({pos, tmp});
        ind[tmp].pop_front();
    }
    return cst;
}

ll cost(const string &x) {
    ll res = 0;
    int n = (int)x.size();
    for(int i=0;i<n;i++) res += st[n-i-1] * (x[i] - '0');
    return res;
}

string stupid(string s, ll y) {
    string ans = s;
    ll cst = cost(s);
    string cps = s;
    sort(all(cps));
    do{
        ll tmp = cost(cps) - y * cost(cps, s);
        if(tmp > cst || (tmp == cst && cps > ans)) {
            cst = tmp;
            ans = cps;
        }
    }while(next_permutation(all(cps)));
    return ans;
}

string clever(string s, ll y) {
    ordered_set<pii> q;
    vector<vector<int>> ind(10);
    int n = (int)s.size();
    for(int i=0;i<n;i++) {
        q.insert({i, s[i] - '0'});
        ind[s[i] - '0'].pb(i);
    }
    string ans;
    for(int j=9;j>=0;j--) {
        for(auto &i: ind[j]) {
            int cnt = (int)q.order_of_key({i, j});
            if(cnt > 17 || n - 1 - (int)ans.size() > 17) {
                ans += char('0' + j);
                q.erase({i, j});
                continue;
            }
            ll sum = 0;
            int tmp = n - (int)ans.size() - 1;
            for(auto &v: q) {
                if(v == pii{i, j}) break;
                sum += st[tmp] * v.ss;
                tmp--;
            }
            if(j * (st[n - 1 - (int)ans.size()] - st[n - 1 - (int)ans.size() - cnt]) + sum / 10 - sum >= cnt * y) {
                ans += char('0' + j);
                q.erase({i, j});
            } else {
                break;
            }
        }
    }
    for(auto &i: q) ans += char('0' + i.ss);
    return ans;
}

void solve() {
    st[0] = 1;
    for(int i=1;i<19;i++) st[i] = st[i-1] * 10ll;
    string s;
    cin >> s;
    ll y;
    cin >> y;
    cout << stupid(s, y) << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    int t = 1;
    //cin >> t;
    while(t--) {
        solve();
    }
}