#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>

using namespace std;

typedef long long ll;
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

//#define int ll

vector<int> from(ll x) {
	vector<int> res;
	while (x > 0) {
		res.emplace_back(x % 10);
		x /= 10;
	}
	reverse(all(res));
	return res;
}

ll to(vector<int>& x) {
	ll res = 0;
	for (auto& i : x)
		res = res * 10 + i;
	return res;
}

vector<int> rev(int i, int j, vector<int>& it) {
	vector<int> itt;
	itt.reserve(it.size());
	for (int k = 0; k < it.size(); ++k) {
		if (k == i) {
			itt.emplace_back(it[j]);
			continue;
		}
		if (k > i) {
			if (k - 1 >= j) itt.emplace_back(it[k]);
			else itt.emplace_back(it[k - 1]);
		}
		else
			itt.emplace_back(it[k]);
	}
	return itt;
}

ll cost(int i, int j, vector<int> x, ll y) {
	ll res = -y * (j - i) - to(x);
	auto itt = rev(i, j, x);
	res += to(itt);
	return res;
}

const int len = 14;

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	cin.tie(0);
	ios_base::sync_with_stdio(false);
#endif
	vector<int> x;
	ll y;
	string s;
	cin >> s;
	for (auto& i : s)
		x.emplace_back(i - '0');
	vector<int> ans;
	vector<pair<int, int>> aa;
	int n = x.size();
	int mx = 0;
	for (int i = n - 1; i >= max(0, n - len); --i) {
		aa.emplace_back(x[i], i);
		if (x[i] > mx) {
			mx = x[i];
		}
	}
	for (int i = n - len - 1; i >= 0; --i) {
		if (mx > x[i]) {
			vector<pair<int, int>> na;
			for (int j = 0; j < len; ++j) {
				if (aa[j].first == mx) {
					mx = -1;
					continue;
				}
				na.emplace_back(aa[j]);
			}
			na.emplace_back(x[i], i);
			aa = na;
			for (auto& i : aa)
				mx = max(mx, i.first);
		}
	}
	reverse(all(aa));
	vector<int> a;
	for (auto& i : aa)
		a.emplace_back(i.first);
	cin >> y;
	bool f = 1;
	int cnt = -1;
	n = a.size();
	while (f) {
		++cnt;
		f = 0;
		ll mx = 0, im = 0, jm = 0;
		for (int i = 0; i < n; ++i) {
			for (int j = i + 1; j < n; ++j) {
				ll cst = cost(i, j, a, y);
				if (cst >= mx) {
					f = 1;
					mx = cst;
					im = i, jm = j;
				}
			}
		}
		a = rev(im, jm, a);
	}
	set<int> used;
	for (auto& i : aa)
		used.emplace(i.second);
	vector<int> last;
	for (int i = 0; i < x.size(); ++i) {
		if (!used.count(i))
			last.emplace_back(x[i]);
	}
	sort(rall(last));
	for (auto& i : last)
		cout << i;
	for (auto& i : a)
		cout << i;
	return 0;
}