#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#define int long long
using namespace std;
map<int, int> new_ch;
auto cmp = [](pair<long long, long long> left, pair<long long, long long> right) { return left.first > right.first; };
int get_new(int i){
    if(new_ch[i] == i) return i;
    new_ch[i] = get_new(new_ch[i]);
    return new_ch[i];
}
signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, q;
    cin >> n >> q;
    vector<long long> a(n);
    for(int i = 0; i < n; ++i) cin >> a[i];
    vector<long long> izn = a;
    set<long long> s;
    std::sort(a.begin(), a.end());
    for(auto i: a) s.insert(i);
    map<long long, int> mb;
    map<long long, int> mr;
    map<long long, int> mm;
    vector<long long> dop(s.size());
    int j = 0;
    for(auto i: s){
        dop[j] = i;
        j++;
    }
    std::sort(dop.begin(), dop.end());
    for(int i = 0; i < dop.size(); ++i){
        mb[dop[i]] = dop.size() - i - 1;
        mr[dop[i]] = 0;
        mm[dop[i]] = -1;
    }
    for(auto i: a){
        mr[i]++;
    }
    for(int i = 0; i < n; ++i){
        if(mm[a[i]] == -1) mm[a[i]] = i;
    }
    vector<pair<long long, long long>> r(dop.size() - 1);
    for(int i = 0; i < dop.size() - 1; ++i){
        r[i] = {dop[i + 1] - dop[i], dop[i]};
    }
    priority_queue<pair<long long, long long>, vector<pair<long long, long long>>, decltype(cmp)> rr(cmp, r);
    vector<tuple<long long, pair<int, int>, int>> questions;
    bool fl = false;
    for(int i = 0; i < q; ++i){
        int t;
        cin >> t;
        if(t == 1 or t == 2){
            int k;
            cin >> k;
            questions.push_back({k, {t, 0}, i});
        }
        else{
            int k, j;
            cin >> k >> j;
            questions.push_back({k, {t, j}, i});
            fl = true;
        }
    }
    std::sort(questions.begin(), questions.end());
    long long prov_round = 0;
    long long sum_prib1 = 0;
    for(int i = 0; i < dop.size(); ++i){
        sum_prib1 += mr[dop[i]]  * mb[dop[i]];
    }
    long long sum_prib = 0;
    vector<long long> ans(q);
    map<long long, int> prib;
    for(auto i: s){
        prib[i] = 0;
    }
    for(auto i: s){
        new_ch[i] = i;
    }
    for(auto i: questions){
        while(rr.size() > 0){
            auto j = rr.top();
            if(get<0>(i) < j.first){
                int dd = get<0>(i) - prov_round;
                sum_prib += sum_prib1 * (get<0>(i) - prov_round);
                prov_round = get<0>(i);
                int di = 0;
                if(fl) {
                    for (auto ch: s) {
                        prib[ch] += (s.size() - di - 1) * dd;
                        di++;
                    }
                }
                if(get<1>(i).first == 1){
                    ans[get<2>(i)] = rr.size() + 1;
//                    cout << rr.size() + 1 << '\n';
                }
                else if(get<1>(i).first == 2){
                    ans[get<2>(i)] = sum_prib;
//                    cout << sum_prib;
                }
                else {
                    int x = get_new(izn[get<1>(i).second - 1]);
                    ans[get<2>(i)] = x + prib[x];
                }
                break;
            }
            else{
                int dd = j.first - prov_round;
                sum_prib += sum_prib1 * (j.first - prov_round);
                prov_round = j.first;
                rr.pop();
                int di = 0;
                if(fl){
                    for(auto ch: s){
                        prib[ch] += (s.size() - di - 1) * dd;
                        di++;
                    }
                    new_ch[j.second] = abc;
                }

                s.erase(j.second);
                int abc = j.first + j.second;
                mr[abc] += mr[j.second];
                sum_prib1 -= mm[abc];
                mm[abc] -= mr[j.second];
                mr[j.second] = 0;

            }
        }
        if(rr.size() == 0){
            if(get<1>(i).first == 1){
                ans[get<2>(i)] = rr.size() + 1;
//                    cout << rr.size() + 1 << '\n';
            }
            else if(get<1>(i).first == 2){
                ans[get<2>(i)] = sum_prib;
//                    cout << sum_prib;
            }
            else {
                int x = get_new(izn[get<1>(i).second - 1]);
                ans[get<2>(i)] = x + prib[x];
            }
        }
    }
    for(auto i: ans) cout << i << '\n';
}
