#include<bits/stdc++.h>
#define int long long
#define p pair<int, int>
#define endl '\n'
const int INF = 1000000001;

using namespace std;

vector<vector<int>> d;
vector<bool> was;

void DFS(int vertex) {
    was[vertex] = true;
    for (int q : d[vertex]) {
        if (!was[q]) {
            DFS(q);
        }
    }
}

vector<int> BFS(int vertex) {
    int n = d.size();
    vector<int> dist1(n, INF);
    vector<map<int, int>> dist0(n);
    for (int q = 0; q < n; q++) {
        for (int q1 : d[q]) {
            dist0[q][q1] = INF;
        }
    }
    queue<pair<int, p>> a;
    a.push({vertex, {1, -1}});
    dist1[vertex] = 0;
    while (!a.empty()) {
        int q = a.front().first, type = a.front().second.first, me = a.front().second.second;
        a.pop();
        if (type == 0) {
            was.assign(n, false);
            was[q] = true;
            DFS(me);
            for (int q1 : d[q]) {
                if (dist1[q1] == INF && was[q1]) {
                    dist1[q1] = dist0[q][me]+1;
                    a.push({q1, {1, -1}});
                }
            }
        } else {
            for (int q1 : d[q]) {
                if (dist0[q1][q] == INF) {
                    dist0[q1][q] = dist1[q]+1;
                    a.push({q1, {0, q}});
                }
            }
        }
    }
    return dist1;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t1;
    cin >> t1;
    for (int q11 = 0; q11 < t1; q11++) {
        int n, m;
        cin >> n >> m;
        d.assign(n, {});
        for (int q = 0; q < m; q++) {
            int x, y;
            cin >> x >> y;
            x--, y--;
            d[x].push_back(y);
            d[y].push_back(x);
        }
        vector<int> dist = BFS(0);
        dist.erase(dist.begin());
        for (int q : dist) {
            cout << (q == INF ? -1 : q) << ' ';
        }
        cout << endl;
    }
    return 0;
}
