#include <bits/stdc++.h>
// #pragma GCC optimize("Ofast")
  
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
  
using namespace std;

void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> G(n);
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		G[a - 1].emplace_back(b - 1);
		G[b - 1].emplace_back(a - 1);
	}
	vector<vector<int>> dist(n, vector<int> (n, -1));
	dist[0][0] = 0;
	deque<pair<int, int>> q;
	q.emplace_back(0, 0);
	while (q.size()) {
		auto [a, b] = q.front();
		q.pop_front();
		for (int i : G[a]) {
			if (a != b && i != b && dist[i][b] == -1) {
				q.emplace_front(i, b);
				dist[i][b] = dist[a][b];
			}
			if (a == b && dist[a][i] == -1) {
				q.emplace_back(a, i);
				dist[a][i] = dist[a][b] + 1;
			}
			if (i == b && dist[a][a] == -1) {
				q.emplace_back(a, a);
				dist[a][a] = dist[a][b] + 1;
			}
		}
	}
	for (int i = 1; i < n; ++i) {
		cout << dist[i][i] << ' ';
	}
	cout << '\n';
}

int main() {
    #ifndef LOCAL
        ios_base::sync_with_stdio(0);
        cin.tie(0);
    #endif

	int t;
	cin >> t;
	while (t--)
		solve();
}