//#pragma GCC optimize("O3,unroll-loops,rename-register,rename-registers,fast-math")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,avx,avx2")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

#define int long long

using ll = long long;
#define all(a) a.begin(), a.end()
using pii = std::pair<int, int>;
const ll INFLL = 0x3f3f3f3f3f3f3f3f;

ll pow(ll p) {
    ll a = 1;
    while (p--) a *= 10;
    return a;
}

struct query {
    int type, k, i, ind;

    query() = default;
};

struct robot {
    int l, r, c, t;

    robot() = default;

    bool operator<(const robot &ro) const {
        return r < ro.r;
    }
};

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);

    std::string s;
    std::cin >> s;
    ll y;
    std::cin >> y;
    std::reverse(all(s));
    int n = s.size();
    for (int i = n - 1; i >= 0; i--) {
        pii best = std::make_pair(-INFLL, i);
        for (int j = 0; j < i; j++) {
            ll add = -y * (i - j);
            add -= (s[j] - '0') * pow(j);
            add += (s[j] - '0') * pow(i);
            ll num = 0;
            for (int k = i; k > j; k--) num = num * 10 + (s[k] - '0');
            add -= num * pow(j + 1);
            add += num * pow(j);
            if (add > best.first || (add == best.first && s[j] > s[best.second])) {
                best = std::make_pair(add, j);
            }
        }
        if (best.first < 0 || (best.first == 0 && s[best.second] > s[i])) continue;
        for (int k = best.second; k < i; k++) {
            std::swap(s[k], s[k + 1]);
        }
    }
    std::reverse(all(s));
    std::cout << s << '\n';
}
