#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<ll> v64;
typedef vector<v64> vv64;
typedef pair<ll,ll> p64;
typedef vector<p64> vp64;
typedef vector<vp64> vvp64;

#define forn(i,n) for(ll i = 0;i < n;i++)
#define forsn(i,a,n) for(ll i = a;i < n;i++)
#define all(v) v.begin(),v.end()
#define fast_cin() ios_base::sync_with_stdio(false);cin.tie(NULL);cout.tie(NULL)
#define ln '\n'

const ll INF = 2e18;

vv64 gr;
v64 dist;
vector<bool> canPut;
vector<bool> used;
vector<bool> used2;

void bfs(){
    queue<pair<ll,pair<ll,bool>>> q;
    q.push({0,{0,false}});
    while (!q.empty()){
        ll v = q.front().first;
        ll len = q.front().second.first;
        bool can = q.front().second.second;
        if(can){
            canPut[v] = true;
            dist[v] = len;
        }
        q.pop();
        for(auto u : gr[v]){
            if(!can && !used[u]){
                q.push({u,{len+1,!can}});
                used[u] = true;
            }
            else if(can && !used2[u]){
                q.push({u,{len+1,!can}});
                used2[u] = true;
            }
        }
    }
}

bool dfs(ll v,ll need,vector<bool> &usd){
    usd[v] = true;
    if(v == need){
        return true;
    }

    for(auto u : gr[v]){
        if(!usd[u]){
            bool a = dfs(u,need,usd);
            if(a) return a;
        }
    }
    return false;
}

void bfs2(){
    queue<pair<ll,pair<ll,bool>>> q;
    q.push({0,{0,false}});
    while (!q.empty()){
        ll v = q.front().first;
        ll len = q.front().second.first;
        bool can = q.front().second.second;
        if(can){
            canPut[v] = true;
            dist[v] = len;
        }
        q.pop();
        for(auto u : gr[v]){
            if(!can && !used[u]){
                q.push({u,{len+1,!can}});
                used[u] = true;
            }
            else if(can && !used2[u]){
                vector<bool> usd(5000,false);
                usd[v] = true;
                if(dfs(0,u,usd)) {
                    q.push({u, {len + 1, !can}});
                    used2[u] = true;
                }
            }
        }
    }
}

int main() {
    fast_cin();
    ll t;
    cin >> t;
    while (t--){
        ll n,m;
        cin >> n >> m;
        gr.assign(n,{});
        used.assign(n,false);
        used2.assign(n,false);
        canPut.assign(n,false);
        dist.assign(n,0);
        forn(i,m){
            ll a,b;
            cin >> a >> b;
            --a;
            --b;
            gr[a].push_back(b);
            gr[b].push_back(a);
        }

        if(n <= 5000){
            bfs2();
            forsn(i,1,n){
                ll ans = INF;
                for(auto u : gr[i]){
                    if(canPut[u]){
                        vector<bool> usd(n,false);
                        usd[u] = true;
                        if(dfs(0,i,usd)) ans = min(ans,dist[u]+1);
                    }
                }
                if(ans == INF){
                    cout << -1 << " ";
                }
                else{
                    cout << ans << " ";
                }
            }
            cout << ln;

            continue;
        }

        bfs();

        forsn(i,1,n){
            ll ans = INF;
            for(auto u : gr[i]){
                if(canPut[u]){
                    ans = min(ans,dist[u]+1);
                }
            }
            if(ans == INF){
                cout << -1 << " ";
            }
            else{
                cout << ans << " ";
            }
        }
        cout << ln;
    }
    return 0;
}
