#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}

#define int long long

const int N = 3e5 + 100, K = 8, INF = 1e18;

int n, q, c[N];

void solve() {
    cin >> n >> q;
    map<int, int> ma;
    int sad = 0;
    for (int i = 0; i < n; i++) {
        cin >> c[i];
        ma[c[i]]++;
    }
    int u = (int) ma.size(), sum = 0;
    vector<int> e, pref;
    e.reserve(u);
    for (auto it : ma) {
        e.push_back(it.first);
        pref.push_back(sum);
        sad += sum;
        sum += it.second;
    }
    pref.push_back(sum);
    vector<pair<int, int>> mm;
    for (int i = 0; i < u - 1; i++) {
        mm.emplace_back(e[i + 1] - e[i], i + 1);
    }
    sort(mm.begin(), mm.end());
    int ms = u - 1;
    vector<int> pans(ms), nad(ms);
    int cans = 0, cad = sad, last = 0;
    for (int i = 0; i < ms; i++) {
        cans += cad * (mm[i].first - last);
        last = mm[i].first;
        cad -= pref[mm[i].second];
        pans[i] = cans;
        nad[i] = cad;
    }
    for (int qq = 0; qq < q; qq++) {
        int t, k;
        cin >> t >> k;
        if (t == 1) {
            int l = -1, r = (int) mm.size();
            while (l + 1 < r) {
                int m = (r + l) / 2;
                if (mm[m].first > k) {
                    r = m;
                } else {
                    l = m;
                }
            }
            cout << u - l - 1 << '\n';
        } else if (t == 2) {
            int ans = -1;
            for (int i = ms - 1; i >= 0; i--) {
                if (mm[i].first <= k) {
                    ans = pans[i] + (k - mm[i].first) * nad[i];
                    break;
                }
            }
            if (ans == -1) {
                ans = sad * k;
            }
            cout << ans << '\n';
        } else {
            int pos;
            cin >> pos;
            pos--;
            cout << -1 << '\n';
        }
    }
}