#include <bits/stdc++.h>
#define int long long
#pragma GCC optimize("unroll-loops")

using namespace std;

int n, m;
vector<vector<int>> g;
vector<vector<int>> ng;
vector<int> us;
vector<bool> bad;
vector<int> tin;
vector<int> fup;
vector<int> color;
int tim = 0;
const int INF = 1e9;

void bads(int v, int par) {
    tin[v] = tim++;
    fup[v] = tin[v];
    us[v] = false;
    int child = 0;
    bool cond = true;
    for (auto u : g[v]) {
        if (u == par) {
            continue;
        }
        if (!us[u]) {
            fup[v] = min(fup[v], tin[u]);
        } else {
            bads(u, v);
            fup[v] = min(fup[v], fup[u]);
            child++;
            if (fup[u] < tin[v]) {
                cond = false;
            }
        }
    }
    if (par == v && child != 1) {
        bad[v] = true;
    }
    if (par != v && child > 0) {
        bad[v] = cond;
    }
}

void dfs(int v, int depth, int beg, bool throws = false) {
    if (depth == 1 && !us[v]) {
        return;
    }
    if (depth == 1 && bad[v]) {
        throws = true;
    }
    if (depth == 2) {
        if ((color[v] == color[beg] && !bad[beg] || !throws) && v != beg) {
            ng[beg].push_back(v);
        }
        return;
    }
    us[v] = false;
    for (auto u : g[v]) {
        dfs(u, depth + 1, beg, throws);
    }
}

void cdfs(int v, int c) {
    us[v] = false;
    if (bad[v]) {
        return;
    }
    color[v] = c;
    for (auto u : g[v]) {
        if (us[u]) {
            cdfs(u, c);
        }
    }
}

void solve() {
    cin >> n >> m;
    g.assign(n, vector<int>());
    ng.assign(n, vector<int>());
    bad.assign(n, false);
    tin.assign(n, 0);
    fup.assign(n, 0);
    color.assign(n, -1);
    tim = 0;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    us.assign(n, true);
    bads(0, 0);
    for (int i = 0; i < n; ++i) {
        if (!bad[i] && color[i] == -1) {
            us.assign(n, true);
            cdfs(i, i);
        }
    }
    for (int i = 0; i < n; ++i) {
        us.assign(n, true);
        dfs(i, 0, i);
    }
    vector<int> d(n, INF);
    queue<int> q;
    q.push(0);
    d[0] = 0;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto u : ng[v]) {
            if (d[u] > d[v] + 2) {
                d[u] = d[v] + 2;
                q.push(u);
            }
        }
    }
    for (int i = 1; i < n; ++i) {
        int p = d[i];
        if (p == INF) {
            cout << -1 << " ";
        } else {
            cout << p << " ";
        }
    }
    cout << "\n";
    // for (auto raw : ng) {
    //     for (auto p : raw) {
    //         cout << p << " ";
    //     }
    //     cout << "\n";
    // }
    // for (auto p : bad) {
    //     cout << p << " ";
    // }
    // cout << "\n";
    // for (auto p : color) {
    //     cout << p << " ";
    // }
    // cout << "\n";
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    for (cin >> t; t; --t) {
        solve();
    }
}