#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

const int N = 3e5 + 5;

struct dsu {
    int p[N];

    int get(int i) {
        if (p[i] == i) return i;
        int res = get(p[i]);
        p[i] = res;
        return res;
    }

    void join(int a, int b) {
        a = p[a];
        b = p[b];
        if (a != b) {
            if (rand() % 2) p[a] = b;
            else p[b] = a;
        }
    }
};

int diff[N];
int new_index[N];
map<int, vector<int>> positions;
ll cost[N];

vector<pair<pair<pll, int>, int>> queries;
ll ans[N];

int main() {

    int n, q; cin >> n >> q;
    int groups_cnt = n;
    ll accumulated_add = 0;

    vector<pair<ll, int>> arr;
    for (int i = 0; i < n; ++i) {
        ll c; cin >> c;
        arr.emplace_back(c, i);
    }
    sort(arr.begin(), arr.end());

    ll mx = arr.back().first;

    for (int i = 0; i < n; ++i) {
        new_index[arr[i].second] = i;
        cost[i] = arr[i].first;
        if (i < n - 1) {
            diff[i] = arr[i + 1].first - arr[i].first;
            if (diff[i] == 0) --groups_cnt;
        }
    }

    for (int i = 0; i < q; ++i) {
        int t; cin >> t;
        if (t == 3) {
            ll k, ind; cin >> k >> ind; --ind;
            queries.push_back({{{k, ind}, 3}, i});
        }
        else {
            ll k; cin >> k;
            queries.push_back({{{k, -1}, t}, i});
        }
    }
    sort(queries.begin(), queries.end());

    ll cur_k = 0;
    for (int t = 0; t < q; ++t) {
        while (queries[t].first.first.first > cur_k) {
            int gs = 1;
            int add = 0;
            for (int i = n - 1; i >= 0; --i) {
                if (diff[i] != 0) {
                    accumulated_add += add * gs;
                    ++add;
                    gs = 1;
                }
                else ++gs;
            }
            accumulated_add += gs * add;
            for (int i = 0; i < n - 1; ++i) {
                if (diff[i] > 0) {
                    diff[i]--;
                    if (diff[i] == 0) --groups_cnt;
                }
            }
            ++cur_k;
        }
        int ind = queries[t].second;
        if (queries[t].first.second == 1) {
            ans[ind] = groups_cnt;
        }
        else if (queries[t].first.second == 2) {
            ans[ind] = accumulated_add;
        }
        else {
            ll res = mx;
            int idx = queries[t].first.first.second;
            idx = new_index[idx];
            for (int i = n - 2; i > idx - 1; --i) {
                res -= diff[i];
            }
            ans[ind] = res;
        }
    }

    for (int i = 0; i < q; ++i) cout << ans[i] << '\n';

    return 0;
}
