#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

vector<vector<int>> g;
bool used[500002];

int main(){
    int t;
    cin >> t;
    for(int iter = 0; iter < t; ++iter){
        int n, m, u, v;
        cin >> n >> m;
        g.clear();
        g.resize(n);
        for(int i =0; i < m; ++i){
            cin >> u >> v; --u; --v;
            g[u].push_back(v);
            g[v].push_back(u);
        }
        for(int i = 0; i < n; ++i){
            used[i] = false;
        }
        vector<pair<int, long long>> bfs;
        vector<int> ans;
        ans.resize(n-1, -1);
        bfs.push_back({0, 0});
        used[0] = true;
        int y = 0, cur;
        while(y != bfs.size()){
            for(int i : g[bfs[y].first]){
                for(int x : g[i]){
                    if(!used[x]){
                        used[x] = true;
                        ans[x-1] =  bfs[y].second+2;
                        bfs.push_back({x, bfs[y].second+2});
                    }
                }
            }
            ++y;
        }
        for(int i : ans){
            cout << i << ' ';
        }
        cout << '\n';
    }
}
