#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <algorithm>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
#include <cmath>

using namespace std;

using ll = long long;
using ld = long double;

ll y, n;

inline ll count(const string& now, string start) {
	ll ans = 0, des = pow(10, now.size() - 1);
	for (int i = 0; i < now.size(); ++i, des /= 10) {
		ans += des * (now[i] - '0');
		if (now[i] != start[i]) {
			for (int j = i + 1;; ++j) {
				if (now[i] == start[j]) {
					ans -= y * (j - i);
					while (j != i) {
						swap(start[j], start[j - 1]);
						--j;
					}
					break;
				}
			}
		}
	}
	return ans;
}

string start, sans;
vector<int> cnt(10, 0);
ll ans;
bool flag = 0;

inline void get(string& now, int it, int pos) {
	if (flag) {
		return;
	}
	if (pos == start.size()) {
		if (now < start) {
			flag = 1;
			return;
		}
		ll temp = count(now, start);
		if (temp > ans) {
			ans = temp;
			sans = now;
		}
		else if (temp == ans && now > sans) {
			sans = now;
		}
		return;
	}
	while (cnt[it] == 0) {
		--it;
	}
	for (int i = it; i >= 0; --i) {
		if (cnt[i]) {
			now.push_back(i + '0');
			--cnt[i];
			get(now, it, pos + 1);
			++cnt[i];
			now.pop_back();
		}
	}
}

inline string ez(string s) {
	start = s;
	sans = s;
	ans = count(s, start);
	for (char i : s) {
		++cnt[i - '0'];
	}
	string now;
	get(now, 9, 0);
	return sans;
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	string s;
	cin >> s >> y;
	n = s.size();
	const ll K = 13;
	if (n <= K) {
		cout << ez(s);
	}
	else {
		sort(s.begin(), s.end() - K, [](char fi, char se) {
			return fi > se;
			});
		while (1) {
			int it = n - K;
			for (int i = n - K; i < n; ++i) {
				if (s[i] > s[it]) {
					it = i;
				}
			}
			if (s[it] > s[n - K - 1]) {
				while (it > 0 && s[it] > s[it - 1]) {
					swap(s[it], s[it - 1]);
					--it;
				}
			}
			else {
				break;
			}
		}
		cout << s.substr(0, n - K) + ez(s.substr(n - K));
	}
	return 0;
}