#include <iostream>
#include <algorithm>
#include <map>
#include <cstdlib>
#include <ctime>
#include <set>

using namespace std;

vector <pair <short, short> > c[10002];

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n, q;
    cin >> n >> q;
    int sum = 0;
    for (int i = 0; i < n; i++){
        int x;
        cin >> x;
        c[0].push_back({x, i});
        sum += x;
    }
    sort(c[0].begin(), c[0].end());
    for (int i = 1; i <= 10001; i++)
        c[i].resize(n + 1);
    for (int i = 1; i <= 10001; i++){
        int inc = 0;
        c[i][n - 1] = c[i - 1][n - 1];
        for (int j = n - 2; j >= 0; j--){
            c[i][j] = c[i - 1][j];
            if (c[i - 1][j].first != c[i - 1][j + 1].first)
                inc++;
            c[i][j].first += inc;
        }
    }
    while (q--){
        int t, x;
        cin >> t >> x;
        if (t == 1){
            set <short> s;
            for (int i = 0; i < n; i++)
                s.insert(c[x][i].first);
            cout << s.size() << '\n';
        }
        else if (t == 2){
            int summa = 0;
            for (int i = 0; i < n; i++)
                summa += c[x][i].first;
            cout << summa - sum << '\n';
        }
        else {
            int j;
            cin >> j;
            for (int i = 0; i < c[x].size(); i++)
                if (c[x][i].second == j - 1){
                    cout << c[x][i].first << '\n';
                    break;
                }
        }
    }
    return 0;
}
