#include <bits/stdc++.h>
//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
//using namespace __gnu_pbds;

//#pragma GCC optimise("O3, unroll-loops")
//#pragma GCC target("avx2")

//template <typename T>
//using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;
typedef long double ld;

#define ff first
#define ss second
#define _ << " " <<
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

#ifdef LOCAL
#define err cerr
#else
#define err if(0) cerr
#endif

#define int ll

mt19937 rnd(time(0));

const int N = 3e5 + 10;

int ans[N];
int p[N];
int s[N];
int add[N];
int val[N];
int prv[N];
int lst[N];

int get(int a) {
    if (p[a] == a) return a;
    return p[a] = get(p[a]);
}

void upd(int a, int b) {
    a = get(a);
    b = get(b);
    if (a == b) return;
    if (s[b] > s[a]) swap(a, b);

    p[b] = a;
    s[a] += s[b];
    add[a] = min(add[a], add[b]);
    prv[a] = min(prv[a], prv[b]);
}

void push(int a, int tmp) {
    a = get(a);
    val[a] += (tmp - lst[a]) * add[a];
    lst[a] = tmp;
}

void update(int a, int b, int cnt) {
    a = get(a);
    b = get(b);
    push(a, cnt);
    upd(a, b);

    if (cnt == 0) return;
    a = get(a);
    int tmp = prv[a];
    while (tmp != -1) {
        tmp = get(tmp);
        push(tmp, cnt);
        add[tmp]--;
        tmp = prv[tmp];
    }
}

void solve() {
    int n, q;
    cin >> n >> q;

    int x;
    vector<int> a(n);
    map<int, int> st;
    for (int i = 0; i < n; ++i) {
        cin >> x;
        a[i] = x;
        st[x]++;
    }

    vector<int> b = a;
    sort(all(b));
    map<int, int> pp;
    for (int i = 0; i < n; ++i) {
        p[i] = i;
        s[i] = 1;
        add[i] = n - i - 1;
        pp[b[i]] = i;
        val[i] = b[i];
        prv[i] = i - 1;
        lst[i] = 0;
    }

    vector<vector<int> > d1;
    for (int i = 1; i < n; ++i) {
        d1.push_back({b[i] - b[i - 1], -i, -(i - 1)});
    }
    sort(all(d1));

    int cnt = st.size();
    vector<pair<int, int> > v;
    for (auto it : st) {
        v.push_back(it);
    }
    vector<pair<int, int> > d;
    if (!v.empty()) {
        int cn = v[0].ss;
        for (int i = 1; i < v.size(); ++i) {
            d.push_back({v[i].ff - v[i - 1].ff, cn});
            cn += v[i].ss;
        }
        sort(all(d));
    }

    int pl = 0;
    int sz = v.size();
    for (int i = 0; i < v.size(); ++i) {
        pl += v[i].ss * (sz - i - 1);
    }

    vector<vector<int> > ask(q);
    int t, k;

    for (int i = 0; i < q; ++i) {
        cin >> t >> k;
        ask[i] = {k, t, i};
    }
    sort(all(ask));

    int pos = 0;
    int sm = 0;
    int pos1 = 0;
    int pr = 0;
    while (pos1 < d1.size() && d1[pos1][0] == 0) {
        update(-d1[pos1][1], -d1[pos1][2], d1[pos1][0] - pr);
        pr = d1[pos1][0];
        ++pos1;
    }

    set<int> stt;
    for (int i = 0; i < n; ++i) {
        stt.insert(get(i));
    }
    int add1 = stt.size();
    for (auto it : stt) {
        add1--;
        add[get(it)] = add1;
    }

    for (int i = 0; i < q; ++i) {
        t = ask[i][1];
        k = ask[i][0];
        int ind = ask[i][2];

        while (pos1 < d1.size() && d1[pos1][0] <= k) {
            update(-d1[pos1][1], -d1[pos1][2], d1[pos1][0] - pr);
            pr = d1[pos1][0];
            ++pos1;
        }
        while (pos < d.size() && d[pos].ff <= k) {
            if (pos == 0 || d[pos].ff != d[pos - 1].ff) {
                if (pos == 0) sm += pl * d[pos].ff;
                else sm += pl * (d[pos].ff - d[pos - 1].ff);
            }
            pl -= d[pos].ss;
            ++pos;
        }

        if (t == 1) {
            ans[ind] = cnt - pos;
        }
        if (t == 2) {
            if (pos == 0) {
                ans[ind] = pl * k;
            } else {
                ans[ind] = sm + pl * (k - d[pos - 1].ff);
            }
        }
        if (t == 3) {
            int ind1;
            cin >> ind1;
            --ind1;
            int tmp = pp[a[ind1]];
            tmp = get(tmp);
            ans[ind] = val[tmp] + add[tmp] * (k - lst[tmp]);
        }
    }

    for (int i = 0; i < q; ++i) {
        cout << ans[i] << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    int tests = 1;
//    cin >> tests;

    while (tests--) {
        solve();
        cout << "\n";
    }
}
