#include <algorithm>
#include <iostream>
#include <vector>
#include <set>

#define all(x) (x).begin(), (x).end()

using namespace std;

typedef long long ll;

const ll inf = 1e18 + 228;
const ll cst = 3e5 + 5;

void ex() {
	cout.flush();
	exit(0);
}

void solve() {
	ll n, m;
	cin >> n >> m;
	vector<ll> a(n);
	for (ll& i : a) cin >> i;
	ll l, r, c, t;
	cin >> l >> r >> c >> t;
	l--;
	r--;
	if (t == 0) {
		ll sm = 0;
		for (ll i = l; i <= r; i++) sm += a[i];
		sm = min(sm, c);
		for (ll i = 0; i < n; i++) cout << sm << " ";
	}
	else {
		for (ll x = 0; x < n; x++) {
			ll nl = min(x, l);
			ll nr = max(r, x);
			ll sm = 0;
			for (ll i = nl; i <= nr; i++) sm += a[i];
			sm = min(sm, c);
			cout << sm << " ";
		}
	}
}

int main() {
	cin.tie(0)->sync_with_stdio(0);
	ll t;
	cin >> t;
	while (t--) {
		solve();
		cout << endl;
	}
	ex();
}
